/** \file
 *  This C source file was generated by $ANTLR version 3.5.2
 *
 *     -  From the grammar source file : /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g
 *     -                            On : 2020-05-07 16:14:09
 *     -                for the parser : Smt2ParserParser
 *
 * Editing it, at least manually, is not wise.
 *
 * C language generator and runtime by Jim Idle, jimi|hereisanat|idle|dotgoeshere|ws.
 *
 *
*/
// [The "BSD license"]
// Copyright (c) 2005-2009 Jim Idle, Temporal Wave LLC
// http://www.temporal-wave.com
// http://www.linkedin.com/in/jimidle
//
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 3. The name of the author may not be used to endorse or promote products
//    derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


/* =============================================================================
 * This is what the grammar programmer asked us to put at the top of every file.
 */

/**
 ** This file is part of the CVC4 project.
 ** Copyright (c) 2009-2016 by the authors listed in the file AUTHORS
 ** in the top-level source directory) and their institutional affiliations.
 ** All rights reserved.  See the file COPYING in the top-level source
 ** directory for licensing information.
 **/

/* End of Header action.
 * =============================================================================
 */

/* -----------------------------------------
 * Include the ANTLR3 generated header file.
 */
#include    "Smt2Parser.h"


#include <set>
#include <sstream>
#include <string>
#include <unordered_set>
#include <vector>

#include "api/cvc4cpp.h"
#include "base/output.h"
#include "expr/expr.h"
#include "expr/kind.h"
#include "expr/type.h"
#include "options/set_language.h"
#include "parser/antlr_input.h"
#include "parser/parser.h"
#include "parser/smt2/smt2.h"
#include "util/floatingpoint.h"
#include "util/hash.h"
#include "util/integer.h"
#include "util/rational.h"
// \todo Review the need for this header
#include "math.h"

using namespace CVC4;
using namespace CVC4::parser;

/* These need to be macros so they can refer to the PARSER macro, which
 * will be defined by ANTLR *after* this section. (If they were functions,
 * PARSER would be undefined.) */
#undef PARSER_STATE
#define PARSER_STATE ((Smt2*)PARSER->super)
#undef EXPR_MANAGER
#define EXPR_MANAGER PARSER_STATE->getExprManager()
#undef MK_EXPR
#define MK_EXPR EXPR_MANAGER->mkExpr
#undef MK_CONST
#define MK_CONST EXPR_MANAGER->mkConst
#undef SOLVER
#define SOLVER PARSER_STATE->getSolver()
#define UNSUPPORTED PARSER_STATE->unimplementedFeature

static bool isClosed(const Expr& e, std::set<Expr>& free, std::unordered_set<Expr, ExprHashFunction>& closedCache) {
  if(closedCache.find(e) != closedCache.end()) {
    return true;
  }

  if(e.getKind() == kind::FORALL || e.getKind() == kind::EXISTS || e.getKind() == kind::LAMBDA) {
    isClosed(e[1], free, closedCache);
    for(Expr::const_iterator i = e[0].begin(); i != e[0].end(); ++i) {
      free.erase(*i);
    }
  } else if(e.getKind() == kind::BOUND_VARIABLE) {
    free.insert(e);
    return false;
  } else {
    if(e.hasOperator()) {
      isClosed(e.getOperator(), free, closedCache);
    }
    for(Expr::const_iterator i = e.begin(); i != e.end(); ++i) {
      isClosed(*i, free, closedCache);
    }
  }

  if(free.empty()) {
    closedCache.insert(e);
    return true;
  } else {
    return false;
  }
}

static inline bool isClosed(const Expr& e, std::set<Expr>& free) {
  std::unordered_set<Expr, ExprHashFunction> cache;
  return isClosed(e, free, cache);
}  
  

/* ----------------------------------------- */





/* MACROS that hide the C interface implementations from the
 * generated code, which makes it a little more understandable to the human eye.
 * I am very much against using C pre-processor macros for function calls and bits
 * of code as you cannot see what is happening when single stepping in debuggers
 * and so on. The exception (in my book at least) is for generated code, where you are
 * not maintaining it, but may wish to read and understand it. If you single step it, you know that input()
 * hides some indirect calls, but is always referring to the input stream. This is
 * probably more readable than ctx->input->istream->input(snarfle0->blarg) and allows me to rejig
 * the runtime interfaces without changing the generated code too often, without
 * confusing the reader of the generated output, who may not wish to know the gory
 * details of the interface inheritance.
 */

#define		CTX	ctx

/* Aids in accessing scopes for grammar programmers
 */
#undef	SCOPE_TYPE
#undef	SCOPE_STACK
#undef	SCOPE_TOP
#define	SCOPE_TYPE(scope)   pSmt2Parser_##scope##_SCOPE
#define SCOPE_STACK(scope)  pSmt2Parser_##scope##Stack
#define	SCOPE_TOP(scope)    ctx->pSmt2Parser_##scope##Top
#define	SCOPE_SIZE(scope)		ctx->pSmt2Parser_##scope##Stack_limit
#define SCOPE_INSTANCE(scope, i)	(ctx->SCOPE_STACK(scope)->get(ctx->SCOPE_STACK(scope),i))

/* Macros for accessing things in the parser
 */

#undef	    PARSER
#undef	    RECOGNIZER
#undef	    HAVEPARSEDRULE
#undef		MEMOIZE
#undef	    INPUT
#undef	    STRSTREAM
#undef	    HASEXCEPTION
#undef	    EXCEPTION
#undef	    MATCHT
#undef	    MATCHANYT
#undef	    FOLLOWSTACK
#undef	    FOLLOWPUSH
#undef	    FOLLOWPOP
#undef	    PRECOVER
#undef	    PREPORTERROR
#undef	    LA
#undef	    LT
#undef	    CONSTRUCTEX
#undef	    CONSUME
#undef	    MARK
#undef	    REWIND
#undef	    REWINDLAST
#undef	    PERRORRECOVERY
#undef	    HASFAILED
#undef	    FAILEDFLAG
#undef	    RECOVERFROMMISMATCHEDSET
#undef	    RECOVERFROMMISMATCHEDELEMENT
#undef		INDEX
#undef      ADAPTOR
#undef		SEEK
#undef	    RULEMEMO
#undef		DBG

#define	    PARSER				ctx->pParser
#define	    RECOGNIZER				PARSER->rec
#define	    PSRSTATE				RECOGNIZER->state
#define	    HAVEPARSEDRULE(r)			RECOGNIZER->alreadyParsedRule(RECOGNIZER, r)
#define	    MEMOIZE(ri,si)			RECOGNIZER->memoize(RECOGNIZER, ri, si)
#define	    INPUT				PARSER->tstream
#define	    STRSTREAM				INPUT
#define	    ISTREAM				INPUT->istream
#define	    INDEX()				ISTREAM->index(INPUT->istream)
#define	    HASEXCEPTION()			(PSRSTATE->error == ANTLR3_TRUE)
#define	    EXCEPTION				PSRSTATE->exception
#define	    MATCHT(t, fs)			RECOGNIZER->match(RECOGNIZER, t, fs)
#define	    MATCHANYT()				RECOGNIZER->matchAny(RECOGNIZER)
#define	    FOLLOWSTACK				PSRSTATE->following
#ifdef  SKIP_FOLLOW_SETS
#define	    FOLLOWPUSH(x)
#define	    FOLLOWPOP()
#else
#define	    FOLLOWPUSH(x)			FOLLOWSTACK->push(FOLLOWSTACK, ((void *)(&(x))), NULL)
#define	    FOLLOWPOP()				FOLLOWSTACK->pop(FOLLOWSTACK)
#endif
#define	    PRECOVER()				RECOGNIZER->recover(RECOGNIZER)
#define	    PREPORTERROR()			RECOGNIZER->reportError(RECOGNIZER)
#define	    LA(n)				INPUT->istream->_LA(ISTREAM, n)
#define	    LT(n)				INPUT->_LT(INPUT, n)
#define	    CONSTRUCTEX()			RECOGNIZER->exConstruct(RECOGNIZER)
#define	    CONSUME()				ISTREAM->consume(ISTREAM)
#define	    MARK()				ISTREAM->mark(ISTREAM)
#define	    REWIND(m)				ISTREAM->rewind(ISTREAM, m)
#define	    REWINDLAST()			ISTREAM->rewindLast(ISTREAM)
#define	    SEEK(n)				ISTREAM->seek(ISTREAM, n)
#define	    PERRORRECOVERY			PSRSTATE->errorRecovery
#define	    FAILEDFLAG				PSRSTATE->failed
#define	    HASFAILED()				(FAILEDFLAG == ANTLR3_TRUE)
#define	    BACKTRACKING			PSRSTATE->backtracking
#define	    RECOVERFROMMISMATCHEDSET(s)		RECOGNIZER->recoverFromMismatchedSet(RECOGNIZER, s)
#define	    RECOVERFROMMISMATCHEDELEMENT(e)	RECOGNIZER->recoverFromMismatchedElement(RECOGNIZER, s)
#define     ADAPTOR                         ctx->adaptor
#define		RULEMEMO						PSRSTATE->ruleMemo
#define		DBG								RECOGNIZER->debugger


#define		TOKTEXT(tok, txt)				tok, (pANTLR3_UINT8)txt

/* The 4 tokens defined below may well clash with your own #defines or token types. If so
 * then for the present you must use different names for your defines as these are hard coded
 * in the code generator. It would be better not to use such names internally, and maybe
 * we can change this in a forthcoming release. I deliberately do not #undef these
 * here as this will at least give you a redefined error somewhere if they clash.
 */
#define	    UP	    ANTLR3_TOKEN_UP
#define	    DOWN    ANTLR3_TOKEN_DOWN
#define	    EOR	    ANTLR3_TOKEN_EOR
#define	    INVALID ANTLR3_TOKEN_INVALID


/* =============================================================================
 * Functions to create and destroy scopes. First come the rule scopes, followed
 * by the global declared scopes.
 */



/* ============================================================================= */

/* =============================================================================
 * Start of recognizer
 */



/** \brief Table of all token names in symbolic order, mainly used for
 *         error reporting.
 */
pANTLR3_UINT8   Smt2ParserTokenNames[161+4]
     = {
        (pANTLR3_UINT8) "<invalid>",       /* String to print to indicate an invalid token */
        (pANTLR3_UINT8) "<EOR>",
        (pANTLR3_UINT8) "<DOWN>",
        (pANTLR3_UINT8) "<UP>",
        (pANTLR3_UINT8) "ALPHA",
        (pANTLR3_UINT8) "AMPERSAND_TOK",
        (pANTLR3_UINT8) "AND_TOK",
        (pANTLR3_UINT8) "ASSERT_TOK",
        (pANTLR3_UINT8) "AS_TOK",
        (pANTLR3_UINT8) "ATTRIBUTE_INST_LEVEL",
        (pANTLR3_UINT8) "ATTRIBUTE_NAMED_TOK",
        (pANTLR3_UINT8) "ATTRIBUTE_NO_PATTERN_TOK",
        (pANTLR3_UINT8) "ATTRIBUTE_PATTERN_TOK",
        (pANTLR3_UINT8) "ATTRIBUTE_RR_PRIORITY",
        (pANTLR3_UINT8) "ATTRIBUTE_TOK",
        (pANTLR3_UINT8) "AT_TOK",
        (pANTLR3_UINT8) "BINARY_LITERAL",
        (pANTLR3_UINT8) "BV2NAT_TOK",
        (pANTLR3_UINT8) "CHECK_SAT_ASSUMING_TOK",
        (pANTLR3_UINT8) "CHECK_SAT_TOK",
        (pANTLR3_UINT8) "CHECK_SYNTH_TOK",
        (pANTLR3_UINT8) "COMMENT",
        (pANTLR3_UINT8) "CONSTRAINT_TOK",
        (pANTLR3_UINT8) "CONST_TOK",
        (pANTLR3_UINT8) "DECIMAL_LITERAL",
        (pANTLR3_UINT8) "DECLARE_CODATATYPES_2_5_TOK",
        (pANTLR3_UINT8) "DECLARE_CODATATYPES_TOK",
        (pANTLR3_UINT8) "DECLARE_CODATATYPE_TOK",
        (pANTLR3_UINT8) "DECLARE_CONST_TOK",
        (pANTLR3_UINT8) "DECLARE_DATATYPES_2_5_TOK",
        (pANTLR3_UINT8) "DECLARE_DATATYPES_TOK",
        (pANTLR3_UINT8) "DECLARE_DATATYPE_TOK",
        (pANTLR3_UINT8) "DECLARE_FUNS_TOK",
        (pANTLR3_UINT8) "DECLARE_FUN_TOK",
        (pANTLR3_UINT8) "DECLARE_HEAP",
        (pANTLR3_UINT8) "DECLARE_PREDS_TOK",
        (pANTLR3_UINT8) "DECLARE_PRIMED_VAR_TOK",
        (pANTLR3_UINT8) "DECLARE_SORTS_TOK",
        (pANTLR3_UINT8) "DECLARE_SORT_TOK",
        (pANTLR3_UINT8) "DECLARE_VAR_TOK",
        (pANTLR3_UINT8) "DEFINE_CONST_TOK",
        (pANTLR3_UINT8) "DEFINE_FUNS_REC_TOK",
        (pANTLR3_UINT8) "DEFINE_FUN_REC_TOK",
        (pANTLR3_UINT8) "DEFINE_FUN_TOK",
        (pANTLR3_UINT8) "DEFINE_SORT_TOK",
        (pANTLR3_UINT8) "DEFINE_TOK",
        (pANTLR3_UINT8) "DIGIT",
        (pANTLR3_UINT8) "DISTINCT_TOK",
        (pANTLR3_UINT8) "DIVISIBLE_TOK",
        (pANTLR3_UINT8) "DIV_TOK",
        (pANTLR3_UINT8) "DTSIZE_TOK",
        (pANTLR3_UINT8) "ECHO_TOK",
        (pANTLR3_UINT8) "EMPTYSET_TOK",
        (pANTLR3_UINT8) "EMP_TOK",
        (pANTLR3_UINT8) "EQUAL_TOK",
        (pANTLR3_UINT8) "EXISTS_TOK",
        (pANTLR3_UINT8) "EXIT_TOK",
        (pANTLR3_UINT8) "FMFCARDVAL_TOK",
        (pANTLR3_UINT8) "FMFCARD_TOK",
        (pANTLR3_UINT8) "FORALL_TOK",
        (pANTLR3_UINT8) "FP_NAN_TOK",
        (pANTLR3_UINT8) "FP_NINF_TOK",
        (pANTLR3_UINT8) "FP_NZERO_TOK",
        (pANTLR3_UINT8) "FP_PINF_TOK",
        (pANTLR3_UINT8) "FP_PZERO_TOK",
        (pANTLR3_UINT8) "FP_RNA_FULL_TOK",
        (pANTLR3_UINT8) "FP_RNA_TOK",
        (pANTLR3_UINT8) "FP_RNE_FULL_TOK",
        (pANTLR3_UINT8) "FP_RNE_TOK",
        (pANTLR3_UINT8) "FP_RTN_FULL_TOK",
        (pANTLR3_UINT8) "FP_RTN_TOK",
        (pANTLR3_UINT8) "FP_RTP_FULL_TOK",
        (pANTLR3_UINT8) "FP_RTP_TOK",
        (pANTLR3_UINT8) "FP_RTZ_FULL_TOK",
        (pANTLR3_UINT8) "FP_RTZ_TOK",
        (pANTLR3_UINT8) "FP_TO_FPBV_TOK",
        (pANTLR3_UINT8) "FP_TO_FPFP_TOK",
        (pANTLR3_UINT8) "FP_TO_FPR_TOK",
        (pANTLR3_UINT8) "FP_TO_FPS_TOK",
        (pANTLR3_UINT8) "FP_TO_FPU_TOK",
        (pANTLR3_UINT8) "FP_TO_FP_TOK",
        (pANTLR3_UINT8) "FP_TO_SBV_TOK",
        (pANTLR3_UINT8) "FP_TO_UBV_TOK",
        (pANTLR3_UINT8) "GET_ASSERTIONS_TOK",
        (pANTLR3_UINT8) "GET_ASSIGNMENT_TOK",
        (pANTLR3_UINT8) "GET_INFO_TOK",
        (pANTLR3_UINT8) "GET_MODEL_TOK",
        (pANTLR3_UINT8) "GET_OPTION_TOK",
        (pANTLR3_UINT8) "GET_PROOF_TOK",
        (pANTLR3_UINT8) "GET_QE_DISJUNCT_TOK",
        (pANTLR3_UINT8) "GET_QE_TOK",
        (pANTLR3_UINT8) "GET_UNSAT_ASSUMPTIONS_TOK",
        (pANTLR3_UINT8) "GET_UNSAT_CORE_TOK",
        (pANTLR3_UINT8) "GET_VALUE_TOK",
        (pANTLR3_UINT8) "GREATER_THAN_EQUAL_TOK",
        (pANTLR3_UINT8) "GREATER_THAN_TOK",
        (pANTLR3_UINT8) "HEX_DIGIT",
        (pANTLR3_UINT8) "HEX_LITERAL",
        (pANTLR3_UINT8) "HO_ARROW_TOK",
        (pANTLR3_UINT8) "HO_LAMBDA_TOK",
        (pANTLR3_UINT8) "IMPLIES_TOK",
        (pANTLR3_UINT8) "INCLUDE_TOK",
        (pANTLR3_UINT8) "INDEX_TOK",
        (pANTLR3_UINT8) "INST_CLOSURE_TOK",
        (pANTLR3_UINT8) "INT2BV_TOK",
        (pANTLR3_UINT8) "INTEGER_LITERAL",
        (pANTLR3_UINT8) "INV_CONSTRAINT_TOK",
        (pANTLR3_UINT8) "ITE_TOK",
        (pANTLR3_UINT8) "KEYWORD",
        (pANTLR3_UINT8) "LESS_THAN_EQUAL_TOK",
        (pANTLR3_UINT8) "LESS_THAN_TOK",
        (pANTLR3_UINT8) "LET_TOK",
        (pANTLR3_UINT8) "LPAREN_TOK",
        (pANTLR3_UINT8) "MATCH_TOK",
        (pANTLR3_UINT8) "META_INFO_TOK",
        (pANTLR3_UINT8) "MINUS_TOK",
        (pANTLR3_UINT8) "NILREF_TOK",
        (pANTLR3_UINT8) "NOT_TOK",
        (pANTLR3_UINT8) "NUMERAL",
        (pANTLR3_UINT8) "OR_TOK",
        (pANTLR3_UINT8) "PAR_TOK",
        (pANTLR3_UINT8) "PLUS_TOK",
        (pANTLR3_UINT8) "POP_TOK",
        (pANTLR3_UINT8) "PROPAGATION_RULE_TOK",
        (pANTLR3_UINT8) "PUSH_TOK",
        (pANTLR3_UINT8) "QUOTED_SYMBOL",
        (pANTLR3_UINT8) "REALLCHAR_TOK",
        (pANTLR3_UINT8) "REAL_PI_TOK",
        (pANTLR3_UINT8) "REDUCTION_RULE_TOK",
        (pANTLR3_UINT8) "RENOSTR_TOK",
        (pANTLR3_UINT8) "RESET_ASSERTIONS_TOK",
        (pANTLR3_UINT8) "RESET_TOK",
        (pANTLR3_UINT8) "REWRITE_RULE_TOK",
        (pANTLR3_UINT8) "RPAREN_TOK",
        (pANTLR3_UINT8) "SET_INFO_TOK",
        (pANTLR3_UINT8) "SET_LOGIC_TOK",
        (pANTLR3_UINT8) "SET_OPTIONS_TOK",
        (pANTLR3_UINT8) "SET_OPTION_TOK",
        (pANTLR3_UINT8) "SIMPLE_SYMBOL",
        (pANTLR3_UINT8) "SIMPLIFY_TOK",
        (pANTLR3_UINT8) "STAR_TOK",
        (pANTLR3_UINT8) "STRING_LITERAL",
        (pANTLR3_UINT8) "SYGUS_CONSTANT_TOK",
        (pANTLR3_UINT8) "SYGUS_INPUT_VARIABLE_TOK",
        (pANTLR3_UINT8) "SYGUS_LET_TOK",
        (pANTLR3_UINT8) "SYGUS_LOCAL_VARIABLE_TOK",
        (pANTLR3_UINT8) "SYGUS_VARIABLE_TOK",
        (pANTLR3_UINT8) "SYMBOL_CHAR",
        (pANTLR3_UINT8) "SYMBOL_CHAR_NOUNDERSCORE_NOATTRIBUTE",
        (pANTLR3_UINT8) "SYNTH_FUN_TOK",
        (pANTLR3_UINT8) "SYNTH_INV_TOK",
        (pANTLR3_UINT8) "TESTER_TOK",
        (pANTLR3_UINT8) "TUPLE_CONST_TOK",
        (pANTLR3_UINT8) "TUPLE_SEL_TOK",
        (pANTLR3_UINT8) "UNIVSET_TOK",
        (pANTLR3_UINT8) "UNTERMINATED_QUOTED_SYMBOL",
        (pANTLR3_UINT8) "WHITESPACE",
        (pANTLR3_UINT8) "XOR_TOK",
        (pANTLR3_UINT8) "'\\\\'",
        (pANTLR3_UINT8) "'extract'",
        (pANTLR3_UINT8) "'repeat'",
        (pANTLR3_UINT8) "'rotate_left'",
        (pANTLR3_UINT8) "'rotate_right'",
        (pANTLR3_UINT8) "'sign_extend'",
        (pANTLR3_UINT8) "'zero_extend'"
       };



// Forward declare the locally static matching functions we have generated.
//
static 
 CVC4::parser::smt2::myExpr
	parseExpr    (pSmt2Parser ctx);
static 
 CVC4::Command*
	parseCommand    (pSmt2Parser ctx);
static 
 CVC4::Command*
	parseSygus    (pSmt2Parser ctx);
static 
 void
	command    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	sygusCommand    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	sygusGrammar    (pSmt2Parser ctx, CVC4::Type & ret, std::vector<CVC4::Expr>& sygus_vars, std::string& fun);
static 
 void
	sygusGTerm    (pSmt2Parser ctx, CVC4::SygusGTerm& sgt, std::string& fun);
static 
 void
	metaInfoInternal    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	setOptionInternal    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	smt25Command    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	extendedCommand    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	datatypes_2_5_DefCommand    (pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	datatypeDefCommand    (pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	datatypesDefCommand    (pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	datatypesDef    (pSmt2Parser ctx, bool isCo, const std::vector<std::string>& dnames, const std::vector<int>& arities, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	rewriterulesCommand    (pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd);
static 
 void
	rewritePropaKind    (pSmt2Parser ctx, CVC4::Kind& kind);
static 
 void
	pattern    (pSmt2Parser ctx, CVC4::Expr& expr);
static 
 void
	simpleSymbolicExprNoKeyword    (pSmt2Parser ctx, CVC4::SExpr& sexpr);
static 
 void
	keyword    (pSmt2Parser ctx, std::string& s);
static 
 void
	simpleSymbolicExpr    (pSmt2Parser ctx, CVC4::SExpr& sexpr);
static 
 void
	symbolicExpr    (pSmt2Parser ctx, CVC4::SExpr& sexpr);
static 
 void
	term    (pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& expr2);
static 
 void
	termNonVariable    (pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& expr2);
static 
 void
	termAtomic    (pSmt2Parser ctx, CVC4::api::Term& atomTerm);
static 
 void
	attribute    (pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& retExpr, std::string& attr);
static 
 void
	indexedFunctionName    (pSmt2Parser ctx, CVC4::Expr& op, CVC4::Kind& kind);
static 
 void
	badIndexedFunctionName    (pSmt2Parser ctx);
static 
 void
	termList    (pSmt2Parser ctx, std::vector<CVC4::Expr>& formulas, CVC4::Expr& expr);
static 
 void
	str    (pSmt2Parser ctx, std::string& s, bool fsmtlib);
static 
 void
	builtinOp    (pSmt2Parser ctx, CVC4::Kind& kind);
static 
 void
	quantOp    (pSmt2Parser ctx, CVC4::Kind& kind);
static 
 void
	functionName    (pSmt2Parser ctx, std::string& name, CVC4::parser::DeclarationCheck check);
static 
 void
	sortList    (pSmt2Parser ctx, std::vector<CVC4::Type>& sorts);
static 
 void
	nonemptySortList    (pSmt2Parser ctx, std::vector<CVC4::Type>& sorts);
static 
 void
	sortedVarList    (pSmt2Parser ctx, std::vector<std::pair<std::string, CVC4::Type> >& sortedVars);
static 
 void
	sortName    (pSmt2Parser ctx, std::string& name, CVC4::parser::DeclarationCheck check);
static 
 void
	sortSymbol    (pSmt2Parser ctx, CVC4::Type& t, CVC4::parser::DeclarationCheck check);
static 
 void
	symbolList    (pSmt2Parser ctx, std::vector<std::string>& names, CVC4::parser::DeclarationCheck check, CVC4::parser::SymbolType type);
static 
 void
	symbol    (pSmt2Parser ctx, std::string& id, CVC4::parser::DeclarationCheck check, CVC4::parser::SymbolType type);
static 
 void
	nonemptyNumeralList    (pSmt2Parser ctx, std::vector<uint64_t>& numerals);
static 
 void
	datatypeDef    (pSmt2Parser ctx, bool isCo, std::vector<CVC4::Datatype>& datatypes, std::vector< CVC4::Type >& params);
static 
 void
	constructorDef    (pSmt2Parser ctx, CVC4::Datatype& type);
static 
 void
	selector    (pSmt2Parser ctx, CVC4::DatatypeConstructor& ctor);
static void	Smt2ParserFree(pSmt2Parser ctx);
static void     Smt2ParserReset (pSmt2Parser ctx);

/* For use in tree output where we are accumulating rule labels via label += ruleRef
 * we need a function that knows how to free a return scope when the list is destroyed.
 * We cannot just use ANTLR3_FREE because in debug tracking mode, this is a macro.
 */
static	void ANTLR3_CDECL freeScope(void * scope)
{
    ANTLR3_FREE(scope);
}

/** \brief Name of the grammar file that generated this code
 */
static const char fileName[] = "/builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g";

/** \brief Return the name of the grammar file that generated this code.
 */
static const char * getGrammarFileName()
{
	return fileName;
}
/** \brief Create a new Smt2Parser parser and return a context for it.
 *
 * \param[in] instream Pointer to an input stream interface.
 *
 * \return Pointer to new parser context upon success.
 */
ANTLR3_API pSmt2Parser
Smt2ParserNew   (pANTLR3_COMMON_TOKEN_STREAM instream)
{
	// See if we can create a new parser with the standard constructor
	//
	return Smt2ParserNewSSD(instream, NULL);
}

/** \brief Create a new Smt2Parser parser and return a context for it.
 *
 * \param[in] instream Pointer to an input stream interface.
 *
 * \return Pointer to new parser context upon success.
 */
ANTLR3_API pSmt2Parser
Smt2ParserNewSSD   (pANTLR3_COMMON_TOKEN_STREAM instream, pANTLR3_RECOGNIZER_SHARED_STATE state)
{
    pSmt2Parser ctx;	    /* Context structure we will build and return   */

    ctx	= (pSmt2Parser) ANTLR3_CALLOC(1, sizeof(Smt2Parser));

    if	(ctx == NULL)
    {
		// Failed to allocate memory for parser context
		//
        return  NULL;
    }

    /* -------------------------------------------------------------------
     * Memory for basic structure is allocated, now to fill in
     * the base ANTLR3 structures. We initialize the function pointers
     * for the standard ANTLR3 parser function set, but upon return
     * from here, the programmer may set the pointers to provide custom
     * implementations of each function.
     *
     * We don't use the macros defined in Smt2Parser.h here, in order that you can get a sense
     * of what goes where.
     */

    /* Create a base parser/recognizer, using the supplied token stream
     */
    ctx->pParser	    = antlr3ParserNewStream(ANTLR3_SIZE_HINT, instream->tstream, state);
    /* Install the implementation of our Smt2Parser interface
     */
    ctx->parseExpr	= parseExpr;
    ctx->parseCommand	= parseCommand;
    ctx->parseSygus	= parseSygus;
    ctx->command	= command;
    ctx->sygusCommand	= sygusCommand;
    ctx->sygusGrammar	= sygusGrammar;
    ctx->sygusGTerm	= sygusGTerm;
    ctx->metaInfoInternal	= metaInfoInternal;
    ctx->setOptionInternal	= setOptionInternal;
    ctx->smt25Command	= smt25Command;
    ctx->extendedCommand	= extendedCommand;
    ctx->datatypes_2_5_DefCommand	= datatypes_2_5_DefCommand;
    ctx->datatypeDefCommand	= datatypeDefCommand;
    ctx->datatypesDefCommand	= datatypesDefCommand;
    ctx->datatypesDef	= datatypesDef;
    ctx->rewriterulesCommand	= rewriterulesCommand;
    ctx->rewritePropaKind	= rewritePropaKind;
    ctx->pattern	= pattern;
    ctx->simpleSymbolicExprNoKeyword	= simpleSymbolicExprNoKeyword;
    ctx->keyword	= keyword;
    ctx->simpleSymbolicExpr	= simpleSymbolicExpr;
    ctx->symbolicExpr	= symbolicExpr;
    ctx->term	= term;
    ctx->termNonVariable	= termNonVariable;
    ctx->termAtomic	= termAtomic;
    ctx->attribute	= attribute;
    ctx->indexedFunctionName	= indexedFunctionName;
    ctx->badIndexedFunctionName	= badIndexedFunctionName;
    ctx->termList	= termList;
    ctx->str	= str;
    ctx->builtinOp	= builtinOp;
    ctx->quantOp	= quantOp;
    ctx->functionName	= functionName;
    ctx->sortList	= sortList;
    ctx->nonemptySortList	= nonemptySortList;
    ctx->sortedVarList	= sortedVarList;
    ctx->sortName	= sortName;
    ctx->sortSymbol	= sortSymbol;
    ctx->symbolList	= symbolList;
    ctx->symbol	= symbol;
    ctx->nonemptyNumeralList	= nonemptyNumeralList;
    ctx->datatypeDef	= datatypeDef;
    ctx->constructorDef	= constructorDef;
    ctx->selector	= selector;
    ctx->free			= Smt2ParserFree;
    ctx->reset			= Smt2ParserReset;
    ctx->getGrammarFileName	= getGrammarFileName;

    /* Install the scope pushing methods.
     */

    /* Install the token table
     */
    PSRSTATE->tokenNames   = Smt2ParserTokenNames;


    /* Return the newly built parser to the caller
     */
    return  ctx;
}

static void
Smt2ParserReset (pSmt2Parser ctx)
{
    RECOGNIZER->reset(RECOGNIZER);
}

/** Free the parser resources
 */
 static void
 Smt2ParserFree(pSmt2Parser ctx)
 {
    /* Free any scope memory
     */

	// Free this parser
	//
    ctx->pParser->free(ctx->pParser);


    ANTLR3_FREE(ctx);

    /* Everything is released, so we can return
     */
    return;
 }

/** Return token names used by this 
parser

 *
 * The returned pointer is used as an index into the token names table (using the token
 * number as the index).
 *
 * \return Pointer to first char * in the table.
 */
static pANTLR3_UINT8    *getTokenNames()
{
        return Smt2ParserTokenNames;
}


/* Declare the bitsets
 */

/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_parseExpr119  */
static	ANTLR3_BITWORD FOLLOW_term_in_parseExpr119_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_parseExpr119	= { FOLLOW_term_in_parseExpr119_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EOF_in_parseExpr126  */
static	ANTLR3_BITWORD FOLLOW_EOF_in_parseExpr126_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EOF_in_parseExpr126	= { FOLLOW_EOF_in_parseExpr126_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_parseCommand155  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_parseCommand155_bits[]	= { ANTLR3_UINT64_LIT(0x01083F6FFE0C0080), ANTLR3_UINT64_LIT(0x1C0400003FF80000), ANTLR3_UINT64_LIT(0x0000000000000EDD) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_parseCommand155	= { FOLLOW_LPAREN_TOK_in_parseCommand155_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_command_in_parseCommand157  */
static	ANTLR3_BITWORD FOLLOW_command_in_parseCommand157_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_command_in_parseCommand157	= { FOLLOW_command_in_parseCommand157_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_parseCommand160  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_parseCommand160_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_parseCommand160	= { FOLLOW_RPAREN_TOK_in_parseCommand160_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_parseCommand173  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_parseCommand173_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000002000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_parseCommand173	= { FOLLOW_LPAREN_TOK_in_parseCommand173_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INCLUDE_TOK_in_parseCommand175  */
static	ANTLR3_BITWORD FOLLOW_INCLUDE_TOK_in_parseCommand175_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000002000) };
static  ANTLR3_BITSET_LIST FOLLOW_INCLUDE_TOK_in_parseCommand175	= { FOLLOW_INCLUDE_TOK_in_parseCommand175_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_str_in_parseCommand177  */
static	ANTLR3_BITWORD FOLLOW_str_in_parseCommand177_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_str_in_parseCommand177	= { FOLLOW_str_in_parseCommand177_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_parseCommand180  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_parseCommand180_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_parseCommand180	= { FOLLOW_RPAREN_TOK_in_parseCommand180_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EOF_in_parseCommand193  */
static	ANTLR3_BITWORD FOLLOW_EOF_in_parseCommand193_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EOF_in_parseCommand193	= { FOLLOW_EOF_in_parseCommand193_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_parseSygus222  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_parseSygus222_bits[]	= { ANTLR3_UINT64_LIT(0x01083FFFFE5C0080), ANTLR3_UINT64_LIT(0x1C0404003FF80000), ANTLR3_UINT64_LIT(0x0000000000600EDD) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_parseSygus222	= { FOLLOW_LPAREN_TOK_in_parseSygus222_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sygusCommand_in_parseSygus224  */
static	ANTLR3_BITWORD FOLLOW_sygusCommand_in_parseSygus224_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sygusCommand_in_parseSygus224	= { FOLLOW_sygusCommand_in_parseSygus224_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_parseSygus227  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_parseSygus227_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_parseSygus227	= { FOLLOW_RPAREN_TOK_in_parseSygus227_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EOF_in_parseSygus233  */
static	ANTLR3_BITWORD FOLLOW_EOF_in_parseSygus233_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EOF_in_parseSygus233	= { FOLLOW_EOF_in_parseSygus233_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SET_LOGIC_TOK_in_command261  */
static	ANTLR3_BITWORD FOLLOW_SET_LOGIC_TOK_in_command261_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SET_LOGIC_TOK_in_command261	= { FOLLOW_SET_LOGIC_TOK_in_command261_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_command263  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_command263_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_command263	= { FOLLOW_symbol_in_command263_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SET_INFO_TOK_in_command282  */
static	ANTLR3_BITWORD FOLLOW_SET_INFO_TOK_in_command282_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_SET_INFO_TOK_in_command282	= { FOLLOW_SET_INFO_TOK_in_command282_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_metaInfoInternal_in_command284  */
static	ANTLR3_BITWORD FOLLOW_metaInfoInternal_in_command284_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_metaInfoInternal_in_command284	= { FOLLOW_metaInfoInternal_in_command284_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_INFO_TOK_in_command297  */
static	ANTLR3_BITWORD FOLLOW_GET_INFO_TOK_in_command297_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_INFO_TOK_in_command297	= { FOLLOW_GET_INFO_TOK_in_command297_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_command299  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_command299_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_command299	= { FOLLOW_KEYWORD_in_command299_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SET_OPTION_TOK_in_command317  */
static	ANTLR3_BITWORD FOLLOW_SET_OPTION_TOK_in_command317_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_SET_OPTION_TOK_in_command317	= { FOLLOW_SET_OPTION_TOK_in_command317_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_setOptionInternal_in_command319  */
static	ANTLR3_BITWORD FOLLOW_setOptionInternal_in_command319_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_setOptionInternal_in_command319	= { FOLLOW_setOptionInternal_in_command319_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_OPTION_TOK_in_command332  */
static	ANTLR3_BITWORD FOLLOW_GET_OPTION_TOK_in_command332_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_OPTION_TOK_in_command332	= { FOLLOW_GET_OPTION_TOK_in_command332_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_command334  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_command334_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_command334	= { FOLLOW_KEYWORD_in_command334_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_SORT_TOK_in_command352  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_SORT_TOK_in_command352_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_SORT_TOK_in_command352	= { FOLLOW_DECLARE_SORT_TOK_in_command352_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_command366  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_command366_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_command366	= { FOLLOW_symbol_in_command366_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_command381  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_command381_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_command381	= { FOLLOW_INTEGER_LITERAL_in_command381_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_SORT_TOK_in_command399  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_SORT_TOK_in_command399_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_SORT_TOK_in_command399	= { FOLLOW_DEFINE_SORT_TOK_in_command399_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_command407  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_command407_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_command407	= { FOLLOW_symbol_in_command407_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_command420  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_command420_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_command420	= { FOLLOW_LPAREN_TOK_in_command420_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbolList_in_command422  */
static	ANTLR3_BITWORD FOLLOW_symbolList_in_command422_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_symbolList_in_command422	= { FOLLOW_symbolList_in_command422_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_command425  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_command425_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_command425	= { FOLLOW_RPAREN_TOK_in_command425_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_command437  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_command437_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_command437	= { FOLLOW_sortSymbol_in_command437_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_FUN_TOK_in_command456  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_FUN_TOK_in_command456_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_FUN_TOK_in_command456	= { FOLLOW_DECLARE_FUN_TOK_in_command456_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_command464  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_command464_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_command464	= { FOLLOW_symbol_in_command464_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_command477  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_command477_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_command477	= { FOLLOW_LPAREN_TOK_in_command477_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortList_in_command479  */
static	ANTLR3_BITWORD FOLLOW_sortList_in_command479_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortList_in_command479	= { FOLLOW_sortList_in_command479_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_command482  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_command482_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_command482	= { FOLLOW_RPAREN_TOK_in_command482_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_command488  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_command488_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_command488	= { FOLLOW_sortSymbol_in_command488_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_FUN_TOK_in_command507  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_FUN_TOK_in_command507_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_FUN_TOK_in_command507	= { FOLLOW_DEFINE_FUN_TOK_in_command507_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_command515  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_command515_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_command515	= { FOLLOW_symbol_in_command515_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_command528  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_command528_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_command528	= { FOLLOW_LPAREN_TOK_in_command528_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_command530  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_command530_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_command530	= { FOLLOW_sortedVarList_in_command530_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_command533  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_command533_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_command533	= { FOLLOW_RPAREN_TOK_in_command533_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_command539  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_command539_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_command539	= { FOLLOW_sortSymbol_in_command539_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_command552  */
static	ANTLR3_BITWORD FOLLOW_term_in_command552_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_command552	= { FOLLOW_term_in_command552_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_DATATYPE_TOK_in_command565  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_DATATYPE_TOK_in_command565_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_DATATYPE_TOK_in_command565	= { FOLLOW_DECLARE_DATATYPE_TOK_in_command565_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypeDefCommand_in_command567  */
static	ANTLR3_BITWORD FOLLOW_datatypeDefCommand_in_command567_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypeDefCommand_in_command567	= { FOLLOW_datatypeDefCommand_in_command567_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_DATATYPES_TOK_in_command574  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_DATATYPES_TOK_in_command574_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_DATATYPES_TOK_in_command574	= { FOLLOW_DECLARE_DATATYPES_TOK_in_command574_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypesDefCommand_in_command576  */
static	ANTLR3_BITWORD FOLLOW_datatypesDefCommand_in_command576_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypesDefCommand_in_command576	= { FOLLOW_datatypesDefCommand_in_command576_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_VALUE_TOK_in_command589  */
static	ANTLR3_BITWORD FOLLOW_GET_VALUE_TOK_in_command589_bits[]	= { ANTLR3_UINT64_LIT(0xFFFFFFFFFFFFFFF0), ANTLR3_UINT64_LIT(0xFFFFFFFFFFFFFFFF), ANTLR3_UINT64_LIT(0x0000001FFFFFFFFF) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_VALUE_TOK_in_command589	= { FOLLOW_GET_VALUE_TOK_in_command589_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_command599  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_command599_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_command599	= { FOLLOW_LPAREN_TOK_in_command599_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_command601  */
static	ANTLR3_BITWORD FOLLOW_termList_in_command601_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_command601	= { FOLLOW_termList_in_command601_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_command604  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_command604_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_command604	= { FOLLOW_RPAREN_TOK_in_command604_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_set_in_command620  */
static	ANTLR3_BITWORD FOLLOW_set_in_command620_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_set_in_command620	= { FOLLOW_set_in_command620_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_ASSIGNMENT_TOK_in_command647  */
static	ANTLR3_BITWORD FOLLOW_GET_ASSIGNMENT_TOK_in_command647_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_ASSIGNMENT_TOK_in_command647	= { FOLLOW_GET_ASSIGNMENT_TOK_in_command647_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ASSERT_TOK_in_command667  */
static	ANTLR3_BITWORD FOLLOW_ASSERT_TOK_in_command667_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_ASSERT_TOK_in_command667	= { FOLLOW_ASSERT_TOK_in_command667_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_command687  */
static	ANTLR3_BITWORD FOLLOW_term_in_command687_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_command687	= { FOLLOW_term_in_command687_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CHECK_SAT_TOK_in_command706  */
static	ANTLR3_BITWORD FOLLOW_CHECK_SAT_TOK_in_command706_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510002), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_CHECK_SAT_TOK_in_command706	= { FOLLOW_CHECK_SAT_TOK_in_command706_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_command722  */
static	ANTLR3_BITWORD FOLLOW_term_in_command722_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_command722	= { FOLLOW_term_in_command722_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CHECK_SAT_ASSUMING_TOK_in_command763  */
static	ANTLR3_BITWORD FOLLOW_CHECK_SAT_ASSUMING_TOK_in_command763_bits[]	= { ANTLR3_UINT64_LIT(0xFFFFFFFFFFFFFFF0), ANTLR3_UINT64_LIT(0xFFFFFFFFFFFFFFFF), ANTLR3_UINT64_LIT(0x0000001FFFFFFFFF) };
static  ANTLR3_BITSET_LIST FOLLOW_CHECK_SAT_ASSUMING_TOK_in_command763	= { FOLLOW_CHECK_SAT_ASSUMING_TOK_in_command763_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_command773  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_command773_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_command773	= { FOLLOW_LPAREN_TOK_in_command773_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_command775  */
static	ANTLR3_BITWORD FOLLOW_termList_in_command775_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_command775	= { FOLLOW_termList_in_command775_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_command778  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_command778_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_command778	= { FOLLOW_RPAREN_TOK_in_command778_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_set_in_command794  */
static	ANTLR3_BITWORD FOLLOW_set_in_command794_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_set_in_command794	= { FOLLOW_set_in_command794_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_ASSERTIONS_TOK_in_command821  */
static	ANTLR3_BITWORD FOLLOW_GET_ASSERTIONS_TOK_in_command821_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_ASSERTIONS_TOK_in_command821	= { FOLLOW_GET_ASSERTIONS_TOK_in_command821_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_PROOF_TOK_in_command841  */
static	ANTLR3_BITWORD FOLLOW_GET_PROOF_TOK_in_command841_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_PROOF_TOK_in_command841	= { FOLLOW_GET_PROOF_TOK_in_command841_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_UNSAT_ASSUMPTIONS_TOK_in_command861  */
static	ANTLR3_BITWORD FOLLOW_GET_UNSAT_ASSUMPTIONS_TOK_in_command861_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_UNSAT_ASSUMPTIONS_TOK_in_command861	= { FOLLOW_GET_UNSAT_ASSUMPTIONS_TOK_in_command861_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_UNSAT_CORE_TOK_in_command881  */
static	ANTLR3_BITWORD FOLLOW_GET_UNSAT_CORE_TOK_in_command881_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_UNSAT_CORE_TOK_in_command881	= { FOLLOW_GET_UNSAT_CORE_TOK_in_command881_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_PUSH_TOK_in_command901  */
static	ANTLR3_BITWORD FOLLOW_PUSH_TOK_in_command901_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_PUSH_TOK_in_command901	= { FOLLOW_PUSH_TOK_in_command901_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_command919  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_command919_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_command919	= { FOLLOW_INTEGER_LITERAL_in_command919_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_POP_TOK_in_command943  */
static	ANTLR3_BITWORD FOLLOW_POP_TOK_in_command943_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_POP_TOK_in_command943	= { FOLLOW_POP_TOK_in_command943_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_command961  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_command961_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_command961	= { FOLLOW_INTEGER_LITERAL_in_command961_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EXIT_TOK_in_command995  */
static	ANTLR3_BITWORD FOLLOW_EXIT_TOK_in_command995_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EXIT_TOK_in_command995	= { FOLLOW_EXIT_TOK_in_command995_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_smt25Command_in_command1014  */
static	ANTLR3_BITWORD FOLLOW_smt25Command_in_command1014_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_smt25Command_in_command1014	= { FOLLOW_smt25Command_in_command1014_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_extendedCommand_in_command1034  */
static	ANTLR3_BITWORD FOLLOW_extendedCommand_in_command1034_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_extendedCommand_in_command1034	= { FOLLOW_extendedCommand_in_command1034_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SIMPLE_SYMBOL_in_command1054  */
static	ANTLR3_BITWORD FOLLOW_SIMPLE_SYMBOL_in_command1054_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_SIMPLE_SYMBOL_in_command1054	= { FOLLOW_SIMPLE_SYMBOL_in_command1054_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_VAR_TOK_in_sygusCommand1086  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_VAR_TOK_in_sygusCommand1086_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_VAR_TOK_in_sygusCommand1086	= { FOLLOW_DECLARE_VAR_TOK_in_sygusCommand1086_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusCommand1094  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusCommand1094_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusCommand1094	= { FOLLOW_symbol_in_sygusCommand1094_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusCommand1107  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusCommand1107_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusCommand1107	= { FOLLOW_sortSymbol_in_sygusCommand1107_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_PRIMED_VAR_TOK_in_sygusCommand1126  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_PRIMED_VAR_TOK_in_sygusCommand1126_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_PRIMED_VAR_TOK_in_sygusCommand1126	= { FOLLOW_DECLARE_PRIMED_VAR_TOK_in_sygusCommand1126_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusCommand1134  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusCommand1134_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusCommand1134	= { FOLLOW_symbol_in_sygusCommand1134_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusCommand1147  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusCommand1147_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusCommand1147	= { FOLLOW_sortSymbol_in_sygusCommand1147_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYNTH_FUN_TOK_in_sygusCommand1169  */
static	ANTLR3_BITWORD FOLLOW_SYNTH_FUN_TOK_in_sygusCommand1169_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYNTH_FUN_TOK_in_sygusCommand1169	= { FOLLOW_SYNTH_FUN_TOK_in_sygusCommand1169_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYNTH_INV_TOK_in_sygusCommand1181  */
static	ANTLR3_BITWORD FOLLOW_SYNTH_INV_TOK_in_sygusCommand1181_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYNTH_INV_TOK_in_sygusCommand1181	= { FOLLOW_SYNTH_INV_TOK_in_sygusCommand1181_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusCommand1201  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusCommand1201_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusCommand1201	= { FOLLOW_symbol_in_sygusCommand1201_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusCommand1208  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusCommand1208_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusCommand1208	= { FOLLOW_LPAREN_TOK_in_sygusCommand1208_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_sygusCommand1210  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_sygusCommand1210_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_sygusCommand1210	= { FOLLOW_sortedVarList_in_sygusCommand1210_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusCommand1213  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusCommand1213_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500002), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusCommand1213	= { FOLLOW_RPAREN_TOK_in_sygusCommand1213_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusCommand1221  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusCommand1221_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusCommand1221	= { FOLLOW_sortSymbol_in_sygusCommand1221_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sygusGrammar_in_sygusCommand1273  */
static	ANTLR3_BITWORD FOLLOW_sygusGrammar_in_sygusCommand1273_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sygusGrammar_in_sygusCommand1273	= { FOLLOW_sygusGrammar_in_sygusCommand1273_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CONSTRAINT_TOK_in_sygusCommand1299  */
static	ANTLR3_BITWORD FOLLOW_CONSTRAINT_TOK_in_sygusCommand1299_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_CONSTRAINT_TOK_in_sygusCommand1299	= { FOLLOW_CONSTRAINT_TOK_in_sygusCommand1299_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_sygusCommand1307  */
static	ANTLR3_BITWORD FOLLOW_term_in_sygusCommand1307_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_sygusCommand1307	= { FOLLOW_term_in_sygusCommand1307_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INV_CONSTRAINT_TOK_in_sygusCommand1320  */
static	ANTLR3_BITWORD FOLLOW_INV_CONSTRAINT_TOK_in_sygusCommand1320_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_INV_CONSTRAINT_TOK_in_sygusCommand1320	= { FOLLOW_INV_CONSTRAINT_TOK_in_sygusCommand1320_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusCommand1330  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusCommand1330_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500002), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusCommand1330	= { FOLLOW_symbol_in_sygusCommand1330_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CHECK_SYNTH_TOK_in_sygusCommand1354  */
static	ANTLR3_BITWORD FOLLOW_CHECK_SYNTH_TOK_in_sygusCommand1354_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_CHECK_SYNTH_TOK_in_sygusCommand1354	= { FOLLOW_CHECK_SYNTH_TOK_in_sygusCommand1354_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_command_in_sygusCommand1372  */
static	ANTLR3_BITWORD FOLLOW_command_in_sygusCommand1372_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_command_in_sygusCommand1372	= { FOLLOW_command_in_sygusCommand1372_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGrammar1394  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGrammar1394_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGrammar1394	= { FOLLOW_LPAREN_TOK_in_sygusGrammar1394_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGrammar1401  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGrammar1401_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGrammar1401	= { FOLLOW_LPAREN_TOK_in_sygusGrammar1401_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusGrammar1410  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusGrammar1410_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusGrammar1410	= { FOLLOW_symbol_in_sygusGrammar1410_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGrammar1413  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGrammar1413_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGrammar1413	= { FOLLOW_sortSymbol_in_sygusGrammar1413_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGrammar1429  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGrammar1429_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGrammar1429	= { FOLLOW_LPAREN_TOK_in_sygusGrammar1429_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sygusGTerm_in_sygusGrammar1431  */
static	ANTLR3_BITWORD FOLLOW_sygusGTerm_in_sygusGrammar1431_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sygusGTerm_in_sygusGrammar1431	= { FOLLOW_sygusGTerm_in_sygusGrammar1431_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGrammar1442  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGrammar1442_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGrammar1442	= { FOLLOW_RPAREN_TOK_in_sygusGrammar1442_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGrammar1446  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGrammar1446_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGrammar1446	= { FOLLOW_RPAREN_TOK_in_sygusGrammar1446_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGrammar1457  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGrammar1457_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGrammar1457	= { FOLLOW_RPAREN_TOK_in_sygusGrammar1457_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGTerm1484  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGTerm1484_bits[]	= { ANTLR3_UINT64_LIT(0x0646809000520040), ANTLR3_UINT64_LIT(0x22A86C90C0000000), ANTLR3_UINT64_LIT(0x000000012867D500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGTerm1484	= { FOLLOW_LPAREN_TOK_in_sygusGTerm1484_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_builtinOp_in_sygusGTerm1497  */
static	ANTLR3_BITWORD FOLLOW_builtinOp_in_sygusGTerm1497_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_builtinOp_in_sygusGTerm1497	= { FOLLOW_builtinOp_in_sygusGTerm1497_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_LET_TOK_in_sygusGTerm1508  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_LET_TOK_in_sygusGTerm1508_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_LET_TOK_in_sygusGTerm1508	= { FOLLOW_SYGUS_LET_TOK_in_sygusGTerm1508_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGTerm1510  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGTerm1510_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGTerm1510	= { FOLLOW_LPAREN_TOK_in_sygusGTerm1510_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sygusGTerm1523  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sygusGTerm1523_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sygusGTerm1523	= { FOLLOW_LPAREN_TOK_in_sygusGTerm1523_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusGTerm1534  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusGTerm1534_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusGTerm1534	= { FOLLOW_symbol_in_sygusGTerm1534_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGTerm1546  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGTerm1546_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGTerm1546	= { FOLLOW_sortSymbol_in_sygusGTerm1546_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sygusGTerm_in_sygusGTerm1560  */
static	ANTLR3_BITWORD FOLLOW_sygusGTerm_in_sygusGTerm1560_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sygusGTerm_in_sygusGTerm1560	= { FOLLOW_sygusGTerm_in_sygusGTerm1560_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGTerm1571  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGTerm1571_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGTerm1571	= { FOLLOW_RPAREN_TOK_in_sygusGTerm1571_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGTerm1576  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGTerm1576_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGTerm1576	= { FOLLOW_RPAREN_TOK_in_sygusGTerm1576_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_CONSTANT_TOK_in_sygusGTerm1584  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_CONSTANT_TOK_in_sygusGTerm1584_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_CONSTANT_TOK_in_sygusGTerm1584	= { FOLLOW_SYGUS_CONSTANT_TOK_in_sygusGTerm1584_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGTerm1586  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGTerm1586_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGTerm1586	= { FOLLOW_sortSymbol_in_sygusGTerm1586_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_VARIABLE_TOK_in_sygusGTerm1604  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_VARIABLE_TOK_in_sygusGTerm1604_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_VARIABLE_TOK_in_sygusGTerm1604	= { FOLLOW_SYGUS_VARIABLE_TOK_in_sygusGTerm1604_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGTerm1606  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGTerm1606_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGTerm1606	= { FOLLOW_sortSymbol_in_sygusGTerm1606_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_LOCAL_VARIABLE_TOK_in_sygusGTerm1623  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_LOCAL_VARIABLE_TOK_in_sygusGTerm1623_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_LOCAL_VARIABLE_TOK_in_sygusGTerm1623	= { FOLLOW_SYGUS_LOCAL_VARIABLE_TOK_in_sygusGTerm1623_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGTerm1625  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGTerm1625_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGTerm1625	= { FOLLOW_sortSymbol_in_sygusGTerm1625_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_INPUT_VARIABLE_TOK_in_sygusGTerm1642  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_INPUT_VARIABLE_TOK_in_sygusGTerm1642_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_INPUT_VARIABLE_TOK_in_sygusGTerm1642	= { FOLLOW_SYGUS_INPUT_VARIABLE_TOK_in_sygusGTerm1642_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sygusGTerm1644  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sygusGTerm1644_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sygusGTerm1644	= { FOLLOW_sortSymbol_in_sygusGTerm1644_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusGTerm1661  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusGTerm1661_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusGTerm1661	= { FOLLOW_symbol_in_sygusGTerm1661_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sygusGTerm_in_sygusGTerm1689  */
static	ANTLR3_BITWORD FOLLOW_sygusGTerm_in_sygusGTerm1689_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_sygusGTerm_in_sygusGTerm1689	= { FOLLOW_sygusGTerm_in_sygusGTerm1689_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sygusGTerm1712  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sygusGTerm1712_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sygusGTerm1712	= { FOLLOW_RPAREN_TOK_in_sygusGTerm1712_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termAtomic_in_sygusGTerm1722  */
static	ANTLR3_BITWORD FOLLOW_termAtomic_in_sygusGTerm1722_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_termAtomic_in_sygusGTerm1722	= { FOLLOW_termAtomic_in_sygusGTerm1722_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sygusGTerm1737  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sygusGTerm1737_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sygusGTerm1737	= { FOLLOW_symbol_in_sygusGTerm1737_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_metaInfoInternal1764  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_metaInfoInternal1764_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C0), ANTLR3_UINT64_LIT(0x3EA97E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FDD) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_metaInfoInternal1764	= { FOLLOW_KEYWORD_in_metaInfoInternal1764_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbolicExpr_in_metaInfoInternal1766  */
static	ANTLR3_BITWORD FOLLOW_symbolicExpr_in_metaInfoInternal1766_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbolicExpr_in_metaInfoInternal1766	= { FOLLOW_symbolicExpr_in_metaInfoInternal1766_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_keyword_in_setOptionInternal1792  */
static	ANTLR3_BITWORD FOLLOW_keyword_in_setOptionInternal1792_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C0), ANTLR3_UINT64_LIT(0x3EA97E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FDD) };
static  ANTLR3_BITSET_LIST FOLLOW_keyword_in_setOptionInternal1792	= { FOLLOW_keyword_in_setOptionInternal1792_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbolicExpr_in_setOptionInternal1795  */
static	ANTLR3_BITWORD FOLLOW_symbolicExpr_in_setOptionInternal1795_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbolicExpr_in_setOptionInternal1795	= { FOLLOW_symbolicExpr_in_setOptionInternal1795_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_META_INFO_TOK_in_smt25Command1827  */
static	ANTLR3_BITWORD FOLLOW_META_INFO_TOK_in_smt25Command1827_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_META_INFO_TOK_in_smt25Command1827	= { FOLLOW_META_INFO_TOK_in_smt25Command1827_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_metaInfoInternal_in_smt25Command1829  */
static	ANTLR3_BITWORD FOLLOW_metaInfoInternal_in_smt25Command1829_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_metaInfoInternal_in_smt25Command1829	= { FOLLOW_metaInfoInternal_in_smt25Command1829_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_CONST_TOK_in_smt25Command1843  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_CONST_TOK_in_smt25Command1843_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_CONST_TOK_in_smt25Command1843	= { FOLLOW_DECLARE_CONST_TOK_in_smt25Command1843_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_smt25Command1851  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_smt25Command1851_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_smt25Command1851	= { FOLLOW_symbol_in_smt25Command1851_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_smt25Command1864  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_smt25Command1864_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_smt25Command1864	= { FOLLOW_sortSymbol_in_smt25Command1864_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_MODEL_TOK_in_smt25Command1884  */
static	ANTLR3_BITWORD FOLLOW_GET_MODEL_TOK_in_smt25Command1884_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_MODEL_TOK_in_smt25Command1884	= { FOLLOW_GET_MODEL_TOK_in_smt25Command1884_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ECHO_TOK_in_smt25Command1905  */
static	ANTLR3_BITWORD FOLLOW_ECHO_TOK_in_smt25Command1905_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C2), ANTLR3_UINT64_LIT(0x3EA87E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FDD) };
static  ANTLR3_BITSET_LIST FOLLOW_ECHO_TOK_in_smt25Command1905	= { FOLLOW_ECHO_TOK_in_smt25Command1905_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_simpleSymbolicExpr_in_smt25Command1913  */
static	ANTLR3_BITWORD FOLLOW_simpleSymbolicExpr_in_smt25Command1913_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_simpleSymbolicExpr_in_smt25Command1913	= { FOLLOW_simpleSymbolicExpr_in_smt25Command1913_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RESET_TOK_in_smt25Command1949  */
static	ANTLR3_BITWORD FOLLOW_RESET_TOK_in_smt25Command1949_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RESET_TOK_in_smt25Command1949	= { FOLLOW_RESET_TOK_in_smt25Command1949_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RESET_ASSERTIONS_TOK_in_smt25Command1967  */
static	ANTLR3_BITWORD FOLLOW_RESET_ASSERTIONS_TOK_in_smt25Command1967_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RESET_ASSERTIONS_TOK_in_smt25Command1967	= { FOLLOW_RESET_ASSERTIONS_TOK_in_smt25Command1967_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_FUN_REC_TOK_in_smt25Command1979  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_FUN_REC_TOK_in_smt25Command1979_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_FUN_REC_TOK_in_smt25Command1979	= { FOLLOW_DEFINE_FUN_REC_TOK_in_smt25Command1979_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_smt25Command1991  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_smt25Command1991_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_smt25Command1991	= { FOLLOW_symbol_in_smt25Command1991_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_smt25Command2004  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_smt25Command2004_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_smt25Command2004	= { FOLLOW_LPAREN_TOK_in_smt25Command2004_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_smt25Command2006  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_smt25Command2006_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_smt25Command2006	= { FOLLOW_sortedVarList_in_smt25Command2006_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_smt25Command2009  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_smt25Command2009_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_smt25Command2009	= { FOLLOW_RPAREN_TOK_in_smt25Command2009_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_smt25Command2015  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_smt25Command2015_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_smt25Command2015	= { FOLLOW_sortSymbol_in_smt25Command2015_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_smt25Command2028  */
static	ANTLR3_BITWORD FOLLOW_term_in_smt25Command2028_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_smt25Command2028	= { FOLLOW_term_in_smt25Command2028_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_FUNS_REC_TOK_in_smt25Command2041  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_FUNS_REC_TOK_in_smt25Command2041_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_FUNS_REC_TOK_in_smt25Command2041	= { FOLLOW_DEFINE_FUNS_REC_TOK_in_smt25Command2041_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_smt25Command2053  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_smt25Command2053_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_smt25Command2053	= { FOLLOW_LPAREN_TOK_in_smt25Command2053_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_smt25Command2061  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_smt25Command2061_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_smt25Command2061	= { FOLLOW_LPAREN_TOK_in_smt25Command2061_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_smt25Command2069  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_smt25Command2069_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_smt25Command2069	= { FOLLOW_symbol_in_smt25Command2069_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_smt25Command2086  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_smt25Command2086_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_smt25Command2086	= { FOLLOW_LPAREN_TOK_in_smt25Command2086_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_smt25Command2088  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_smt25Command2088_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_smt25Command2088	= { FOLLOW_sortedVarList_in_smt25Command2088_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_smt25Command2091  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_smt25Command2091_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_smt25Command2091	= { FOLLOW_RPAREN_TOK_in_smt25Command2091_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_smt25Command2099  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_smt25Command2099_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_smt25Command2099	= { FOLLOW_sortSymbol_in_smt25Command2099_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_smt25Command2116  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_smt25Command2116_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_smt25Command2116	= { FOLLOW_RPAREN_TOK_in_smt25Command2116_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_smt25Command2129  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_smt25Command2129_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_smt25Command2129	= { FOLLOW_RPAREN_TOK_in_smt25Command2129_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_smt25Command2135  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_smt25Command2135_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_smt25Command2135	= { FOLLOW_LPAREN_TOK_in_smt25Command2135_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_smt25Command2153  */
static	ANTLR3_BITWORD FOLLOW_term_in_smt25Command2153_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_smt25Command2153	= { FOLLOW_term_in_smt25Command2153_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_smt25Command2173  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_smt25Command2173_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_smt25Command2173	= { FOLLOW_RPAREN_TOK_in_smt25Command2173_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_DATATYPES_2_5_TOK_in_extendedCommand2204  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_DATATYPES_2_5_TOK_in_extendedCommand2204_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_DATATYPES_2_5_TOK_in_extendedCommand2204	= { FOLLOW_DECLARE_DATATYPES_2_5_TOK_in_extendedCommand2204_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2206  */
static	ANTLR3_BITWORD FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2206_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2206	= { FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2206_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_CODATATYPES_2_5_TOK_in_extendedCommand2213  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_CODATATYPES_2_5_TOK_in_extendedCommand2213_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_CODATATYPES_2_5_TOK_in_extendedCommand2213	= { FOLLOW_DECLARE_CODATATYPES_2_5_TOK_in_extendedCommand2213_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2215  */
static	ANTLR3_BITWORD FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2215_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2215	= { FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2215_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_CODATATYPE_TOK_in_extendedCommand2222  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_CODATATYPE_TOK_in_extendedCommand2222_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_CODATATYPE_TOK_in_extendedCommand2222	= { FOLLOW_DECLARE_CODATATYPE_TOK_in_extendedCommand2222_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypeDefCommand_in_extendedCommand2224  */
static	ANTLR3_BITWORD FOLLOW_datatypeDefCommand_in_extendedCommand2224_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypeDefCommand_in_extendedCommand2224	= { FOLLOW_datatypeDefCommand_in_extendedCommand2224_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_CODATATYPES_TOK_in_extendedCommand2231  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_CODATATYPES_TOK_in_extendedCommand2231_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_CODATATYPES_TOK_in_extendedCommand2231	= { FOLLOW_DECLARE_CODATATYPES_TOK_in_extendedCommand2231_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypesDefCommand_in_extendedCommand2233  */
static	ANTLR3_BITWORD FOLLOW_datatypesDefCommand_in_extendedCommand2233_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypesDefCommand_in_extendedCommand2233	= { FOLLOW_datatypesDefCommand_in_extendedCommand2233_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_rewriterulesCommand_in_extendedCommand2240  */
static	ANTLR3_BITWORD FOLLOW_rewriterulesCommand_in_extendedCommand2240_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_rewriterulesCommand_in_extendedCommand2240	= { FOLLOW_rewriterulesCommand_in_extendedCommand2240_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_SORTS_TOK_in_extendedCommand2255  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_SORTS_TOK_in_extendedCommand2255_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_SORTS_TOK_in_extendedCommand2255	= { FOLLOW_DECLARE_SORTS_TOK_in_extendedCommand2255_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2275  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2275_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2275	= { FOLLOW_LPAREN_TOK_in_extendedCommand2275_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2283  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2283_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2283	= { FOLLOW_symbol_in_extendedCommand2283_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2305  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2305_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2305	= { FOLLOW_RPAREN_TOK_in_extendedCommand2305_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_FUNS_TOK_in_extendedCommand2318  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_FUNS_TOK_in_extendedCommand2318_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_FUNS_TOK_in_extendedCommand2318	= { FOLLOW_DECLARE_FUNS_TOK_in_extendedCommand2318_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2332  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2332_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2332	= { FOLLOW_LPAREN_TOK_in_extendedCommand2332_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2340  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2340_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2340	= { FOLLOW_LPAREN_TOK_in_extendedCommand2340_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2342  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2342_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2342	= { FOLLOW_symbol_in_extendedCommand2342_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_nonemptySortList_in_extendedCommand2359  */
static	ANTLR3_BITWORD FOLLOW_nonemptySortList_in_extendedCommand2359_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_nonemptySortList_in_extendedCommand2359	= { FOLLOW_nonemptySortList_in_extendedCommand2359_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2362  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2362_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2362	= { FOLLOW_RPAREN_TOK_in_extendedCommand2362_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2383  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2383_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2383	= { FOLLOW_RPAREN_TOK_in_extendedCommand2383_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_PREDS_TOK_in_extendedCommand2396  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_PREDS_TOK_in_extendedCommand2396_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_PREDS_TOK_in_extendedCommand2396	= { FOLLOW_DECLARE_PREDS_TOK_in_extendedCommand2396_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2410  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2410_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2410	= { FOLLOW_LPAREN_TOK_in_extendedCommand2410_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2418  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2418_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2418	= { FOLLOW_LPAREN_TOK_in_extendedCommand2418_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2420  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2420_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2420	= { FOLLOW_symbol_in_extendedCommand2420_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortList_in_extendedCommand2437  */
static	ANTLR3_BITWORD FOLLOW_sortList_in_extendedCommand2437_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortList_in_extendedCommand2437	= { FOLLOW_sortList_in_extendedCommand2437_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2440  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2440_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2440	= { FOLLOW_RPAREN_TOK_in_extendedCommand2440_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2461  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2461_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2461	= { FOLLOW_RPAREN_TOK_in_extendedCommand2461_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_TOK_in_extendedCommand2474  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_TOK_in_extendedCommand2474_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_TOK_in_extendedCommand2474	= { FOLLOW_DEFINE_TOK_in_extendedCommand2474_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2484  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2484_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2484	= { FOLLOW_symbol_in_extendedCommand2484_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2501  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2501_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2501	= { FOLLOW_term_in_extendedCommand2501_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2518  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2518_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2518	= { FOLLOW_LPAREN_TOK_in_extendedCommand2518_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2526  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2526_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2526	= { FOLLOW_symbol_in_extendedCommand2526_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_extendedCommand2543  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_extendedCommand2543_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_extendedCommand2543	= { FOLLOW_sortedVarList_in_extendedCommand2543_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2546  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2546_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2546	= { FOLLOW_RPAREN_TOK_in_extendedCommand2546_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2562  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2562_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2562	= { FOLLOW_term_in_extendedCommand2562_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DEFINE_CONST_TOK_in_extendedCommand2583  */
static	ANTLR3_BITWORD FOLLOW_DEFINE_CONST_TOK_in_extendedCommand2583_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_DEFINE_CONST_TOK_in_extendedCommand2583	= { FOLLOW_DEFINE_CONST_TOK_in_extendedCommand2583_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_extendedCommand2591  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_extendedCommand2591_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_extendedCommand2591	= { FOLLOW_symbol_in_extendedCommand2591_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_extendedCommand2604  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_extendedCommand2604_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_extendedCommand2604	= { FOLLOW_sortSymbol_in_extendedCommand2604_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2617  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2617_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2617	= { FOLLOW_term_in_extendedCommand2617_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SIMPLIFY_TOK_in_extendedCommand2631  */
static	ANTLR3_BITWORD FOLLOW_SIMPLIFY_TOK_in_extendedCommand2631_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_SIMPLIFY_TOK_in_extendedCommand2631	= { FOLLOW_SIMPLIFY_TOK_in_extendedCommand2631_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2639  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2639_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2639	= { FOLLOW_term_in_extendedCommand2639_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_QE_TOK_in_extendedCommand2652  */
static	ANTLR3_BITWORD FOLLOW_GET_QE_TOK_in_extendedCommand2652_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_QE_TOK_in_extendedCommand2652	= { FOLLOW_GET_QE_TOK_in_extendedCommand2652_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2660  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2660_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2660	= { FOLLOW_term_in_extendedCommand2660_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GET_QE_DISJUNCT_TOK_in_extendedCommand2673  */
static	ANTLR3_BITWORD FOLLOW_GET_QE_DISJUNCT_TOK_in_extendedCommand2673_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_GET_QE_DISJUNCT_TOK_in_extendedCommand2673	= { FOLLOW_GET_QE_DISJUNCT_TOK_in_extendedCommand2673_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_extendedCommand2681  */
static	ANTLR3_BITWORD FOLLOW_term_in_extendedCommand2681_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_extendedCommand2681	= { FOLLOW_term_in_extendedCommand2681_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_HEAP_in_extendedCommand2694  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_HEAP_in_extendedCommand2694_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_HEAP_in_extendedCommand2694	= { FOLLOW_DECLARE_HEAP_in_extendedCommand2694_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_extendedCommand2696  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_extendedCommand2696_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_extendedCommand2696	= { FOLLOW_LPAREN_TOK_in_extendedCommand2696_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_extendedCommand2703  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_extendedCommand2703_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_extendedCommand2703	= { FOLLOW_sortSymbol_in_extendedCommand2703_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_extendedCommand2711  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_extendedCommand2711_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_extendedCommand2711	= { FOLLOW_sortSymbol_in_extendedCommand2711_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_extendedCommand2729  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_extendedCommand2729_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_extendedCommand2729	= { FOLLOW_RPAREN_TOK_in_extendedCommand2729_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2753  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2753_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2753	= { FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2753_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_datatypes_2_5_DefCommand2761  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_datatypes_2_5_DefCommand2761_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_datatypes_2_5_DefCommand2761	= { FOLLOW_symbol_in_datatypes_2_5_DefCommand2761_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2777  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2777_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2777	= { FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2777_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2781  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2781_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2781	= { FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2781_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2785  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2785_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2785	= { FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2785_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypeDef_in_datatypes_2_5_DefCommand2787  */
static	ANTLR3_BITWORD FOLLOW_datatypeDef_in_datatypes_2_5_DefCommand2787_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypeDef_in_datatypes_2_5_DefCommand2787	= { FOLLOW_datatypeDef_in_datatypes_2_5_DefCommand2787_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2790  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2790_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2790	= { FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2790_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2795  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2795_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2795	= { FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2795_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_datatypeDefCommand2824  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_datatypeDefCommand2824_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_datatypeDefCommand2824	= { FOLLOW_symbol_in_datatypeDefCommand2824_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypesDef_in_datatypeDefCommand2831  */
static	ANTLR3_BITWORD FOLLOW_datatypesDef_in_datatypeDefCommand2831_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypesDef_in_datatypeDefCommand2831	= { FOLLOW_datatypesDef_in_datatypeDefCommand2831_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDefCommand2856  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDefCommand2856_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDefCommand2856	= { FOLLOW_LPAREN_TOK_in_datatypesDefCommand2856_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDefCommand2864  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDefCommand2864_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDefCommand2864	= { FOLLOW_LPAREN_TOK_in_datatypesDefCommand2864_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_datatypesDefCommand2866  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_datatypesDefCommand2866_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_datatypesDefCommand2866	= { FOLLOW_symbol_in_datatypesDefCommand2866_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_datatypesDefCommand2871  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_datatypesDefCommand2871_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_datatypesDefCommand2871	= { FOLLOW_INTEGER_LITERAL_in_datatypesDefCommand2871_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDefCommand2873  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDefCommand2873_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDefCommand2873	= { FOLLOW_RPAREN_TOK_in_datatypesDefCommand2873_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDefCommand2888  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDefCommand2888_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDefCommand2888	= { FOLLOW_RPAREN_TOK_in_datatypesDefCommand2888_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDefCommand2893  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDefCommand2893_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDefCommand2893	= { FOLLOW_LPAREN_TOK_in_datatypesDefCommand2893_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_datatypesDef_in_datatypesDefCommand2898  */
static	ANTLR3_BITWORD FOLLOW_datatypesDef_in_datatypesDefCommand2898_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_datatypesDef_in_datatypesDefCommand2898	= { FOLLOW_datatypesDef_in_datatypesDefCommand2898_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDefCommand2903  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDefCommand2903_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDefCommand2903	= { FOLLOW_RPAREN_TOK_in_datatypesDefCommand2903_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDef2932  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDef2932_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0101000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDef2932	= { FOLLOW_LPAREN_TOK_in_datatypesDef2932_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_PAR_TOK_in_datatypesDef2942  */
static	ANTLR3_BITWORD FOLLOW_PAR_TOK_in_datatypesDef2942_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_PAR_TOK_in_datatypesDef2942	= { FOLLOW_PAR_TOK_in_datatypesDef2942_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDef2946  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDef2946_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDef2946	= { FOLLOW_LPAREN_TOK_in_datatypesDef2946_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_datatypesDef2956  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_datatypesDef2956_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_datatypesDef2956	= { FOLLOW_symbol_in_datatypesDef2956_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDef2984  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDef2984_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDef2984	= { FOLLOW_RPAREN_TOK_in_datatypesDef2984_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDef2994  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDef2994_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDef2994	= { FOLLOW_LPAREN_TOK_in_datatypesDef2994_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDef3004  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDef3004_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDef3004	= { FOLLOW_LPAREN_TOK_in_datatypesDef3004_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_constructorDef_in_datatypesDef3006  */
static	ANTLR3_BITWORD FOLLOW_constructorDef_in_datatypesDef3006_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_constructorDef_in_datatypesDef3006	= { FOLLOW_constructorDef_in_datatypesDef3006_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDef3009  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDef3009_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDef3009	= { FOLLOW_RPAREN_TOK_in_datatypesDef3009_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDef3020  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDef3020_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDef3020	= { FOLLOW_RPAREN_TOK_in_datatypesDef3020_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypesDef3041  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypesDef3041_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypesDef3041	= { FOLLOW_LPAREN_TOK_in_datatypesDef3041_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_constructorDef_in_datatypesDef3043  */
static	ANTLR3_BITWORD FOLLOW_constructorDef_in_datatypesDef3043_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_constructorDef_in_datatypesDef3043	= { FOLLOW_constructorDef_in_datatypesDef3043_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDef3046  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDef3046_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDef3046	= { FOLLOW_RPAREN_TOK_in_datatypesDef3046_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypesDef3061  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypesDef3061_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypesDef3061	= { FOLLOW_RPAREN_TOK_in_datatypesDef3061_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_REWRITE_RULE_TOK_in_rewriterulesCommand3097  */
static	ANTLR3_BITWORD FOLLOW_REWRITE_RULE_TOK_in_rewriterulesCommand3097_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_REWRITE_RULE_TOK_in_rewriterulesCommand3097	= { FOLLOW_REWRITE_RULE_TOK_in_rewriterulesCommand3097_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3103  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3103_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3103	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3103_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_rewriterulesCommand3105  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_rewriterulesCommand3105_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_rewriterulesCommand3105	= { FOLLOW_sortedVarList_in_rewriterulesCommand3105_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3108  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3108_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3108	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3108_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3120  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3120_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3120	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3120_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_pattern_in_rewriterulesCommand3124  */
static	ANTLR3_BITWORD FOLLOW_pattern_in_rewriterulesCommand3124_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_pattern_in_rewriterulesCommand3124	= { FOLLOW_pattern_in_rewriterulesCommand3124_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3132  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3132_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3132	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3132_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3138  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3138_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3138	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3138_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_rewriterulesCommand3141  */
static	ANTLR3_BITWORD FOLLOW_termList_in_rewriterulesCommand3141_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_rewriterulesCommand3141	= { FOLLOW_termList_in_rewriterulesCommand3141_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3146  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3146_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3146	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3146_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_rewriterulesCommand3152  */
static	ANTLR3_BITWORD FOLLOW_term_in_rewriterulesCommand3152_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_rewriterulesCommand3152	= { FOLLOW_term_in_rewriterulesCommand3152_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_rewriterulesCommand3155  */
static	ANTLR3_BITWORD FOLLOW_term_in_rewriterulesCommand3155_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_rewriterulesCommand3155	= { FOLLOW_term_in_rewriterulesCommand3155_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_rewritePropaKind_in_rewriterulesCommand3174  */
static	ANTLR3_BITWORD FOLLOW_rewritePropaKind_in_rewriterulesCommand3174_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_rewritePropaKind_in_rewriterulesCommand3174	= { FOLLOW_rewritePropaKind_in_rewriterulesCommand3174_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3181  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3181_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3181	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3181_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_rewriterulesCommand3183  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_rewriterulesCommand3183_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_rewriterulesCommand3183	= { FOLLOW_sortedVarList_in_rewriterulesCommand3183_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3186  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3186_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3186	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3186_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3198  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3198_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3198	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3198_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_pattern_in_rewriterulesCommand3202  */
static	ANTLR3_BITWORD FOLLOW_pattern_in_rewriterulesCommand3202_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_pattern_in_rewriterulesCommand3202	= { FOLLOW_pattern_in_rewriterulesCommand3202_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3210  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3210_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3210	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3210_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3216  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3216_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3216	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3216_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_rewriterulesCommand3219  */
static	ANTLR3_BITWORD FOLLOW_termList_in_rewriterulesCommand3219_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_rewriterulesCommand3219	= { FOLLOW_termList_in_rewriterulesCommand3219_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3224  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3224_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3224	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3224_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_rewriterulesCommand3230  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_rewriterulesCommand3230_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_rewriterulesCommand3230	= { FOLLOW_LPAREN_TOK_in_rewriterulesCommand3230_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_rewriterulesCommand3233  */
static	ANTLR3_BITWORD FOLLOW_termList_in_rewriterulesCommand3233_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_rewriterulesCommand3233	= { FOLLOW_termList_in_rewriterulesCommand3233_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_rewriterulesCommand3238  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_rewriterulesCommand3238_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_rewriterulesCommand3238	= { FOLLOW_RPAREN_TOK_in_rewriterulesCommand3238_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_rewriterulesCommand3244  */
static	ANTLR3_BITWORD FOLLOW_term_in_rewriterulesCommand3244_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_rewriterulesCommand3244	= { FOLLOW_term_in_rewriterulesCommand3244_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_REDUCTION_RULE_TOK_in_rewritePropaKind3265  */
static	ANTLR3_BITWORD FOLLOW_REDUCTION_RULE_TOK_in_rewritePropaKind3265_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_REDUCTION_RULE_TOK_in_rewritePropaKind3265	= { FOLLOW_REDUCTION_RULE_TOK_in_rewritePropaKind3265_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_PROPAGATION_RULE_TOK_in_rewritePropaKind3276  */
static	ANTLR3_BITWORD FOLLOW_PROPAGATION_RULE_TOK_in_rewritePropaKind3276_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_PROPAGATION_RULE_TOK_in_rewritePropaKind3276	= { FOLLOW_PROPAGATION_RULE_TOK_in_rewritePropaKind3276_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_pattern3298  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_pattern3298_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_pattern3298	= { FOLLOW_LPAREN_TOK_in_pattern3298_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_pattern3300  */
static	ANTLR3_BITWORD FOLLOW_termList_in_pattern3300_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_pattern3300	= { FOLLOW_termList_in_pattern3300_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_pattern3303  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_pattern3303_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_pattern3303	= { FOLLOW_RPAREN_TOK_in_pattern3303_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_simpleSymbolicExprNoKeyword3328  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_simpleSymbolicExprNoKeyword3328_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_simpleSymbolicExprNoKeyword3328	= { FOLLOW_INTEGER_LITERAL_in_simpleSymbolicExprNoKeyword3328_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECIMAL_LITERAL_in_simpleSymbolicExprNoKeyword3340  */
static	ANTLR3_BITWORD FOLLOW_DECIMAL_LITERAL_in_simpleSymbolicExprNoKeyword3340_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DECIMAL_LITERAL_in_simpleSymbolicExprNoKeyword3340	= { FOLLOW_DECIMAL_LITERAL_in_simpleSymbolicExprNoKeyword3340_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_HEX_LITERAL_in_simpleSymbolicExprNoKeyword3352  */
static	ANTLR3_BITWORD FOLLOW_HEX_LITERAL_in_simpleSymbolicExprNoKeyword3352_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_HEX_LITERAL_in_simpleSymbolicExprNoKeyword3352	= { FOLLOW_HEX_LITERAL_in_simpleSymbolicExprNoKeyword3352_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_BINARY_LITERAL_in_simpleSymbolicExprNoKeyword3364  */
static	ANTLR3_BITWORD FOLLOW_BINARY_LITERAL_in_simpleSymbolicExprNoKeyword3364_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_BINARY_LITERAL_in_simpleSymbolicExprNoKeyword3364	= { FOLLOW_BINARY_LITERAL_in_simpleSymbolicExprNoKeyword3364_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_str_in_simpleSymbolicExprNoKeyword3376  */
static	ANTLR3_BITWORD FOLLOW_str_in_simpleSymbolicExprNoKeyword3376_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_str_in_simpleSymbolicExprNoKeyword3376	= { FOLLOW_str_in_simpleSymbolicExprNoKeyword3376_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_simpleSymbolicExprNoKeyword3396  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_simpleSymbolicExprNoKeyword3396_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_simpleSymbolicExprNoKeyword3396	= { FOLLOW_symbol_in_simpleSymbolicExprNoKeyword3396_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_set_in_simpleSymbolicExprNoKeyword3411  */
static	ANTLR3_BITWORD FOLLOW_set_in_simpleSymbolicExprNoKeyword3411_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_set_in_simpleSymbolicExprNoKeyword3411	= { FOLLOW_set_in_simpleSymbolicExprNoKeyword3411_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_builtinOp_in_simpleSymbolicExprNoKeyword3621  */
static	ANTLR3_BITWORD FOLLOW_builtinOp_in_simpleSymbolicExprNoKeyword3621_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_builtinOp_in_simpleSymbolicExprNoKeyword3621	= { FOLLOW_builtinOp_in_simpleSymbolicExprNoKeyword3621_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_keyword3642  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_keyword3642_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_keyword3642	= { FOLLOW_KEYWORD_in_keyword3642_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_simpleSymbolicExprNoKeyword_in_simpleSymbolicExpr3662  */
static	ANTLR3_BITWORD FOLLOW_simpleSymbolicExprNoKeyword_in_simpleSymbolicExpr3662_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_simpleSymbolicExprNoKeyword_in_simpleSymbolicExpr3662	= { FOLLOW_simpleSymbolicExprNoKeyword_in_simpleSymbolicExpr3662_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_simpleSymbolicExpr3669  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_simpleSymbolicExpr3669_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_simpleSymbolicExpr3669	= { FOLLOW_KEYWORD_in_simpleSymbolicExpr3669_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_simpleSymbolicExpr_in_symbolicExpr3694  */
static	ANTLR3_BITWORD FOLLOW_simpleSymbolicExpr_in_symbolicExpr3694_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_simpleSymbolicExpr_in_symbolicExpr3694	= { FOLLOW_simpleSymbolicExpr_in_symbolicExpr3694_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_symbolicExpr3701  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_symbolicExpr3701_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C0), ANTLR3_UINT64_LIT(0x3EA97E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FFD) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_symbolicExpr3701	= { FOLLOW_LPAREN_TOK_in_symbolicExpr3701_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbolicExpr_in_symbolicExpr3709  */
static	ANTLR3_BITWORD FOLLOW_symbolicExpr_in_symbolicExpr3709_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C0), ANTLR3_UINT64_LIT(0x3EA97E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FFD) };
static  ANTLR3_BITSET_LIST FOLLOW_symbolicExpr_in_symbolicExpr3709	= { FOLLOW_symbolicExpr_in_symbolicExpr3709_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_symbolicExpr3717  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_symbolicExpr3717_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_symbolicExpr3717	= { FOLLOW_RPAREN_TOK_in_symbolicExpr3717_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termNonVariable_in_term3742  */
static	ANTLR3_BITWORD FOLLOW_termNonVariable_in_term3742_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_termNonVariable_in_term3742	= { FOLLOW_termNonVariable_in_term3742_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_term3755  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_term3755_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_term3755	= { FOLLOW_symbol_in_term3755_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3789  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3789_bits[]	= { ANTLR3_UINT64_LIT(0x0646800000020040), ANTLR3_UINT64_LIT(0x02A86890C0000000), ANTLR3_UINT64_LIT(0x0000000020001000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3789	= { FOLLOW_LPAREN_TOK_in_termNonVariable3789_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_builtinOp_in_termNonVariable3791  */
static	ANTLR3_BITWORD FOLLOW_builtinOp_in_termNonVariable3791_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_builtinOp_in_termNonVariable3791	= { FOLLOW_builtinOp_in_termNonVariable3791_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_termNonVariable3794  */
static	ANTLR3_BITWORD FOLLOW_termList_in_termNonVariable3794_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_termNonVariable3794	= { FOLLOW_termList_in_termNonVariable3794_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3797  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3797_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3797	= { FOLLOW_RPAREN_TOK_in_termNonVariable3797_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3809  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3809_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000100) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3809	= { FOLLOW_LPAREN_TOK_in_termNonVariable3809_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_AS_TOK_in_termNonVariable3811  */
static	ANTLR3_BITWORD FOLLOW_AS_TOK_in_termNonVariable3811_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_AS_TOK_in_termNonVariable3811	= { FOLLOW_AS_TOK_in_termNonVariable3811_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termNonVariable_in_termNonVariable3815  */
static	ANTLR3_BITWORD FOLLOW_termNonVariable_in_termNonVariable3815_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_termNonVariable_in_termNonVariable3815	= { FOLLOW_termNonVariable_in_termNonVariable3815_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_termNonVariable3820  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_termNonVariable3820_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_termNonVariable3820	= { FOLLOW_symbol_in_termNonVariable3820_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_termNonVariable3832  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_termNonVariable3832_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_termNonVariable3832	= { FOLLOW_sortSymbol_in_termNonVariable3832_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3835  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3835_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3835	= { FOLLOW_RPAREN_TOK_in_termNonVariable3835_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3847  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3847_bits[]	= { ANTLR3_UINT64_LIT(0x0880000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3847	= { FOLLOW_LPAREN_TOK_in_termNonVariable3847_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_quantOp_in_termNonVariable3849  */
static	ANTLR3_BITWORD FOLLOW_quantOp_in_termNonVariable3849_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_quantOp_in_termNonVariable3849	= { FOLLOW_quantOp_in_termNonVariable3849_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3856  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3856_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3856	= { FOLLOW_LPAREN_TOK_in_termNonVariable3856_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_termNonVariable3858  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_termNonVariable3858_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_termNonVariable3858	= { FOLLOW_sortedVarList_in_termNonVariable3858_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3861  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3861_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3861	= { FOLLOW_RPAREN_TOK_in_termNonVariable3861_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable3873  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable3873_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable3873	= { FOLLOW_term_in_termNonVariable3873_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3876  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3876_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3876	= { FOLLOW_RPAREN_TOK_in_termNonVariable3876_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3888  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3888_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3888	= { FOLLOW_LPAREN_TOK_in_termNonVariable3888_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_functionName_in_termNonVariable3890  */
static	ANTLR3_BITWORD FOLLOW_functionName_in_termNonVariable3890_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_functionName_in_termNonVariable3890	= { FOLLOW_functionName_in_termNonVariable3890_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_termNonVariable3908  */
static	ANTLR3_BITWORD FOLLOW_termList_in_termNonVariable3908_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_termNonVariable3908	= { FOLLOW_termList_in_termNonVariable3908_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3911  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3911_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3911	= { FOLLOW_RPAREN_TOK_in_termNonVariable3911_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3923  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3923_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3923	= { FOLLOW_LPAREN_TOK_in_termNonVariable3923_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_indexedFunctionName_in_termNonVariable3939  */
static	ANTLR3_BITWORD FOLLOW_indexedFunctionName_in_termNonVariable3939_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_indexedFunctionName_in_termNonVariable3939	= { FOLLOW_indexedFunctionName_in_termNonVariable3939_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_termNonVariable3942  */
static	ANTLR3_BITWORD FOLLOW_termList_in_termNonVariable3942_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_termNonVariable3942	= { FOLLOW_termList_in_termNonVariable3942_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3945  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3945_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3945	= { FOLLOW_RPAREN_TOK_in_termNonVariable3945_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable3963  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable3963_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000100) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable3963	= { FOLLOW_LPAREN_TOK_in_termNonVariable3963_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_AS_TOK_in_termNonVariable3965  */
static	ANTLR3_BITWORD FOLLOW_AS_TOK_in_termNonVariable3965_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000800000) };
static  ANTLR3_BITSET_LIST FOLLOW_AS_TOK_in_termNonVariable3965	= { FOLLOW_AS_TOK_in_termNonVariable3965_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CONST_TOK_in_termNonVariable3967  */
static	ANTLR3_BITWORD FOLLOW_CONST_TOK_in_termNonVariable3967_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_CONST_TOK_in_termNonVariable3967	= { FOLLOW_CONST_TOK_in_termNonVariable3967_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_termNonVariable3969  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_termNonVariable3969_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_termNonVariable3969	= { FOLLOW_sortSymbol_in_termNonVariable3969_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3978  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3978_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3978	= { FOLLOW_RPAREN_TOK_in_termNonVariable3978_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable3980  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable3980_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable3980	= { FOLLOW_term_in_termNonVariable3980_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable3983  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable3983_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable3983	= { FOLLOW_RPAREN_TOK_in_termNonVariable3983_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4009  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4009_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000800000000000), ANTLR3_UINT64_LIT(0x0000000000010000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4009	= { FOLLOW_LPAREN_TOK_in_termNonVariable4009_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LET_TOK_in_termNonVariable4020  */
static	ANTLR3_BITWORD FOLLOW_LET_TOK_in_termNonVariable4020_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LET_TOK_in_termNonVariable4020	= { FOLLOW_LET_TOK_in_termNonVariable4020_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4022  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4022_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4022	= { FOLLOW_LPAREN_TOK_in_termNonVariable4022_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4040  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4040_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4040	= { FOLLOW_LPAREN_TOK_in_termNonVariable4040_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_termNonVariable4042  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_termNonVariable4042_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_termNonVariable4042	= { FOLLOW_symbol_in_termNonVariable4042_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4053  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4053_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4053	= { FOLLOW_term_in_termNonVariable4053_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4064  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4064_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4064	= { FOLLOW_RPAREN_TOK_in_termNonVariable4064_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYGUS_LET_TOK_in_termNonVariable4105  */
static	ANTLR3_BITWORD FOLLOW_SYGUS_LET_TOK_in_termNonVariable4105_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_SYGUS_LET_TOK_in_termNonVariable4105	= { FOLLOW_SYGUS_LET_TOK_in_termNonVariable4105_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4107  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4107_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4107	= { FOLLOW_LPAREN_TOK_in_termNonVariable4107_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4125  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4125_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4125	= { FOLLOW_LPAREN_TOK_in_termNonVariable4125_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_termNonVariable4127  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_termNonVariable4127_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_termNonVariable4127	= { FOLLOW_symbol_in_termNonVariable4127_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_termNonVariable4138  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_termNonVariable4138_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_termNonVariable4138	= { FOLLOW_sortSymbol_in_termNonVariable4138_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4149  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4149_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4149	= { FOLLOW_term_in_termNonVariable4149_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4160  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4160_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4160	= { FOLLOW_RPAREN_TOK_in_termNonVariable4160_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4205  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4205_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4205	= { FOLLOW_RPAREN_TOK_in_termNonVariable4205_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4211  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4211_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4211	= { FOLLOW_term_in_termNonVariable4211_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4218  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4218_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4218	= { FOLLOW_RPAREN_TOK_in_termNonVariable4218_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4236  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4236_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0002000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4236	= { FOLLOW_LPAREN_TOK_in_termNonVariable4236_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_MATCH_TOK_in_termNonVariable4238  */
static	ANTLR3_BITWORD FOLLOW_MATCH_TOK_in_termNonVariable4238_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_MATCH_TOK_in_termNonVariable4238	= { FOLLOW_MATCH_TOK_in_termNonVariable4238_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4240  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4240_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4240	= { FOLLOW_term_in_termNonVariable4240_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4249  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4249_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4249	= { FOLLOW_LPAREN_TOK_in_termNonVariable4249_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4273  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4273_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000004000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4273	= { FOLLOW_LPAREN_TOK_in_termNonVariable4273_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INDEX_TOK_in_termNonVariable4275  */
static	ANTLR3_BITWORD FOLLOW_INDEX_TOK_in_termNonVariable4275_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_INDEX_TOK_in_termNonVariable4275	= { FOLLOW_INDEX_TOK_in_termNonVariable4275_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4277  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4277_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4277	= { FOLLOW_term_in_termNonVariable4277_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4290  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4290_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4290	= { FOLLOW_RPAREN_TOK_in_termNonVariable4290_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4300  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4300_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4300	= { FOLLOW_LPAREN_TOK_in_termNonVariable4300_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4302  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4302_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4302	= { FOLLOW_LPAREN_TOK_in_termNonVariable4302_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4304  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4304_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4304	= { FOLLOW_term_in_termNonVariable4304_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_termNonVariable4330  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_termNonVariable4330_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_termNonVariable4330	= { FOLLOW_symbol_in_termNonVariable4330_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4356  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4356_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4356	= { FOLLOW_RPAREN_TOK_in_termNonVariable4356_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4367  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4367_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4367	= { FOLLOW_term_in_termNonVariable4367_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4381  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4381_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4381	= { FOLLOW_RPAREN_TOK_in_termNonVariable4381_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4404  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4404_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4404	= { FOLLOW_LPAREN_TOK_in_termNonVariable4404_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_termNonVariable4406  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_termNonVariable4406_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_termNonVariable4406	= { FOLLOW_symbol_in_termNonVariable4406_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4420  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4420_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4420	= { FOLLOW_term_in_termNonVariable4420_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4434  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4434_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4434	= { FOLLOW_RPAREN_TOK_in_termNonVariable4434_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4447  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4447_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4447	= { FOLLOW_RPAREN_TOK_in_termNonVariable4447_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4449  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4449_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4449	= { FOLLOW_RPAREN_TOK_in_termNonVariable4449_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4465  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4465_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000004000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4465	= { FOLLOW_LPAREN_TOK_in_termNonVariable4465_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ATTRIBUTE_TOK_in_termNonVariable4467  */
static	ANTLR3_BITWORD FOLLOW_ATTRIBUTE_TOK_in_termNonVariable4467_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_ATTRIBUTE_TOK_in_termNonVariable4467	= { FOLLOW_ATTRIBUTE_TOK_in_termNonVariable4467_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4469  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4469_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000003E00), ANTLR3_UINT64_LIT(0x0000100000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4469	= { FOLLOW_term_in_termNonVariable4469_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_attribute_in_termNonVariable4478  */
static	ANTLR3_BITWORD FOLLOW_attribute_in_termNonVariable4478_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000003E00), ANTLR3_UINT64_LIT(0x0000100000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_attribute_in_termNonVariable4478	= { FOLLOW_attribute_in_termNonVariable4478_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4496  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4496_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4496	= { FOLLOW_RPAREN_TOK_in_termNonVariable4496_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4514  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4514_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000800000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4514	= { FOLLOW_LPAREN_TOK_in_termNonVariable4514_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_HO_LAMBDA_TOK_in_termNonVariable4516  */
static	ANTLR3_BITWORD FOLLOW_HO_LAMBDA_TOK_in_termNonVariable4516_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_HO_LAMBDA_TOK_in_termNonVariable4516	= { FOLLOW_HO_LAMBDA_TOK_in_termNonVariable4516_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4522  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4522_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4522	= { FOLLOW_LPAREN_TOK_in_termNonVariable4522_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortedVarList_in_termNonVariable4524  */
static	ANTLR3_BITWORD FOLLOW_sortedVarList_in_termNonVariable4524_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortedVarList_in_termNonVariable4524	= { FOLLOW_sortedVarList_in_termNonVariable4524_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4527  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4527_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4527	= { FOLLOW_RPAREN_TOK_in_termNonVariable4527_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termNonVariable4539  */
static	ANTLR3_BITWORD FOLLOW_term_in_termNonVariable4539_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termNonVariable4539	= { FOLLOW_term_in_termNonVariable4539_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4542  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4542_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4542	= { FOLLOW_RPAREN_TOK_in_termNonVariable4542_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termNonVariable4555  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termNonVariable4555_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000001000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termNonVariable4555	= { FOLLOW_LPAREN_TOK_in_termNonVariable4555_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_TUPLE_CONST_TOK_in_termNonVariable4557  */
static	ANTLR3_BITWORD FOLLOW_TUPLE_CONST_TOK_in_termNonVariable4557_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_TUPLE_CONST_TOK_in_termNonVariable4557	= { FOLLOW_TUPLE_CONST_TOK_in_termNonVariable4557_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termList_in_termNonVariable4559  */
static	ANTLR3_BITWORD FOLLOW_termList_in_termNonVariable4559_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_termList_in_termNonVariable4559	= { FOLLOW_termList_in_termNonVariable4559_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termNonVariable4562  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termNonVariable4562_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termNonVariable4562	= { FOLLOW_RPAREN_TOK_in_termNonVariable4562_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_termAtomic_in_termNonVariable4578  */
static	ANTLR3_BITWORD FOLLOW_termAtomic_in_termNonVariable4578_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_termAtomic_in_termNonVariable4578	= { FOLLOW_termAtomic_in_termNonVariable4578_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4609  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4609_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4609	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4609_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECIMAL_LITERAL_in_termAtomic4621  */
static	ANTLR3_BITWORD FOLLOW_DECIMAL_LITERAL_in_termAtomic4621_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DECIMAL_LITERAL_in_termAtomic4621	= { FOLLOW_DECIMAL_LITERAL_in_termAtomic4621_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_REAL_PI_TOK_in_termAtomic4637  */
static	ANTLR3_BITWORD FOLLOW_REAL_PI_TOK_in_termAtomic4637_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_REAL_PI_TOK_in_termAtomic4637	= { FOLLOW_REAL_PI_TOK_in_termAtomic4637_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_termAtomic4652  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_termAtomic4652_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000004000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_termAtomic4652	= { FOLLOW_LPAREN_TOK_in_termAtomic4652_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INDEX_TOK_in_termAtomic4654  */
static	ANTLR3_BITWORD FOLLOW_INDEX_TOK_in_termAtomic4654_bits[]	= { ANTLR3_UINT64_LIT(0xF020000000000000), ANTLR3_UINT64_LIT(0x0000000000000001), ANTLR3_UINT64_LIT(0x0000000000000400) };
static  ANTLR3_BITSET_LIST FOLLOW_INDEX_TOK_in_termAtomic4654	= { FOLLOW_INDEX_TOK_in_termAtomic4654_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SIMPLE_SYMBOL_in_termAtomic4665  */
static	ANTLR3_BITWORD FOLLOW_SIMPLE_SYMBOL_in_termAtomic4665_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_SIMPLE_SYMBOL_in_termAtomic4665	= { FOLLOW_SIMPLE_SYMBOL_in_termAtomic4665_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4669  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4669_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4669	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4669_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_PINF_TOK_in_termAtomic4692  */
static	ANTLR3_BITWORD FOLLOW_FP_PINF_TOK_in_termAtomic4692_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_PINF_TOK_in_termAtomic4692	= { FOLLOW_FP_PINF_TOK_in_termAtomic4692_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4696  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4696_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4696	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4696_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4700  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4700_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4700	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4700_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_NINF_TOK_in_termAtomic4716  */
static	ANTLR3_BITWORD FOLLOW_FP_NINF_TOK_in_termAtomic4716_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_NINF_TOK_in_termAtomic4716	= { FOLLOW_FP_NINF_TOK_in_termAtomic4716_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4720  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4720_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4720	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4720_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4724  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4724_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4724	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4724_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_NAN_TOK_in_termAtomic4740  */
static	ANTLR3_BITWORD FOLLOW_FP_NAN_TOK_in_termAtomic4740_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_NAN_TOK_in_termAtomic4740	= { FOLLOW_FP_NAN_TOK_in_termAtomic4740_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4744  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4744_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4744	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4744_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4748  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4748_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4748	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4748_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_PZERO_TOK_in_termAtomic4764  */
static	ANTLR3_BITWORD FOLLOW_FP_PZERO_TOK_in_termAtomic4764_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_PZERO_TOK_in_termAtomic4764	= { FOLLOW_FP_PZERO_TOK_in_termAtomic4764_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4768  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4768_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4768	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4768_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4772  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4772_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4772	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4772_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_NZERO_TOK_in_termAtomic4788  */
static	ANTLR3_BITWORD FOLLOW_FP_NZERO_TOK_in_termAtomic4788_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_NZERO_TOK_in_termAtomic4788	= { FOLLOW_FP_NZERO_TOK_in_termAtomic4788_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4792  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4792_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4792	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4792_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_termAtomic4796  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_termAtomic4796_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_termAtomic4796	= { FOLLOW_INTEGER_LITERAL_in_termAtomic4796_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EMP_TOK_in_termAtomic4818  */
static	ANTLR3_BITWORD FOLLOW_EMP_TOK_in_termAtomic4818_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_EMP_TOK_in_termAtomic4818	= { FOLLOW_EMP_TOK_in_termAtomic4818_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_termAtomic4826  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_termAtomic4826_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_termAtomic4826	= { FOLLOW_sortSymbol_in_termAtomic4826_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_termAtomic4835  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_termAtomic4835_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_termAtomic4835	= { FOLLOW_sortSymbol_in_termAtomic4835_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_termAtomic4862  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_termAtomic4862_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_termAtomic4862	= { FOLLOW_RPAREN_TOK_in_termAtomic4862_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_HEX_LITERAL_in_termAtomic4872  */
static	ANTLR3_BITWORD FOLLOW_HEX_LITERAL_in_termAtomic4872_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_HEX_LITERAL_in_termAtomic4872	= { FOLLOW_HEX_LITERAL_in_termAtomic4872_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_BINARY_LITERAL_in_termAtomic4882  */
static	ANTLR3_BITWORD FOLLOW_BINARY_LITERAL_in_termAtomic4882_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_BINARY_LITERAL_in_termAtomic4882	= { FOLLOW_BINARY_LITERAL_in_termAtomic4882_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RNE_TOK_in_termAtomic4898  */
static	ANTLR3_BITWORD FOLLOW_FP_RNE_TOK_in_termAtomic4898_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RNE_TOK_in_termAtomic4898	= { FOLLOW_FP_RNE_TOK_in_termAtomic4898_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RNA_TOK_in_termAtomic4911  */
static	ANTLR3_BITWORD FOLLOW_FP_RNA_TOK_in_termAtomic4911_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RNA_TOK_in_termAtomic4911	= { FOLLOW_FP_RNA_TOK_in_termAtomic4911_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTP_TOK_in_termAtomic4924  */
static	ANTLR3_BITWORD FOLLOW_FP_RTP_TOK_in_termAtomic4924_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTP_TOK_in_termAtomic4924	= { FOLLOW_FP_RTP_TOK_in_termAtomic4924_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTN_TOK_in_termAtomic4937  */
static	ANTLR3_BITWORD FOLLOW_FP_RTN_TOK_in_termAtomic4937_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTN_TOK_in_termAtomic4937	= { FOLLOW_FP_RTN_TOK_in_termAtomic4937_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTZ_TOK_in_termAtomic4950  */
static	ANTLR3_BITWORD FOLLOW_FP_RTZ_TOK_in_termAtomic4950_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTZ_TOK_in_termAtomic4950	= { FOLLOW_FP_RTZ_TOK_in_termAtomic4950_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RNE_FULL_TOK_in_termAtomic4963  */
static	ANTLR3_BITWORD FOLLOW_FP_RNE_FULL_TOK_in_termAtomic4963_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RNE_FULL_TOK_in_termAtomic4963	= { FOLLOW_FP_RNE_FULL_TOK_in_termAtomic4963_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RNA_FULL_TOK_in_termAtomic4971  */
static	ANTLR3_BITWORD FOLLOW_FP_RNA_FULL_TOK_in_termAtomic4971_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RNA_FULL_TOK_in_termAtomic4971	= { FOLLOW_FP_RNA_FULL_TOK_in_termAtomic4971_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTP_FULL_TOK_in_termAtomic4979  */
static	ANTLR3_BITWORD FOLLOW_FP_RTP_FULL_TOK_in_termAtomic4979_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTP_FULL_TOK_in_termAtomic4979	= { FOLLOW_FP_RTP_FULL_TOK_in_termAtomic4979_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTN_FULL_TOK_in_termAtomic4987  */
static	ANTLR3_BITWORD FOLLOW_FP_RTN_FULL_TOK_in_termAtomic4987_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTN_FULL_TOK_in_termAtomic4987	= { FOLLOW_FP_RTN_FULL_TOK_in_termAtomic4987_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_RTZ_FULL_TOK_in_termAtomic4995  */
static	ANTLR3_BITWORD FOLLOW_FP_RTZ_FULL_TOK_in_termAtomic4995_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_RTZ_FULL_TOK_in_termAtomic4995	= { FOLLOW_FP_RTZ_FULL_TOK_in_termAtomic4995_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_str_in_termAtomic5007  */
static	ANTLR3_BITWORD FOLLOW_str_in_termAtomic5007_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_str_in_termAtomic5007	= { FOLLOW_str_in_termAtomic5007_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RENOSTR_TOK_in_termAtomic5020  */
static	ANTLR3_BITWORD FOLLOW_RENOSTR_TOK_in_termAtomic5020_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RENOSTR_TOK_in_termAtomic5020	= { FOLLOW_RENOSTR_TOK_in_termAtomic5020_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_REALLCHAR_TOK_in_termAtomic5028  */
static	ANTLR3_BITWORD FOLLOW_REALLCHAR_TOK_in_termAtomic5028_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_REALLCHAR_TOK_in_termAtomic5028	= { FOLLOW_REALLCHAR_TOK_in_termAtomic5028_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EMPTYSET_TOK_in_termAtomic5040  */
static	ANTLR3_BITWORD FOLLOW_EMPTYSET_TOK_in_termAtomic5040_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EMPTYSET_TOK_in_termAtomic5040	= { FOLLOW_EMPTYSET_TOK_in_termAtomic5040_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_UNIVSET_TOK_in_termAtomic5048  */
static	ANTLR3_BITWORD FOLLOW_UNIVSET_TOK_in_termAtomic5048_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_UNIVSET_TOK_in_termAtomic5048	= { FOLLOW_UNIVSET_TOK_in_termAtomic5048_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_NILREF_TOK_in_termAtomic5064  */
static	ANTLR3_BITWORD FOLLOW_NILREF_TOK_in_termAtomic5064_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_NILREF_TOK_in_termAtomic5064	= { FOLLOW_NILREF_TOK_in_termAtomic5064_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_TUPLE_CONST_TOK_in_termAtomic5088  */
static	ANTLR3_BITWORD FOLLOW_TUPLE_CONST_TOK_in_termAtomic5088_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_TUPLE_CONST_TOK_in_termAtomic5088	= { FOLLOW_TUPLE_CONST_TOK_in_termAtomic5088_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_KEYWORD_in_attribute5117  */
static	ANTLR3_BITWORD FOLLOW_KEYWORD_in_attribute5117_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C2), ANTLR3_UINT64_LIT(0x3EA86E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FDD) };
static  ANTLR3_BITSET_LIST FOLLOW_KEYWORD_in_attribute5117	= { FOLLOW_KEYWORD_in_attribute5117_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_simpleSymbolicExprNoKeyword_in_attribute5121  */
static	ANTLR3_BITWORD FOLLOW_simpleSymbolicExprNoKeyword_in_attribute5121_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_simpleSymbolicExprNoKeyword_in_attribute5121	= { FOLLOW_simpleSymbolicExprNoKeyword_in_attribute5121_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ATTRIBUTE_PATTERN_TOK_in_attribute5137  */
static	ANTLR3_BITWORD FOLLOW_ATTRIBUTE_PATTERN_TOK_in_attribute5137_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_ATTRIBUTE_PATTERN_TOK_in_attribute5137	= { FOLLOW_ATTRIBUTE_PATTERN_TOK_in_attribute5137_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_attribute5139  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_attribute5139_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_attribute5139	= { FOLLOW_LPAREN_TOK_in_attribute5139_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_attribute5147  */
static	ANTLR3_BITWORD FOLLOW_term_in_attribute5147_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602522) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_attribute5147	= { FOLLOW_term_in_attribute5147_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_attribute5165  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_attribute5165_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_attribute5165	= { FOLLOW_RPAREN_TOK_in_attribute5165_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ATTRIBUTE_NO_PATTERN_TOK_in_attribute5177  */
static	ANTLR3_BITWORD FOLLOW_ATTRIBUTE_NO_PATTERN_TOK_in_attribute5177_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_ATTRIBUTE_NO_PATTERN_TOK_in_attribute5177	= { FOLLOW_ATTRIBUTE_NO_PATTERN_TOK_in_attribute5177_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_attribute5179  */
static	ANTLR3_BITWORD FOLLOW_term_in_attribute5179_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_attribute5179	= { FOLLOW_term_in_attribute5179_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_set_in_attribute5194  */
static	ANTLR3_BITWORD FOLLOW_set_in_attribute5194_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_set_in_attribute5194	= { FOLLOW_set_in_attribute5194_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_attribute5204  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_attribute5204_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_attribute5204	= { FOLLOW_INTEGER_LITERAL_in_attribute5204_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ATTRIBUTE_NAMED_TOK_in_attribute5216  */
static	ANTLR3_BITWORD FOLLOW_ATTRIBUTE_NAMED_TOK_in_attribute5216_bits[]	= { ANTLR3_UINT64_LIT(0x074E9ED2415F00C0), ANTLR3_UINT64_LIT(0x3EA97E92F9F80000), ANTLR3_UINT64_LIT(0x0000000128603FDD) };
static  ANTLR3_BITSET_LIST FOLLOW_ATTRIBUTE_NAMED_TOK_in_attribute5216	= { FOLLOW_ATTRIBUTE_NAMED_TOK_in_attribute5216_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbolicExpr_in_attribute5218  */
static	ANTLR3_BITWORD FOLLOW_symbolicExpr_in_attribute5218_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbolicExpr_in_attribute5218	= { FOLLOW_symbolicExpr_in_attribute5218_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_indexedFunctionName5246  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_indexedFunctionName5246_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000004000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_indexedFunctionName5246	= { FOLLOW_LPAREN_TOK_in_indexedFunctionName5246_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INDEX_TOK_in_indexedFunctionName5248  */
static	ANTLR3_BITWORD FOLLOW_INDEX_TOK_in_indexedFunctionName5248_bits[]	= { ANTLR3_UINT64_LIT(0x0001000000000000), ANTLR3_UINT64_LIT(0x200001000007F800), ANTLR3_UINT64_LIT(0x0000001F8A800400) };
static  ANTLR3_BITSET_LIST FOLLOW_INDEX_TOK_in_indexedFunctionName5248	= { FOLLOW_INDEX_TOK_in_indexedFunctionName5248_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_159_in_indexedFunctionName5256  */
static	ANTLR3_BITWORD FOLLOW_159_in_indexedFunctionName5256_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_159_in_indexedFunctionName5256	= { FOLLOW_159_in_indexedFunctionName5256_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5260  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5260_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5260	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5260_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5264  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5264_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5264	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5264_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_160_in_indexedFunctionName5280  */
static	ANTLR3_BITWORD FOLLOW_160_in_indexedFunctionName5280_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_160_in_indexedFunctionName5280	= { FOLLOW_160_in_indexedFunctionName5280_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5284  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5284_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5284	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5284_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_164_in_indexedFunctionName5300  */
static	ANTLR3_BITWORD FOLLOW_164_in_indexedFunctionName5300_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_164_in_indexedFunctionName5300	= { FOLLOW_164_in_indexedFunctionName5300_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5304  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5304_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5304	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5304_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_163_in_indexedFunctionName5320  */
static	ANTLR3_BITWORD FOLLOW_163_in_indexedFunctionName5320_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_163_in_indexedFunctionName5320	= { FOLLOW_163_in_indexedFunctionName5320_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5324  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5324_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5324	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5324_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_161_in_indexedFunctionName5340  */
static	ANTLR3_BITWORD FOLLOW_161_in_indexedFunctionName5340_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_161_in_indexedFunctionName5340	= { FOLLOW_161_in_indexedFunctionName5340_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5344  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5344_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5344	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5344_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_162_in_indexedFunctionName5360  */
static	ANTLR3_BITWORD FOLLOW_162_in_indexedFunctionName5360_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_162_in_indexedFunctionName5360	= { FOLLOW_162_in_indexedFunctionName5360_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5364  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5364_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5364	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5364_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DIVISIBLE_TOK_in_indexedFunctionName5380  */
static	ANTLR3_BITWORD FOLLOW_DIVISIBLE_TOK_in_indexedFunctionName5380_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_DIVISIBLE_TOK_in_indexedFunctionName5380	= { FOLLOW_DIVISIBLE_TOK_in_indexedFunctionName5380_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5384  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5384_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5384	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5384_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INT2BV_TOK_in_indexedFunctionName5400  */
static	ANTLR3_BITWORD FOLLOW_INT2BV_TOK_in_indexedFunctionName5400_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INT2BV_TOK_in_indexedFunctionName5400	= { FOLLOW_INT2BV_TOK_in_indexedFunctionName5400_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5404  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5404_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5404	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5404_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FP_TOK_in_indexedFunctionName5420  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FP_TOK_in_indexedFunctionName5420_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FP_TOK_in_indexedFunctionName5420	= { FOLLOW_FP_TO_FP_TOK_in_indexedFunctionName5420_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5424  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5424_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5424	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5424_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5428  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5428_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5428	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5428_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FPBV_TOK_in_indexedFunctionName5444  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FPBV_TOK_in_indexedFunctionName5444_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FPBV_TOK_in_indexedFunctionName5444	= { FOLLOW_FP_TO_FPBV_TOK_in_indexedFunctionName5444_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5448  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5448_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5448	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5448_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5452  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5452_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5452	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5452_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FPFP_TOK_in_indexedFunctionName5468  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FPFP_TOK_in_indexedFunctionName5468_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FPFP_TOK_in_indexedFunctionName5468	= { FOLLOW_FP_TO_FPFP_TOK_in_indexedFunctionName5468_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5472  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5472_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5472	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5472_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5476  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5476_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5476	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5476_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FPR_TOK_in_indexedFunctionName5492  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FPR_TOK_in_indexedFunctionName5492_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FPR_TOK_in_indexedFunctionName5492	= { FOLLOW_FP_TO_FPR_TOK_in_indexedFunctionName5492_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5496  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5496_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5496	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5496_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5500  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5500_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5500	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5500_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FPS_TOK_in_indexedFunctionName5516  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FPS_TOK_in_indexedFunctionName5516_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FPS_TOK_in_indexedFunctionName5516	= { FOLLOW_FP_TO_FPS_TOK_in_indexedFunctionName5516_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5520  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5520_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5520	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5520_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5524  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5524_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5524	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5524_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_FPU_TOK_in_indexedFunctionName5540  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_FPU_TOK_in_indexedFunctionName5540_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_FPU_TOK_in_indexedFunctionName5540	= { FOLLOW_FP_TO_FPU_TOK_in_indexedFunctionName5540_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5544  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5544_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5544	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5544_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5548  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5548_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5548	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5548_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_UBV_TOK_in_indexedFunctionName5564  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_UBV_TOK_in_indexedFunctionName5564_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_UBV_TOK_in_indexedFunctionName5564	= { FOLLOW_FP_TO_UBV_TOK_in_indexedFunctionName5564_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5568  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5568_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5568	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5568_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FP_TO_SBV_TOK_in_indexedFunctionName5584  */
static	ANTLR3_BITWORD FOLLOW_FP_TO_SBV_TOK_in_indexedFunctionName5584_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_FP_TO_SBV_TOK_in_indexedFunctionName5584	= { FOLLOW_FP_TO_SBV_TOK_in_indexedFunctionName5584_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5588  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5588_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5588	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5588_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_TESTER_TOK_in_indexedFunctionName5604  */
static	ANTLR3_BITWORD FOLLOW_TESTER_TOK_in_indexedFunctionName5604_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510000), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_TESTER_TOK_in_indexedFunctionName5604	= { FOLLOW_TESTER_TOK_in_indexedFunctionName5604_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_indexedFunctionName5606  */
static	ANTLR3_BITWORD FOLLOW_term_in_indexedFunctionName5606_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_indexedFunctionName5606	= { FOLLOW_term_in_indexedFunctionName5606_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_TUPLE_SEL_TOK_in_indexedFunctionName5617  */
static	ANTLR3_BITWORD FOLLOW_TUPLE_SEL_TOK_in_indexedFunctionName5617_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_TUPLE_SEL_TOK_in_indexedFunctionName5617	= { FOLLOW_TUPLE_SEL_TOK_in_indexedFunctionName5617_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5621  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5621_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5621	= { FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5621_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_badIndexedFunctionName_in_indexedFunctionName5632  */
static	ANTLR3_BITWORD FOLLOW_badIndexedFunctionName_in_indexedFunctionName5632_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_badIndexedFunctionName_in_indexedFunctionName5632	= { FOLLOW_badIndexedFunctionName_in_indexedFunctionName5632_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_indexedFunctionName5644  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_indexedFunctionName5644_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_indexedFunctionName5644	= { FOLLOW_RPAREN_TOK_in_indexedFunctionName5644_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_set_in_badIndexedFunctionName5666  */
static	ANTLR3_BITWORD FOLLOW_set_in_badIndexedFunctionName5666_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_set_in_badIndexedFunctionName5666	= { FOLLOW_set_in_badIndexedFunctionName5666_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_term_in_termList5707  */
static	ANTLR3_BITWORD FOLLOW_term_in_termList5707_bits[]	= { ANTLR3_UINT64_LIT(0x0010009001510002), ANTLR3_UINT64_LIT(0xE0110602000007FE), ANTLR3_UINT64_LIT(0x000000010D602502) };
static  ANTLR3_BITSET_LIST FOLLOW_term_in_termList5707	= { FOLLOW_term_in_termList5707_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_STRING_LITERAL_in_str5729  */
static	ANTLR3_BITWORD FOLLOW_STRING_LITERAL_in_str5729_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_STRING_LITERAL_in_str5729	= { FOLLOW_STRING_LITERAL_in_str5729_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_NOT_TOK_in_builtinOp5756  */
static	ANTLR3_BITWORD FOLLOW_NOT_TOK_in_builtinOp5756_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_NOT_TOK_in_builtinOp5756	= { FOLLOW_NOT_TOK_in_builtinOp5756_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_IMPLIES_TOK_in_builtinOp5769  */
static	ANTLR3_BITWORD FOLLOW_IMPLIES_TOK_in_builtinOp5769_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_IMPLIES_TOK_in_builtinOp5769	= { FOLLOW_IMPLIES_TOK_in_builtinOp5769_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_AND_TOK_in_builtinOp5778  */
static	ANTLR3_BITWORD FOLLOW_AND_TOK_in_builtinOp5778_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_AND_TOK_in_builtinOp5778	= { FOLLOW_AND_TOK_in_builtinOp5778_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_OR_TOK_in_builtinOp5791  */
static	ANTLR3_BITWORD FOLLOW_OR_TOK_in_builtinOp5791_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_OR_TOK_in_builtinOp5791	= { FOLLOW_OR_TOK_in_builtinOp5791_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_XOR_TOK_in_builtinOp5805  */
static	ANTLR3_BITWORD FOLLOW_XOR_TOK_in_builtinOp5805_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_XOR_TOK_in_builtinOp5805	= { FOLLOW_XOR_TOK_in_builtinOp5805_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EQUAL_TOK_in_builtinOp5818  */
static	ANTLR3_BITWORD FOLLOW_EQUAL_TOK_in_builtinOp5818_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EQUAL_TOK_in_builtinOp5818	= { FOLLOW_EQUAL_TOK_in_builtinOp5818_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DISTINCT_TOK_in_builtinOp5829  */
static	ANTLR3_BITWORD FOLLOW_DISTINCT_TOK_in_builtinOp5829_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DISTINCT_TOK_in_builtinOp5829	= { FOLLOW_DISTINCT_TOK_in_builtinOp5829_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_ITE_TOK_in_builtinOp5837  */
static	ANTLR3_BITWORD FOLLOW_ITE_TOK_in_builtinOp5837_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_ITE_TOK_in_builtinOp5837	= { FOLLOW_ITE_TOK_in_builtinOp5837_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GREATER_THAN_TOK_in_builtinOp5850  */
static	ANTLR3_BITWORD FOLLOW_GREATER_THAN_TOK_in_builtinOp5850_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GREATER_THAN_TOK_in_builtinOp5850	= { FOLLOW_GREATER_THAN_TOK_in_builtinOp5850_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_GREATER_THAN_EQUAL_TOK_in_builtinOp5875  */
static	ANTLR3_BITWORD FOLLOW_GREATER_THAN_EQUAL_TOK_in_builtinOp5875_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_GREATER_THAN_EQUAL_TOK_in_builtinOp5875	= { FOLLOW_GREATER_THAN_EQUAL_TOK_in_builtinOp5875_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LESS_THAN_EQUAL_TOK_in_builtinOp5900  */
static	ANTLR3_BITWORD FOLLOW_LESS_THAN_EQUAL_TOK_in_builtinOp5900_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_LESS_THAN_EQUAL_TOK_in_builtinOp5900	= { FOLLOW_LESS_THAN_EQUAL_TOK_in_builtinOp5900_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LESS_THAN_TOK_in_builtinOp5925  */
static	ANTLR3_BITWORD FOLLOW_LESS_THAN_TOK_in_builtinOp5925_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_LESS_THAN_TOK_in_builtinOp5925	= { FOLLOW_LESS_THAN_TOK_in_builtinOp5925_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_PLUS_TOK_in_builtinOp5950  */
static	ANTLR3_BITWORD FOLLOW_PLUS_TOK_in_builtinOp5950_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_PLUS_TOK_in_builtinOp5950	= { FOLLOW_PLUS_TOK_in_builtinOp5950_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_MINUS_TOK_in_builtinOp5962  */
static	ANTLR3_BITWORD FOLLOW_MINUS_TOK_in_builtinOp5962_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_MINUS_TOK_in_builtinOp5962	= { FOLLOW_MINUS_TOK_in_builtinOp5962_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_STAR_TOK_in_builtinOp5973  */
static	ANTLR3_BITWORD FOLLOW_STAR_TOK_in_builtinOp5973_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_STAR_TOK_in_builtinOp5973	= { FOLLOW_STAR_TOK_in_builtinOp5973_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DIV_TOK_in_builtinOp5985  */
static	ANTLR3_BITWORD FOLLOW_DIV_TOK_in_builtinOp5985_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DIV_TOK_in_builtinOp5985	= { FOLLOW_DIV_TOK_in_builtinOp5985_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_BV2NAT_TOK_in_builtinOp5999  */
static	ANTLR3_BITWORD FOLLOW_BV2NAT_TOK_in_builtinOp5999_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_BV2NAT_TOK_in_builtinOp5999	= { FOLLOW_BV2NAT_TOK_in_builtinOp5999_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DTSIZE_TOK_in_builtinOp6012  */
static	ANTLR3_BITWORD FOLLOW_DTSIZE_TOK_in_builtinOp6012_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DTSIZE_TOK_in_builtinOp6012	= { FOLLOW_DTSIZE_TOK_in_builtinOp6012_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FMFCARD_TOK_in_builtinOp6026  */
static	ANTLR3_BITWORD FOLLOW_FMFCARD_TOK_in_builtinOp6026_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FMFCARD_TOK_in_builtinOp6026	= { FOLLOW_FMFCARD_TOK_in_builtinOp6026_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FMFCARDVAL_TOK_in_builtinOp6039  */
static	ANTLR3_BITWORD FOLLOW_FMFCARDVAL_TOK_in_builtinOp6039_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FMFCARDVAL_TOK_in_builtinOp6039	= { FOLLOW_FMFCARDVAL_TOK_in_builtinOp6039_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INST_CLOSURE_TOK_in_builtinOp6049  */
static	ANTLR3_BITWORD FOLLOW_INST_CLOSURE_TOK_in_builtinOp6049_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INST_CLOSURE_TOK_in_builtinOp6049	= { FOLLOW_INST_CLOSURE_TOK_in_builtinOp6049_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EXISTS_TOK_in_quantOp6091  */
static	ANTLR3_BITWORD FOLLOW_EXISTS_TOK_in_quantOp6091_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EXISTS_TOK_in_quantOp6091	= { FOLLOW_EXISTS_TOK_in_quantOp6091_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_FORALL_TOK_in_quantOp6102  */
static	ANTLR3_BITWORD FOLLOW_FORALL_TOK_in_quantOp6102_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_FORALL_TOK_in_quantOp6102	= { FOLLOW_FORALL_TOK_in_quantOp6102_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_functionName6123  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_functionName6123_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_functionName6123	= { FOLLOW_symbol_in_functionName6123_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sortList6147  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sortList6147_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500002), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sortList6147	= { FOLLOW_sortSymbol_in_sortList6147_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_nonemptySortList6174  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_nonemptySortList6174_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500002), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_nonemptySortList6174	= { FOLLOW_sortSymbol_in_nonemptySortList6174_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sortedVarList6203  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sortedVarList6203_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sortedVarList6203	= { FOLLOW_LPAREN_TOK_in_sortedVarList6203_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sortedVarList6205  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sortedVarList6205_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sortedVarList6205	= { FOLLOW_symbol_in_sortedVarList6205_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_sortedVarList6214  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_sortedVarList6214_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_sortedVarList6214	= { FOLLOW_sortSymbol_in_sortedVarList6214_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sortedVarList6217  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sortedVarList6217_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sortedVarList6217	= { FOLLOW_RPAREN_TOK_in_sortedVarList6217_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sortName6248  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sortName6248_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sortName6248	= { FOLLOW_symbol_in_sortName6248_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortName_in_sortSymbol6268  */
static	ANTLR3_BITWORD FOLLOW_sortName_in_sortSymbol6268_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortName_in_sortSymbol6268	= { FOLLOW_sortName_in_sortSymbol6268_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sortSymbol6281  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sortSymbol6281_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000044000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sortSymbol6281	= { FOLLOW_LPAREN_TOK_in_sortSymbol6281_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INDEX_TOK_in_sortSymbol6284  */
static	ANTLR3_BITWORD FOLLOW_INDEX_TOK_in_sortSymbol6284_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_INDEX_TOK_in_sortSymbol6284	= { FOLLOW_INDEX_TOK_in_sortSymbol6284_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_sortSymbol6297  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_sortSymbol6297_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001060000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_sortSymbol6297	= { FOLLOW_symbol_in_sortSymbol6297_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_nonemptyNumeralList_in_sortSymbol6306  */
static	ANTLR3_BITWORD FOLLOW_nonemptyNumeralList_in_sortSymbol6306_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_nonemptyNumeralList_in_sortSymbol6306	= { FOLLOW_nonemptyNumeralList_in_sortSymbol6306_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortList_in_sortSymbol6323  */
static	ANTLR3_BITWORD FOLLOW_sortList_in_sortSymbol6323_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortList_in_sortSymbol6323	= { FOLLOW_sortList_in_sortSymbol6323_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sortSymbol6340  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sortSymbol6340_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sortSymbol6340	= { FOLLOW_RPAREN_TOK_in_sortSymbol6340_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_sortSymbol6346  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_sortSymbol6346_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000400000000) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_sortSymbol6346	= { FOLLOW_LPAREN_TOK_in_sortSymbol6346_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_HO_ARROW_TOK_in_sortSymbol6348  */
static	ANTLR3_BITWORD FOLLOW_HO_ARROW_TOK_in_sortSymbol6348_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600520) };
static  ANTLR3_BITSET_LIST FOLLOW_HO_ARROW_TOK_in_sortSymbol6348	= { FOLLOW_HO_ARROW_TOK_in_sortSymbol6348_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortList_in_sortSymbol6350  */
static	ANTLR3_BITWORD FOLLOW_sortList_in_sortSymbol6350_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_sortList_in_sortSymbol6350	= { FOLLOW_sortList_in_sortSymbol6350_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_sortSymbol6353  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_sortSymbol6353_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_sortSymbol6353	= { FOLLOW_RPAREN_TOK_in_sortSymbol6353_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_symbolList6382  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_symbolList6382_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500002), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_symbolList6382	= { FOLLOW_symbol_in_symbolList6382_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SIMPLE_SYMBOL_in_symbol6404  */
static	ANTLR3_BITWORD FOLLOW_SIMPLE_SYMBOL_in_symbol6404_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_SIMPLE_SYMBOL_in_symbol6404	= { FOLLOW_SIMPLE_SYMBOL_in_symbol6404_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_160_in_symbol6418  */
static	ANTLR3_BITWORD FOLLOW_160_in_symbol6418_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_160_in_symbol6418	= { FOLLOW_160_in_symbol6418_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SET_OPTIONS_TOK_in_symbol6434  */
static	ANTLR3_BITWORD FOLLOW_SET_OPTIONS_TOK_in_symbol6434_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_SET_OPTIONS_TOK_in_symbol6434	= { FOLLOW_SET_OPTIONS_TOK_in_symbol6434_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_VAR_TOK_in_symbol6444  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_VAR_TOK_in_symbol6444_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_VAR_TOK_in_symbol6444	= { FOLLOW_DECLARE_VAR_TOK_in_symbol6444_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_DECLARE_PRIMED_VAR_TOK_in_symbol6454  */
static	ANTLR3_BITWORD FOLLOW_DECLARE_PRIMED_VAR_TOK_in_symbol6454_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_DECLARE_PRIMED_VAR_TOK_in_symbol6454	= { FOLLOW_DECLARE_PRIMED_VAR_TOK_in_symbol6454_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYNTH_FUN_TOK_in_symbol6464  */
static	ANTLR3_BITWORD FOLLOW_SYNTH_FUN_TOK_in_symbol6464_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_SYNTH_FUN_TOK_in_symbol6464	= { FOLLOW_SYNTH_FUN_TOK_in_symbol6464_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_SYNTH_INV_TOK_in_symbol6474  */
static	ANTLR3_BITWORD FOLLOW_SYNTH_INV_TOK_in_symbol6474_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_SYNTH_INV_TOK_in_symbol6474	= { FOLLOW_SYNTH_INV_TOK_in_symbol6474_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CONSTRAINT_TOK_in_symbol6484  */
static	ANTLR3_BITWORD FOLLOW_CONSTRAINT_TOK_in_symbol6484_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_CONSTRAINT_TOK_in_symbol6484	= { FOLLOW_CONSTRAINT_TOK_in_symbol6484_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INV_CONSTRAINT_TOK_in_symbol6494  */
static	ANTLR3_BITWORD FOLLOW_INV_CONSTRAINT_TOK_in_symbol6494_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_INV_CONSTRAINT_TOK_in_symbol6494	= { FOLLOW_INV_CONSTRAINT_TOK_in_symbol6494_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_CHECK_SYNTH_TOK_in_symbol6504  */
static	ANTLR3_BITWORD FOLLOW_CHECK_SYNTH_TOK_in_symbol6504_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_CHECK_SYNTH_TOK_in_symbol6504	= { FOLLOW_CHECK_SYNTH_TOK_in_symbol6504_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_QUOTED_SYMBOL_in_symbol6524  */
static	ANTLR3_BITWORD FOLLOW_QUOTED_SYMBOL_in_symbol6524_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_QUOTED_SYMBOL_in_symbol6524	= { FOLLOW_QUOTED_SYMBOL_in_symbol6524_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_UNTERMINATED_QUOTED_SYMBOL_in_symbol6536  */
static	ANTLR3_BITWORD FOLLOW_UNTERMINATED_QUOTED_SYMBOL_in_symbol6536_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000040000000) };
static  ANTLR3_BITSET_LIST FOLLOW_UNTERMINATED_QUOTED_SYMBOL_in_symbol6536	= { FOLLOW_UNTERMINATED_QUOTED_SYMBOL_in_symbol6536_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_EOF_in_symbol6544  */
static	ANTLR3_BITWORD FOLLOW_EOF_in_symbol6544_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_EOF_in_symbol6544	= { FOLLOW_EOF_in_symbol6544_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_158_in_symbol6560  */
static	ANTLR3_BITWORD FOLLOW_158_in_symbol6560_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_158_in_symbol6560	= { FOLLOW_158_in_symbol6560_bits, 1	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_INTEGER_LITERAL_in_nonemptyNumeralList6592  */
static	ANTLR3_BITWORD FOLLOW_INTEGER_LITERAL_in_nonemptyNumeralList6592_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0000020000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_INTEGER_LITERAL_in_nonemptyNumeralList6592	= { FOLLOW_INTEGER_LITERAL_in_nonemptyNumeralList6592_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_datatypeDef6634  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_datatypeDef6634_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_datatypeDef6634	= { FOLLOW_symbol_in_datatypeDef6634_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_datatypeDef6657  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_datatypeDef6657_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_datatypeDef6657	= { FOLLOW_LPAREN_TOK_in_datatypeDef6657_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_constructorDef_in_datatypeDef6659  */
static	ANTLR3_BITWORD FOLLOW_constructorDef_in_datatypeDef6659_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_constructorDef_in_datatypeDef6659	= { FOLLOW_constructorDef_in_datatypeDef6659_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_datatypeDef6662  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_datatypeDef6662_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_datatypeDef6662	= { FOLLOW_RPAREN_TOK_in_datatypeDef6662_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_constructorDef6692  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_constructorDef6692_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_constructorDef6692	= { FOLLOW_symbol_in_constructorDef6692_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_LPAREN_TOK_in_constructorDef6707  */
static	ANTLR3_BITWORD FOLLOW_LPAREN_TOK_in_constructorDef6707_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2000040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_LPAREN_TOK_in_constructorDef6707	= { FOLLOW_LPAREN_TOK_in_constructorDef6707_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_selector_in_constructorDef6709  */
static	ANTLR3_BITWORD FOLLOW_selector_in_constructorDef6709_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000000), ANTLR3_UINT64_LIT(0x0000000000000020) };
static  ANTLR3_BITSET_LIST FOLLOW_selector_in_constructorDef6709	= { FOLLOW_selector_in_constructorDef6709_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_RPAREN_TOK_in_constructorDef6712  */
static	ANTLR3_BITWORD FOLLOW_RPAREN_TOK_in_constructorDef6712_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002), ANTLR3_UINT64_LIT(0x0001000000000000) };
static  ANTLR3_BITSET_LIST FOLLOW_RPAREN_TOK_in_constructorDef6712	= { FOLLOW_RPAREN_TOK_in_constructorDef6712_bits, 2	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_symbol_in_selector6740  */
static	ANTLR3_BITWORD FOLLOW_symbol_in_selector6740_bits[]	= { ANTLR3_UINT64_LIT(0x0000009000500000), ANTLR3_UINT64_LIT(0x2001040000000000), ANTLR3_UINT64_LIT(0x0000000108600500) };
static  ANTLR3_BITSET_LIST FOLLOW_symbol_in_selector6740	= { FOLLOW_symbol_in_selector6740_bits, 3	};
/** Bitset defining follow set for error recovery in rule state: FOLLOW_sortSymbol_in_selector6743  */
static	ANTLR3_BITWORD FOLLOW_sortSymbol_in_selector6743_bits[]	= { ANTLR3_UINT64_LIT(0x0000000000000002) };
static  ANTLR3_BITSET_LIST FOLLOW_sortSymbol_in_selector6743	= { FOLLOW_sortSymbol_in_selector6743_bits, 1	};


/* ==============================================
 * Parsing rules
 */
/**
 * $ANTLR start parseExpr
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:195:1: parseExpr returns [CVC4::parser::smt2::myExpr expr] : ( term[expr, expr2] | EOF );
 */
static CVC4::parser::smt2::myExpr
parseExpr(pSmt2Parser ctx)
{
    CVC4::parser::smt2::myExpr expr;



      Expr expr2;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:199:3: ( term[expr, expr2] | EOF )

            ANTLR3_UINT32 alt1;

            alt1=2;

            switch ( LA(1) )
            {
            case BINARY_LITERAL:
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECIMAL_LITERAL:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case EMPTYSET_TOK:
            case FP_RNA_FULL_TOK:
            case FP_RNA_TOK:
            case FP_RNE_FULL_TOK:
            case FP_RNE_TOK:
            case FP_RTN_FULL_TOK:
            case FP_RTN_TOK:
            case FP_RTP_FULL_TOK:
            case FP_RTP_TOK:
            case FP_RTZ_FULL_TOK:
            case FP_RTZ_TOK:
            case HEX_LITERAL:
            case INTEGER_LITERAL:
            case INV_CONSTRAINT_TOK:
            case LPAREN_TOK:
            case NILREF_TOK:
            case QUOTED_SYMBOL:
            case REALLCHAR_TOK:
            case REAL_PI_TOK:
            case RENOSTR_TOK:
            case SET_OPTIONS_TOK:
            case SIMPLE_SYMBOL:
            case STRING_LITERAL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case TUPLE_CONST_TOK:
            case UNIVSET_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case 160:
            	{
            		alt1=1;
            	}
                break;
            case EOF:
            	{
            		alt1=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 1;
                EXCEPTION->state        = 0;


                goto ruleparseExprEx;

            }

            switch (alt1)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:199:5: term[expr, expr2]
        	    {
        	        FOLLOWPUSH(FOLLOW_term_in_parseExpr119);
        	        term(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseExprEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:200:5: EOF
        	    {
        	         MATCHT(EOF, &FOLLOW_EOF_in_parseExpr126);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseExprEx;
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruleparseExprEx; /* Prevent compiler warnings */
    ruleparseExprEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return expr;
}
/* $ANTLR end parseExpr */

/**
 * $ANTLR start parseCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:207:1: parseCommand returns [CVC4::Command* cmd_return = NULL] : ( LPAREN_TOK command[&cmd] RPAREN_TOK | LPAREN_TOK INCLUDE_TOK str[name,true] RPAREN_TOK | EOF );
 */
static CVC4::Command*
parseCommand(pSmt2Parser ctx)
{
    CVC4::Command* cmd_return;



      std::unique_ptr<CVC4::Command> cmd;
      std::string name;

    /* Initialize rule variables
     */
    cmd_return =  NULL;


    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:215:3: ( LPAREN_TOK command[&cmd] RPAREN_TOK | LPAREN_TOK INCLUDE_TOK str[name,true] RPAREN_TOK | EOF )

            ANTLR3_UINT32 alt2;

            alt2=3;

            switch ( LA(1) )
            {
            case LPAREN_TOK:
            	{
            		switch ( LA(2) )
            		{
            		case INCLUDE_TOK:
            			{
            				alt2=2;
            			}
            		    break;
            		case ASSERT_TOK:
            		case CHECK_SAT_ASSUMING_TOK:
            		case CHECK_SAT_TOK:
            		case DECLARE_CODATATYPES_2_5_TOK:
            		case DECLARE_CODATATYPES_TOK:
            		case DECLARE_CODATATYPE_TOK:
            		case DECLARE_CONST_TOK:
            		case DECLARE_DATATYPES_2_5_TOK:
            		case DECLARE_DATATYPES_TOK:
            		case DECLARE_DATATYPE_TOK:
            		case DECLARE_FUNS_TOK:
            		case DECLARE_FUN_TOK:
            		case DECLARE_HEAP:
            		case DECLARE_PREDS_TOK:
            		case DECLARE_SORTS_TOK:
            		case DECLARE_SORT_TOK:
            		case DEFINE_CONST_TOK:
            		case DEFINE_FUNS_REC_TOK:
            		case DEFINE_FUN_REC_TOK:
            		case DEFINE_FUN_TOK:
            		case DEFINE_SORT_TOK:
            		case DEFINE_TOK:
            		case ECHO_TOK:
            		case EXIT_TOK:
            		case GET_ASSERTIONS_TOK:
            		case GET_ASSIGNMENT_TOK:
            		case GET_INFO_TOK:
            		case GET_MODEL_TOK:
            		case GET_OPTION_TOK:
            		case GET_PROOF_TOK:
            		case GET_QE_DISJUNCT_TOK:
            		case GET_QE_TOK:
            		case GET_UNSAT_ASSUMPTIONS_TOK:
            		case GET_UNSAT_CORE_TOK:
            		case GET_VALUE_TOK:
            		case META_INFO_TOK:
            		case POP_TOK:
            		case PROPAGATION_RULE_TOK:
            		case PUSH_TOK:
            		case REDUCTION_RULE_TOK:
            		case RESET_ASSERTIONS_TOK:
            		case RESET_TOK:
            		case REWRITE_RULE_TOK:
            		case SET_INFO_TOK:
            		case SET_LOGIC_TOK:
            		case SET_OPTION_TOK:
            		case SIMPLE_SYMBOL:
            		case SIMPLIFY_TOK:
            			{
            				alt2=1;
            			}
            		    break;

            		default:
            		    CONSTRUCTEX();
            		    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
            		    EXCEPTION->message      = (void *)"";
            		    EXCEPTION->decisionNum  = 2;
            		    EXCEPTION->state        = 1;


            		    goto ruleparseCommandEx;

            		}

            	}
                break;
            case EOF:
            	{
            		alt2=3;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 2;
                EXCEPTION->state        = 0;


                goto ruleparseCommandEx;

            }

            switch (alt2)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:215:5: LPAREN_TOK command[&cmd] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_parseCommand155);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_command_in_parseCommand157);
        	        command(ctx, &cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_parseCommand160);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:220:5: LPAREN_TOK INCLUDE_TOK str[name,true] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_parseCommand173);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	         MATCHT(INCLUDE_TOK, &FOLLOW_INCLUDE_TOK_in_parseCommand175);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_str_in_parseCommand177);
        	        str(ctx, name, true);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_parseCommand180);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	        {
        	             if(!PARSER_STATE->canIncludeFile()) {
        	                    PARSER_STATE->parseError("include-file feature was disabled for this "
        	                                             "run.");
        	                  }
        	                  if(PARSER_STATE->strictModeEnabled()) {
        	                    PARSER_STATE->parseError("Extended commands are not permitted while "
        	                                             "operating in strict compliance mode.");
        	                  }
        	                  PARSER_STATE->includeFile(name);
        	                  // The command of the included file will be produced at the next
        	                  // parseCommand() call
        	                  cmd.reset(new EmptyCommand("include::" + name));
        	                
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:235:5: EOF
        	    {
        	         MATCHT(EOF, &FOLLOW_EOF_in_parseCommand193);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseCommandEx;
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruleparseCommandEx; /* Prevent compiler warnings */
    ruleparseCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
            else
            {
                {

                      cmd_return = cmd.release();

                }
            }


    return cmd_return;
}
/* $ANTLR end parseCommand */

/**
 * $ANTLR start parseSygus
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:243:1: parseSygus returns [CVC4::Command* cmd_return = NULL] : ( LPAREN_TOK sygusCommand[&cmd] RPAREN_TOK | EOF );
 */
static CVC4::Command*
parseSygus(pSmt2Parser ctx)
{
    CVC4::Command* cmd_return;



      std::unique_ptr<CVC4::Command> cmd;
      std::string name;

    /* Initialize rule variables
     */
    cmd_return =  NULL;


    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:251:3: ( LPAREN_TOK sygusCommand[&cmd] RPAREN_TOK | EOF )

            ANTLR3_UINT32 alt3;

            alt3=2;

            switch ( LA(1) )
            {
            case LPAREN_TOK:
            	{
            		alt3=1;
            	}
                break;
            case EOF:
            	{
            		alt3=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 3;
                EXCEPTION->state        = 0;


                goto ruleparseSygusEx;

            }

            switch (alt3)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:251:5: LPAREN_TOK sygusCommand[&cmd] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_parseSygus222);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseSygusEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sygusCommand_in_parseSygus224);
        	        sygusCommand(ctx, &cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseSygusEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_parseSygus227);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseSygusEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:252:5: EOF
        	    {
        	         MATCHT(EOF, &FOLLOW_EOF_in_parseSygus233);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleparseSygusEx;
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruleparseSygusEx; /* Prevent compiler warnings */
    ruleparseSygusEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
            else
            {
                {

                      cmd_return = cmd.release();

                }
            }


    return cmd_return;
}
/* $ANTLR end parseSygus */

/**
 * $ANTLR start command
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:259:1: command[std::unique_ptr<CVC4::Command>* cmd] : ( SET_LOGIC_TOK symbol[name,CHECK_NONE,SYM_SORT] | SET_INFO_TOK metaInfoInternal[cmd] | GET_INFO_TOK KEYWORD | SET_OPTION_TOK setOptionInternal[cmd] | GET_OPTION_TOK KEYWORD | DECLARE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL | DEFINE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] LPAREN_TOK symbolList[names,CHECK_NONE,SYM_SORT] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] | DECLARE_FUN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortList[sorts] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] | DEFINE_FUN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2] | DECLARE_DATATYPE_TOK datatypeDefCommand[false, cmd] | DECLARE_DATATYPES_TOK datatypesDefCommand[false, cmd] | GET_VALUE_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK ) | GET_ASSIGNMENT_TOK | ASSERT_TOK term[expr, expr2] | CHECK_SAT_TOK ( term[expr, expr2] |) | CHECK_SAT_ASSUMING_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK ) | GET_ASSERTIONS_TOK | GET_PROOF_TOK | GET_UNSAT_ASSUMPTIONS_TOK | GET_UNSAT_CORE_TOK | PUSH_TOK (k= INTEGER_LITERAL |) | POP_TOK (k= INTEGER_LITERAL |) | EXIT_TOK | smt25Command[cmd] | extendedCommand[cmd] | SIMPLE_SYMBOL );
 */
static void
command(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::string name;
      std::vector<std::string> names;
      Expr expr, expr2;
      Type t;
      std::vector<Expr> terms;
      std::vector<Type> sorts;
      std::vector<std::pair<std::string, Type> > sortedVarNames;
      std::vector<Expr> flattenVars;

    pANTLR3_COMMON_TOKEN    n;
    pANTLR3_COMMON_TOKEN    k;
    pANTLR3_COMMON_TOKEN    KEYWORD1;
    pANTLR3_COMMON_TOKEN    KEYWORD2;
    pANTLR3_COMMON_TOKEN    SIMPLE_SYMBOL3;

    /* Initialize rule variables
     */

    n       = NULL;
    k       = NULL;
    KEYWORD1       = NULL;
    KEYWORD2       = NULL;
    SIMPLE_SYMBOL3       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:270:3: ( SET_LOGIC_TOK symbol[name,CHECK_NONE,SYM_SORT] | SET_INFO_TOK metaInfoInternal[cmd] | GET_INFO_TOK KEYWORD | SET_OPTION_TOK setOptionInternal[cmd] | GET_OPTION_TOK KEYWORD | DECLARE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL | DEFINE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] LPAREN_TOK symbolList[names,CHECK_NONE,SYM_SORT] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] | DECLARE_FUN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortList[sorts] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] | DEFINE_FUN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2] | DECLARE_DATATYPE_TOK datatypeDefCommand[false, cmd] | DECLARE_DATATYPES_TOK datatypesDefCommand[false, cmd] | GET_VALUE_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK ) | GET_ASSIGNMENT_TOK | ASSERT_TOK term[expr, expr2] | CHECK_SAT_TOK ( term[expr, expr2] |) | CHECK_SAT_ASSUMING_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK ) | GET_ASSERTIONS_TOK | GET_PROOF_TOK | GET_UNSAT_ASSUMPTIONS_TOK | GET_UNSAT_CORE_TOK | PUSH_TOK (k= INTEGER_LITERAL |) | POP_TOK (k= INTEGER_LITERAL |) | EXIT_TOK | smt25Command[cmd] | extendedCommand[cmd] | SIMPLE_SYMBOL )

            ANTLR3_UINT32 alt9;

            alt9=26;

            switch ( LA(1) )
            {
            case SET_LOGIC_TOK:
            	{
            		alt9=1;
            	}
                break;
            case SET_INFO_TOK:
            	{
            		alt9=2;
            	}
                break;
            case GET_INFO_TOK:
            	{
            		alt9=3;
            	}
                break;
            case SET_OPTION_TOK:
            	{
            		alt9=4;
            	}
                break;
            case GET_OPTION_TOK:
            	{
            		alt9=5;
            	}
                break;
            case DECLARE_SORT_TOK:
            	{
            		alt9=6;
            	}
                break;
            case DEFINE_SORT_TOK:
            	{
            		alt9=7;
            	}
                break;
            case DECLARE_FUN_TOK:
            	{
            		alt9=8;
            	}
                break;
            case DEFINE_FUN_TOK:
            	{
            		alt9=9;
            	}
                break;
            case DECLARE_DATATYPE_TOK:
            	{
            		alt9=10;
            	}
                break;
            case DECLARE_DATATYPES_TOK:
            	{
            		alt9=11;
            	}
                break;
            case GET_VALUE_TOK:
            	{
            		alt9=12;
            	}
                break;
            case GET_ASSIGNMENT_TOK:
            	{
            		alt9=13;
            	}
                break;
            case ASSERT_TOK:
            	{
            		alt9=14;
            	}
                break;
            case CHECK_SAT_TOK:
            	{
            		alt9=15;
            	}
                break;
            case CHECK_SAT_ASSUMING_TOK:
            	{
            		alt9=16;
            	}
                break;
            case GET_ASSERTIONS_TOK:
            	{
            		alt9=17;
            	}
                break;
            case GET_PROOF_TOK:
            	{
            		alt9=18;
            	}
                break;
            case GET_UNSAT_ASSUMPTIONS_TOK:
            	{
            		alt9=19;
            	}
                break;
            case GET_UNSAT_CORE_TOK:
            	{
            		alt9=20;
            	}
                break;
            case PUSH_TOK:
            	{
            		alt9=21;
            	}
                break;
            case POP_TOK:
            	{
            		alt9=22;
            	}
                break;
            case EXIT_TOK:
            	{
            		alt9=23;
            	}
                break;
            case DECLARE_CONST_TOK:
            case DEFINE_FUNS_REC_TOK:
            case DEFINE_FUN_REC_TOK:
            case ECHO_TOK:
            case GET_MODEL_TOK:
            case META_INFO_TOK:
            case RESET_ASSERTIONS_TOK:
            case RESET_TOK:
            	{
            		alt9=24;
            	}
                break;
            case DECLARE_CODATATYPES_2_5_TOK:
            case DECLARE_CODATATYPES_TOK:
            case DECLARE_CODATATYPE_TOK:
            case DECLARE_DATATYPES_2_5_TOK:
            case DECLARE_FUNS_TOK:
            case DECLARE_HEAP:
            case DECLARE_PREDS_TOK:
            case DECLARE_SORTS_TOK:
            case DEFINE_CONST_TOK:
            case DEFINE_TOK:
            case GET_QE_DISJUNCT_TOK:
            case GET_QE_TOK:
            case PROPAGATION_RULE_TOK:
            case REDUCTION_RULE_TOK:
            case REWRITE_RULE_TOK:
            case SIMPLIFY_TOK:
            	{
            		alt9=25;
            	}
                break;
            case SIMPLE_SYMBOL:
            	{
            		alt9=26;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 9;
                EXCEPTION->state        = 0;


                goto rulecommandEx;

            }

            switch (alt9)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:271:5: SET_LOGIC_TOK symbol[name,CHECK_NONE,SYM_SORT]
        	    {
        	         MATCHT(SET_LOGIC_TOK, &FOLLOW_SET_LOGIC_TOK_in_command261);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_command263);
        	        symbol(ctx, name, CHECK_NONE, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             Debug("parser") << "set logic: '" << name << "'" << std::endl;
        	                  if( PARSER_STATE->logicIsSet() ) {
        	                    PARSER_STATE->parseError("Only one set-logic is allowed.");
        	                  }
        	                  PARSER_STATE->setLogic(name);
        	                  if( PARSER_STATE->sygus() ){
        	                    cmd->reset(new SetBenchmarkLogicCommand(PARSER_STATE->getLogic().getLogicString()));
        	                  }else{
        	                    cmd->reset(new SetBenchmarkLogicCommand(name));
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:284:5: SET_INFO_TOK metaInfoInternal[cmd]
        	    {
        	         MATCHT(SET_INFO_TOK, &FOLLOW_SET_INFO_TOK_in_command282);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_metaInfoInternal_in_command284);
        	        metaInfoInternal(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:286:5: GET_INFO_TOK KEYWORD
        	    {
        	         MATCHT(GET_INFO_TOK, &FOLLOW_GET_INFO_TOK_in_command297);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        KEYWORD1 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_command299);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             cmd->reset(new GetInfoCommand(
        	                      AntlrInput::tokenText(KEYWORD1).c_str() + 1));
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:291:5: SET_OPTION_TOK setOptionInternal[cmd]
        	    {
        	         MATCHT(SET_OPTION_TOK, &FOLLOW_SET_OPTION_TOK_in_command317);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_setOptionInternal_in_command319);
        	        setOptionInternal(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:293:5: GET_OPTION_TOK KEYWORD
        	    {
        	         MATCHT(GET_OPTION_TOK, &FOLLOW_GET_OPTION_TOK_in_command332);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        KEYWORD2 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_command334);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             cmd->reset(new GetOptionCommand(
        	                      AntlrInput::tokenText(KEYWORD2).c_str() + 1));
        	                
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:298:5: DECLARE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL
        	    {
        	         MATCHT(DECLARE_SORT_TOK, &FOLLOW_DECLARE_SORT_TOK_in_command352);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             if(!PARSER_STATE->isTheoryEnabled(Smt2::THEORY_UF) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_ARRAYS) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_DATATYPES) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_SETS)) {
        	                      PARSER_STATE->parseErrorLogic("Free sort symbols not allowed in ");
        	                  }
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_command366);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_command381);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             Debug("parser") << "declare sort: '" << name
        	                                  << "' arity=" << n << std::endl;
        	                  unsigned arity = AntlrInput::tokenToUnsigned(n);
        	                  if(arity == 0) {
        	                    Type type = PARSER_STATE->mkSort(name);
        	                    cmd->reset(new DeclareTypeCommand(name, 0, type));
        	                  } else {
        	                    Type type = PARSER_STATE->mkSortConstructor(name, arity);
        	                    cmd->reset(new DeclareTypeCommand(name, arity, type));
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:321:5: DEFINE_SORT_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] LPAREN_TOK symbolList[names,CHECK_NONE,SYM_SORT] RPAREN_TOK sortSymbol[t,CHECK_DECLARED]
        	    {
        	         MATCHT(DEFINE_SORT_TOK, &FOLLOW_DEFINE_SORT_TOK_in_command399);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_command407);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_command420);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_symbolList_in_command422);
        	        symbolList(ctx, names, CHECK_NONE, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_command425);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::string>::const_iterator i = names.begin(),
        	                        iend = names.end();
        	                      i != iend;
        	                      ++i) {
        	                    sorts.push_back(PARSER_STATE->mkSort(*i));
        	                  }
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_command437);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->popScope();
        	                  // Do NOT call mkSort, since that creates a new sort!
        	                  // This name is not its own distinct sort, it's an alias.
        	                  PARSER_STATE->defineParameterizedType(name, sorts, t);
        	                  cmd->reset(new DefineTypeCommand(name, sorts, t));
        	                
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:341:5: DECLARE_FUN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortList[sorts] RPAREN_TOK sortSymbol[t,CHECK_DECLARED]
        	    {
        	         MATCHT(DECLARE_FUN_TOK, &FOLLOW_DECLARE_FUN_TOK_in_command456);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_command464);
        	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_command477);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortList_in_command479);
        	        sortList(ctx, sorts);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_command482);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_command488);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             Debug("parser") << "declare fun: '" << name << "'" << std::endl;
        	                  if( !sorts.empty() ) {
        	                    t = PARSER_STATE->mkFlatFunctionType(sorts, t);
        	                  }
        	                  if(t.isFunction() && !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_UF)) {
        	                    PARSER_STATE->parseErrorLogic("Functions (of non-zero arity) cannot "
        	                                                  "be declared in logic ");
        	                  }
        	                  // we allow overloading for function declarations
        	                  if (PARSER_STATE->sygus())
        	                  {
        	                    // it is a higher-order universal variable
        	                    Expr func = PARSER_STATE->mkBoundVar(name, t);
        	                    cmd->reset(new DeclareSygusFunctionCommand(name, func, t));
        	                  }
        	                  else
        	                  {
        	                    Expr func = PARSER_STATE->mkVar(name, t, ExprManager::VAR_FLAG_NONE, true);
        	                    cmd->reset(new DeclareFunctionCommand(name, func, t));
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 9:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:368:5: DEFINE_FUN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2]
        	    {
        	         MATCHT(DEFINE_FUN_TOK, &FOLLOW_DEFINE_FUN_TOK_in_command507);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_command515);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_command528);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_command530);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_command533);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_command539);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             /* add variables to parser state before parsing term */
        	                  Debug("parser") << "define fun: '" << name << "'" << std::endl;
        	                  if( sortedVarNames.size() > 0 ) {
        	                    sorts.reserve(sortedVarNames.size());
        	                    for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                          sortedVarNames.begin(), iend = sortedVarNames.end();
        	                        i != iend;
        	                        ++i) {
        	                      sorts.push_back((*i).second);
        	                    }
        	                    t = PARSER_STATE->mkFlatFunctionType(sorts, t, flattenVars);
        	                  }
        	                  PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                        sortedVarNames.begin(), iend = sortedVarNames.end();
        	                      i != iend;
        	                      ++i) {
        	                    terms.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	                  }
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_command552);
        	        term(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {

        	                  if( !flattenVars.empty() ){
        	                    // if this function has any implicit variables flattenVars,
        	                    // we apply the body of the definition to the flatten vars
        	                    expr = PARSER_STATE->mkHoApply(expr, flattenVars);
        	                    terms.insert(terms.end(), flattenVars.begin(), flattenVars.end());
        	                  }
        	                  PARSER_STATE->popScope();
        	                  // declare the name down here (while parsing term, signature
        	                  // must not be extended with the name itself; no recursion
        	                  // permitted)
        	                  // we allow overloading for function definitions
        	                  Expr func = PARSER_STATE->mkFunction(name, t,
        	                                                       ExprManager::VAR_FLAG_DEFINED, true);
        	                  cmd->reset(new DefineFunctionCommand(name, func, terms, expr));
        	                
        	        }


        	    }
        	    break;
        	case 10:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:410:5: DECLARE_DATATYPE_TOK datatypeDefCommand[false, cmd]
        	    {
        	         MATCHT(DECLARE_DATATYPE_TOK, &FOLLOW_DECLARE_DATATYPE_TOK_in_command565);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypeDefCommand_in_command567);
        	        datatypeDefCommand(ctx, false, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	    }
        	    break;
        	case 11:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:411:5: DECLARE_DATATYPES_TOK datatypesDefCommand[false, cmd]
        	    {
        	         MATCHT(DECLARE_DATATYPES_TOK, &FOLLOW_DECLARE_DATATYPES_TOK_in_command574);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypesDefCommand_in_command576);
        	        datatypesDefCommand(ctx, false, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	    }
        	    break;
        	case 12:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:413:5: GET_VALUE_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK )
        	    {
        	         MATCHT(GET_VALUE_TOK, &FOLLOW_GET_VALUE_TOK_in_command589);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:414:5: ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK )
        	        {
        	            int alt4=2;
        	            switch ( LA(1) )
        	            {
        	            case LPAREN_TOK:
        	            	{
        	            		alt4=1;
        	            	}
        	                break;
        	            case ALPHA:
        	            case AMPERSAND_TOK:
        	            case AND_TOK:
        	            case ASSERT_TOK:
        	            case AS_TOK:
        	            case ATTRIBUTE_INST_LEVEL:
        	            case ATTRIBUTE_NAMED_TOK:
        	            case ATTRIBUTE_NO_PATTERN_TOK:
        	            case ATTRIBUTE_PATTERN_TOK:
        	            case ATTRIBUTE_RR_PRIORITY:
        	            case ATTRIBUTE_TOK:
        	            case AT_TOK:
        	            case BINARY_LITERAL:
        	            case BV2NAT_TOK:
        	            case CHECK_SAT_ASSUMING_TOK:
        	            case CHECK_SAT_TOK:
        	            case CHECK_SYNTH_TOK:
        	            case COMMENT:
        	            case CONSTRAINT_TOK:
        	            case CONST_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_CODATATYPES_2_5_TOK:
        	            case DECLARE_CODATATYPES_TOK:
        	            case DECLARE_CODATATYPE_TOK:
        	            case DECLARE_CONST_TOK:
        	            case DECLARE_DATATYPES_2_5_TOK:
        	            case DECLARE_DATATYPES_TOK:
        	            case DECLARE_DATATYPE_TOK:
        	            case DECLARE_FUNS_TOK:
        	            case DECLARE_FUN_TOK:
        	            case DECLARE_HEAP:
        	            case DECLARE_PREDS_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_SORTS_TOK:
        	            case DECLARE_SORT_TOK:
        	            case DECLARE_VAR_TOK:
        	            case DEFINE_CONST_TOK:
        	            case DEFINE_FUNS_REC_TOK:
        	            case DEFINE_FUN_REC_TOK:
        	            case DEFINE_FUN_TOK:
        	            case DEFINE_SORT_TOK:
        	            case DEFINE_TOK:
        	            case DIGIT:
        	            case DISTINCT_TOK:
        	            case DIVISIBLE_TOK:
        	            case DIV_TOK:
        	            case DTSIZE_TOK:
        	            case ECHO_TOK:
        	            case EMPTYSET_TOK:
        	            case EMP_TOK:
        	            case EQUAL_TOK:
        	            case EXISTS_TOK:
        	            case EXIT_TOK:
        	            case FMFCARDVAL_TOK:
        	            case FMFCARD_TOK:
        	            case FORALL_TOK:
        	            case FP_NAN_TOK:
        	            case FP_NINF_TOK:
        	            case FP_NZERO_TOK:
        	            case FP_PINF_TOK:
        	            case FP_PZERO_TOK:
        	            case FP_RNA_FULL_TOK:
        	            case FP_RNA_TOK:
        	            case FP_RNE_FULL_TOK:
        	            case FP_RNE_TOK:
        	            case FP_RTN_FULL_TOK:
        	            case FP_RTN_TOK:
        	            case FP_RTP_FULL_TOK:
        	            case FP_RTP_TOK:
        	            case FP_RTZ_FULL_TOK:
        	            case FP_RTZ_TOK:
        	            case FP_TO_FPBV_TOK:
        	            case FP_TO_FPFP_TOK:
        	            case FP_TO_FPR_TOK:
        	            case FP_TO_FPS_TOK:
        	            case FP_TO_FPU_TOK:
        	            case FP_TO_FP_TOK:
        	            case FP_TO_SBV_TOK:
        	            case FP_TO_UBV_TOK:
        	            case GET_ASSERTIONS_TOK:
        	            case GET_ASSIGNMENT_TOK:
        	            case GET_INFO_TOK:
        	            case GET_MODEL_TOK:
        	            case GET_OPTION_TOK:
        	            case GET_PROOF_TOK:
        	            case GET_QE_DISJUNCT_TOK:
        	            case GET_QE_TOK:
        	            case GET_UNSAT_ASSUMPTIONS_TOK:
        	            case GET_UNSAT_CORE_TOK:
        	            case GET_VALUE_TOK:
        	            case GREATER_THAN_EQUAL_TOK:
        	            case GREATER_THAN_TOK:
        	            case HEX_DIGIT:
        	            case HEX_LITERAL:
        	            case HO_ARROW_TOK:
        	            case HO_LAMBDA_TOK:
        	            case IMPLIES_TOK:
        	            case INCLUDE_TOK:
        	            case INDEX_TOK:
        	            case INST_CLOSURE_TOK:
        	            case INT2BV_TOK:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case ITE_TOK:
        	            case KEYWORD:
        	            case LESS_THAN_EQUAL_TOK:
        	            case LESS_THAN_TOK:
        	            case LET_TOK:
        	            case MATCH_TOK:
        	            case META_INFO_TOK:
        	            case MINUS_TOK:
        	            case NILREF_TOK:
        	            case NOT_TOK:
        	            case NUMERAL:
        	            case OR_TOK:
        	            case PAR_TOK:
        	            case PLUS_TOK:
        	            case POP_TOK:
        	            case PROPAGATION_RULE_TOK:
        	            case PUSH_TOK:
        	            case QUOTED_SYMBOL:
        	            case REALLCHAR_TOK:
        	            case REAL_PI_TOK:
        	            case REDUCTION_RULE_TOK:
        	            case RENOSTR_TOK:
        	            case RESET_ASSERTIONS_TOK:
        	            case RESET_TOK:
        	            case REWRITE_RULE_TOK:
        	            case RPAREN_TOK:
        	            case SET_INFO_TOK:
        	            case SET_LOGIC_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SET_OPTION_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SIMPLIFY_TOK:
        	            case STAR_TOK:
        	            case STRING_LITERAL:
        	            case SYGUS_CONSTANT_TOK:
        	            case SYGUS_INPUT_VARIABLE_TOK:
        	            case SYGUS_LET_TOK:
        	            case SYGUS_LOCAL_VARIABLE_TOK:
        	            case SYGUS_VARIABLE_TOK:
        	            case SYMBOL_CHAR:
        	            case SYMBOL_CHAR_NOUNDERSCORE_NOATTRIBUTE:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case TESTER_TOK:
        	            case TUPLE_CONST_TOK:
        	            case TUPLE_SEL_TOK:
        	            case UNIVSET_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case WHITESPACE:
        	            case XOR_TOK:
        	            case 158:
        	            case 159:
        	            case 160:
        	            case 161:
        	            case 162:
        	            case 163:
        	            case 164:
        	            	{
        	            		alt4=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 4;
        	                EXCEPTION->state        = 0;


        	                goto rulecommandEx;

        	            }

        	            switch (alt4)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:414:7: LPAREN_TOK termList[terms,expr] RPAREN_TOK
        	        	    {
        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_command599);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_termList_in_command601);
        	        	        termList(ctx, terms, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_command604);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             cmd->reset(new GetValueCommand(terms)); 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:416:7: ~ LPAREN_TOK
        	        	    {
        	        	        if ( ((LA(1) >= ALPHA) && (LA(1) <= LET_TOK)) || ((LA(1) >= MATCH_TOK) && (LA(1) <= 164)) )
        	        	        {
        	        	            CONSUME();
        	        	            PERRORRECOVERY=ANTLR3_FALSE;
        	        	        }
        	        	        else
        	        	        {
        	        	            CONSTRUCTEX();
        	        	            EXCEPTION->type         = ANTLR3_MISMATCHED_SET_EXCEPTION;
        	        	            EXCEPTION->name         = (void *)ANTLR3_MISMATCHED_SET_NAME;
        	        	            EXCEPTION->expectingSet = NULL;

        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->parseError("The get-value command expects a list of "
        	        	                                             "terms.  Perhaps you forgot a pair of "
        	        	                                             "parentheses?");
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 13:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:423:5: GET_ASSIGNMENT_TOK
        	    {
        	         MATCHT(GET_ASSIGNMENT_TOK, &FOLLOW_GET_ASSIGNMENT_TOK_in_command647);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetAssignmentCommand()); 
        	        }


        	    }
        	    break;
        	case 14:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:426:5: ASSERT_TOK term[expr, expr2]
        	    {
        	         MATCHT(ASSERT_TOK, &FOLLOW_ASSERT_TOK_in_command667);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             PARSER_STATE->clearLastNamedTerm(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_command687);
        	        term(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             bool inUnsatCore = PARSER_STATE->lastNamedTerm().first == expr;
        	                  cmd->reset(new AssertCommand(expr, inUnsatCore));
        	                  if(inUnsatCore) {
        	                    // set the expression name, if there was a named term
        	                    std::pair<Expr, std::string> namedTerm = PARSER_STATE->lastNamedTerm();
        	                    Command* csen = new SetExpressionNameCommand(namedTerm.first, namedTerm.second);
        	                    csen->setMuted(true);
        	                    PARSER_STATE->preemptCommand(csen);
        	                  }
        	                  // if sygus, check whether it has a free variable
        	                  // this is because, due to the sygus format, one can write assertions
        	                  // that have free function variables in them
        	                  if (PARSER_STATE->sygus())
        	                  {
        	                    if (expr.hasFreeVariable())
        	                    {
        	                      PARSER_STATE->parseError("Assertion has free variable. Perhaps you "
        	                                               "meant constraint instead of assert?");
        	                    }
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 15:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:455:5: CHECK_SAT_TOK ( term[expr, expr2] |)
        	    {
        	         MATCHT(CHECK_SAT_TOK, &FOLLOW_CHECK_SAT_TOK_in_command706);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             if( PARSER_STATE->sygus() ){
        	                    PARSER_STATE->parseError("Sygus does not support check-sat command.");
        	                  }
        	                
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:460:5: ( term[expr, expr2] |)
        	        {
        	            int alt5=2;
        	            switch ( LA(1) )
        	            {
        	            case BINARY_LITERAL:
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case EMPTYSET_TOK:
        	            case FP_RNA_FULL_TOK:
        	            case FP_RNA_TOK:
        	            case FP_RNE_FULL_TOK:
        	            case FP_RNE_TOK:
        	            case FP_RTN_FULL_TOK:
        	            case FP_RTN_TOK:
        	            case FP_RTP_FULL_TOK:
        	            case FP_RTP_TOK:
        	            case FP_RTZ_FULL_TOK:
        	            case FP_RTZ_TOK:
        	            case HEX_LITERAL:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case LPAREN_TOK:
        	            case NILREF_TOK:
        	            case QUOTED_SYMBOL:
        	            case REALLCHAR_TOK:
        	            case REAL_PI_TOK:
        	            case RENOSTR_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case STRING_LITERAL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case TUPLE_CONST_TOK:
        	            case UNIVSET_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt5=1;
        	            	}
        	                break;
        	            case RPAREN_TOK:
        	            	{
        	            		alt5=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 5;
        	                EXCEPTION->state        = 0;


        	                goto rulecommandEx;

        	            }

        	            switch (alt5)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:460:7: term[expr, expr2]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_term_in_command722);
        	        	        term(ctx, expr, expr2);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             if(PARSER_STATE->strictModeEnabled()) {
        	        	                      PARSER_STATE->parseError(
        	        	                          "Extended commands (such as check-sat with an argument) are not "
        	        	                          "permitted while operating in strict compliance mode.");
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:467:7: 
        	        	    {
        	        	        {
        	        	             expr = Expr(); 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {
        	             cmd->reset(new CheckSatCommand(expr)); 
        	        }


        	    }
        	    break;
        	case 16:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:471:5: CHECK_SAT_ASSUMING_TOK ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK )
        	    {
        	         MATCHT(CHECK_SAT_ASSUMING_TOK, &FOLLOW_CHECK_SAT_ASSUMING_TOK_in_command763);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:472:5: ( LPAREN_TOK termList[terms,expr] RPAREN_TOK |~ LPAREN_TOK )
        	        {
        	            int alt6=2;
        	            switch ( LA(1) )
        	            {
        	            case LPAREN_TOK:
        	            	{
        	            		alt6=1;
        	            	}
        	                break;
        	            case ALPHA:
        	            case AMPERSAND_TOK:
        	            case AND_TOK:
        	            case ASSERT_TOK:
        	            case AS_TOK:
        	            case ATTRIBUTE_INST_LEVEL:
        	            case ATTRIBUTE_NAMED_TOK:
        	            case ATTRIBUTE_NO_PATTERN_TOK:
        	            case ATTRIBUTE_PATTERN_TOK:
        	            case ATTRIBUTE_RR_PRIORITY:
        	            case ATTRIBUTE_TOK:
        	            case AT_TOK:
        	            case BINARY_LITERAL:
        	            case BV2NAT_TOK:
        	            case CHECK_SAT_ASSUMING_TOK:
        	            case CHECK_SAT_TOK:
        	            case CHECK_SYNTH_TOK:
        	            case COMMENT:
        	            case CONSTRAINT_TOK:
        	            case CONST_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_CODATATYPES_2_5_TOK:
        	            case DECLARE_CODATATYPES_TOK:
        	            case DECLARE_CODATATYPE_TOK:
        	            case DECLARE_CONST_TOK:
        	            case DECLARE_DATATYPES_2_5_TOK:
        	            case DECLARE_DATATYPES_TOK:
        	            case DECLARE_DATATYPE_TOK:
        	            case DECLARE_FUNS_TOK:
        	            case DECLARE_FUN_TOK:
        	            case DECLARE_HEAP:
        	            case DECLARE_PREDS_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_SORTS_TOK:
        	            case DECLARE_SORT_TOK:
        	            case DECLARE_VAR_TOK:
        	            case DEFINE_CONST_TOK:
        	            case DEFINE_FUNS_REC_TOK:
        	            case DEFINE_FUN_REC_TOK:
        	            case DEFINE_FUN_TOK:
        	            case DEFINE_SORT_TOK:
        	            case DEFINE_TOK:
        	            case DIGIT:
        	            case DISTINCT_TOK:
        	            case DIVISIBLE_TOK:
        	            case DIV_TOK:
        	            case DTSIZE_TOK:
        	            case ECHO_TOK:
        	            case EMPTYSET_TOK:
        	            case EMP_TOK:
        	            case EQUAL_TOK:
        	            case EXISTS_TOK:
        	            case EXIT_TOK:
        	            case FMFCARDVAL_TOK:
        	            case FMFCARD_TOK:
        	            case FORALL_TOK:
        	            case FP_NAN_TOK:
        	            case FP_NINF_TOK:
        	            case FP_NZERO_TOK:
        	            case FP_PINF_TOK:
        	            case FP_PZERO_TOK:
        	            case FP_RNA_FULL_TOK:
        	            case FP_RNA_TOK:
        	            case FP_RNE_FULL_TOK:
        	            case FP_RNE_TOK:
        	            case FP_RTN_FULL_TOK:
        	            case FP_RTN_TOK:
        	            case FP_RTP_FULL_TOK:
        	            case FP_RTP_TOK:
        	            case FP_RTZ_FULL_TOK:
        	            case FP_RTZ_TOK:
        	            case FP_TO_FPBV_TOK:
        	            case FP_TO_FPFP_TOK:
        	            case FP_TO_FPR_TOK:
        	            case FP_TO_FPS_TOK:
        	            case FP_TO_FPU_TOK:
        	            case FP_TO_FP_TOK:
        	            case FP_TO_SBV_TOK:
        	            case FP_TO_UBV_TOK:
        	            case GET_ASSERTIONS_TOK:
        	            case GET_ASSIGNMENT_TOK:
        	            case GET_INFO_TOK:
        	            case GET_MODEL_TOK:
        	            case GET_OPTION_TOK:
        	            case GET_PROOF_TOK:
        	            case GET_QE_DISJUNCT_TOK:
        	            case GET_QE_TOK:
        	            case GET_UNSAT_ASSUMPTIONS_TOK:
        	            case GET_UNSAT_CORE_TOK:
        	            case GET_VALUE_TOK:
        	            case GREATER_THAN_EQUAL_TOK:
        	            case GREATER_THAN_TOK:
        	            case HEX_DIGIT:
        	            case HEX_LITERAL:
        	            case HO_ARROW_TOK:
        	            case HO_LAMBDA_TOK:
        	            case IMPLIES_TOK:
        	            case INCLUDE_TOK:
        	            case INDEX_TOK:
        	            case INST_CLOSURE_TOK:
        	            case INT2BV_TOK:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case ITE_TOK:
        	            case KEYWORD:
        	            case LESS_THAN_EQUAL_TOK:
        	            case LESS_THAN_TOK:
        	            case LET_TOK:
        	            case MATCH_TOK:
        	            case META_INFO_TOK:
        	            case MINUS_TOK:
        	            case NILREF_TOK:
        	            case NOT_TOK:
        	            case NUMERAL:
        	            case OR_TOK:
        	            case PAR_TOK:
        	            case PLUS_TOK:
        	            case POP_TOK:
        	            case PROPAGATION_RULE_TOK:
        	            case PUSH_TOK:
        	            case QUOTED_SYMBOL:
        	            case REALLCHAR_TOK:
        	            case REAL_PI_TOK:
        	            case REDUCTION_RULE_TOK:
        	            case RENOSTR_TOK:
        	            case RESET_ASSERTIONS_TOK:
        	            case RESET_TOK:
        	            case REWRITE_RULE_TOK:
        	            case RPAREN_TOK:
        	            case SET_INFO_TOK:
        	            case SET_LOGIC_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SET_OPTION_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SIMPLIFY_TOK:
        	            case STAR_TOK:
        	            case STRING_LITERAL:
        	            case SYGUS_CONSTANT_TOK:
        	            case SYGUS_INPUT_VARIABLE_TOK:
        	            case SYGUS_LET_TOK:
        	            case SYGUS_LOCAL_VARIABLE_TOK:
        	            case SYGUS_VARIABLE_TOK:
        	            case SYMBOL_CHAR:
        	            case SYMBOL_CHAR_NOUNDERSCORE_NOATTRIBUTE:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case TESTER_TOK:
        	            case TUPLE_CONST_TOK:
        	            case TUPLE_SEL_TOK:
        	            case UNIVSET_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case WHITESPACE:
        	            case XOR_TOK:
        	            case 158:
        	            case 159:
        	            case 160:
        	            case 161:
        	            case 162:
        	            case 163:
        	            case 164:
        	            	{
        	            		alt6=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 6;
        	                EXCEPTION->state        = 0;


        	                goto rulecommandEx;

        	            }

        	            switch (alt6)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:472:7: LPAREN_TOK termList[terms,expr] RPAREN_TOK
        	        	    {
        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_command773);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_termList_in_command775);
        	        	        termList(ctx, terms, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_command778);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             cmd->reset(new CheckSatAssumingCommand(terms)); 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:474:7: ~ LPAREN_TOK
        	        	    {
        	        	        if ( ((LA(1) >= ALPHA) && (LA(1) <= LET_TOK)) || ((LA(1) >= MATCH_TOK) && (LA(1) <= 164)) )
        	        	        {
        	        	            CONSUME();
        	        	            PERRORRECOVERY=ANTLR3_FALSE;
        	        	        }
        	        	        else
        	        	        {
        	        	            CONSTRUCTEX();
        	        	            EXCEPTION->type         = ANTLR3_MISMATCHED_SET_EXCEPTION;
        	        	            EXCEPTION->name         = (void *)ANTLR3_MISMATCHED_SET_NAME;
        	        	            EXCEPTION->expectingSet = NULL;

        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->parseError("The check-sat-assuming command expects a "
        	        	                                             "list of terms.  Perhaps you forgot a pair of "
        	        	                                             "parentheses?");
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 17:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:481:5: GET_ASSERTIONS_TOK
        	    {
        	         MATCHT(GET_ASSERTIONS_TOK, &FOLLOW_GET_ASSERTIONS_TOK_in_command821);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetAssertionsCommand()); 
        	        }


        	    }
        	    break;
        	case 18:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:484:5: GET_PROOF_TOK
        	    {
        	         MATCHT(GET_PROOF_TOK, &FOLLOW_GET_PROOF_TOK_in_command841);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetProofCommand()); 
        	        }


        	    }
        	    break;
        	case 19:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:487:5: GET_UNSAT_ASSUMPTIONS_TOK
        	    {
        	         MATCHT(GET_UNSAT_ASSUMPTIONS_TOK, &FOLLOW_GET_UNSAT_ASSUMPTIONS_TOK_in_command861);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetUnsatAssumptionsCommand); 
        	        }


        	    }
        	    break;
        	case 20:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:490:5: GET_UNSAT_CORE_TOK
        	    {
        	         MATCHT(GET_UNSAT_CORE_TOK, &FOLLOW_GET_UNSAT_CORE_TOK_in_command881);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetUnsatCoreCommand); 
        	        }


        	    }
        	    break;
        	case 21:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:493:5: PUSH_TOK (k= INTEGER_LITERAL |)
        	    {
        	         MATCHT(PUSH_TOK, &FOLLOW_PUSH_TOK_in_command901);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             if( PARSER_STATE->sygus() ){
        	                    PARSER_STATE->parseError("Sygus does not support push command.");
        	                  }
        	                
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:498:5: (k= INTEGER_LITERAL |)
        	        {
        	            int alt7=2;
        	            switch ( LA(1) )
        	            {
        	            case INTEGER_LITERAL:
        	            	{
        	            		alt7=1;
        	            	}
        	                break;
        	            case RPAREN_TOK:
        	            	{
        	            		alt7=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 7;
        	                EXCEPTION->state        = 0;


        	                goto rulecommandEx;

        	            }

        	            switch (alt7)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:498:7: k= INTEGER_LITERAL
        	        	    {
        	        	        k = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_command919);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             unsigned n = AntlrInput::tokenToUnsigned(k);
        	        	                    if(n == 0) {
        	        	                      cmd->reset(new EmptyCommand());
        	        	                    } else if(n == 1) {
        	        	                      PARSER_STATE->pushScope();
        	        	                      cmd->reset(new PushCommand());
        	        	                    } else {
        	        	                      std::unique_ptr<CommandSequence> seq(new CommandSequence());
        	        	                      do {
        	        	                        PARSER_STATE->pushScope();
        	        	                        Command* push_cmd = new PushCommand();
        	        	                        push_cmd->setMuted(n > 1);
        	        	                        seq->addCommand(push_cmd);
        	        	                        --n;
        	        	                        } while(n > 0);
        	        	                      cmd->reset(seq.release());
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:517:7: 
        	        	    {
        	        	        {
        	        	             if(PARSER_STATE->strictModeEnabled()) {
        	        	                      PARSER_STATE->parseError(
        	        	                          "Strict compliance mode demands an integer to be provided to "
        	        	                          "PUSH.  Maybe you want (push 1)?");
        	        	                    } else {
        	        	                      PARSER_STATE->pushScope();
        	        	                      cmd->reset(new PushCommand());
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 22:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:526:5: POP_TOK (k= INTEGER_LITERAL |)
        	    {
        	         MATCHT(POP_TOK, &FOLLOW_POP_TOK_in_command943);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             if( PARSER_STATE->sygus() ){
        	                    PARSER_STATE->parseError("Sygus does not support pop command.");
        	                  }
        	                
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:531:5: (k= INTEGER_LITERAL |)
        	        {
        	            int alt8=2;
        	            switch ( LA(1) )
        	            {
        	            case INTEGER_LITERAL:
        	            	{
        	            		alt8=1;
        	            	}
        	                break;
        	            case RPAREN_TOK:
        	            	{
        	            		alt8=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 8;
        	                EXCEPTION->state        = 0;


        	                goto rulecommandEx;

        	            }

        	            switch (alt8)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:531:7: k= INTEGER_LITERAL
        	        	    {
        	        	        k = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_command961);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulecommandEx;
        	        	        }


        	        	        {
        	        	             unsigned n = AntlrInput::tokenToUnsigned(k);
        	        	                    if(n > PARSER_STATE->scopeLevel()) {
        	        	                      PARSER_STATE->parseError("Attempted to pop above the top stack "
        	        	                                               "frame.");
        	        	                    }
        	        	                    if(n == 0) {
        	        	                      cmd->reset(new EmptyCommand());
        	        	                    } else if(n == 1) {
        	        	                      PARSER_STATE->popScope();
        	        	                      cmd->reset(new PopCommand());
        	        	                    } else {
        	        	                      std::unique_ptr<CommandSequence> seq(new CommandSequence());
        	        	                      do {
        	        	                        PARSER_STATE->popScope();
        	        	                        Command* pop_command = new PopCommand();
        	        	                        pop_command->setMuted(n > 1);
        	        	                        seq->addCommand(pop_command);
        	        	                        --n;
        	        	                      } while(n > 0);
        	        	                      cmd->reset(seq.release());
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:554:7: 
        	        	    {
        	        	        {
        	        	             if(PARSER_STATE->strictModeEnabled()) {
        	        	                      PARSER_STATE->parseError(
        	        	                          "Strict compliance mode demands an integer to be provided to POP."
        	        	                          "Maybe you want (pop 1)?");
        	        	                    } else {
        	        	                      PARSER_STATE->popScope();
        	        	                      cmd->reset(new PopCommand());
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 23:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:565:5: EXIT_TOK
        	    {
        	         MATCHT(EXIT_TOK, &FOLLOW_EXIT_TOK_in_command995);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             cmd->reset(new QuitCommand()); 
        	        }


        	    }
        	    break;
        	case 24:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:569:5: smt25Command[cmd]
        	    {
        	        FOLLOWPUSH(FOLLOW_smt25Command_in_command1014);
        	        smt25Command(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             if(PARSER_STATE->v2_0() && PARSER_STATE->strictModeEnabled()) {
        	                    PARSER_STATE->parseError(
        	                        "SMT-LIB 2.5 commands are not permitted while operating in strict "
        	                        "compliance mode and in SMT-LIB 2.0 mode.");
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 25:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:578:5: extendedCommand[cmd]
        	    {
        	        FOLLOWPUSH(FOLLOW_extendedCommand_in_command1034);
        	        extendedCommand(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             if(PARSER_STATE->strictModeEnabled()) {
        	                    PARSER_STATE->parseError(
        	                        "Extended commands are not permitted while operating in strict "
        	                        "compliance mode.");
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 26:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:587:5: SIMPLE_SYMBOL
        	    {
        	        SIMPLE_SYMBOL3 = (pANTLR3_COMMON_TOKEN) MATCHT(SIMPLE_SYMBOL, &FOLLOW_SIMPLE_SYMBOL_in_command1054);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulecommandEx;
        	        }


        	        {
        	             std::string id = AntlrInput::tokenText(SIMPLE_SYMBOL3);
        	                  if(id == "benchmark") {
        	                    PARSER_STATE->parseError(
        	                        "In SMT-LIBv2 mode, but got something that looks like SMT-LIBv1. "
        	                        "Use --lang smt1 for SMT-LIBv1.");
        	                  } else {
        	                    PARSER_STATE->parseError("expected SMT-LIBv2 command, got `" + id +
        	                                             "'.");
        	                  }
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulecommandEx; /* Prevent compiler warnings */
    rulecommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end command */

/**
 * $ANTLR start sygusCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:600:1: sygusCommand[std::unique_ptr<CVC4::Command>* cmd] : ( DECLARE_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | DECLARE_PRIMED_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | ( SYNTH_FUN_TOK | SYNTH_INV_TOK ) symbol[fun,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK ( sortSymbol[range,CHECK_DECLARED] )? ( sygusGrammar[sygus_type, sygus_vars, fun] )? | CONSTRAINT_TOK term[expr, expr2] | INV_CONSTRAINT_TOK ( symbol[name,CHECK_NONE,SYM_VARIABLE] )+ | CHECK_SYNTH_TOK | command[cmd] );
 */
static void
sygusCommand(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::string name, fun;
      std::vector<std::string> names;
      Expr expr, expr2;
      Type t, range;
      std::vector<Expr> terms;
      std::vector<Expr> sygus_vars;
      std::vector<std::pair<std::string, Type> > sortedVarNames;
      Type sygus_ret;
      Expr synth_fun;
      Type sygus_type;
      bool isInv;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:614:3: ( DECLARE_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | DECLARE_PRIMED_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | ( SYNTH_FUN_TOK | SYNTH_INV_TOK ) symbol[fun,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK ( sortSymbol[range,CHECK_DECLARED] )? ( sygusGrammar[sygus_type, sygus_vars, fun] )? | CONSTRAINT_TOK term[expr, expr2] | INV_CONSTRAINT_TOK ( symbol[name,CHECK_NONE,SYM_VARIABLE] )+ | CHECK_SYNTH_TOK | command[cmd] )

            ANTLR3_UINT32 alt14;

            alt14=7;

            switch ( LA(1) )
            {
            case DECLARE_VAR_TOK:
            	{
            		alt14=1;
            	}
                break;
            case DECLARE_PRIMED_VAR_TOK:
            	{
            		alt14=2;
            	}
                break;
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            	{
            		alt14=3;
            	}
                break;
            case CONSTRAINT_TOK:
            	{
            		alt14=4;
            	}
                break;
            case INV_CONSTRAINT_TOK:
            	{
            		alt14=5;
            	}
                break;
            case CHECK_SYNTH_TOK:
            	{
            		alt14=6;
            	}
                break;
            case ASSERT_TOK:
            case CHECK_SAT_ASSUMING_TOK:
            case CHECK_SAT_TOK:
            case DECLARE_CODATATYPES_2_5_TOK:
            case DECLARE_CODATATYPES_TOK:
            case DECLARE_CODATATYPE_TOK:
            case DECLARE_CONST_TOK:
            case DECLARE_DATATYPES_2_5_TOK:
            case DECLARE_DATATYPES_TOK:
            case DECLARE_DATATYPE_TOK:
            case DECLARE_FUNS_TOK:
            case DECLARE_FUN_TOK:
            case DECLARE_HEAP:
            case DECLARE_PREDS_TOK:
            case DECLARE_SORTS_TOK:
            case DECLARE_SORT_TOK:
            case DEFINE_CONST_TOK:
            case DEFINE_FUNS_REC_TOK:
            case DEFINE_FUN_REC_TOK:
            case DEFINE_FUN_TOK:
            case DEFINE_SORT_TOK:
            case DEFINE_TOK:
            case ECHO_TOK:
            case EXIT_TOK:
            case GET_ASSERTIONS_TOK:
            case GET_ASSIGNMENT_TOK:
            case GET_INFO_TOK:
            case GET_MODEL_TOK:
            case GET_OPTION_TOK:
            case GET_PROOF_TOK:
            case GET_QE_DISJUNCT_TOK:
            case GET_QE_TOK:
            case GET_UNSAT_ASSUMPTIONS_TOK:
            case GET_UNSAT_CORE_TOK:
            case GET_VALUE_TOK:
            case META_INFO_TOK:
            case POP_TOK:
            case PROPAGATION_RULE_TOK:
            case PUSH_TOK:
            case REDUCTION_RULE_TOK:
            case RESET_ASSERTIONS_TOK:
            case RESET_TOK:
            case REWRITE_RULE_TOK:
            case SET_INFO_TOK:
            case SET_LOGIC_TOK:
            case SET_OPTION_TOK:
            case SIMPLE_SYMBOL:
            case SIMPLIFY_TOK:
            	{
            		alt14=7;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 14;
                EXCEPTION->state        = 0;


                goto rulesygusCommandEx;

            }

            switch (alt14)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:615:5: DECLARE_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED]
        	    {
        	         MATCHT(DECLARE_VAR_TOK, &FOLLOW_DECLARE_VAR_TOK_in_sygusCommand1086);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_sygusCommand1094);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusCommand1107);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {

        	                  Expr var = PARSER_STATE->mkBoundVar(name, t);
        	                  cmd->reset(new DeclareSygusVarCommand(name, var, t));
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:624:5: DECLARE_PRIMED_VAR_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED]
        	    {
        	         MATCHT(DECLARE_PRIMED_VAR_TOK, &FOLLOW_DECLARE_PRIMED_VAR_TOK_in_sygusCommand1126);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_sygusCommand1134);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusCommand1147);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {

        	                  // spurious command, we do not need to create a variable. We only keep
        	                  // track of the command for sanity checking / dumping
        	                  cmd->reset(new DeclareSygusPrimedVarCommand(name, t));
        	                
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:635:5: ( SYNTH_FUN_TOK | SYNTH_INV_TOK ) symbol[fun,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK ( sortSymbol[range,CHECK_DECLARED] )? ( sygusGrammar[sygus_type, sygus_vars, fun] )?
        	    {

        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:635:5: ( SYNTH_FUN_TOK | SYNTH_INV_TOK )
        	        {
        	            int alt10=2;
        	            switch ( LA(1) )
        	            {
        	            case SYNTH_FUN_TOK:
        	            	{
        	            		alt10=1;
        	            	}
        	                break;
        	            case SYNTH_INV_TOK:
        	            	{
        	            		alt10=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 10;
        	                EXCEPTION->state        = 0;


        	                goto rulesygusCommandEx;

        	            }

        	            switch (alt10)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:635:7: SYNTH_FUN_TOK
        	        	    {
        	        	         MATCHT(SYNTH_FUN_TOK, &FOLLOW_SYNTH_FUN_TOK_in_sygusCommand1169);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusCommandEx;
        	        	        }


        	        	        {
        	        	             isInv = false; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:636:9: SYNTH_INV_TOK
        	        	    {
        	        	         MATCHT(SYNTH_INV_TOK, &FOLLOW_SYNTH_INV_TOK_in_sygusCommand1181);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusCommandEx;
        	        	        }


        	        	        {
        	        	             isInv = true; range = EXPR_MANAGER->booleanType(); 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_sygusCommand1201);
        	        symbol(ctx, fun, CHECK_UNDECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusCommand1208);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_sygusCommand1210);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusCommand1213);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:641:5: ( sortSymbol[range,CHECK_DECLARED] )?
        	        {
        	            int alt11=2;
        	            switch ( LA(1) )
        	            {
        	                case CHECK_SYNTH_TOK:
        	                case CONSTRAINT_TOK:
        	                case DECLARE_PRIMED_VAR_TOK:
        	                case DECLARE_VAR_TOK:
        	                case INV_CONSTRAINT_TOK:
        	                case QUOTED_SYMBOL:
        	                case SET_OPTIONS_TOK:
        	                case SIMPLE_SYMBOL:
        	                case SYNTH_FUN_TOK:
        	                case SYNTH_INV_TOK:
        	                case UNTERMINATED_QUOTED_SYMBOL:
        	                case 160:
        	                	{
        	                		alt11=1;
        	                	}
        	                    break;
        	                case LPAREN_TOK:
        	                	{
        	                		switch ( LA(2) )
        	                		{
        	                		    case CHECK_SYNTH_TOK:
        	                		    case CONSTRAINT_TOK:
        	                		    case DECLARE_PRIMED_VAR_TOK:
        	                		    case DECLARE_VAR_TOK:
        	                		    case HO_ARROW_TOK:
        	                		    case INDEX_TOK:
        	                		    case INV_CONSTRAINT_TOK:
        	                		    case QUOTED_SYMBOL:
        	                		    case SET_OPTIONS_TOK:
        	                		    case SIMPLE_SYMBOL:
        	                		    case SYNTH_FUN_TOK:
        	                		    case SYNTH_INV_TOK:
        	                		    case UNTERMINATED_QUOTED_SYMBOL:
        	                		    case 160:
        	                		    	{
        	                		    		alt11=1;
        	                		    	}
        	                		        break;
        	                		}

        	                	}
        	                    break;
        	            }

        	            switch (alt11)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:641:7: sortSymbol[range,CHECK_DECLARED]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusCommand1221);
        	        	        sortSymbol(ctx, range, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusCommandEx;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {

        	                  if (range.isNull())
        	                  {
        	                    PARSER_STATE->parseError("Must supply return type for synth-fun.");
        	                  }
        	                  if (range.isFunction())
        	                  {
        	                    PARSER_STATE->parseError(
        	                        "Cannot use synth-fun with function return type.");
        	                  }
        	                  std::vector<Type> var_sorts;
        	                  for (const std::pair<std::string, CVC4::Type>& p : sortedVarNames)
        	                  {
        	                    var_sorts.push_back(p.second);
        	                  }
        	                  Debug("parser-sygus") << "Define synth fun : " << fun << std::endl;
        	                  Type synth_fun_type = var_sorts.size() > 0
        	                                            ? EXPR_MANAGER->mkFunctionType(var_sorts, range)
        	                                            : range;
        	                  // we do not allow overloading for synth fun
        	                  synth_fun = PARSER_STATE->mkBoundVar(fun, synth_fun_type);
        	                  // set the sygus type to be range by default, which is overwritten below
        	                  // if a grammar is provided
        	                  sygus_type = range;
        	                  // create new scope for parsing the grammar, if any
        	                  PARSER_STATE->pushScope(true);
        	                  for (const std::pair<std::string, CVC4::Type>& p : sortedVarNames)
        	                  {
        	                    sygus_vars.push_back(PARSER_STATE->mkBoundVar(p.first, p.second));
        	                  }
        	                
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:673:5: ( sygusGrammar[sygus_type, sygus_vars, fun] )?
        	        {
        	            int alt12=2;
        	            switch ( LA(1) )
        	            {
        	                case LPAREN_TOK:
        	                	{
        	                		alt12=1;
        	                	}
        	                    break;
        	            }

        	            switch (alt12)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:678:7: sygusGrammar[sygus_type, sygus_vars, fun]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_sygusGrammar_in_sygusCommand1273);
        	        	        sygusGrammar(ctx, sygus_type, sygus_vars, fun);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusCommandEx;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {

        	                  PARSER_STATE->popScope();
        	                  Debug("parser-sygus") << "...read synth fun " << fun << std::endl;
        	                  cmd->reset(
        	                      new SynthFunCommand(fun, synth_fun, sygus_type, isInv, sygus_vars));
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:687:5: CONSTRAINT_TOK term[expr, expr2]
        	    {
        	         MATCHT(CONSTRAINT_TOK, &FOLLOW_CONSTRAINT_TOK_in_sygusCommand1299);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {

        	                  PARSER_STATE->checkThatLogicIsSet();
        	                  Debug("parser-sygus") << "Sygus : define sygus funs..." << std::endl;
        	                  Debug("parser-sygus") << "Sygus : read constraint..." << std::endl;
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_sygusCommand1307);
        	        term(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             Debug("parser-sygus") << "...read constraint " << expr << std::endl;
        	                  cmd->reset(new SygusConstraintCommand(expr));
        	                
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:696:5: INV_CONSTRAINT_TOK ( symbol[name,CHECK_NONE,SYM_VARIABLE] )+
        	    {
        	         MATCHT(INV_CONSTRAINT_TOK, &FOLLOW_INV_CONSTRAINT_TOK_in_sygusCommand1320);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {

        	                  PARSER_STATE->checkThatLogicIsSet();
        	                  Debug("parser-sygus") << "Sygus : define sygus funs..." << std::endl;
        	                  Debug("parser-sygus") << "Sygus : read inv-constraint..." << std::endl;
        	                
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:701:5: ( symbol[name,CHECK_NONE,SYM_VARIABLE] )+
        	        {
        	            int cnt13=0;

        	            for (;;)
        	            {
        	                int alt13=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case CHECK_SYNTH_TOK:
        	        	case CONSTRAINT_TOK:
        	        	case DECLARE_PRIMED_VAR_TOK:
        	        	case DECLARE_VAR_TOK:
        	        	case INV_CONSTRAINT_TOK:
        	        	case QUOTED_SYMBOL:
        	        	case SET_OPTIONS_TOK:
        	        	case SIMPLE_SYMBOL:
        	        	case SYNTH_FUN_TOK:
        	        	case SYNTH_INV_TOK:
        	        	case UNTERMINATED_QUOTED_SYMBOL:
        	        	case 160:
        	        		{
        	        			alt13=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt13)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:701:7: symbol[name,CHECK_NONE,SYM_VARIABLE]
        	        	        {
        	        	            FOLLOWPUSH(FOLLOW_symbol_in_sygusCommand1330);
        	        	            symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesygusCommandEx;
        	        	            }


        	        	            {

        	        	                        if( !terms.empty() ){
        	        	                          if( !PARSER_STATE->isDefinedFunction(name) ){
        	        	                            std::stringstream ss;
        	        	                            ss << "Function " << name << " in inv-constraint is not defined.";
        	        	                            PARSER_STATE->parseError(ss.str());
        	        	                          }
        	        	                        }
        	        	                        terms.push_back( PARSER_STATE->getVariable(name) );
        	        	                      
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt13 >= 1 )
        	        		{
        	        		    goto loop13;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto rulesygusCommandEx;
        	        	}
        	        	cnt13++;
        	            }
        	            loop13: ;	/* Jump to here if this rule does not match */
        	        }

        	        {

        	                  if( terms.size()!=4 ){
        	                    PARSER_STATE->parseError("Bad syntax for inv-constraint: expected 4 "
        	                                             "arguments.");
        	                  }

        	                  cmd->reset(new SygusInvConstraintCommand(terms));
        	                
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:720:5: CHECK_SYNTH_TOK
        	    {
        	         MATCHT(CHECK_SYNTH_TOK, &FOLLOW_CHECK_SYNTH_TOK_in_sygusCommand1354);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {

        	                  cmd->reset(new CheckSynthCommand());
        	                
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:725:5: command[cmd]
        	    {
        	        FOLLOWPUSH(FOLLOW_command_in_sygusCommand1372);
        	        command(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusCommandEx;
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesygusCommandEx; /* Prevent compiler warnings */
    rulesygusCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sygusCommand */

/**
 * $ANTLR start sygusGrammar
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:737:1: sygusGrammar[CVC4::Type & ret,\n std::vector<CVC4::Expr>& sygus_vars,\n std::string& fun] : LPAREN_TOK ( LPAREN_TOK symbol[name, CHECK_NONE, SYM_VARIABLE] sortSymbol[t, CHECK_DECLARED] LPAREN_TOK ( sygusGTerm[sgts.back().back(), fun] )+ RPAREN_TOK RPAREN_TOK )+ RPAREN_TOK ;
 */
static void
sygusGrammar(pSmt2Parser ctx, CVC4::Type & ret, std::vector<CVC4::Expr>& sygus_vars, std::string& fun)
{

      Type t;
      std::string name;
      unsigned startIndex = 0;
      std::vector<std::vector<CVC4::SygusGTerm>> sgts;
      std::vector<CVC4::Datatype> datatypes;
      std::vector<Type> sorts;
      std::vector<std::vector<Expr>> ops;
      std::vector<std::vector<std::string>> cnames;
      std::vector<std::vector<std::vector<CVC4::Type>>> cargs;
      std::vector<bool> allow_const;
      std::vector<std::vector<std::string>> unresolved_gterm_sym;
      std::map<CVC4::Type, CVC4::Type> sygus_to_builtin;
      std::map<CVC4::Type, CVC4::Expr> sygus_to_builtin_expr;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:756:3: ( LPAREN_TOK ( LPAREN_TOK symbol[name, CHECK_NONE, SYM_VARIABLE] sortSymbol[t, CHECK_DECLARED] LPAREN_TOK ( sygusGTerm[sgts.back().back(), fun] )+ RPAREN_TOK RPAREN_TOK )+ RPAREN_TOK )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:756:5: LPAREN_TOK ( LPAREN_TOK symbol[name, CHECK_NONE, SYM_VARIABLE] sortSymbol[t, CHECK_DECLARED] LPAREN_TOK ( sygusGTerm[sgts.back().back(), fun] )+ RPAREN_TOK RPAREN_TOK )+ RPAREN_TOK
        {
             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGrammar1394);
            if  (HASEXCEPTION())
            {
                goto rulesygusGrammarEx;
            }


            {
                 PARSER_STATE->pushScope(); 
            }


            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:757:3: ( LPAREN_TOK symbol[name, CHECK_NONE, SYM_VARIABLE] sortSymbol[t, CHECK_DECLARED] LPAREN_TOK ( sygusGTerm[sgts.back().back(), fun] )+ RPAREN_TOK RPAREN_TOK )+
            {
                int cnt16=0;

                for (;;)
                {
                    int alt16=2;
            	switch ( LA(1) )
            	{
            	case LPAREN_TOK:
            		{
            			alt16=1;
            		}
            	    break;

            	}

            	switch (alt16)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:757:4: LPAREN_TOK symbol[name, CHECK_NONE, SYM_VARIABLE] sortSymbol[t, CHECK_DECLARED] LPAREN_TOK ( sygusGTerm[sgts.back().back(), fun] )+ RPAREN_TOK RPAREN_TOK
            	        {
            	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGrammar1401);
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	            FOLLOWPUSH(FOLLOW_symbol_in_sygusGrammar1410);
            	            symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	            FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGrammar1413);
            	            sortSymbol(ctx, t, CHECK_DECLARED);

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	            {

            	                         std::stringstream ss;
            	                         ss << fun << "_" << name;
            	                         if (name == "Start")
            	                         {
            	                           startIndex = datatypes.size();
            	                         }
            	                         std::string dname = ss.str();
            	                         sgts.push_back(std::vector<CVC4::SygusGTerm>());
            	                         sgts.back().push_back(CVC4::SygusGTerm());
            	                         PARSER_STATE->pushSygusDatatypeDef(t,
            	                                                            dname,
            	                                                            datatypes,
            	                                                            sorts,
            	                                                            ops,
            	                                                            cnames,
            	                                                            cargs,
            	                                                            allow_const,
            	                                                            unresolved_gterm_sym);
            	                         Type unres_t;
            	                         if (!PARSER_STATE->isUnresolvedType(dname))
            	                         {
            	                           // if not unresolved, must be undeclared
            	                           Debug("parser-sygus") << "Make unresolved type : " << dname
            	                                                 << std::endl;
            	                           PARSER_STATE->checkDeclaration(dname, CHECK_UNDECLARED, SYM_SORT);
            	                           unres_t = PARSER_STATE->mkUnresolvedType(dname);
            	                         }
            	                         else
            	                         {
            	                           Debug("parser-sygus") << "Get sort : " << dname << std::endl;
            	                           unres_t = PARSER_STATE->getSort(dname);
            	                         }
            	                         sygus_to_builtin[unres_t] = t;
            	                         Debug("parser-sygus") << "--- Read sygus grammar " << name
            	                                               << " under function " << fun << "..."
            	                                               << std::endl
            	                                               << "    type to resolve " << unres_t << std::endl
            	                                               << "    builtin type " << t << std::endl;
            	                       
            	            }


            	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGrammar1429);
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:800:14: ( sygusGTerm[sgts.back().back(), fun] )+
            	            {
            	                int cnt15=0;

            	                for (;;)
            	                {
            	                    int alt15=2;
            	            	switch ( LA(1) )
            	            	{
            	            	case BINARY_LITERAL:
            	            	case CHECK_SYNTH_TOK:
            	            	case CONSTRAINT_TOK:
            	            	case DECIMAL_LITERAL:
            	            	case DECLARE_PRIMED_VAR_TOK:
            	            	case DECLARE_VAR_TOK:
            	            	case EMPTYSET_TOK:
            	            	case FP_RNA_FULL_TOK:
            	            	case FP_RNA_TOK:
            	            	case FP_RNE_FULL_TOK:
            	            	case FP_RNE_TOK:
            	            	case FP_RTN_FULL_TOK:
            	            	case FP_RTN_TOK:
            	            	case FP_RTP_FULL_TOK:
            	            	case FP_RTP_TOK:
            	            	case FP_RTZ_FULL_TOK:
            	            	case FP_RTZ_TOK:
            	            	case HEX_LITERAL:
            	            	case INTEGER_LITERAL:
            	            	case INV_CONSTRAINT_TOK:
            	            	case LPAREN_TOK:
            	            	case NILREF_TOK:
            	            	case QUOTED_SYMBOL:
            	            	case REALLCHAR_TOK:
            	            	case REAL_PI_TOK:
            	            	case RENOSTR_TOK:
            	            	case SET_OPTIONS_TOK:
            	            	case SIMPLE_SYMBOL:
            	            	case STRING_LITERAL:
            	            	case SYNTH_FUN_TOK:
            	            	case SYNTH_INV_TOK:
            	            	case TUPLE_CONST_TOK:
            	            	case UNIVSET_TOK:
            	            	case UNTERMINATED_QUOTED_SYMBOL:
            	            	case 160:
            	            		{
            	            			alt15=1;
            	            		}
            	            	    break;

            	            	}

            	            	switch (alt15)
            	            	{
            	            	    case 1:
            	            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:800:15: sygusGTerm[sgts.back().back(), fun]
            	            	        {
            	            	            FOLLOWPUSH(FOLLOW_sygusGTerm_in_sygusGrammar1431);
            	            	            sygusGTerm(ctx, sgts.back().back(), fun);

            	            	            FOLLOWPOP();
            	            	            if  (HASEXCEPTION())
            	            	            {
            	            	                goto rulesygusGrammarEx;
            	            	            }


            	            	            {

            	            	                     sgts.back().push_back(CVC4::SygusGTerm());
            	            	                   
            	            	            }


            	            	        }
            	            	        break;

            	            	    default:

            	            		if ( cnt15 >= 1 )
            	            		{
            	            		    goto loop15;
            	            		}
            	            		/* mismatchedSetEx()
            	            		 */
            	            		CONSTRUCTEX();
            	            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            	            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            	            		goto rulesygusGrammarEx;
            	            	}
            	            	cnt15++;
            	                }
            	                loop15: ;	/* Jump to here if this rule does not match */
            	            }

            	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGrammar1442);
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	            {
            	                 sgts.back().pop_back(); 
            	            }


            	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGrammar1446);
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulesygusGrammarEx;
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt16 >= 1 )
            		{
            		    goto loop16;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto rulesygusGrammarEx;
            	}
            	cnt16++;
                }
                loop16: ;	/* Jump to here if this rule does not match */
            }

             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGrammar1457);
            if  (HASEXCEPTION())
            {
                goto rulesygusGrammarEx;
            }


            {

                    unsigned numSTerms = sgts.size();
                    Debug("parser-sygus") << "--- Process " << numSTerms << " sygus gterms..."
                                          << std::endl;
                    for (unsigned i = 0; i < numSTerms; i++)
                    {
                      for (unsigned j = 0, size = sgts[i].size(); j < size; j++)
                      {
                        Type sub_ret;
                        PARSER_STATE->processSygusGTerm(sgts[i][j],
                                                        i,
                                                        datatypes,
                                                        sorts,
                                                        ops,
                                                        cnames,
                                                        cargs,
                                                        allow_const,
                                                        unresolved_gterm_sym,
                                                        sygus_vars,
                                                        sygus_to_builtin,
                                                        sygus_to_builtin_expr,
                                                        sub_ret);
                      }
                    }
                    // swap index if necessary
                    Debug("parser-sygus") << "--- Making sygus datatypes..." << std::endl;
                    unsigned ndatatypes = datatypes.size();
                    for (unsigned i = 0; i < ndatatypes; i++)
                    {
                      Debug("parser-sygus") << "..." << datatypes[i].getName()
                                            << " has builtin sort " << sorts[i] << std::endl;
                    }
                    Expr bvl;
                    if (!sygus_vars.empty())
                    {
                      bvl = MK_EXPR(kind::BOUND_VAR_LIST, sygus_vars);
                    }
                    for (unsigned i = 0; i < ndatatypes; i++)
                    {
                      Debug("parser-sygus") << "...make " << datatypes[i].getName()
                                            << " with builtin sort " << sorts[i] << std::endl;
                      if (sorts[i].isNull())
                      {
                        PARSER_STATE->parseError(
                            "Internal error : could not infer "
                            "builtin sort for nested gterm.");
                      }
                      datatypes[i].setSygus(sorts[i], bvl, allow_const[i], false);
                      PARSER_STATE->mkSygusDatatype(datatypes[i],
                                                    ops[i],
                                                    cnames[i],
                                                    cargs[i],
                                                    unresolved_gterm_sym[i],
                                                    sygus_to_builtin);
                    }
                    PARSER_STATE->setSygusStartIndex(fun, startIndex, datatypes, sorts, ops);
                    PARSER_STATE->popScope();
                    Debug("parser-sygus") << "--- Make " << ndatatypes
                                          << " mutual datatypes..." << std::endl;
                    for (unsigned i = 0; i < ndatatypes; i++)
                    {
                      Debug("parser-sygus") << "  " << i << " : " << datatypes[i].getName()
                                            << std::endl;
                    }
                    std::vector<DatatypeType> datatypeTypes =
                        PARSER_STATE->mkMutualDatatypeTypes(datatypes);
                    ret = datatypeTypes[0];
                  
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesygusGrammarEx; /* Prevent compiler warnings */
    rulesygusGrammarEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sygusGrammar */

/**
 * $ANTLR start sygusGTerm
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:881:1: sygusGTerm[CVC4::SygusGTerm& sgt, std::string& fun] : ( LPAREN_TOK ( builtinOp[k] | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+ RPAREN_TOK | SYGUS_CONSTANT_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_LOCAL_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_INPUT_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | symbol[name,CHECK_NONE,SYM_VARIABLE] ) ( sygusGTerm[sgt.d_children.back(), fun] )* RPAREN_TOK | termAtomic[atomTerm] | symbol[name,CHECK_NONE,SYM_VARIABLE] );
 */
static void
sygusGTerm(pSmt2Parser ctx, CVC4::SygusGTerm& sgt, std::string& fun)
{

      std::string name, name2;
      Kind k;
      Type t;
      std::string sname;
      std::vector< Expr > let_vars;
      bool readingLet = false;
      std::string s;
      CVC4::api::Term atomTerm;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:892:3: ( LPAREN_TOK ( builtinOp[k] | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+ RPAREN_TOK | SYGUS_CONSTANT_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_LOCAL_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_INPUT_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | symbol[name,CHECK_NONE,SYM_VARIABLE] ) ( sygusGTerm[sgt.d_children.back(), fun] )* RPAREN_TOK | termAtomic[atomTerm] | symbol[name,CHECK_NONE,SYM_VARIABLE] )

            ANTLR3_UINT32 alt20;

            alt20=3;

            switch ( LA(1) )
            {
            case LPAREN_TOK:
            	{
            		switch ( LA(2) )
            		{
            		case INDEX_TOK:
            			{
            				alt20=2;
            			}
            		    break;
            		case AND_TOK:
            		case BV2NAT_TOK:
            		case CHECK_SYNTH_TOK:
            		case CONSTRAINT_TOK:
            		case DECLARE_PRIMED_VAR_TOK:
            		case DECLARE_VAR_TOK:
            		case DISTINCT_TOK:
            		case DIV_TOK:
            		case DTSIZE_TOK:
            		case EQUAL_TOK:
            		case FMFCARDVAL_TOK:
            		case FMFCARD_TOK:
            		case GREATER_THAN_EQUAL_TOK:
            		case GREATER_THAN_TOK:
            		case IMPLIES_TOK:
            		case INST_CLOSURE_TOK:
            		case INV_CONSTRAINT_TOK:
            		case ITE_TOK:
            		case LESS_THAN_EQUAL_TOK:
            		case LESS_THAN_TOK:
            		case MINUS_TOK:
            		case NOT_TOK:
            		case OR_TOK:
            		case PLUS_TOK:
            		case QUOTED_SYMBOL:
            		case SET_OPTIONS_TOK:
            		case SIMPLE_SYMBOL:
            		case STAR_TOK:
            		case SYGUS_CONSTANT_TOK:
            		case SYGUS_INPUT_VARIABLE_TOK:
            		case SYGUS_LET_TOK:
            		case SYGUS_LOCAL_VARIABLE_TOK:
            		case SYGUS_VARIABLE_TOK:
            		case SYNTH_FUN_TOK:
            		case SYNTH_INV_TOK:
            		case UNTERMINATED_QUOTED_SYMBOL:
            		case XOR_TOK:
            		case 160:
            			{
            				alt20=1;
            			}
            		    break;

            		default:
            		    CONSTRUCTEX();
            		    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
            		    EXCEPTION->message      = (void *)"";
            		    EXCEPTION->decisionNum  = 20;
            		    EXCEPTION->state        = 1;


            		    goto rulesygusGTermEx;

            		}

            	}
                break;
            case BINARY_LITERAL:
            case DECIMAL_LITERAL:
            case EMPTYSET_TOK:
            case FP_RNA_FULL_TOK:
            case FP_RNA_TOK:
            case FP_RNE_FULL_TOK:
            case FP_RNE_TOK:
            case FP_RTN_FULL_TOK:
            case FP_RTN_TOK:
            case FP_RTP_FULL_TOK:
            case FP_RTP_TOK:
            case FP_RTZ_FULL_TOK:
            case FP_RTZ_TOK:
            case HEX_LITERAL:
            case INTEGER_LITERAL:
            case NILREF_TOK:
            case REALLCHAR_TOK:
            case REAL_PI_TOK:
            case RENOSTR_TOK:
            case STRING_LITERAL:
            case TUPLE_CONST_TOK:
            case UNIVSET_TOK:
            	{
            		alt20=2;
            	}
                break;
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case INV_CONSTRAINT_TOK:
            case QUOTED_SYMBOL:
            case SET_OPTIONS_TOK:
            case SIMPLE_SYMBOL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case 160:
            	{
            		alt20=3;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 20;
                EXCEPTION->state        = 0;


                goto rulesygusGTermEx;

            }

            switch (alt20)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:892:5: LPAREN_TOK ( builtinOp[k] | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+ RPAREN_TOK | SYGUS_CONSTANT_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_LOCAL_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_INPUT_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | symbol[name,CHECK_NONE,SYM_VARIABLE] ) ( sygusGTerm[sgt.d_children.back(), fun] )* RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGTerm1484);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusGTermEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:894:5: ( builtinOp[k] | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+ RPAREN_TOK | SYGUS_CONSTANT_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_LOCAL_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | SYGUS_INPUT_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED] | symbol[name,CHECK_NONE,SYM_VARIABLE] )
        	        {
        	            int alt18=7;
        	            switch ( LA(1) )
        	            {
        	            case AND_TOK:
        	            case BV2NAT_TOK:
        	            case DISTINCT_TOK:
        	            case DIV_TOK:
        	            case DTSIZE_TOK:
        	            case EQUAL_TOK:
        	            case FMFCARDVAL_TOK:
        	            case FMFCARD_TOK:
        	            case GREATER_THAN_EQUAL_TOK:
        	            case GREATER_THAN_TOK:
        	            case IMPLIES_TOK:
        	            case INST_CLOSURE_TOK:
        	            case ITE_TOK:
        	            case LESS_THAN_EQUAL_TOK:
        	            case LESS_THAN_TOK:
        	            case MINUS_TOK:
        	            case NOT_TOK:
        	            case OR_TOK:
        	            case PLUS_TOK:
        	            case STAR_TOK:
        	            case XOR_TOK:
        	            	{
        	            		alt18=1;
        	            	}
        	                break;
        	            case SYGUS_LET_TOK:
        	            	{
        	            		alt18=2;
        	            	}
        	                break;
        	            case SYGUS_CONSTANT_TOK:
        	            	{
        	            		alt18=3;
        	            	}
        	                break;
        	            case SYGUS_VARIABLE_TOK:
        	            	{
        	            		alt18=4;
        	            	}
        	                break;
        	            case SYGUS_LOCAL_VARIABLE_TOK:
        	            	{
        	            		alt18=5;
        	            	}
        	                break;
        	            case SYGUS_INPUT_VARIABLE_TOK:
        	            	{
        	            		alt18=6;
        	            	}
        	                break;
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case INV_CONSTRAINT_TOK:
        	            case QUOTED_SYMBOL:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt18=7;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 18;
        	                EXCEPTION->state        = 0;


        	                goto rulesygusGTermEx;

        	            }

        	            switch (alt18)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:894:7: builtinOp[k]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_builtinOp_in_sygusGTerm1497);
        	        	        builtinOp(ctx, k);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             
        	        	                    Debug("parser-sygus") << "Sygus grammar " << fun << " : builtin op : "
        	        	                                          << name << std::endl;
        	        	                    sgt.d_name = kind::kindToString(k);
        	        	                    sgt.d_gterm_type = SygusGTerm::gterm_op;
        	        	                    sgt.d_expr = EXPR_MANAGER->operatorOf(k);
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:901:8: SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+ RPAREN_TOK
        	        	    {
        	        	         MATCHT(SYGUS_LET_TOK, &FOLLOW_SYGUS_LET_TOK_in_sygusGTerm1508);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGTerm1510);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             
        	        	                     sgt.d_name = std::string("let");
        	        	                     sgt.d_gterm_type = SygusGTerm::gterm_let;
        	        	                     PARSER_STATE->pushScope(true);
        	        	                     readingLet = true;
        	        	                   
        	        	        }


        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:907:8: ( LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK )+
        	        	        {
        	        	            int cnt17=0;

        	        	            for (;;)
        	        	            {
        	        	                int alt17=2;
        	        	        	switch ( LA(1) )
        	        	        	{
        	        	        	case LPAREN_TOK:
        	        	        		{
        	        	        			alt17=1;
        	        	        		}
        	        	        	    break;

        	        	        	}

        	        	        	switch (alt17)
        	        	        	{
        	        	        	    case 1:
        	        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:907:10: LPAREN_TOK symbol[sname,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] sygusGTerm[sgt.d_children.back(), fun] RPAREN_TOK
        	        	        	        {
        	        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sygusGTerm1523);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto rulesygusGTermEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_symbol_in_sygusGTerm1534);
        	        	        	            symbol(ctx, sname, CHECK_NONE, SYM_VARIABLE);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto rulesygusGTermEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGTerm1546);
        	        	        	            sortSymbol(ctx, t, CHECK_DECLARED);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto rulesygusGTermEx;
        	        	        	            }


        	        	        	            {
        	        	        	                 
        	        	        	                          Expr v = PARSER_STATE->mkBoundVar(sname,t); 
        	        	        	                          sgt.d_let_vars.push_back( v ); 
        	        	        	                          sgt.addChild();
        	        	        	                        
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_sygusGTerm_in_sygusGTerm1560);
        	        	        	            sygusGTerm(ctx, sgt.d_children.back(), fun);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto rulesygusGTermEx;
        	        	        	            }


        	        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGTerm1571);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto rulesygusGTermEx;
        	        	        	            }


        	        	        	        }
        	        	        	        break;

        	        	        	    default:

        	        	        		if ( cnt17 >= 1 )
        	        	        		{
        	        	        		    goto loop17;
        	        	        		}
        	        	        		/* mismatchedSetEx()
        	        	        		 */
        	        	        		CONSTRUCTEX();
        	        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        	        		goto rulesygusGTermEx;
        	        	        	}
        	        	        	cnt17++;
        	        	            }
        	        	            loop17: ;	/* Jump to here if this rule does not match */
        	        	        }

        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGTerm1576);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	    }
        	        	    break;
        	        	case 3:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:916:7: SYGUS_CONSTANT_TOK sortSymbol[t,CHECK_DECLARED]
        	        	    {
        	        	         MATCHT(SYGUS_CONSTANT_TOK, &FOLLOW_SYGUS_CONSTANT_TOK_in_sygusGTerm1584);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGTerm1586);
        	        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             sgt.d_gterm_type = SygusGTerm::gterm_constant;
        	        	                    sgt.d_type = t;
        	        	                    Debug("parser-sygus") << "Sygus grammar constant." << std::endl;
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 4:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:921:7: SYGUS_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED]
        	        	    {
        	        	         MATCHT(SYGUS_VARIABLE_TOK, &FOLLOW_SYGUS_VARIABLE_TOK_in_sygusGTerm1604);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGTerm1606);
        	        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             sgt.d_gterm_type = SygusGTerm::gterm_variable;
        	        	                    sgt.d_type = t;
        	        	                    Debug("parser-sygus") << "Sygus grammar variable." << std::endl;
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 5:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:926:7: SYGUS_LOCAL_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED]
        	        	    {
        	        	         MATCHT(SYGUS_LOCAL_VARIABLE_TOK, &FOLLOW_SYGUS_LOCAL_VARIABLE_TOK_in_sygusGTerm1623);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGTerm1625);
        	        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             sgt.d_gterm_type = SygusGTerm::gterm_local_variable;
        	        	                    sgt.d_type = t;
        	        	                    Debug("parser-sygus") << "Sygus grammar local variable...ignore."
        	        	                                          << std::endl;
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 6:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:932:7: SYGUS_INPUT_VARIABLE_TOK sortSymbol[t,CHECK_DECLARED]
        	        	    {
        	        	         MATCHT(SYGUS_INPUT_VARIABLE_TOK, &FOLLOW_SYGUS_INPUT_VARIABLE_TOK_in_sygusGTerm1642);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sygusGTerm1644);
        	        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             sgt.d_gterm_type = SygusGTerm::gterm_input_variable;
        	        	                    sgt.d_type = t;
        	        	                    Debug("parser-sygus") << "Sygus grammar (input) variable."
        	        	                                          << std::endl;
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 7:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:938:7: symbol[name,CHECK_NONE,SYM_VARIABLE]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_symbol_in_sygusGTerm1661);
        	        	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             
        	        	                    bool isBuiltinOperator = PARSER_STATE->isOperatorEnabled(name);
        	        	                    if(isBuiltinOperator) {
        	        	                      Debug("parser-sygus") << "Sygus grammar " << fun << " : builtin op : "
        	        	                                            << name << std::endl;
        	        	                      k = PARSER_STATE->getOperatorKind(name);
        	        	                      sgt.d_name = kind::kindToString(k);
        	        	                      sgt.d_gterm_type = SygusGTerm::gterm_op;
        	        	                      sgt.d_expr = EXPR_MANAGER->operatorOf(k);
        	        	                    }else{
        	        	                      // what is this sygus term trying to accomplish here, if the
        	        	                      // symbol isn't yet declared?!  probably the following line will
        	        	                      // fail, but we need an operator to continue here..
        	        	                      Debug("parser-sygus")
        	        	                          << "Sygus grammar " << fun << " : op (declare="
        	        	                          << PARSER_STATE->isDeclared(name) << ", define="
        	        	                          << PARSER_STATE->isDefinedFunction(name) << ") : " << name
        	        	                          << std::endl;
        	        	                      if(!PARSER_STATE->isDeclared(name) &&
        	        	                         !PARSER_STATE->isDefinedFunction(name) ){
        	        	                        PARSER_STATE->parseError("Functions in sygus grammars must be "
        	        	                                                 "defined.");
        	        	                      }
        	        	                      sgt.d_name = name;
        	        	                      sgt.d_gterm_type = SygusGTerm::gterm_op;
        	        	                      sgt.d_expr = PARSER_STATE->getVariable(name) ;
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {
        	             Debug("parser-sygus") << "Read arguments under " << sgt.d_name
        	                                        << std::endl;
        	                  sgt.addChild();
        	                
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:972:5: ( sygusGTerm[sgt.d_children.back(), fun] )*

        	        for (;;)
        	        {
        	            int alt19=2;
        	            switch ( LA(1) )
        	            {
        	            case BINARY_LITERAL:
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case EMPTYSET_TOK:
        	            case FP_RNA_FULL_TOK:
        	            case FP_RNA_TOK:
        	            case FP_RNE_FULL_TOK:
        	            case FP_RNE_TOK:
        	            case FP_RTN_FULL_TOK:
        	            case FP_RTN_TOK:
        	            case FP_RTP_FULL_TOK:
        	            case FP_RTP_TOK:
        	            case FP_RTZ_FULL_TOK:
        	            case FP_RTZ_TOK:
        	            case HEX_LITERAL:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case LPAREN_TOK:
        	            case NILREF_TOK:
        	            case QUOTED_SYMBOL:
        	            case REALLCHAR_TOK:
        	            case REAL_PI_TOK:
        	            case RENOSTR_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case STRING_LITERAL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case TUPLE_CONST_TOK:
        	            case UNIVSET_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt19=1;
        	            	}
        	                break;

        	            }

        	            switch (alt19)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:972:7: sygusGTerm[sgt.d_children.back(), fun]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_sygusGTerm_in_sygusGTerm1689);
        	        	        sygusGTerm(ctx, sgt.d_children.back(), fun);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesygusGTermEx;
        	        	        }


        	        	        {
        	        	             Debug("parser-sygus") << "Finished read argument #"
        	        	                                          << sgt.d_children.size() << "..." << std::endl;
        	        	                    sgt.addChild();
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	        	default:
        	        	    goto loop19;	/* break out of the loop */
        	        	    break;
        	            }
        	        }
        	        loop19: ; /* Jump out to here if this rule does not match */


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sygusGTerm1712);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusGTermEx;
        	        }


        	        {

        	                  //pop last child index 
        	                  sgt.d_children.pop_back();   
        	                  if( readingLet ){
        	                    PARSER_STATE->popScope();
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:985:7: termAtomic[atomTerm]
        	    {
        	        FOLLOWPUSH(FOLLOW_termAtomic_in_sygusGTerm1722);
        	        termAtomic(ctx, atomTerm);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusGTermEx;
        	        }


        	        {

        	                    Debug("parser-sygus") << "Sygus grammar " << fun << " : atomic "
        	                                          << "expression " << atomTerm << std::endl;
        	                    std::stringstream ss;
        	                    ss << atomTerm;
        	                    sgt.d_expr = atomTerm.getExpr();
        	                    sgt.d_name = ss.str();
        	                    sgt.d_gterm_type = SygusGTerm::gterm_op;
        	                  
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:995:5: symbol[name,CHECK_NONE,SYM_VARIABLE]
        	    {
        	        FOLLOWPUSH(FOLLOW_symbol_in_sygusGTerm1737);
        	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesygusGTermEx;
        	        }


        	        {
        	             
        	                  if( name[0] == '-' ){  //hack for unary minus
        	                    Debug("parser-sygus") << "Sygus grammar " << fun
        	                                          << " : unary minus integer literal " << name
        	                                          << std::endl;
        	                    sgt.d_expr = MK_CONST(Rational(name));
        	                    sgt.d_name = name;
        	                    sgt.d_gterm_type = SygusGTerm::gterm_op;
        	                  }else if( PARSER_STATE->isDeclared(name,SYM_VARIABLE) ){
        	                    Debug("parser-sygus") << "Sygus grammar " << fun << " : symbol "
        	                                          << name << std::endl;
        	                    sgt.d_expr = PARSER_STATE->getVariable(name);
        	                    sgt.d_name = name;
        	                    sgt.d_gterm_type = SygusGTerm::gterm_op;
        	                  }else{
        	                    //prepend function name to base sorts when reading an operator
        	                    std::stringstream ss;
        	                    ss << fun << "_" << name;
        	                    name = ss.str();
        	                    if( PARSER_STATE->isDeclared(name, SYM_SORT) ){
        	                      Debug("parser-sygus") << "Sygus grammar " << fun
        	                                            << " : nested sort " << name << std::endl;
        	                      sgt.d_type = PARSER_STATE->getSort(name);
        	                      sgt.d_gterm_type = SygusGTerm::gterm_nested_sort;
        	                    }else{
        	                      Debug("parser-sygus") << "Sygus grammar " << fun
        	                                            << " : unresolved symbol " << name
        	                                            << std::endl;
        	                      sgt.d_gterm_type = SygusGTerm::gterm_unresolved;
        	                      sgt.d_name = name;
        	                    }
        	                  }
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesygusGTermEx; /* Prevent compiler warnings */
    rulesygusGTermEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sygusGTerm */

/**
 * $ANTLR start metaInfoInternal
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1032:1: metaInfoInternal[std::unique_ptr<CVC4::Command>* cmd] : KEYWORD symbolicExpr[sexpr] ;
 */
static void
metaInfoInternal(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::string name;
      SExpr sexpr;

    pANTLR3_COMMON_TOKEN    KEYWORD4;

    /* Initialize rule variables
     */

    KEYWORD4       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1037:3: ( KEYWORD symbolicExpr[sexpr] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1037:5: KEYWORD symbolicExpr[sexpr]
        {
            KEYWORD4 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_metaInfoInternal1764);
            if  (HASEXCEPTION())
            {
                goto rulemetaInfoInternalEx;
            }


            FOLLOWPUSH(FOLLOW_symbolicExpr_in_metaInfoInternal1766);
            symbolicExpr(ctx, sexpr);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulemetaInfoInternalEx;
            }


            {
                 name = AntlrInput::tokenText(KEYWORD4);
                      if(name == ":cvc4-logic" || name == ":cvc4_logic") {
                        PARSER_STATE->setLogic(sexpr.getValue());
                      }
                      PARSER_STATE->setInfo(name.c_str() + 1, sexpr);
                      cmd->reset(new SetInfoCommand(name.c_str() + 1, sexpr));
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulemetaInfoInternalEx; /* Prevent compiler warnings */
    rulemetaInfoInternalEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end metaInfoInternal */

/**
 * $ANTLR start setOptionInternal
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1047:1: setOptionInternal[std::unique_ptr<CVC4::Command>* cmd] : keyword[name] symbolicExpr[sexpr] ;
 */
static void
setOptionInternal(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{
    /* Initialize rule variables
     */


      std::string name;
      SExpr sexpr;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1052:3: ( keyword[name] symbolicExpr[sexpr] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1052:5: keyword[name] symbolicExpr[sexpr]
        {
            FOLLOWPUSH(FOLLOW_keyword_in_setOptionInternal1792);
            keyword(ctx, name);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulesetOptionInternalEx;
            }


            FOLLOWPUSH(FOLLOW_symbolicExpr_in_setOptionInternal1795);
            symbolicExpr(ctx, sexpr);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulesetOptionInternalEx;
            }


            {
                 PARSER_STATE->setOption(name.c_str() + 1, sexpr);
                      cmd->reset(new SetOptionCommand(name.c_str() + 1, sexpr));
                      // Ugly that this changes the state of the parser; but
                      // global-declarations affects parsing, so we can't hold off
                      // on this until some SmtEngine eventually (if ever) executes it.
                      if(name == ":global-declarations") {
                        PARSER_STATE->setGlobalDeclarations(sexpr.getValue() == "true");
                      }
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesetOptionInternalEx; /* Prevent compiler warnings */
    rulesetOptionInternalEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end setOptionInternal */

/**
 * $ANTLR start smt25Command
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1064:1: smt25Command[std::unique_ptr<CVC4::Command>* cmd] : ( META_INFO_TOK metaInfoInternal[cmd] | DECLARE_CONST_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | GET_MODEL_TOK | ECHO_TOK ( simpleSymbolicExpr[sexpr] |) | RESET_TOK | RESET_ASSERTIONS_TOK | DEFINE_FUN_REC_TOK symbol[fname,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2] | DEFINE_FUNS_REC_TOK LPAREN_TOK ( LPAREN_TOK symbol[fname,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )+ RPAREN_TOK LPAREN_TOK ( term[expr,expr2] )+ RPAREN_TOK );
 */
static void
smt25Command(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::string name;
      std::string fname;
      Expr expr, expr2;
      std::vector<std::pair<std::string, Type> > sortedVarNames;
      SExpr sexpr;
      Type t;
      Expr func;
      std::vector<Expr> bvs;
      std::vector< std::vector<std::pair<std::string, Type> > > sortedVarNamesList;
      std::vector<std::vector<Expr>> flattenVarsList;
      std::vector<std::vector<Expr>> formals;
      std::vector<Expr> funcs;
      std::vector<Expr> func_defs;
      Expr aexpr;
      std::unique_ptr<CVC4::CommandSequence> seq;
      std::vector<Type> sorts;
      std::vector<Expr> flattenVars;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1085:3: ( META_INFO_TOK metaInfoInternal[cmd] | DECLARE_CONST_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] | GET_MODEL_TOK | ECHO_TOK ( simpleSymbolicExpr[sexpr] |) | RESET_TOK | RESET_ASSERTIONS_TOK | DEFINE_FUN_REC_TOK symbol[fname,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2] | DEFINE_FUNS_REC_TOK LPAREN_TOK ( LPAREN_TOK symbol[fname,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )+ RPAREN_TOK LPAREN_TOK ( term[expr,expr2] )+ RPAREN_TOK )

            ANTLR3_UINT32 alt24;

            alt24=8;

            switch ( LA(1) )
            {
            case META_INFO_TOK:
            	{
            		alt24=1;
            	}
                break;
            case DECLARE_CONST_TOK:
            	{
            		alt24=2;
            	}
                break;
            case GET_MODEL_TOK:
            	{
            		alt24=3;
            	}
                break;
            case ECHO_TOK:
            	{
            		alt24=4;
            	}
                break;
            case RESET_TOK:
            	{
            		alt24=5;
            	}
                break;
            case RESET_ASSERTIONS_TOK:
            	{
            		alt24=6;
            	}
                break;
            case DEFINE_FUN_REC_TOK:
            	{
            		alt24=7;
            	}
                break;
            case DEFINE_FUNS_REC_TOK:
            	{
            		alt24=8;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 24;
                EXCEPTION->state        = 0;


                goto rulesmt25CommandEx;

            }

            switch (alt24)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1085:5: META_INFO_TOK metaInfoInternal[cmd]
        	    {
        	         MATCHT(META_INFO_TOK, &FOLLOW_META_INFO_TOK_in_smt25Command1827);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_metaInfoInternal_in_smt25Command1829);
        	        metaInfoInternal(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1088:5: DECLARE_CONST_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED]
        	    {
        	         MATCHT(DECLARE_CONST_TOK, &FOLLOW_DECLARE_CONST_TOK_in_smt25Command1843);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_smt25Command1851);
        	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_smt25Command1864);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             // allow overloading here
        	                  Expr c = PARSER_STATE->mkVar(name, t, ExprManager::VAR_FLAG_NONE, true);
        	                  cmd->reset(new DeclareFunctionCommand(name, c, t)); 
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1097:5: GET_MODEL_TOK
        	    {
        	         MATCHT(GET_MODEL_TOK, &FOLLOW_GET_MODEL_TOK_in_smt25Command1884);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             cmd->reset(new GetModelCommand()); 
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1101:5: ECHO_TOK ( simpleSymbolicExpr[sexpr] |)
        	    {
        	         MATCHT(ECHO_TOK, &FOLLOW_ECHO_TOK_in_smt25Command1905);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1102:5: ( simpleSymbolicExpr[sexpr] |)
        	        {
        	            int alt21=2;
        	            switch ( LA(1) )
        	            {
        	            case AND_TOK:
        	            case ASSERT_TOK:
        	            case BINARY_LITERAL:
        	            case BV2NAT_TOK:
        	            case CHECK_SAT_ASSUMING_TOK:
        	            case CHECK_SAT_TOK:
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_DATATYPES_TOK:
        	            case DECLARE_FUN_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_SORT_TOK:
        	            case DECLARE_VAR_TOK:
        	            case DEFINE_FUNS_REC_TOK:
        	            case DEFINE_FUN_REC_TOK:
        	            case DEFINE_FUN_TOK:
        	            case DEFINE_SORT_TOK:
        	            case DISTINCT_TOK:
        	            case DIV_TOK:
        	            case DTSIZE_TOK:
        	            case ECHO_TOK:
        	            case EQUAL_TOK:
        	            case EXIT_TOK:
        	            case FMFCARDVAL_TOK:
        	            case FMFCARD_TOK:
        	            case GET_ASSERTIONS_TOK:
        	            case GET_ASSIGNMENT_TOK:
        	            case GET_INFO_TOK:
        	            case GET_MODEL_TOK:
        	            case GET_OPTION_TOK:
        	            case GET_PROOF_TOK:
        	            case GET_UNSAT_ASSUMPTIONS_TOK:
        	            case GET_UNSAT_CORE_TOK:
        	            case GET_VALUE_TOK:
        	            case GREATER_THAN_EQUAL_TOK:
        	            case GREATER_THAN_TOK:
        	            case HEX_LITERAL:
        	            case IMPLIES_TOK:
        	            case INST_CLOSURE_TOK:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case ITE_TOK:
        	            case KEYWORD:
        	            case LESS_THAN_EQUAL_TOK:
        	            case LESS_THAN_TOK:
        	            case MINUS_TOK:
        	            case NOT_TOK:
        	            case OR_TOK:
        	            case PLUS_TOK:
        	            case POP_TOK:
        	            case PROPAGATION_RULE_TOK:
        	            case PUSH_TOK:
        	            case QUOTED_SYMBOL:
        	            case REDUCTION_RULE_TOK:
        	            case RESET_ASSERTIONS_TOK:
        	            case RESET_TOK:
        	            case REWRITE_RULE_TOK:
        	            case SET_INFO_TOK:
        	            case SET_LOGIC_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SET_OPTION_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SIMPLIFY_TOK:
        	            case STAR_TOK:
        	            case STRING_LITERAL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case XOR_TOK:
        	            case 160:
        	            	{
        	            		alt21=1;
        	            	}
        	                break;
        	            case RPAREN_TOK:
        	            	{
        	            		alt21=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 21;
        	                EXCEPTION->state        = 0;


        	                goto rulesmt25CommandEx;

        	            }

        	            switch (alt21)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1102:7: simpleSymbolicExpr[sexpr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_simpleSymbolicExpr_in_smt25Command1913);
        	        	        simpleSymbolicExpr(ctx, sexpr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesmt25CommandEx;
        	        	        }


        	        	        {
        	        	             cmd->reset(new EchoCommand(sexpr.toString())); 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1104:7: 
        	        	    {
        	        	        {
        	        	             cmd->reset(new EchoCommand()); 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1109:5: RESET_TOK
        	    {
        	         MATCHT(RESET_TOK, &FOLLOW_RESET_TOK_in_smt25Command1949);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             cmd->reset(new ResetCommand());
        	                  PARSER_STATE->reset();
        	                
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1115:5: RESET_ASSERTIONS_TOK
        	    {
        	         MATCHT(RESET_ASSERTIONS_TOK, &FOLLOW_RESET_ASSERTIONS_TOK_in_smt25Command1967);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             cmd->reset(new ResetAssertionsCommand());
        	                  PARSER_STATE->resetAssertions();
        	                
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1119:5: DEFINE_FUN_REC_TOK symbol[fname,CHECK_NONE,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] term[expr, expr2]
        	    {
        	         MATCHT(DEFINE_FUN_REC_TOK, &FOLLOW_DEFINE_FUN_REC_TOK_in_smt25Command1979);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_smt25Command1991);
        	        symbol(ctx, fname, CHECK_NONE, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(fname); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_smt25Command2004);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_smt25Command2006);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_smt25Command2009);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_smt25Command2015);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {

        	                  func = PARSER_STATE->mkDefineFunRec(fname, sortedVarNames, t, flattenVars);
        	                  PARSER_STATE->pushDefineFunRecScope(sortedVarNames, func, flattenVars, bvs, true );
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_smt25Command2028);
        	        term(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->popScope(); 
        	                  if( !flattenVars.empty() ){
        	                    expr = PARSER_STATE->mkHoApply( expr, flattenVars );
        	                  }
        	                  cmd->reset(new DefineFunctionRecCommand(func,bvs,expr));
        	                
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1136:5: DEFINE_FUNS_REC_TOK LPAREN_TOK ( LPAREN_TOK symbol[fname,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )+ RPAREN_TOK LPAREN_TOK ( term[expr,expr2] )+ RPAREN_TOK
        	    {
        	         MATCHT(DEFINE_FUNS_REC_TOK, &FOLLOW_DEFINE_FUNS_REC_TOK_in_smt25Command2041);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet();
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_smt25Command2053);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1139:5: ( LPAREN_TOK symbol[fname,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )+
        	        {
        	            int cnt22=0;

        	            for (;;)
        	            {
        	                int alt22=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case LPAREN_TOK:
        	        		{
        	        			alt22=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt22)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1139:7: LPAREN_TOK symbol[fname,CHECK_UNDECLARED,SYM_VARIABLE] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK sortSymbol[t,CHECK_DECLARED] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_smt25Command2061);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_symbol_in_smt25Command2069);
        	        	            symbol(ctx, fname, CHECK_UNDECLARED, SYM_VARIABLE);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            {
        	        	                 PARSER_STATE->checkUserSymbol(fname); 
        	        	            }


        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_smt25Command2086);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_sortedVarList_in_smt25Command2088);
        	        	            sortedVarList(ctx, sortedVarNames);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_smt25Command2091);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_sortSymbol_in_smt25Command2099);
        	        	            sortSymbol(ctx, t, CHECK_DECLARED);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            {

        	        	                        flattenVars.clear();
        	        	                        func = PARSER_STATE->mkDefineFunRec( fname, sortedVarNames, t, flattenVars );
        	        	                        funcs.push_back( func );

        	        	                        // add to lists (need to remember for when parsing the bodies)
        	        	                        sortedVarNamesList.push_back( sortedVarNames );
        	        	                        flattenVarsList.push_back( flattenVars );

        	        	                        // set up parsing the next variable list block
        	        	                        sortedVarNames.clear();
        	        	                        flattenVars.clear();
        	        	                      
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_smt25Command2116);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt22 >= 1 )
        	        		{
        	        		    goto loop22;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto rulesmt25CommandEx;
        	        	}
        	        	cnt22++;
        	            }
        	            loop22: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_smt25Command2129);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_smt25Command2135);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             
        	                  //set up the first scope 
        	                  if( sortedVarNamesList.empty() ){
        	                    PARSER_STATE->parseError("Must define at least one function in "
        	                                             "define-funs-rec");
        	                  }
        	                  bvs.clear();
        	                  PARSER_STATE->pushDefineFunRecScope( sortedVarNamesList[0], funcs[0],
        	                                                       flattenVarsList[0], bvs, true);
        	                
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1171:5: ( term[expr,expr2] )+
        	        {
        	            int cnt23=0;

        	            for (;;)
        	            {
        	                int alt23=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case BINARY_LITERAL:
        	        	case CHECK_SYNTH_TOK:
        	        	case CONSTRAINT_TOK:
        	        	case DECIMAL_LITERAL:
        	        	case DECLARE_PRIMED_VAR_TOK:
        	        	case DECLARE_VAR_TOK:
        	        	case EMPTYSET_TOK:
        	        	case FP_RNA_FULL_TOK:
        	        	case FP_RNA_TOK:
        	        	case FP_RNE_FULL_TOK:
        	        	case FP_RNE_TOK:
        	        	case FP_RTN_FULL_TOK:
        	        	case FP_RTN_TOK:
        	        	case FP_RTP_FULL_TOK:
        	        	case FP_RTP_TOK:
        	        	case FP_RTZ_FULL_TOK:
        	        	case FP_RTZ_TOK:
        	        	case HEX_LITERAL:
        	        	case INTEGER_LITERAL:
        	        	case INV_CONSTRAINT_TOK:
        	        	case LPAREN_TOK:
        	        	case NILREF_TOK:
        	        	case QUOTED_SYMBOL:
        	        	case REALLCHAR_TOK:
        	        	case REAL_PI_TOK:
        	        	case RENOSTR_TOK:
        	        	case SET_OPTIONS_TOK:
        	        	case SIMPLE_SYMBOL:
        	        	case STRING_LITERAL:
        	        	case SYNTH_FUN_TOK:
        	        	case SYNTH_INV_TOK:
        	        	case TUPLE_CONST_TOK:
        	        	case UNIVSET_TOK:
        	        	case UNTERMINATED_QUOTED_SYMBOL:
        	        	case 160:
        	        		{
        	        			alt23=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt23)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1172:5: term[expr,expr2]
        	        	        {
        	        	            FOLLOWPUSH(FOLLOW_term_in_smt25Command2153);
        	        	            term(ctx, expr, expr2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto rulesmt25CommandEx;
        	        	            }


        	        	            {
        	        	                 
        	        	                      unsigned j = func_defs.size();
        	        	                      if( !flattenVarsList[j].empty() ){
        	        	                        expr = PARSER_STATE->mkHoApply( expr, flattenVarsList[j] );
        	        	                      }
        	        	                      func_defs.push_back( expr );
        	        	                      formals.push_back(bvs);
        	        	                      j++;
        	        	                      //set up the next scope 
        	        	                      PARSER_STATE->popScope();
        	        	                      if( func_defs.size()<funcs.size() ){
        	        	                        bvs.clear();
        	        	                        PARSER_STATE->pushDefineFunRecScope( sortedVarNamesList[j], funcs[j], 
        	        	                                                             flattenVarsList[j], bvs, true);
        	        	                      }
        	        	                    
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt23 >= 1 )
        	        		{
        	        		    goto loop23;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto rulesmt25CommandEx;
        	        	}
        	        	cnt23++;
        	            }
        	            loop23: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_smt25Command2173);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesmt25CommandEx;
        	        }


        	        {
        	             if( funcs.size()!=func_defs.size() ){
        	                    PARSER_STATE->parseError(std::string(
        	                        "Number of functions defined does not match number listed in "
        	                        "define-funs-rec"));
        	                  }
        	                  cmd->reset( new DefineFunctionRecCommand(funcs,formals,func_defs));
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesmt25CommandEx; /* Prevent compiler warnings */
    rulesmt25CommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end smt25Command */

/**
 * $ANTLR start extendedCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1200:1: extendedCommand[std::unique_ptr<CVC4::Command>* cmd] : ( DECLARE_DATATYPES_2_5_TOK datatypes_2_5_DefCommand[false, cmd] | DECLARE_CODATATYPES_2_5_TOK datatypes_2_5_DefCommand[true, cmd] | DECLARE_CODATATYPE_TOK datatypeDefCommand[true, cmd] | DECLARE_CODATATYPES_TOK datatypesDefCommand[true, cmd] | rewriterulesCommand[cmd] | DECLARE_SORTS_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )+ RPAREN_TOK | DECLARE_FUNS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] nonemptySortList[sorts] RPAREN_TOK )+ RPAREN_TOK | DECLARE_PREDS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortList[sorts] RPAREN_TOK )+ RPAREN_TOK | DEFINE_TOK ( symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] term[e,e2] | LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortedVarList[sortedVarNames] RPAREN_TOK term[e,e2] ) | DEFINE_CONST_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] term[e, e2] | SIMPLIFY_TOK term[e,e2] | GET_QE_TOK term[e,e2] | GET_QE_DISJUNCT_TOK term[e,e2] | DECLARE_HEAP LPAREN_TOK sortSymbol[t,CHECK_DECLARED] sortSymbol[t, CHECK_DECLARED] RPAREN_TOK );
 */
static void
extendedCommand(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<CVC4::Datatype> dts;
      Expr e, e2;
      Type t;
      std::string name;
      std::vector<std::string> names;
      std::vector<Expr> terms;
      std::vector<Type> sorts;
      std::vector<std::pair<std::string, Type> > sortedVarNames;
      std::unique_ptr<CVC4::CommandSequence> seq;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1214:3: ( DECLARE_DATATYPES_2_5_TOK datatypes_2_5_DefCommand[false, cmd] | DECLARE_CODATATYPES_2_5_TOK datatypes_2_5_DefCommand[true, cmd] | DECLARE_CODATATYPE_TOK datatypeDefCommand[true, cmd] | DECLARE_CODATATYPES_TOK datatypesDefCommand[true, cmd] | rewriterulesCommand[cmd] | DECLARE_SORTS_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )+ RPAREN_TOK | DECLARE_FUNS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] nonemptySortList[sorts] RPAREN_TOK )+ RPAREN_TOK | DECLARE_PREDS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortList[sorts] RPAREN_TOK )+ RPAREN_TOK | DEFINE_TOK ( symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] term[e,e2] | LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortedVarList[sortedVarNames] RPAREN_TOK term[e,e2] ) | DEFINE_CONST_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] term[e, e2] | SIMPLIFY_TOK term[e,e2] | GET_QE_TOK term[e,e2] | GET_QE_DISJUNCT_TOK term[e,e2] | DECLARE_HEAP LPAREN_TOK sortSymbol[t,CHECK_DECLARED] sortSymbol[t, CHECK_DECLARED] RPAREN_TOK )

            ANTLR3_UINT32 alt29;

            alt29=14;

            switch ( LA(1) )
            {
            case DECLARE_DATATYPES_2_5_TOK:
            	{
            		alt29=1;
            	}
                break;
            case DECLARE_CODATATYPES_2_5_TOK:
            	{
            		alt29=2;
            	}
                break;
            case DECLARE_CODATATYPE_TOK:
            	{
            		alt29=3;
            	}
                break;
            case DECLARE_CODATATYPES_TOK:
            	{
            		alt29=4;
            	}
                break;
            case PROPAGATION_RULE_TOK:
            case REDUCTION_RULE_TOK:
            case REWRITE_RULE_TOK:
            	{
            		alt29=5;
            	}
                break;
            case DECLARE_SORTS_TOK:
            	{
            		alt29=6;
            	}
                break;
            case DECLARE_FUNS_TOK:
            	{
            		alt29=7;
            	}
                break;
            case DECLARE_PREDS_TOK:
            	{
            		alt29=8;
            	}
                break;
            case DEFINE_TOK:
            	{
            		alt29=9;
            	}
                break;
            case DEFINE_CONST_TOK:
            	{
            		alt29=10;
            	}
                break;
            case SIMPLIFY_TOK:
            	{
            		alt29=11;
            	}
                break;
            case GET_QE_TOK:
            	{
            		alt29=12;
            	}
                break;
            case GET_QE_DISJUNCT_TOK:
            	{
            		alt29=13;
            	}
                break;
            case DECLARE_HEAP:
            	{
            		alt29=14;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 29;
                EXCEPTION->state        = 0;


                goto ruleextendedCommandEx;

            }

            switch (alt29)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1214:5: DECLARE_DATATYPES_2_5_TOK datatypes_2_5_DefCommand[false, cmd]
        	    {
        	         MATCHT(DECLARE_DATATYPES_2_5_TOK, &FOLLOW_DECLARE_DATATYPES_2_5_TOK_in_extendedCommand2204);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2206);
        	        datatypes_2_5_DefCommand(ctx, false, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1215:5: DECLARE_CODATATYPES_2_5_TOK datatypes_2_5_DefCommand[true, cmd]
        	    {
        	         MATCHT(DECLARE_CODATATYPES_2_5_TOK, &FOLLOW_DECLARE_CODATATYPES_2_5_TOK_in_extendedCommand2213);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypes_2_5_DefCommand_in_extendedCommand2215);
        	        datatypes_2_5_DefCommand(ctx, true, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1216:5: DECLARE_CODATATYPE_TOK datatypeDefCommand[true, cmd]
        	    {
        	         MATCHT(DECLARE_CODATATYPE_TOK, &FOLLOW_DECLARE_CODATATYPE_TOK_in_extendedCommand2222);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypeDefCommand_in_extendedCommand2224);
        	        datatypeDefCommand(ctx, true, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1217:5: DECLARE_CODATATYPES_TOK datatypesDefCommand[true, cmd]
        	    {
        	         MATCHT(DECLARE_CODATATYPES_TOK, &FOLLOW_DECLARE_CODATATYPES_TOK_in_extendedCommand2231);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_datatypesDefCommand_in_extendedCommand2233);
        	        datatypesDefCommand(ctx, true, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1218:5: rewriterulesCommand[cmd]
        	    {
        	        FOLLOWPUSH(FOLLOW_rewriterulesCommand_in_extendedCommand2240);
        	        rewriterulesCommand(ctx, cmd);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1222:5: DECLARE_SORTS_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )+ RPAREN_TOK
        	    {
        	         MATCHT(DECLARE_SORTS_TOK, &FOLLOW_DECLARE_SORTS_TOK_in_extendedCommand2255);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             if(!PARSER_STATE->isTheoryEnabled(Smt2::THEORY_UF) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_ARRAYS) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_DATATYPES) &&
        	                     !PARSER_STATE->isTheoryEnabled(Smt2::THEORY_SETS)) {
        	                    PARSER_STATE->parseErrorLogic("Free sort symbols not allowed in ");
        	                  }
        	                
        	        }


        	        {
        	             seq.reset(new CVC4::CommandSequence()); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2275);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1232:5: ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )+
        	        {
        	            int cnt25=0;

        	            for (;;)
        	            {
        	                int alt25=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case CHECK_SYNTH_TOK:
        	        	case CONSTRAINT_TOK:
        	        	case DECLARE_PRIMED_VAR_TOK:
        	        	case DECLARE_VAR_TOK:
        	        	case INV_CONSTRAINT_TOK:
        	        	case QUOTED_SYMBOL:
        	        	case SET_OPTIONS_TOK:
        	        	case SIMPLE_SYMBOL:
        	        	case SYNTH_FUN_TOK:
        	        	case SYNTH_INV_TOK:
        	        	case UNTERMINATED_QUOTED_SYMBOL:
        	        	case 160:
        	        		{
        	        			alt25=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt25)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1232:7: symbol[name,CHECK_UNDECLARED,SYM_SORT]
        	        	        {
        	        	            FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2283);
        	        	            symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            {
        	        	                 PARSER_STATE->checkUserSymbol(name);
        	        	                        Type type = PARSER_STATE->mkSort(name);
        	        	                        seq->addCommand(new DeclareTypeCommand(name, 0, type));
        	        	                      
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt25 >= 1 )
        	        		{
        	        		    goto loop25;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruleextendedCommandEx;
        	        	}
        	        	cnt25++;
        	            }
        	            loop25: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2305);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(seq.release()); 
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1241:5: DECLARE_FUNS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] nonemptySortList[sorts] RPAREN_TOK )+ RPAREN_TOK
        	    {
        	         MATCHT(DECLARE_FUNS_TOK, &FOLLOW_DECLARE_FUNS_TOK_in_extendedCommand2318);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             seq.reset(new CVC4::CommandSequence()); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2332);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1244:5: ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] nonemptySortList[sorts] RPAREN_TOK )+
        	        {
        	            int cnt26=0;

        	            for (;;)
        	            {
        	                int alt26=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case LPAREN_TOK:
        	        		{
        	        			alt26=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt26)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1244:7: LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] nonemptySortList[sorts] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2340);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2342);
        	        	            symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            {
        	        	                 PARSER_STATE->checkUserSymbol(name); 
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_nonemptySortList_in_extendedCommand2359);
        	        	            nonemptySortList(ctx, sorts);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2362);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            {
        	        	                 Type t;
        	        	                        if(sorts.size() > 1) {
        	        	                          if(!PARSER_STATE->isTheoryEnabled(Smt2::THEORY_UF)) {
        	        	                            PARSER_STATE->parseErrorLogic("Functions (of non-zero arity) "
        	        	                                                          "cannot be declared in logic ");
        	        	                          }
        	        	                          // must flatten
        	        	                          Type range = sorts.back();
        	        	                          sorts.pop_back();
        	        	                          t = PARSER_STATE->mkFlatFunctionType(sorts, range);
        	        	                        } else {
        	        	                          t = sorts[0];
        	        	                        }
        	        	                        // allow overloading
        	        	                        Expr func = PARSER_STATE->mkVar(name, t, ExprManager::VAR_FLAG_NONE, true);
        	        	                        seq->addCommand(new DeclareFunctionCommand(name, func, t));
        	        	                        sorts.clear();
        	        	                      
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt26 >= 1 )
        	        		{
        	        		    goto loop26;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruleextendedCommandEx;
        	        	}
        	        	cnt26++;
        	            }
        	            loop26: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2383);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(seq.release()); 
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1268:5: DECLARE_PREDS_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortList[sorts] RPAREN_TOK )+ RPAREN_TOK
        	    {
        	         MATCHT(DECLARE_PREDS_TOK, &FOLLOW_DECLARE_PREDS_TOK_in_extendedCommand2396);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        {
        	             seq.reset(new CVC4::CommandSequence()); 
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2410);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1271:5: ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortList[sorts] RPAREN_TOK )+
        	        {
        	            int cnt27=0;

        	            for (;;)
        	            {
        	                int alt27=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case LPAREN_TOK:
        	        		{
        	        			alt27=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt27)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1271:7: LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortList[sorts] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2418);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2420);
        	        	            symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            {
        	        	                 PARSER_STATE->checkUserSymbol(name); 
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_sortList_in_extendedCommand2437);
        	        	            sortList(ctx, sorts);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2440);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleextendedCommandEx;
        	        	            }


        	        	            {
        	        	                 Type t = EXPR_MANAGER->booleanType();
        	        	                        if(sorts.size() > 0) {
        	        	                          if(!PARSER_STATE->isTheoryEnabled(Smt2::THEORY_UF)) {
        	        	                            PARSER_STATE->parseErrorLogic("Predicates (of non-zero arity) "
        	        	                                                          "cannot be declared in logic ");
        	        	                          }
        	        	                          t = EXPR_MANAGER->mkFunctionType(sorts, t);
        	        	                        }
        	        	                        // allow overloading
        	        	                        Expr func = PARSER_STATE->mkVar(name, t, ExprManager::VAR_FLAG_NONE, true);
        	        	                        seq->addCommand(new DeclareFunctionCommand(name, func, t));
        	        	                        sorts.clear();
        	        	                      
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt27 >= 1 )
        	        		{
        	        		    goto loop27;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruleextendedCommandEx;
        	        	}
        	        	cnt27++;
        	            }
        	            loop27: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2461);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(seq.release()); 
        	        }


        	    }
        	    break;
        	case 9:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1291:5: DEFINE_TOK ( symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] term[e,e2] | LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortedVarList[sortedVarNames] RPAREN_TOK term[e,e2] )
        	    {
        	         MATCHT(DEFINE_TOK, &FOLLOW_DEFINE_TOK_in_extendedCommand2474);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1292:5: ( symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] term[e,e2] | LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortedVarList[sortedVarNames] RPAREN_TOK term[e,e2] )
        	        {
        	            int alt28=2;
        	            switch ( LA(1) )
        	            {
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case INV_CONSTRAINT_TOK:
        	            case QUOTED_SYMBOL:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt28=1;
        	            	}
        	                break;
        	            case LPAREN_TOK:
        	            	{
        	            		alt28=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 28;
        	                EXCEPTION->state        = 0;


        	                goto ruleextendedCommandEx;

        	            }

        	            switch (alt28)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1292:7: symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] term[e,e2]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2484);
        	        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->checkUserSymbol(name); 
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2501);
        	        	        term(ctx, e, e2);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        {
        	        	             Expr func = PARSER_STATE->mkFunction(name, e.getType(),
        	        	                                                         ExprManager::VAR_FLAG_DEFINED);
        	        	                    cmd->reset(new DefineFunctionCommand(name, func, e));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1299:7: LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortedVarList[sortedVarNames] RPAREN_TOK term[e,e2]
        	        	    {
        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2518);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2526);
        	        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->checkUserSymbol(name); 
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_extendedCommand2543);
        	        	        sortedVarList(ctx, sortedVarNames);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2546);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        {
        	        	             /* add variables to parser state before parsing term */
        	        	                    Debug("parser") << "define fun: '" << name << "'" << std::endl;
        	        	                    PARSER_STATE->pushScope(true);
        	        	                    for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	        	                          sortedVarNames.begin(), iend = sortedVarNames.end(); i != iend;
        	        	                        ++i) {
        	        	                      terms.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	        	                    }
        	        	                  
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2562);
        	        	        term(ctx, e, e2);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleextendedCommandEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->popScope();
        	        	                    // declare the name down here (while parsing term, signature
        	        	                    // must not be extended with the name itself; no recursion
        	        	                    // permitted)
        	        	                    Type t = e.getType();
        	        	                    if( sortedVarNames.size() > 0 ) {
        	        	                      std::vector<CVC4::Type> sorts;
        	        	                      sorts.reserve(sortedVarNames.size());
        	        	                      for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator
        	        	                            i = sortedVarNames.begin(), iend = sortedVarNames.end();
        	        	                          i != iend; ++i) {
        	        	                        sorts.push_back((*i).second);
        	        	                      }
        	        	                      t = EXPR_MANAGER->mkFunctionType(sorts, t);
        	        	                    }
        	        	                    Expr func = PARSER_STATE->mkFunction(name, t,
        	        	                                                         ExprManager::VAR_FLAG_DEFINED);
        	        	                    cmd->reset(new DefineFunctionCommand(name, func, terms, e));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 10:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1333:5: DEFINE_CONST_TOK symbol[name,CHECK_UNDECLARED,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] term[e, e2]
        	    {
        	         MATCHT(DEFINE_CONST_TOK, &FOLLOW_DEFINE_CONST_TOK_in_extendedCommand2583);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_symbol_in_extendedCommand2591);
        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkUserSymbol(name); 
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_extendedCommand2604);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             /* add variables to parser state before parsing term */
        	                  Debug("parser") << "define const: '" << name << "'" << std::endl;
        	                  PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                        sortedVarNames.begin(), iend = sortedVarNames.end(); i != iend;
        	                      ++i) {
        	                    terms.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	                  }
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2617);
        	        term(ctx, e, e2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->popScope();
        	                  // declare the name down here (while parsing term, signature
        	                  // must not be extended with the name itself; no recursion
        	                  // permitted)
        	                  Expr func = PARSER_STATE->mkFunction(name, t,
        	                                                       ExprManager::VAR_FLAG_DEFINED);
        	                  cmd->reset(new DefineFunctionCommand(name, func, terms, e));
        	                
        	        }


        	    }
        	    break;
        	case 11:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1356:5: SIMPLIFY_TOK term[e,e2]
        	    {
        	         MATCHT(SIMPLIFY_TOK, &FOLLOW_SIMPLIFY_TOK_in_extendedCommand2631);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2639);
        	        term(ctx, e, e2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(new SimplifyCommand(e)); 
        	        }


        	    }
        	    break;
        	case 12:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1359:5: GET_QE_TOK term[e,e2]
        	    {
        	         MATCHT(GET_QE_TOK, &FOLLOW_GET_QE_TOK_in_extendedCommand2652);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2660);
        	        term(ctx, e, e2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(new GetQuantifierEliminationCommand(e, true)); 
        	        }


        	    }
        	    break;
        	case 13:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1362:5: GET_QE_DISJUNCT_TOK term[e,e2]
        	    {
        	         MATCHT(GET_QE_DISJUNCT_TOK, &FOLLOW_GET_QE_DISJUNCT_TOK_in_extendedCommand2673);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             PARSER_STATE->checkThatLogicIsSet(); 
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_extendedCommand2681);
        	        term(ctx, e, e2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(new GetQuantifierEliminationCommand(e, false)); 
        	        }


        	    }
        	    break;
        	case 14:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1365:5: DECLARE_HEAP LPAREN_TOK sortSymbol[t,CHECK_DECLARED] sortSymbol[t, CHECK_DECLARED] RPAREN_TOK
        	    {
        	         MATCHT(DECLARE_HEAP, &FOLLOW_DECLARE_HEAP_in_extendedCommand2694);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_extendedCommand2696);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_extendedCommand2703);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_extendedCommand2711);
        	        sortSymbol(ctx, t, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	        {
        	             cmd->reset(new EmptyCommand()); 
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_extendedCommand2729);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleextendedCommandEx;
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruleextendedCommandEx; /* Prevent compiler warnings */
    ruleextendedCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end extendedCommand */

/**
 * $ANTLR start datatypes_2_5_DefCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1374:1: datatypes_2_5_DefCommand[bool isCo, std::unique_ptr<CVC4::Command>* cmd] : LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK datatypeDef[isCo, dts, sorts] RPAREN_TOK )+ RPAREN_TOK ;
 */
static void
datatypes_2_5_DefCommand(pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<CVC4::Datatype> dts;
      std::string name;
      std::vector<Type> sorts;
      std::vector<std::string> dnames;
      std::vector<unsigned> arities;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1382:3: ( LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK datatypeDef[isCo, dts, sorts] RPAREN_TOK )+ RPAREN_TOK )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1382:5: LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK datatypeDef[isCo, dts, sorts] RPAREN_TOK )+ RPAREN_TOK
        {
            {
                 PARSER_STATE->checkThatLogicIsSet();
                    /* open a scope to keep the UnresolvedTypes contained */
                    PARSER_STATE->pushScope(true); 
            }


             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2753);
            if  (HASEXCEPTION())
            {
                goto ruledatatypes_2_5_DefCommandEx;
            }



            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1386:3: ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )*

            for (;;)
            {
                int alt30=2;
                switch ( LA(1) )
                {
                case CHECK_SYNTH_TOK:
                case CONSTRAINT_TOK:
                case DECLARE_PRIMED_VAR_TOK:
                case DECLARE_VAR_TOK:
                case INV_CONSTRAINT_TOK:
                case QUOTED_SYMBOL:
                case SET_OPTIONS_TOK:
                case SIMPLE_SYMBOL:
                case SYNTH_FUN_TOK:
                case SYNTH_INV_TOK:
                case UNTERMINATED_QUOTED_SYMBOL:
                case 160:
                	{
                		alt30=1;
                	}
                    break;

                }

                switch (alt30)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1386:5: symbol[name,CHECK_UNDECLARED,SYM_SORT]
            	    {
            	        FOLLOWPUSH(FOLLOW_symbol_in_datatypes_2_5_DefCommand2761);
            	        symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruledatatypes_2_5_DefCommandEx;
            	        }


            	        {
            	             sorts.push_back( PARSER_STATE->mkSort(name, ExprManager::SORT_FLAG_PLACEHOLDER) ); 
            	        }


            	    }
            	    break;

            	default:
            	    goto loop30;	/* break out of the loop */
            	    break;
                }
            }
            loop30: ; /* Jump out to here if this rule does not match */


             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2777);
            if  (HASEXCEPTION())
            {
                goto ruledatatypes_2_5_DefCommandEx;
            }


             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2781);
            if  (HASEXCEPTION())
            {
                goto ruledatatypes_2_5_DefCommandEx;
            }


            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1390:14: ( LPAREN_TOK datatypeDef[isCo, dts, sorts] RPAREN_TOK )+
            {
                int cnt31=0;

                for (;;)
                {
                    int alt31=2;
            	switch ( LA(1) )
            	{
            	case LPAREN_TOK:
            		{
            			alt31=1;
            		}
            	    break;

            	}

            	switch (alt31)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1390:16: LPAREN_TOK datatypeDef[isCo, dts, sorts] RPAREN_TOK
            	        {
            	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypes_2_5_DefCommand2785);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypes_2_5_DefCommandEx;
            	            }


            	            FOLLOWPUSH(FOLLOW_datatypeDef_in_datatypes_2_5_DefCommand2787);
            	            datatypeDef(ctx, isCo, dts, sorts);

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypes_2_5_DefCommandEx;
            	            }


            	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2790);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypes_2_5_DefCommandEx;
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt31 >= 1 )
            		{
            		    goto loop31;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto ruledatatypes_2_5_DefCommandEx;
            	}
            	cnt31++;
                }
                loop31: ;	/* Jump to here if this rule does not match */
            }

             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypes_2_5_DefCommand2795);
            if  (HASEXCEPTION())
            {
                goto ruledatatypes_2_5_DefCommandEx;
            }


            {
                 PARSER_STATE->popScope();
                    cmd->reset(new DatatypeDeclarationCommand(PARSER_STATE->mkMutualDatatypeTypes(dts, true)));
                  
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruledatatypes_2_5_DefCommandEx; /* Prevent compiler warnings */
    ruledatatypes_2_5_DefCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end datatypes_2_5_DefCommand */

/**
 * $ANTLR start datatypeDefCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1396:1: datatypeDefCommand[bool isCo, std::unique_ptr<CVC4::Command>* cmd] : symbol[name,CHECK_UNDECLARED,SYM_SORT] datatypesDef[isCo, dnames, arities, cmd] ;
 */
static void
datatypeDefCommand(pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<CVC4::Datatype> dts;
      std::string name;
      std::vector<std::string> dnames;
      std::vector<int> arities;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1403:2: ( symbol[name,CHECK_UNDECLARED,SYM_SORT] datatypesDef[isCo, dnames, arities, cmd] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1403:4: symbol[name,CHECK_UNDECLARED,SYM_SORT] datatypesDef[isCo, dnames, arities, cmd]
        {
            {
                 PARSER_STATE->checkThatLogicIsSet(); 
            }


            FOLLOWPUSH(FOLLOW_symbol_in_datatypeDefCommand2824);
            symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruledatatypeDefCommandEx;
            }


            {

                   dnames.push_back(name);
                   arities.push_back(-1);
                 
            }


            FOLLOWPUSH(FOLLOW_datatypesDef_in_datatypeDefCommand2831);
            datatypesDef(ctx, isCo, dnames, arities, cmd);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruledatatypeDefCommandEx;
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruledatatypeDefCommandEx; /* Prevent compiler warnings */
    ruledatatypeDefCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end datatypeDefCommand */

/**
 * $ANTLR start datatypesDefCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1412:1: datatypesDefCommand[bool isCo, std::unique_ptr<CVC4::Command>* cmd] : LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL RPAREN_TOK )* RPAREN_TOK LPAREN_TOK datatypesDef[isCo, dnames, arities, cmd] RPAREN_TOK ;
 */
static void
datatypesDefCommand(pSmt2Parser ctx, bool isCo, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<CVC4::Datatype> dts;
      std::string name;
      std::vector<std::string> dnames;
      std::vector<int> arities;

    pANTLR3_COMMON_TOKEN    n;

    /* Initialize rule variables
     */

    n       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1419:3: ( LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL RPAREN_TOK )* RPAREN_TOK LPAREN_TOK datatypesDef[isCo, dnames, arities, cmd] RPAREN_TOK )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1419:5: LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL RPAREN_TOK )* RPAREN_TOK LPAREN_TOK datatypesDef[isCo, dnames, arities, cmd] RPAREN_TOK
        {
            {
                 PARSER_STATE->checkThatLogicIsSet(); 
            }


             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDefCommand2856);
            if  (HASEXCEPTION())
            {
                goto ruledatatypesDefCommandEx;
            }



            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1421:3: ( LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL RPAREN_TOK )*

            for (;;)
            {
                int alt32=2;
                switch ( LA(1) )
                {
                case LPAREN_TOK:
                	{
                		alt32=1;
                	}
                    break;

                }

                switch (alt32)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1421:5: LPAREN_TOK symbol[name,CHECK_UNDECLARED,SYM_SORT] n= INTEGER_LITERAL RPAREN_TOK
            	    {
            	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDefCommand2864);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruledatatypesDefCommandEx;
            	        }


            	        FOLLOWPUSH(FOLLOW_symbol_in_datatypesDefCommand2866);
            	        symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruledatatypesDefCommandEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_datatypesDefCommand2871);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruledatatypesDefCommandEx;
            	        }


            	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDefCommand2873);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruledatatypesDefCommandEx;
            	        }


            	        {
            	             unsigned arity = AntlrInput::tokenToUnsigned(n);
            	                  Debug("parser-dt") << "Datatype : " << name << ", arity = " << arity << std::endl;
            	                  dnames.push_back(name);
            	                  arities.push_back( static_cast<int>(arity) );
            	                
            	        }


            	    }
            	    break;

            	default:
            	    goto loop32;	/* break out of the loop */
            	    break;
                }
            }
            loop32: ; /* Jump out to here if this rule does not match */


             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDefCommand2888);
            if  (HASEXCEPTION())
            {
                goto ruledatatypesDefCommandEx;
            }


             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDefCommand2893);
            if  (HASEXCEPTION())
            {
                goto ruledatatypesDefCommandEx;
            }


            FOLLOWPUSH(FOLLOW_datatypesDef_in_datatypesDefCommand2898);
            datatypesDef(ctx, isCo, dnames, arities, cmd);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruledatatypesDefCommandEx;
            }


             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDefCommand2903);
            if  (HASEXCEPTION())
            {
                goto ruledatatypesDefCommandEx;
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruledatatypesDefCommandEx; /* Prevent compiler warnings */
    ruledatatypesDefCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end datatypesDefCommand */

/**
 * $ANTLR start datatypesDef
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1439:1: datatypesDef[bool isCo,\n const std::vector<std::string>& dnames,\n const std::vector<int>& arities,\n std::unique_ptr<CVC4::Command>* cmd] : ( LPAREN_TOK ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ ) RPAREN_TOK )+ ;
 */
static void
datatypesDef(pSmt2Parser ctx, bool isCo, const std::vector<std::string>& dnames, const std::vector<int>& arities, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<CVC4::Datatype> dts;
      std::string name;
      std::vector<Type> params;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1448:3: ( ( LPAREN_TOK ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ ) RPAREN_TOK )+ )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1448:5: ( LPAREN_TOK ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ ) RPAREN_TOK )+
        {
            {
                 PARSER_STATE->pushScope(true); 
            }


            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1449:5: ( LPAREN_TOK ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ ) RPAREN_TOK )+
            {
                int cnt37=0;

                for (;;)
                {
                    int alt37=2;
            	switch ( LA(1) )
            	{
            	case LPAREN_TOK:
            		{
            			alt37=1;
            		}
            	    break;

            	}

            	switch (alt37)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1449:7: LPAREN_TOK ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ ) RPAREN_TOK
            	        {
            	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDef2932);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypesDefEx;
            	            }


            	            {

            	                      params.clear(); 
            	                      Debug("parser-dt") << "Processing datatype #" << dts.size() << std::endl;
            	                      if( dts.size()>=dnames.size() ){
            	                        PARSER_STATE->parseError("Too many datatypes defined in this block.");
            	                      }
            	                    
            	            }



            	            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1456:5: ( PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK | ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ )
            	            {
            	                int alt36=2;
            	                switch ( LA(1) )
            	                {
            	                case PAR_TOK:
            	                	{
            	                		alt36=1;
            	                	}
            	                    break;
            	                case LPAREN_TOK:
            	                	{
            	                		alt36=2;
            	                	}
            	                    break;

            	                default:
            	                    CONSTRUCTEX();
            	                    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
            	                    EXCEPTION->message      = (void *)"";
            	                    EXCEPTION->decisionNum  = 36;
            	                    EXCEPTION->state        = 0;


            	                    goto ruledatatypesDefEx;

            	                }

            	                switch (alt36)
            	                {
            	            	case 1:
            	            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1456:7: PAR_TOK LPAREN_TOK ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )* RPAREN_TOK LPAREN_TOK ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+ RPAREN_TOK
            	            	    {
            	            	         MATCHT(PAR_TOK, &FOLLOW_PAR_TOK_in_datatypesDef2942);
            	            	        if  (HASEXCEPTION())
            	            	        {
            	            	            goto ruledatatypesDefEx;
            	            	        }


            	            	        {
            	            	             PARSER_STATE->pushScope(true); 
            	            	        }


            	            	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDef2946);
            	            	        if  (HASEXCEPTION())
            	            	        {
            	            	            goto ruledatatypesDefEx;
            	            	        }



            	            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1457:7: ( symbol[name,CHECK_UNDECLARED,SYM_SORT] )*

            	            	        for (;;)
            	            	        {
            	            	            int alt33=2;
            	            	            switch ( LA(1) )
            	            	            {
            	            	            case CHECK_SYNTH_TOK:
            	            	            case CONSTRAINT_TOK:
            	            	            case DECLARE_PRIMED_VAR_TOK:
            	            	            case DECLARE_VAR_TOK:
            	            	            case INV_CONSTRAINT_TOK:
            	            	            case QUOTED_SYMBOL:
            	            	            case SET_OPTIONS_TOK:
            	            	            case SIMPLE_SYMBOL:
            	            	            case SYNTH_FUN_TOK:
            	            	            case SYNTH_INV_TOK:
            	            	            case UNTERMINATED_QUOTED_SYMBOL:
            	            	            case 160:
            	            	            	{
            	            	            		alt33=1;
            	            	            	}
            	            	                break;

            	            	            }

            	            	            switch (alt33)
            	            	            {
            	            	        	case 1:
            	            	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1457:9: symbol[name,CHECK_UNDECLARED,SYM_SORT]
            	            	        	    {
            	            	        	        FOLLOWPUSH(FOLLOW_symbol_in_datatypesDef2956);
            	            	        	        symbol(ctx, name, CHECK_UNDECLARED, SYM_SORT);

            	            	        	        FOLLOWPOP();
            	            	        	        if  (HASEXCEPTION())
            	            	        	        {
            	            	        	            goto ruledatatypesDefEx;
            	            	        	        }


            	            	        	        {
            	            	        	             params.push_back( PARSER_STATE->mkSort(name, ExprManager::SORT_FLAG_PLACEHOLDER) ); 
            	            	        	        }


            	            	        	    }
            	            	        	    break;

            	            	        	default:
            	            	        	    goto loop33;	/* break out of the loop */
            	            	        	    break;
            	            	            }
            	            	        }
            	            	        loop33: ; /* Jump out to here if this rule does not match */


            	            	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDef2984);
            	            	        if  (HASEXCEPTION())
            	            	        {
            	            	            goto ruledatatypesDefEx;
            	            	        }


            	            	        {

            	            	                    // if the arity was fixed by prelude and is not equal to the number of parameters
            	            	                    if( arities[dts.size()]>=0 && static_cast<int>(params.size())!=arities[dts.size()] ){
            	            	                      PARSER_STATE->parseError("Wrong number of parameters for datatype.");
            	            	                    }
            	            	                    Debug("parser-dt") << params.size() << " parameters for " << dnames[dts.size()] << std::endl;
            	            	                    dts.push_back(Datatype(dnames[dts.size()],params,isCo));
            	            	                  
            	            	        }


            	            	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDef2994);
            	            	        if  (HASEXCEPTION())
            	            	        {
            	            	            goto ruledatatypesDefEx;
            	            	        }


            	            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1469:7: ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+
            	            	        {
            	            	            int cnt34=0;

            	            	            for (;;)
            	            	            {
            	            	                int alt34=2;
            	            	        	switch ( LA(1) )
            	            	        	{
            	            	        	case LPAREN_TOK:
            	            	        		{
            	            	        			alt34=1;
            	            	        		}
            	            	        	    break;

            	            	        	}

            	            	        	switch (alt34)
            	            	        	{
            	            	        	    case 1:
            	            	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1469:9: LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK
            	            	        	        {
            	            	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDef3004);
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	            FOLLOWPUSH(FOLLOW_constructorDef_in_datatypesDef3006);
            	            	        	            constructorDef(ctx, dts.back());

            	            	        	            FOLLOWPOP();
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDef3009);
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	        }
            	            	        	        break;

            	            	        	    default:

            	            	        		if ( cnt34 >= 1 )
            	            	        		{
            	            	        		    goto loop34;
            	            	        		}
            	            	        		/* mismatchedSetEx()
            	            	        		 */
            	            	        		CONSTRUCTEX();
            	            	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            	            	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            	            	        		goto ruledatatypesDefEx;
            	            	        	}
            	            	        	cnt34++;
            	            	            }
            	            	            loop34: ;	/* Jump to here if this rule does not match */
            	            	        }

            	            	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDef3020);
            	            	        if  (HASEXCEPTION())
            	            	        {
            	            	            goto ruledatatypesDefEx;
            	            	        }


            	            	        {
            	            	             PARSER_STATE->popScope(); 
            	            	        }


            	            	    }
            	            	    break;
            	            	case 2:
            	            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1471:7: ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+
            	            	    {
            	            	        {
            	            	             // if the arity was fixed by prelude and is not equal to 0
            	            	                    if( arities[dts.size()]>0 ){
            	            	                      PARSER_STATE->parseError("No parameters given for datatype.");
            	            	                    }
            	            	                    Debug("parser-dt") << params.size() << " parameters for " << dnames[dts.size()] << std::endl;
            	            	                    dts.push_back(Datatype(dnames[dts.size()],params,isCo));
            	            	                  
            	            	        }


            	            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1478:7: ( LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK )+
            	            	        {
            	            	            int cnt35=0;

            	            	            for (;;)
            	            	            {
            	            	                int alt35=2;
            	            	        	switch ( LA(1) )
            	            	        	{
            	            	        	case LPAREN_TOK:
            	            	        		{
            	            	        			alt35=1;
            	            	        		}
            	            	        	    break;

            	            	        	}

            	            	        	switch (alt35)
            	            	        	{
            	            	        	    case 1:
            	            	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1478:9: LPAREN_TOK constructorDef[dts.back()] RPAREN_TOK
            	            	        	        {
            	            	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypesDef3041);
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	            FOLLOWPUSH(FOLLOW_constructorDef_in_datatypesDef3043);
            	            	        	            constructorDef(ctx, dts.back());

            	            	        	            FOLLOWPOP();
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDef3046);
            	            	        	            if  (HASEXCEPTION())
            	            	        	            {
            	            	        	                goto ruledatatypesDefEx;
            	            	        	            }


            	            	        	        }
            	            	        	        break;

            	            	        	    default:

            	            	        		if ( cnt35 >= 1 )
            	            	        		{
            	            	        		    goto loop35;
            	            	        		}
            	            	        		/* mismatchedSetEx()
            	            	        		 */
            	            	        		CONSTRUCTEX();
            	            	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            	            	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            	            	        		goto ruledatatypesDefEx;
            	            	        	}
            	            	        	cnt35++;
            	            	            }
            	            	            loop35: ;	/* Jump to here if this rule does not match */
            	            	        }

            	            	    }
            	            	    break;

            	                }
            	            }

            	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypesDef3061);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypesDefEx;
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt37 >= 1 )
            		{
            		    goto loop37;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto ruledatatypesDefEx;
            	}
            	cnt37++;
                }
                loop37: ;	/* Jump to here if this rule does not match */
            }

            {

                    PARSER_STATE->popScope();
                    cmd->reset(new DatatypeDeclarationCommand(PARSER_STATE->mkMutualDatatypeTypes(dts, true))); 
                  
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruledatatypesDefEx; /* Prevent compiler warnings */
    ruledatatypesDefEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end datatypesDef */

/**
 * $ANTLR start rewriterulesCommand
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1488:1: rewriterulesCommand[std::unique_ptr<CVC4::Command>* cmd] : ( REWRITE_RULE_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK term[head, expr2] term[body, expr2] | rewritePropaKind[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK LPAREN_TOK ( termList[heads,expr] )? RPAREN_TOK term[body, expr2] );
 */
static void
rewriterulesCommand(pSmt2Parser ctx, std::unique_ptr<CVC4::Command>* cmd)
{

      std::vector<std::pair<std::string, Type> > sortedVarNames;
      std::vector<Expr> args, guards, heads, triggers;
      Expr head, body, expr, expr2, bvl;
      Kind kind;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1495:3: ( REWRITE_RULE_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK term[head, expr2] term[body, expr2] | rewritePropaKind[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK LPAREN_TOK ( termList[heads,expr] )? RPAREN_TOK term[body, expr2] )

            ANTLR3_UINT32 alt43;

            alt43=2;

            switch ( LA(1) )
            {
            case REWRITE_RULE_TOK:
            	{
            		alt43=1;
            	}
                break;
            case PROPAGATION_RULE_TOK:
            case REDUCTION_RULE_TOK:
            	{
            		alt43=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 43;
                EXCEPTION->state        = 0;


                goto rulerewriterulesCommandEx;

            }

            switch (alt43)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1496:5: REWRITE_RULE_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK term[head, expr2] term[body, expr2]
        	    {
        	         MATCHT(REWRITE_RULE_TOK, &FOLLOW_REWRITE_RULE_TOK_in_rewriterulesCommand3097);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3103);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_rewriterulesCommand3105);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3108);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        {

        	                  kind = CVC4::kind::RR_REWRITE;
        	                  PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                        sortedVarNames.begin(), iend = sortedVarNames.end();
        	                      i != iend;
        	                      ++i) {
        	                    args.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	                  }
        	                  bvl = MK_EXPR(kind::BOUND_VAR_LIST, args);
        	                
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3120);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1509:16: ( pattern[expr] )*

        	        for (;;)
        	        {
        	            int alt38=2;
        	            switch ( LA(1) )
        	            {
        	            case LPAREN_TOK:
        	            	{
        	            		alt38=1;
        	            	}
        	                break;

        	            }

        	            switch (alt38)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1509:18: pattern[expr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_pattern_in_rewriterulesCommand3124);
        	        	        pattern(ctx, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulerewriterulesCommandEx;
        	        	        }


        	        	        {
        	        	             triggers.push_back( expr ); 
        	        	        }


        	        	    }
        	        	    break;

        	        	default:
        	        	    goto loop38;	/* break out of the loop */
        	        	    break;
        	            }
        	        }
        	        loop38: ; /* Jump out to here if this rule does not match */


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3132);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3138);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1510:16: ( termList[guards,expr] )?
        	        {
        	            int alt39=2;
        	            switch ( LA(1) )
        	            {
        	                case BINARY_LITERAL:
        	                case CHECK_SYNTH_TOK:
        	                case CONSTRAINT_TOK:
        	                case DECIMAL_LITERAL:
        	                case DECLARE_PRIMED_VAR_TOK:
        	                case DECLARE_VAR_TOK:
        	                case EMPTYSET_TOK:
        	                case FP_RNA_FULL_TOK:
        	                case FP_RNA_TOK:
        	                case FP_RNE_FULL_TOK:
        	                case FP_RNE_TOK:
        	                case FP_RTN_FULL_TOK:
        	                case FP_RTN_TOK:
        	                case FP_RTP_FULL_TOK:
        	                case FP_RTP_TOK:
        	                case FP_RTZ_FULL_TOK:
        	                case FP_RTZ_TOK:
        	                case HEX_LITERAL:
        	                case INTEGER_LITERAL:
        	                case INV_CONSTRAINT_TOK:
        	                case LPAREN_TOK:
        	                case NILREF_TOK:
        	                case QUOTED_SYMBOL:
        	                case REALLCHAR_TOK:
        	                case REAL_PI_TOK:
        	                case RENOSTR_TOK:
        	                case SET_OPTIONS_TOK:
        	                case SIMPLE_SYMBOL:
        	                case STRING_LITERAL:
        	                case SYNTH_FUN_TOK:
        	                case SYNTH_INV_TOK:
        	                case TUPLE_CONST_TOK:
        	                case UNIVSET_TOK:
        	                case UNTERMINATED_QUOTED_SYMBOL:
        	                case 160:
        	                	{
        	                		alt39=1;
        	                	}
        	                    break;
        	            }

        	            switch (alt39)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1510:17: termList[guards,expr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_termList_in_rewriterulesCommand3141);
        	        	        termList(ctx, guards, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulerewriterulesCommandEx;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3146);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_rewriterulesCommand3152);
        	        term(ctx, head, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_rewriterulesCommand3155);
        	        term(ctx, body, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        {

        	                  args.clear();
        	                  args.push_back(head);
        	                  args.push_back(body);
        	                  /* triggers */
        	                  if( !triggers.empty() ){
        	                    expr2 = MK_EXPR(kind::INST_PATTERN_LIST, triggers);
        	                    args.push_back(expr2);
        	                  };
        	                  expr = MK_EXPR(kind, args);
        	                  args.clear();
        	                  args.push_back(bvl);
        	                  /* guards */
        	                  switch( guards.size() ){
        	                  case 0:
        	                    args.push_back(MK_CONST(bool(true))); break;
        	                  case 1:
        	                    args.push_back(guards[0]); break;
        	                  default:
        	                    expr2 = MK_EXPR(kind::AND, guards);
        	                    args.push_back(expr2); break;
        	                  };
        	                  args.push_back(expr);
        	                  expr = MK_EXPR(CVC4::kind::REWRITE_RULE, args);
        	                  cmd->reset(new AssertCommand(expr, false)); 
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1538:5: rewritePropaKind[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK LPAREN_TOK ( pattern[expr] )* RPAREN_TOK LPAREN_TOK ( termList[guards,expr] )? RPAREN_TOK LPAREN_TOK ( termList[heads,expr] )? RPAREN_TOK term[body, expr2]
        	    {
        	        FOLLOWPUSH(FOLLOW_rewritePropaKind_in_rewriterulesCommand3174);
        	        rewritePropaKind(ctx, kind);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3181);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_rewriterulesCommand3183);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3186);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        {

        	                  PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                        sortedVarNames.begin(), iend = sortedVarNames.end();
        	                      i != iend;
        	                      ++i) {
        	                    args.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	                  }
        	                  bvl = MK_EXPR(kind::BOUND_VAR_LIST, args);
        	                
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3198);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1550:16: ( pattern[expr] )*

        	        for (;;)
        	        {
        	            int alt40=2;
        	            switch ( LA(1) )
        	            {
        	            case LPAREN_TOK:
        	            	{
        	            		alt40=1;
        	            	}
        	                break;

        	            }

        	            switch (alt40)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1550:18: pattern[expr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_pattern_in_rewriterulesCommand3202);
        	        	        pattern(ctx, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulerewriterulesCommandEx;
        	        	        }


        	        	        {
        	        	             triggers.push_back( expr ); 
        	        	        }


        	        	    }
        	        	    break;

        	        	default:
        	        	    goto loop40;	/* break out of the loop */
        	        	    break;
        	            }
        	        }
        	        loop40: ; /* Jump out to here if this rule does not match */


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3210);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3216);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1551:16: ( termList[guards,expr] )?
        	        {
        	            int alt41=2;
        	            switch ( LA(1) )
        	            {
        	                case BINARY_LITERAL:
        	                case CHECK_SYNTH_TOK:
        	                case CONSTRAINT_TOK:
        	                case DECIMAL_LITERAL:
        	                case DECLARE_PRIMED_VAR_TOK:
        	                case DECLARE_VAR_TOK:
        	                case EMPTYSET_TOK:
        	                case FP_RNA_FULL_TOK:
        	                case FP_RNA_TOK:
        	                case FP_RNE_FULL_TOK:
        	                case FP_RNE_TOK:
        	                case FP_RTN_FULL_TOK:
        	                case FP_RTN_TOK:
        	                case FP_RTP_FULL_TOK:
        	                case FP_RTP_TOK:
        	                case FP_RTZ_FULL_TOK:
        	                case FP_RTZ_TOK:
        	                case HEX_LITERAL:
        	                case INTEGER_LITERAL:
        	                case INV_CONSTRAINT_TOK:
        	                case LPAREN_TOK:
        	                case NILREF_TOK:
        	                case QUOTED_SYMBOL:
        	                case REALLCHAR_TOK:
        	                case REAL_PI_TOK:
        	                case RENOSTR_TOK:
        	                case SET_OPTIONS_TOK:
        	                case SIMPLE_SYMBOL:
        	                case STRING_LITERAL:
        	                case SYNTH_FUN_TOK:
        	                case SYNTH_INV_TOK:
        	                case TUPLE_CONST_TOK:
        	                case UNIVSET_TOK:
        	                case UNTERMINATED_QUOTED_SYMBOL:
        	                case 160:
        	                	{
        	                		alt41=1;
        	                	}
        	                    break;
        	            }

        	            switch (alt41)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1551:17: termList[guards,expr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_termList_in_rewriterulesCommand3219);
        	        	        termList(ctx, guards, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulerewriterulesCommandEx;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3224);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_rewriterulesCommand3230);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1552:16: ( termList[heads,expr] )?
        	        {
        	            int alt42=2;
        	            switch ( LA(1) )
        	            {
        	                case BINARY_LITERAL:
        	                case CHECK_SYNTH_TOK:
        	                case CONSTRAINT_TOK:
        	                case DECIMAL_LITERAL:
        	                case DECLARE_PRIMED_VAR_TOK:
        	                case DECLARE_VAR_TOK:
        	                case EMPTYSET_TOK:
        	                case FP_RNA_FULL_TOK:
        	                case FP_RNA_TOK:
        	                case FP_RNE_FULL_TOK:
        	                case FP_RNE_TOK:
        	                case FP_RTN_FULL_TOK:
        	                case FP_RTN_TOK:
        	                case FP_RTP_FULL_TOK:
        	                case FP_RTP_TOK:
        	                case FP_RTZ_FULL_TOK:
        	                case FP_RTZ_TOK:
        	                case HEX_LITERAL:
        	                case INTEGER_LITERAL:
        	                case INV_CONSTRAINT_TOK:
        	                case LPAREN_TOK:
        	                case NILREF_TOK:
        	                case QUOTED_SYMBOL:
        	                case REALLCHAR_TOK:
        	                case REAL_PI_TOK:
        	                case RENOSTR_TOK:
        	                case SET_OPTIONS_TOK:
        	                case SIMPLE_SYMBOL:
        	                case STRING_LITERAL:
        	                case SYNTH_FUN_TOK:
        	                case SYNTH_INV_TOK:
        	                case TUPLE_CONST_TOK:
        	                case UNIVSET_TOK:
        	                case UNTERMINATED_QUOTED_SYMBOL:
        	                case 160:
        	                	{
        	                		alt42=1;
        	                	}
        	                    break;
        	            }

        	            switch (alt42)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1552:17: termList[heads,expr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_termList_in_rewriterulesCommand3233);
        	        	        termList(ctx, heads, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulerewriterulesCommandEx;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_rewriterulesCommand3238);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_rewriterulesCommand3244);
        	        term(ctx, body, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewriterulesCommandEx;
        	        }


        	        {

        	                  args.clear();
        	                  /* heads */
        	                  switch( heads.size() ){
        	                  case 0:
        	                    args.push_back(MK_CONST(bool(true))); break;
        	                  case 1:
        	                    args.push_back(heads[0]); break;
        	                  default:
        	                    expr2 = MK_EXPR(kind::AND, heads);
        	                    args.push_back(expr2); break;
        	                  };
        	                  args.push_back(body);
        	                  /* triggers */
        	                  if( !triggers.empty() ){
        	                    expr2 = MK_EXPR(kind::INST_PATTERN_LIST, triggers);
        	                    args.push_back(expr2);
        	                  };
        	                  expr = MK_EXPR(kind, args);
        	                  args.clear();
        	                  args.push_back(bvl);
        	                  /* guards */
        	                  switch( guards.size() ){
        	                  case 0:
        	                    args.push_back(MK_CONST(bool(true))); break;
        	                  case 1:
        	                    args.push_back(guards[0]); break;
        	                  default:
        	                    expr2 = MK_EXPR(kind::AND, guards);
        	                    args.push_back(expr2); break;
        	                  };
        	                  args.push_back(expr);
        	                  expr = MK_EXPR(CVC4::kind::REWRITE_RULE, args);
        	                  cmd->reset(new AssertCommand(expr, false));
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulerewriterulesCommandEx; /* Prevent compiler warnings */
    rulerewriterulesCommandEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end rewriterulesCommand */

/**
 * $ANTLR start rewritePropaKind
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1591:1: rewritePropaKind[CVC4::Kind& kind] : ( REDUCTION_RULE_TOK | PROPAGATION_RULE_TOK );
 */
static void
rewritePropaKind(pSmt2Parser ctx, CVC4::Kind& kind)
{
    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1592:3: ( REDUCTION_RULE_TOK | PROPAGATION_RULE_TOK )

            ANTLR3_UINT32 alt44;

            alt44=2;

            switch ( LA(1) )
            {
            case REDUCTION_RULE_TOK:
            	{
            		alt44=1;
            	}
                break;
            case PROPAGATION_RULE_TOK:
            	{
            		alt44=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 44;
                EXCEPTION->state        = 0;


                goto rulerewritePropaKindEx;

            }

            switch (alt44)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1592:5: REDUCTION_RULE_TOK
        	    {
        	         MATCHT(REDUCTION_RULE_TOK, &FOLLOW_REDUCTION_RULE_TOK_in_rewritePropaKind3265);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewritePropaKindEx;
        	        }


        	        {
        	             kind= CVC4::kind::RR_REDUCTION; 
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1593:5: PROPAGATION_RULE_TOK
        	    {
        	         MATCHT(PROPAGATION_RULE_TOK, &FOLLOW_PROPAGATION_RULE_TOK_in_rewritePropaKind3276);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulerewritePropaKindEx;
        	        }


        	        {
        	             kind= CVC4::kind::RR_DEDUCTION; 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulerewritePropaKindEx; /* Prevent compiler warnings */
    rulerewritePropaKindEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end rewritePropaKind */

/**
 * $ANTLR start pattern
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1596:1: pattern[CVC4::Expr& expr] : LPAREN_TOK termList[patexpr,expr] RPAREN_TOK ;
 */
static void
pattern(pSmt2Parser ctx, CVC4::Expr& expr)
{

      std::vector<Expr> patexpr;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1600:3: ( LPAREN_TOK termList[patexpr,expr] RPAREN_TOK )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1600:5: LPAREN_TOK termList[patexpr,expr] RPAREN_TOK
        {
             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_pattern3298);
            if  (HASEXCEPTION())
            {
                goto rulepatternEx;
            }


            FOLLOWPUSH(FOLLOW_termList_in_pattern3300);
            termList(ctx, patexpr, expr);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulepatternEx;
            }


             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_pattern3303);
            if  (HASEXCEPTION())
            {
                goto rulepatternEx;
            }


            {

                      expr = MK_EXPR(kind::INST_PATTERN, patexpr);
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulepatternEx; /* Prevent compiler warnings */
    rulepatternEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end pattern */

/**
 * $ANTLR start simpleSymbolicExprNoKeyword
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1606:1: simpleSymbolicExprNoKeyword[CVC4::SExpr& sexpr] : ( INTEGER_LITERAL | DECIMAL_LITERAL | HEX_LITERAL | BINARY_LITERAL | str[s,false] | symbol[s,CHECK_NONE,SYM_SORT] |tok= ( ASSERT_TOK | CHECK_SAT_TOK | CHECK_SAT_ASSUMING_TOK | DECLARE_FUN_TOK | DECLARE_SORT_TOK | DEFINE_FUN_TOK | DEFINE_FUN_REC_TOK | DEFINE_FUNS_REC_TOK | DEFINE_SORT_TOK | GET_VALUE_TOK | GET_ASSIGNMENT_TOK | GET_ASSERTIONS_TOK | GET_PROOF_TOK | GET_UNSAT_ASSUMPTIONS_TOK | GET_UNSAT_CORE_TOK | EXIT_TOK | RESET_TOK | RESET_ASSERTIONS_TOK | SET_LOGIC_TOK | SET_INFO_TOK | GET_INFO_TOK | SET_OPTION_TOK | GET_OPTION_TOK | PUSH_TOK | POP_TOK | DECLARE_DATATYPES_TOK | GET_MODEL_TOK | ECHO_TOK | REWRITE_RULE_TOK | REDUCTION_RULE_TOK | PROPAGATION_RULE_TOK | SIMPLIFY_TOK ) | builtinOp[k] );
 */
static void
simpleSymbolicExprNoKeyword(pSmt2Parser ctx, CVC4::SExpr& sexpr)
{

      CVC4::Kind k;
      std::string s;
      std::vector<unsigned int> s_vec;

    pANTLR3_COMMON_TOKEN    tok;
    pANTLR3_COMMON_TOKEN    INTEGER_LITERAL5;
    pANTLR3_COMMON_TOKEN    DECIMAL_LITERAL6;
    pANTLR3_COMMON_TOKEN    HEX_LITERAL7;
    pANTLR3_COMMON_TOKEN    BINARY_LITERAL8;

    /* Initialize rule variables
     */

    tok       = NULL;
    INTEGER_LITERAL5       = NULL;
    DECIMAL_LITERAL6       = NULL;
    HEX_LITERAL7       = NULL;
    BINARY_LITERAL8       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1612:3: ( INTEGER_LITERAL | DECIMAL_LITERAL | HEX_LITERAL | BINARY_LITERAL | str[s,false] | symbol[s,CHECK_NONE,SYM_SORT] |tok= ( ASSERT_TOK | CHECK_SAT_TOK | CHECK_SAT_ASSUMING_TOK | DECLARE_FUN_TOK | DECLARE_SORT_TOK | DEFINE_FUN_TOK | DEFINE_FUN_REC_TOK | DEFINE_FUNS_REC_TOK | DEFINE_SORT_TOK | GET_VALUE_TOK | GET_ASSIGNMENT_TOK | GET_ASSERTIONS_TOK | GET_PROOF_TOK | GET_UNSAT_ASSUMPTIONS_TOK | GET_UNSAT_CORE_TOK | EXIT_TOK | RESET_TOK | RESET_ASSERTIONS_TOK | SET_LOGIC_TOK | SET_INFO_TOK | GET_INFO_TOK | SET_OPTION_TOK | GET_OPTION_TOK | PUSH_TOK | POP_TOK | DECLARE_DATATYPES_TOK | GET_MODEL_TOK | ECHO_TOK | REWRITE_RULE_TOK | REDUCTION_RULE_TOK | PROPAGATION_RULE_TOK | SIMPLIFY_TOK ) | builtinOp[k] )

            ANTLR3_UINT32 alt45;

            alt45=8;

            switch ( LA(1) )
            {
            case INTEGER_LITERAL:
            	{
            		alt45=1;
            	}
                break;
            case DECIMAL_LITERAL:
            	{
            		alt45=2;
            	}
                break;
            case HEX_LITERAL:
            	{
            		alt45=3;
            	}
                break;
            case BINARY_LITERAL:
            	{
            		alt45=4;
            	}
                break;
            case STRING_LITERAL:
            	{
            		alt45=5;
            	}
                break;
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case INV_CONSTRAINT_TOK:
            case QUOTED_SYMBOL:
            case SET_OPTIONS_TOK:
            case SIMPLE_SYMBOL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case 160:
            	{
            		alt45=6;
            	}
                break;
            case ASSERT_TOK:
            case CHECK_SAT_ASSUMING_TOK:
            case CHECK_SAT_TOK:
            case DECLARE_DATATYPES_TOK:
            case DECLARE_FUN_TOK:
            case DECLARE_SORT_TOK:
            case DEFINE_FUNS_REC_TOK:
            case DEFINE_FUN_REC_TOK:
            case DEFINE_FUN_TOK:
            case DEFINE_SORT_TOK:
            case ECHO_TOK:
            case EXIT_TOK:
            case GET_ASSERTIONS_TOK:
            case GET_ASSIGNMENT_TOK:
            case GET_INFO_TOK:
            case GET_MODEL_TOK:
            case GET_OPTION_TOK:
            case GET_PROOF_TOK:
            case GET_UNSAT_ASSUMPTIONS_TOK:
            case GET_UNSAT_CORE_TOK:
            case GET_VALUE_TOK:
            case POP_TOK:
            case PROPAGATION_RULE_TOK:
            case PUSH_TOK:
            case REDUCTION_RULE_TOK:
            case RESET_ASSERTIONS_TOK:
            case RESET_TOK:
            case REWRITE_RULE_TOK:
            case SET_INFO_TOK:
            case SET_LOGIC_TOK:
            case SET_OPTION_TOK:
            case SIMPLIFY_TOK:
            	{
            		alt45=7;
            	}
                break;
            case AND_TOK:
            case BV2NAT_TOK:
            case DISTINCT_TOK:
            case DIV_TOK:
            case DTSIZE_TOK:
            case EQUAL_TOK:
            case FMFCARDVAL_TOK:
            case FMFCARD_TOK:
            case GREATER_THAN_EQUAL_TOK:
            case GREATER_THAN_TOK:
            case IMPLIES_TOK:
            case INST_CLOSURE_TOK:
            case ITE_TOK:
            case LESS_THAN_EQUAL_TOK:
            case LESS_THAN_TOK:
            case MINUS_TOK:
            case NOT_TOK:
            case OR_TOK:
            case PLUS_TOK:
            case STAR_TOK:
            case XOR_TOK:
            	{
            		alt45=8;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 45;
                EXCEPTION->state        = 0;


                goto rulesimpleSymbolicExprNoKeywordEx;

            }

            switch (alt45)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1612:5: INTEGER_LITERAL
        	    {
        	        INTEGER_LITERAL5 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_simpleSymbolicExprNoKeyword3328);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             sexpr = SExpr(Integer(AntlrInput::tokenText(INTEGER_LITERAL5))); 
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1614:5: DECIMAL_LITERAL
        	    {
        	        DECIMAL_LITERAL6 = (pANTLR3_COMMON_TOKEN) MATCHT(DECIMAL_LITERAL, &FOLLOW_DECIMAL_LITERAL_in_simpleSymbolicExprNoKeyword3340);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             sexpr = SExpr(AntlrInput::tokenToRational(DECIMAL_LITERAL6)); 
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1616:5: HEX_LITERAL
        	    {
        	        HEX_LITERAL7 = (pANTLR3_COMMON_TOKEN) MATCHT(HEX_LITERAL, &FOLLOW_HEX_LITERAL_in_simpleSymbolicExprNoKeyword3352);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             assert( AntlrInput::tokenText(HEX_LITERAL7).find("#x") == 0 );
        	                  std::string hexString = AntlrInput::tokenTextSubstr(HEX_LITERAL7, 2);
        	                  sexpr = SExpr(Integer(hexString, 16));
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1621:5: BINARY_LITERAL
        	    {
        	        BINARY_LITERAL8 = (pANTLR3_COMMON_TOKEN) MATCHT(BINARY_LITERAL, &FOLLOW_BINARY_LITERAL_in_simpleSymbolicExprNoKeyword3364);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             assert( AntlrInput::tokenText(BINARY_LITERAL8).find("#b") == 0 );
        	                  std::string binString = AntlrInput::tokenTextSubstr(BINARY_LITERAL8, 2);
        	                  sexpr = SExpr(Integer(binString, 2));
        	                
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1626:5: str[s,false]
        	    {
        	        FOLLOWPUSH(FOLLOW_str_in_simpleSymbolicExprNoKeyword3376);
        	        str(ctx, s, false);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             sexpr = SExpr(s); 
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1635:5: symbol[s,CHECK_NONE,SYM_SORT]
        	    {
        	        FOLLOWPUSH(FOLLOW_symbol_in_simpleSymbolicExprNoKeyword3396);
        	        symbol(ctx, s, CHECK_NONE, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             sexpr = SExpr(SExpr::Keyword(s)); 
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1637:5: tok= ( ASSERT_TOK | CHECK_SAT_TOK | CHECK_SAT_ASSUMING_TOK | DECLARE_FUN_TOK | DECLARE_SORT_TOK | DEFINE_FUN_TOK | DEFINE_FUN_REC_TOK | DEFINE_FUNS_REC_TOK | DEFINE_SORT_TOK | GET_VALUE_TOK | GET_ASSIGNMENT_TOK | GET_ASSERTIONS_TOK | GET_PROOF_TOK | GET_UNSAT_ASSUMPTIONS_TOK | GET_UNSAT_CORE_TOK | EXIT_TOK | RESET_TOK | RESET_ASSERTIONS_TOK | SET_LOGIC_TOK | SET_INFO_TOK | GET_INFO_TOK | SET_OPTION_TOK | GET_OPTION_TOK | PUSH_TOK | POP_TOK | DECLARE_DATATYPES_TOK | GET_MODEL_TOK | ECHO_TOK | REWRITE_RULE_TOK | REDUCTION_RULE_TOK | PROPAGATION_RULE_TOK | SIMPLIFY_TOK )
        	    {
        	        tok=(pANTLR3_COMMON_TOKEN)LT(1);

        	        if ( LA(1) == ASSERT_TOK || ((LA(1) >= CHECK_SAT_ASSUMING_TOK) && (LA(1) <= CHECK_SAT_TOK)) || LA(1) == DECLARE_DATATYPES_TOK || LA(1) == DECLARE_FUN_TOK || LA(1) == DECLARE_SORT_TOK || ((LA(1) >= DEFINE_FUNS_REC_TOK) && (LA(1) <= DEFINE_SORT_TOK)) || LA(1) == ECHO_TOK || LA(1) == EXIT_TOK || ((LA(1) >= GET_ASSERTIONS_TOK) && (LA(1) <= GET_PROOF_TOK)) || ((LA(1) >= GET_UNSAT_ASSUMPTIONS_TOK) && (LA(1) <= GET_VALUE_TOK)) || ((LA(1) >= POP_TOK) && (LA(1) <= PUSH_TOK)) || LA(1) == REDUCTION_RULE_TOK || ((LA(1) >= RESET_ASSERTIONS_TOK) && (LA(1) <= REWRITE_RULE_TOK)) || ((LA(1) >= SET_INFO_TOK) && (LA(1) <= SET_LOGIC_TOK)) || LA(1) == SET_OPTION_TOK || LA(1) == SIMPLIFY_TOK )
        	        {
        	            CONSUME();
        	            PERRORRECOVERY=ANTLR3_FALSE;
        	        }
        	        else
        	        {
        	            CONSTRUCTEX();
        	            EXCEPTION->type         = ANTLR3_MISMATCHED_SET_EXCEPTION;
        	            EXCEPTION->name         = (void *)ANTLR3_MISMATCHED_SET_NAME;
        	            EXCEPTION->expectingSet = NULL;

        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             sexpr = SExpr(SExpr::Keyword(AntlrInput::tokenText(tok))); 
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1648:5: builtinOp[k]
        	    {
        	        FOLLOWPUSH(FOLLOW_builtinOp_in_simpleSymbolicExprNoKeyword3621);
        	        builtinOp(ctx, k);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprNoKeywordEx;
        	        }


        	        {
        	             std::stringstream ss;
        	                  ss << language::SetLanguage(CVC4::language::output::LANG_SMTLIB_V2_5)
        	                     << EXPR_MANAGER->mkConst(k);
        	                  sexpr = SExpr(ss.str());
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesimpleSymbolicExprNoKeywordEx; /* Prevent compiler warnings */
    rulesimpleSymbolicExprNoKeywordEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end simpleSymbolicExprNoKeyword */

/**
 * $ANTLR start keyword
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1656:1: keyword[std::string& s] : KEYWORD ;
 */
static void
keyword(pSmt2Parser ctx, std::string& s)
{
    pANTLR3_COMMON_TOKEN    KEYWORD9;

    /* Initialize rule variables
     */

    KEYWORD9       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1657:3: ( KEYWORD )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1657:5: KEYWORD
        {
            KEYWORD9 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_keyword3642);
            if  (HASEXCEPTION())
            {
                goto rulekeywordEx;
            }


            {
                 s = AntlrInput::tokenText(KEYWORD9); 
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulekeywordEx; /* Prevent compiler warnings */
    rulekeywordEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end keyword */

/**
 * $ANTLR start simpleSymbolicExpr
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1661:1: simpleSymbolicExpr[CVC4::SExpr& sexpr] : ( simpleSymbolicExprNoKeyword[sexpr] | KEYWORD );
 */
static void
simpleSymbolicExpr(pSmt2Parser ctx, CVC4::SExpr& sexpr)
{
    pANTLR3_COMMON_TOKEN    KEYWORD10;

    /* Initialize rule variables
     */

    KEYWORD10       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1662:3: ( simpleSymbolicExprNoKeyword[sexpr] | KEYWORD )

            ANTLR3_UINT32 alt46;

            alt46=2;

            switch ( LA(1) )
            {
            case AND_TOK:
            case ASSERT_TOK:
            case BINARY_LITERAL:
            case BV2NAT_TOK:
            case CHECK_SAT_ASSUMING_TOK:
            case CHECK_SAT_TOK:
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECIMAL_LITERAL:
            case DECLARE_DATATYPES_TOK:
            case DECLARE_FUN_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_SORT_TOK:
            case DECLARE_VAR_TOK:
            case DEFINE_FUNS_REC_TOK:
            case DEFINE_FUN_REC_TOK:
            case DEFINE_FUN_TOK:
            case DEFINE_SORT_TOK:
            case DISTINCT_TOK:
            case DIV_TOK:
            case DTSIZE_TOK:
            case ECHO_TOK:
            case EQUAL_TOK:
            case EXIT_TOK:
            case FMFCARDVAL_TOK:
            case FMFCARD_TOK:
            case GET_ASSERTIONS_TOK:
            case GET_ASSIGNMENT_TOK:
            case GET_INFO_TOK:
            case GET_MODEL_TOK:
            case GET_OPTION_TOK:
            case GET_PROOF_TOK:
            case GET_UNSAT_ASSUMPTIONS_TOK:
            case GET_UNSAT_CORE_TOK:
            case GET_VALUE_TOK:
            case GREATER_THAN_EQUAL_TOK:
            case GREATER_THAN_TOK:
            case HEX_LITERAL:
            case IMPLIES_TOK:
            case INST_CLOSURE_TOK:
            case INTEGER_LITERAL:
            case INV_CONSTRAINT_TOK:
            case ITE_TOK:
            case LESS_THAN_EQUAL_TOK:
            case LESS_THAN_TOK:
            case MINUS_TOK:
            case NOT_TOK:
            case OR_TOK:
            case PLUS_TOK:
            case POP_TOK:
            case PROPAGATION_RULE_TOK:
            case PUSH_TOK:
            case QUOTED_SYMBOL:
            case REDUCTION_RULE_TOK:
            case RESET_ASSERTIONS_TOK:
            case RESET_TOK:
            case REWRITE_RULE_TOK:
            case SET_INFO_TOK:
            case SET_LOGIC_TOK:
            case SET_OPTIONS_TOK:
            case SET_OPTION_TOK:
            case SIMPLE_SYMBOL:
            case SIMPLIFY_TOK:
            case STAR_TOK:
            case STRING_LITERAL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case XOR_TOK:
            case 160:
            	{
            		alt46=1;
            	}
                break;
            case KEYWORD:
            	{
            		alt46=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 46;
                EXCEPTION->state        = 0;


                goto rulesimpleSymbolicExprEx;

            }

            switch (alt46)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1662:5: simpleSymbolicExprNoKeyword[sexpr]
        	    {
        	        FOLLOWPUSH(FOLLOW_simpleSymbolicExprNoKeyword_in_simpleSymbolicExpr3662);
        	        simpleSymbolicExprNoKeyword(ctx, sexpr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1663:5: KEYWORD
        	    {
        	        KEYWORD10 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_simpleSymbolicExpr3669);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesimpleSymbolicExprEx;
        	        }


        	        {
        	             sexpr = SExpr(AntlrInput::tokenText(KEYWORD10)); 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesimpleSymbolicExprEx; /* Prevent compiler warnings */
    rulesimpleSymbolicExprEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end simpleSymbolicExpr */

/**
 * $ANTLR start symbolicExpr
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1667:1: symbolicExpr[CVC4::SExpr& sexpr] : ( simpleSymbolicExpr[sexpr] | LPAREN_TOK ( symbolicExpr[sexpr] )* RPAREN_TOK );
 */
static void
symbolicExpr(pSmt2Parser ctx, CVC4::SExpr& sexpr)
{

      std::vector<SExpr> children;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1671:3: ( simpleSymbolicExpr[sexpr] | LPAREN_TOK ( symbolicExpr[sexpr] )* RPAREN_TOK )

            ANTLR3_UINT32 alt48;

            alt48=2;

            switch ( LA(1) )
            {
            case AND_TOK:
            case ASSERT_TOK:
            case BINARY_LITERAL:
            case BV2NAT_TOK:
            case CHECK_SAT_ASSUMING_TOK:
            case CHECK_SAT_TOK:
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECIMAL_LITERAL:
            case DECLARE_DATATYPES_TOK:
            case DECLARE_FUN_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_SORT_TOK:
            case DECLARE_VAR_TOK:
            case DEFINE_FUNS_REC_TOK:
            case DEFINE_FUN_REC_TOK:
            case DEFINE_FUN_TOK:
            case DEFINE_SORT_TOK:
            case DISTINCT_TOK:
            case DIV_TOK:
            case DTSIZE_TOK:
            case ECHO_TOK:
            case EQUAL_TOK:
            case EXIT_TOK:
            case FMFCARDVAL_TOK:
            case FMFCARD_TOK:
            case GET_ASSERTIONS_TOK:
            case GET_ASSIGNMENT_TOK:
            case GET_INFO_TOK:
            case GET_MODEL_TOK:
            case GET_OPTION_TOK:
            case GET_PROOF_TOK:
            case GET_UNSAT_ASSUMPTIONS_TOK:
            case GET_UNSAT_CORE_TOK:
            case GET_VALUE_TOK:
            case GREATER_THAN_EQUAL_TOK:
            case GREATER_THAN_TOK:
            case HEX_LITERAL:
            case IMPLIES_TOK:
            case INST_CLOSURE_TOK:
            case INTEGER_LITERAL:
            case INV_CONSTRAINT_TOK:
            case ITE_TOK:
            case KEYWORD:
            case LESS_THAN_EQUAL_TOK:
            case LESS_THAN_TOK:
            case MINUS_TOK:
            case NOT_TOK:
            case OR_TOK:
            case PLUS_TOK:
            case POP_TOK:
            case PROPAGATION_RULE_TOK:
            case PUSH_TOK:
            case QUOTED_SYMBOL:
            case REDUCTION_RULE_TOK:
            case RESET_ASSERTIONS_TOK:
            case RESET_TOK:
            case REWRITE_RULE_TOK:
            case SET_INFO_TOK:
            case SET_LOGIC_TOK:
            case SET_OPTIONS_TOK:
            case SET_OPTION_TOK:
            case SIMPLE_SYMBOL:
            case SIMPLIFY_TOK:
            case STAR_TOK:
            case STRING_LITERAL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case XOR_TOK:
            case 160:
            	{
            		alt48=1;
            	}
                break;
            case LPAREN_TOK:
            	{
            		alt48=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 48;
                EXCEPTION->state        = 0;


                goto rulesymbolicExprEx;

            }

            switch (alt48)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1671:5: simpleSymbolicExpr[sexpr]
        	    {
        	        FOLLOWPUSH(FOLLOW_simpleSymbolicExpr_in_symbolicExpr3694);
        	        simpleSymbolicExpr(ctx, sexpr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolicExprEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1672:5: LPAREN_TOK ( symbolicExpr[sexpr] )* RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_symbolicExpr3701);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolicExprEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1673:5: ( symbolicExpr[sexpr] )*

        	        for (;;)
        	        {
        	            int alt47=2;
        	            switch ( LA(1) )
        	            {
        	            case AND_TOK:
        	            case ASSERT_TOK:
        	            case BINARY_LITERAL:
        	            case BV2NAT_TOK:
        	            case CHECK_SAT_ASSUMING_TOK:
        	            case CHECK_SAT_TOK:
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECIMAL_LITERAL:
        	            case DECLARE_DATATYPES_TOK:
        	            case DECLARE_FUN_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_SORT_TOK:
        	            case DECLARE_VAR_TOK:
        	            case DEFINE_FUNS_REC_TOK:
        	            case DEFINE_FUN_REC_TOK:
        	            case DEFINE_FUN_TOK:
        	            case DEFINE_SORT_TOK:
        	            case DISTINCT_TOK:
        	            case DIV_TOK:
        	            case DTSIZE_TOK:
        	            case ECHO_TOK:
        	            case EQUAL_TOK:
        	            case EXIT_TOK:
        	            case FMFCARDVAL_TOK:
        	            case FMFCARD_TOK:
        	            case GET_ASSERTIONS_TOK:
        	            case GET_ASSIGNMENT_TOK:
        	            case GET_INFO_TOK:
        	            case GET_MODEL_TOK:
        	            case GET_OPTION_TOK:
        	            case GET_PROOF_TOK:
        	            case GET_UNSAT_ASSUMPTIONS_TOK:
        	            case GET_UNSAT_CORE_TOK:
        	            case GET_VALUE_TOK:
        	            case GREATER_THAN_EQUAL_TOK:
        	            case GREATER_THAN_TOK:
        	            case HEX_LITERAL:
        	            case IMPLIES_TOK:
        	            case INST_CLOSURE_TOK:
        	            case INTEGER_LITERAL:
        	            case INV_CONSTRAINT_TOK:
        	            case ITE_TOK:
        	            case KEYWORD:
        	            case LESS_THAN_EQUAL_TOK:
        	            case LESS_THAN_TOK:
        	            case LPAREN_TOK:
        	            case MINUS_TOK:
        	            case NOT_TOK:
        	            case OR_TOK:
        	            case PLUS_TOK:
        	            case POP_TOK:
        	            case PROPAGATION_RULE_TOK:
        	            case PUSH_TOK:
        	            case QUOTED_SYMBOL:
        	            case REDUCTION_RULE_TOK:
        	            case RESET_ASSERTIONS_TOK:
        	            case RESET_TOK:
        	            case REWRITE_RULE_TOK:
        	            case SET_INFO_TOK:
        	            case SET_LOGIC_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SET_OPTION_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SIMPLIFY_TOK:
        	            case STAR_TOK:
        	            case STRING_LITERAL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case XOR_TOK:
        	            case 160:
        	            	{
        	            		alt47=1;
        	            	}
        	                break;

        	            }

        	            switch (alt47)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1673:7: symbolicExpr[sexpr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_symbolicExpr_in_symbolicExpr3709);
        	        	        symbolicExpr(ctx, sexpr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolicExprEx;
        	        	        }


        	        	        {
        	        	             children.push_back(sexpr); 
        	        	        }


        	        	    }
        	        	    break;

        	        	default:
        	        	    goto loop47;	/* break out of the loop */
        	        	    break;
        	            }
        	        }
        	        loop47: ; /* Jump out to here if this rule does not match */


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_symbolicExpr3717);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolicExprEx;
        	        }


        	        {
        	             sexpr = SExpr(children); 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesymbolicExprEx; /* Prevent compiler warnings */
    rulesymbolicExprEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end symbolicExpr */

/**
 * $ANTLR start term
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1681:1: term[CVC4::Expr& expr, CVC4::Expr& expr2] : ( termNonVariable[expr, expr2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] );
 */
static void
term(pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& expr2)
{
    /* Initialize rule variables
     */


      std::string name;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1685:3: ( termNonVariable[expr, expr2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] )

            ANTLR3_UINT32 alt49;

            alt49=2;

            switch ( LA(1) )
            {
            case BINARY_LITERAL:
            case DECIMAL_LITERAL:
            case EMPTYSET_TOK:
            case FP_RNA_FULL_TOK:
            case FP_RNA_TOK:
            case FP_RNE_FULL_TOK:
            case FP_RNE_TOK:
            case FP_RTN_FULL_TOK:
            case FP_RTN_TOK:
            case FP_RTP_FULL_TOK:
            case FP_RTP_TOK:
            case FP_RTZ_FULL_TOK:
            case FP_RTZ_TOK:
            case HEX_LITERAL:
            case INTEGER_LITERAL:
            case LPAREN_TOK:
            case NILREF_TOK:
            case REALLCHAR_TOK:
            case REAL_PI_TOK:
            case RENOSTR_TOK:
            case STRING_LITERAL:
            case TUPLE_CONST_TOK:
            case UNIVSET_TOK:
            	{
            		alt49=1;
            	}
                break;
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case INV_CONSTRAINT_TOK:
            case QUOTED_SYMBOL:
            case SET_OPTIONS_TOK:
            case SIMPLE_SYMBOL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case 160:
            	{
            		alt49=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 49;
                EXCEPTION->state        = 0;


                goto ruletermEx;

            }

            switch (alt49)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1685:3: termNonVariable[expr, expr2]
        	    {
        	        FOLLOWPUSH(FOLLOW_termNonVariable_in_term3742);
        	        termNonVariable(ctx, expr, expr2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermEx;
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1687:5: symbol[name,CHECK_DECLARED,SYM_VARIABLE]
        	    {
        	        FOLLOWPUSH(FOLLOW_symbol_in_term3755);
        	        symbol(ctx, name, CHECK_DECLARED, SYM_VARIABLE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermEx;
        	        }


        	        {
        	             expr = PARSER_STATE->getExpressionForName(name); 
        	                  assert( !expr.isNull() );
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruletermEx; /* Prevent compiler warnings */
    ruletermEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end term */

/**
 * $ANTLR start termNonVariable
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1698:1: termNonVariable[CVC4::Expr& expr, CVC4::Expr& expr2] : ( LPAREN_TOK builtinOp[kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK ( termNonVariable[f, f2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] ) sortSymbol[type, CHECK_DECLARED] RPAREN_TOK | LPAREN_TOK quantOp[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK functionName[name, CHECK_NONE] termList[args,expr] RPAREN_TOK | LPAREN_TOK ( indexedFunctionName[op, kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK CONST_TOK sortSymbol[type, CHECK_DECLARED] RPAREN_TOK term[f, f2] RPAREN_TOK ) | LPAREN_TOK ( LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+ | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+ ) RPAREN_TOK term[expr, f2] RPAREN_TOK | LPAREN_TOK MATCH_TOK term[expr, f2] LPAREN_TOK ( LPAREN_TOK INDEX_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK LPAREN_TOK term[f, f2] ( symbol[name,CHECK_NONE,SYM_VARIABLE] )* RPAREN_TOK term[f3, f2] RPAREN_TOK | LPAREN_TOK symbol[name,CHECK_DECLARED,SYM_VARIABLE] term[f3, f2] RPAREN_TOK )+ RPAREN_TOK RPAREN_TOK | LPAREN_TOK ATTRIBUTE_TOK term[expr, f2] ( attribute[expr, attexpr, attr] )+ RPAREN_TOK | LPAREN_TOK HO_LAMBDA_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK TUPLE_CONST_TOK termList[args,expr] RPAREN_TOK | termAtomic[atomTerm] );
 */
static void
termNonVariable(pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& expr2)
{
    /* Initialize rule variables
     */


      Debug("parser") << "term: " << AntlrInput::tokenText(LT(1)) << std::endl;
      Kind kind = kind::NULL_EXPR;
      Expr op;
      std::string name, name2;
      std::vector<Expr> args;
      std::vector< std::pair<std::string, Type> > sortedVarNames;
      Expr f, f2, f3, f4;
      std::string attr;
      Expr attexpr;
      std::vector<Expr> patexprs;
      std::vector<Expr> patconds;
      std::unordered_set<std::string> names;
      std::vector< std::pair<std::string, Expr> > binders;
      bool isBuiltinOperator = false;
      bool isOverloadedFunction = false;
      bool readVariable = false;
      int match_vindex = -1;
      std::vector<Type> match_ptypes;
      Type type;
      Type type2;
      api::Term atomTerm;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1722:3: ( LPAREN_TOK builtinOp[kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK ( termNonVariable[f, f2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] ) sortSymbol[type, CHECK_DECLARED] RPAREN_TOK | LPAREN_TOK quantOp[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK functionName[name, CHECK_NONE] termList[args,expr] RPAREN_TOK | LPAREN_TOK ( indexedFunctionName[op, kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK CONST_TOK sortSymbol[type, CHECK_DECLARED] RPAREN_TOK term[f, f2] RPAREN_TOK ) | LPAREN_TOK ( LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+ | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+ ) RPAREN_TOK term[expr, f2] RPAREN_TOK | LPAREN_TOK MATCH_TOK term[expr, f2] LPAREN_TOK ( LPAREN_TOK INDEX_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK LPAREN_TOK term[f, f2] ( symbol[name,CHECK_NONE,SYM_VARIABLE] )* RPAREN_TOK term[f3, f2] RPAREN_TOK | LPAREN_TOK symbol[name,CHECK_DECLARED,SYM_VARIABLE] term[f3, f2] RPAREN_TOK )+ RPAREN_TOK RPAREN_TOK | LPAREN_TOK ATTRIBUTE_TOK term[expr, f2] ( attribute[expr, attexpr, attr] )+ RPAREN_TOK | LPAREN_TOK HO_LAMBDA_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK TUPLE_CONST_TOK termList[args,expr] RPAREN_TOK | termAtomic[atomTerm] )

            ANTLR3_UINT32 alt58;

            alt58=11;

            switch ( LA(1) )
            {
            case LPAREN_TOK:
            	{
            		switch ( LA(2) )
            		{
            		case AS_TOK:
            			{
            				alt58=2;
            			}
            		    break;
            		case MATCH_TOK:
            			{
            				alt58=7;
            			}
            		    break;
            		case ATTRIBUTE_TOK:
            			{
            				alt58=8;
            			}
            		    break;
            		case HO_LAMBDA_TOK:
            			{
            				alt58=9;
            			}
            		    break;
            		case TUPLE_CONST_TOK:
            			{
            				alt58=10;
            			}
            		    break;
            		case INDEX_TOK:
            			{
            				alt58=11;
            			}
            		    break;
            		case AND_TOK:
            		case BV2NAT_TOK:
            		case DISTINCT_TOK:
            		case DIV_TOK:
            		case DTSIZE_TOK:
            		case EQUAL_TOK:
            		case FMFCARDVAL_TOK:
            		case FMFCARD_TOK:
            		case GREATER_THAN_EQUAL_TOK:
            		case GREATER_THAN_TOK:
            		case IMPLIES_TOK:
            		case INST_CLOSURE_TOK:
            		case ITE_TOK:
            		case LESS_THAN_EQUAL_TOK:
            		case LESS_THAN_TOK:
            		case MINUS_TOK:
            		case NOT_TOK:
            		case OR_TOK:
            		case PLUS_TOK:
            		case STAR_TOK:
            		case XOR_TOK:
            			{
            				alt58=1;
            			}
            		    break;
            		case EXISTS_TOK:
            		case FORALL_TOK:
            			{
            				alt58=3;
            			}
            		    break;
            		case CHECK_SYNTH_TOK:
            		case CONSTRAINT_TOK:
            		case DECLARE_PRIMED_VAR_TOK:
            		case DECLARE_VAR_TOK:
            		case INV_CONSTRAINT_TOK:
            		case QUOTED_SYMBOL:
            		case SET_OPTIONS_TOK:
            		case SIMPLE_SYMBOL:
            		case SYNTH_FUN_TOK:
            		case SYNTH_INV_TOK:
            		case UNTERMINATED_QUOTED_SYMBOL:
            		case 160:
            			{
            				alt58=4;
            			}
            		    break;
            		case LPAREN_TOK:
            			{
            				alt58=5;
            			}
            		    break;
            		case LET_TOK:
            		case SYGUS_LET_TOK:
            			{
            				alt58=6;
            			}
            		    break;

            		default:
            		    CONSTRUCTEX();
            		    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
            		    EXCEPTION->message      = (void *)"";
            		    EXCEPTION->decisionNum  = 58;
            		    EXCEPTION->state        = 1;


            		    goto ruletermNonVariableEx;

            		}

            	}
                break;
            case BINARY_LITERAL:
            case DECIMAL_LITERAL:
            case EMPTYSET_TOK:
            case FP_RNA_FULL_TOK:
            case FP_RNA_TOK:
            case FP_RNE_FULL_TOK:
            case FP_RNE_TOK:
            case FP_RTN_FULL_TOK:
            case FP_RTN_TOK:
            case FP_RTP_FULL_TOK:
            case FP_RTP_TOK:
            case FP_RTZ_FULL_TOK:
            case FP_RTZ_TOK:
            case HEX_LITERAL:
            case INTEGER_LITERAL:
            case NILREF_TOK:
            case REALLCHAR_TOK:
            case REAL_PI_TOK:
            case RENOSTR_TOK:
            case STRING_LITERAL:
            case TUPLE_CONST_TOK:
            case UNIVSET_TOK:
            	{
            		alt58=11;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 58;
                EXCEPTION->state        = 0;


                goto ruletermNonVariableEx;

            }

            switch (alt58)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1723:5: LPAREN_TOK builtinOp[kind] termList[args,expr] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3789);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_builtinOp_in_termNonVariable3791);
        	        builtinOp(ctx, kind);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_termList_in_termNonVariable3794);
        	        termList(ctx, args, expr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3797);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  if( !PARSER_STATE->strictModeEnabled() &&
        	                      (kind == CVC4::kind::AND || kind == CVC4::kind::OR) &&
        	                      args.size() == 1) {
        	                    /* Unary AND/OR can be replaced with the argument.
        	                     * It just so happens expr should already be the only argument. */
        	                    assert( expr == args[0] );
        	                  } else if( CVC4::kind::isAssociative(kind) &&
        	                             args.size() > EXPR_MANAGER->maxArity(kind) ) {
        	                    /* Special treatment for associative operators with lots of children */
        	                    expr = EXPR_MANAGER->mkAssociative(kind, args);
        	                  } else if( kind == CVC4::kind::MINUS && args.size() == 1 ) {
        	                    expr = MK_EXPR(CVC4::kind::UMINUS, args[0]);
        	                  }
        	                  else if ((kind == CVC4::kind::XOR || kind == CVC4::kind::MINUS
        	                            || kind == CVC4::kind::DIVISION)
        	                           && args.size() > 2)
        	                  {
        	                    /* left-associative, but CVC4 internally only supports 2 args */
        	                    expr = EXPR_MANAGER->mkLeftAssociative(kind,args);
        	                  } else if( kind == CVC4::kind::IMPLIES && args.size() > 2 ) {
        	                    /* right-associative, but CVC4 internally only supports 2 args */
        	                    expr = EXPR_MANAGER->mkRightAssociative(kind,args);
        	                  } else if( ( kind == CVC4::kind::EQUAL ||
        	                               kind == CVC4::kind::LT || kind == CVC4::kind::GT ||
        	                               kind == CVC4::kind::LEQ || kind == CVC4::kind::GEQ ) &&
        	                             args.size() > 2 ) {
        	                    /* "chainable", but CVC4 internally only supports 2 args */
        	                    expr = MK_EXPR(MK_CONST(Chain(kind)), args);
        	                  } else if( PARSER_STATE->strictModeEnabled() && kind == CVC4::kind::ABS &&
        	                             args.size() == 1 && !args[0].getType().isInteger() ) {
        	                    /* first, check that ABS is even defined in this logic */
        	                    PARSER_STATE->checkOperator(kind, args.size());
        	                    PARSER_STATE->parseError("abs can only be applied to Int, not Real, "
        	                                             "while in strict SMT-LIB compliance mode");
        	                  } else {
        	                    PARSER_STATE->checkOperator(kind, args.size());
        	                    expr = MK_EXPR(kind, args);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1764:5: LPAREN_TOK AS_TOK ( termNonVariable[f, f2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] ) sortSymbol[type, CHECK_DECLARED] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3809);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(AS_TOK, &FOLLOW_AS_TOK_in_termNonVariable3811);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1764:23: ( termNonVariable[f, f2] | symbol[name,CHECK_DECLARED,SYM_VARIABLE] )
        	        {
        	            int alt50=2;
        	            switch ( LA(1) )
        	            {
        	            case BINARY_LITERAL:
        	            case DECIMAL_LITERAL:
        	            case EMPTYSET_TOK:
        	            case FP_RNA_FULL_TOK:
        	            case FP_RNA_TOK:
        	            case FP_RNE_FULL_TOK:
        	            case FP_RNE_TOK:
        	            case FP_RTN_FULL_TOK:
        	            case FP_RTN_TOK:
        	            case FP_RTP_FULL_TOK:
        	            case FP_RTP_TOK:
        	            case FP_RTZ_FULL_TOK:
        	            case FP_RTZ_TOK:
        	            case HEX_LITERAL:
        	            case INTEGER_LITERAL:
        	            case LPAREN_TOK:
        	            case NILREF_TOK:
        	            case REALLCHAR_TOK:
        	            case REAL_PI_TOK:
        	            case RENOSTR_TOK:
        	            case STRING_LITERAL:
        	            case TUPLE_CONST_TOK:
        	            case UNIVSET_TOK:
        	            	{
        	            		alt50=1;
        	            	}
        	                break;
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case INV_CONSTRAINT_TOK:
        	            case QUOTED_SYMBOL:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt50=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 50;
        	                EXCEPTION->state        = 0;


        	                goto ruletermNonVariableEx;

        	            }

        	            switch (alt50)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1764:25: termNonVariable[f, f2]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_termNonVariable_in_termNonVariable3815);
        	        	        termNonVariable(ctx, f, f2);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1764:50: symbol[name,CHECK_DECLARED,SYM_VARIABLE]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_symbol_in_termNonVariable3820);
        	        	        symbol(ctx, name, CHECK_DECLARED, SYM_VARIABLE);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        {
        	        	             readVariable = true; 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_termNonVariable3832);
        	        sortSymbol(ctx, type, CHECK_DECLARED);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3835);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  if(readVariable) {
        	                    Trace("parser-overloading") << "Getting variable expression of type " << name << " with type " << type << std::endl;
        	                    // get the variable expression for the type
        	                    f = PARSER_STATE->getExpressionForNameAndType(name, type); 
        	                    assert( !f.isNull() );
        	                  }
        	                  if(f.getKind() == CVC4::kind::APPLY_CONSTRUCTOR && type.isDatatype()) {
        	                    // could be a parametric type constructor or just an overloaded constructor
        	                    if(((DatatypeType)type).isParametric()) {
        	                      std::vector<CVC4::Expr> v;
        	                      Expr e = f.getOperator();
        	                      const DatatypeConstructor& dtc =
        	                          Datatype::datatypeOf(e)[Datatype::indexOf(e)];
        	                      v.push_back(MK_EXPR( CVC4::kind::APPLY_TYPE_ASCRIPTION,
        	                                           MK_CONST(AscriptionType(dtc.getSpecializedConstructorType(type))), f.getOperator() ));
        	                      v.insert(v.end(), f.begin(), f.end());
        	                      expr = MK_EXPR(CVC4::kind::APPLY_CONSTRUCTOR, v);
        	                    }else{
        	                      expr = f;
        	                    }
        	                  } else if(f.getKind() == CVC4::kind::EMPTYSET) {
        	                    Debug("parser") << "Empty set encountered: " << f << " "
        	                                      << f2 << " " << type <<  std::endl;
        	                    expr = MK_CONST( ::CVC4::EmptySet(type) );
        	                  } else if(f.getKind() == CVC4::kind::UNIVERSE_SET) {
        	                    expr = EXPR_MANAGER->mkNullaryOperator(type, kind::UNIVERSE_SET);
        	                  } else if(f.getKind() == CVC4::kind::SEP_NIL) {
        	                    //We don't want the nil reference to be a constant: for instance, it
        	                    //could be of type Int but is not a const rational. However, the
        	                    //expression has 0 children. So we convert to a SEP_NIL variable.
        	                    expr = EXPR_MANAGER->mkNullaryOperator(type, kind::SEP_NIL);
        	                  } else {
        	                    if(f.getType() != type) {
        	                      PARSER_STATE->parseError("Type ascription not satisfied.");
        	                    }else{
        	                      expr = f;
        	                    }
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1806:5: LPAREN_TOK quantOp[kind] LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3847);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_quantOp_in_termNonVariable3849);
        	        quantOp(ctx, kind);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3856);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_termNonVariable3858);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3861);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  PARSER_STATE->pushScope(true);
        	                  for(std::vector<std::pair<std::string, CVC4::Type> >::const_iterator i =
        	                        sortedVarNames.begin(), iend = sortedVarNames.end();
        	                      i != iend;
        	                      ++i) {
        	                    args.push_back(PARSER_STATE->mkBoundVar((*i).first, (*i).second));
        	                  }
        	                  Expr bvl = MK_EXPR(kind::BOUND_VAR_LIST, args);
        	                  args.clear();
        	                  args.push_back(bvl);
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable3873);
        	        term(ctx, f, f2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3876);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  PARSER_STATE->popScope();
        	                  switch(f.getKind()) {
        	                  case CVC4::kind::RR_REWRITE:
        	                  case CVC4::kind::RR_REDUCTION:
        	                  case CVC4::kind::RR_DEDUCTION:
        	                    if(kind == CVC4::kind::EXISTS) {
        	                      PARSER_STATE->parseError("Use Exists instead of Forall for a rewrite "
        	                                               "rule.");
        	                    }
        	                    args.push_back(f2); // guards
        	                    args.push_back(f); // rule
        	                    expr = MK_EXPR(CVC4::kind::REWRITE_RULE, args);
        	                    break;
        	                  default:
        	                    args.push_back(f);
        	                    if(! f2.isNull()){
        	                      args.push_back(f2);
        	                    }
        	                    expr = MK_EXPR(kind, args);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1843:5: LPAREN_TOK functionName[name, CHECK_NONE] termList[args,expr] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3888);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_functionName_in_termNonVariable3890);
        	        functionName(ctx, name, CHECK_NONE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {
        	             isBuiltinOperator = PARSER_STATE->isOperatorEnabled(name);
        	                  if(isBuiltinOperator) {
        	                    /* A built-in operator not already handled by the lexer */
        	                    kind = PARSER_STATE->getOperatorKind(name);
        	                  } else {
        	                    /* A non-built-in function application */
        	                    PARSER_STATE->checkDeclaration(name, CHECK_DECLARED, SYM_VARIABLE);
        	                    expr = PARSER_STATE->getVariable(name);
        	                    if(!expr.isNull()) {
        	                      //hack to allow constants with parentheses (disabled for now)
        	                      //if( PARSER_STATE->sygus() && !PARSER_STATE->isFunctionLike(expr) ){
        	                      //  op = PARSER_STATE->getVariable(name);
        	                      //}else{
        	                      PARSER_STATE->checkFunctionLike(expr);
        	                      kind = PARSER_STATE->getKindForFunction(expr);
        	                      args.push_back(expr);
        	                    }else{
        	                      isOverloadedFunction = true;
        	                    }
        	                  }
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_termList_in_termNonVariable3908);
        	        termList(ctx, args, expr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3911);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {
        	             Debug("parser") << "args has size " << args.size() << std::endl
        	                                  << "expr is " << expr << std::endl;
        	                  for(std::vector<Expr>::iterator i = args.begin(); i != args.end(); ++i) {
        	                    Debug("parser") << "++ " << *i << std::endl;
        	                  }
        	                  if(isOverloadedFunction) {
        	                    std::vector< Type > argTypes;
        	                    for(std::vector<Expr>::iterator i = args.begin(); i != args.end(); ++i) {
        	                      argTypes.push_back( (*i).getType() );
        	                    }
        	                    expr = PARSER_STATE->getOverloadedFunctionForTypes(name, argTypes);
        	                    if(!expr.isNull()) {
        	                      PARSER_STATE->checkFunctionLike(expr);
        	                      kind = PARSER_STATE->getKindForFunction(expr);
        	                      args.insert(args.begin(),expr);
        	                    }else{
        	                      PARSER_STATE->parseError("Cannot find unambiguous overloaded function for argument types.");
        	                    }
        	                  }
        	                  Kind lassocKind = CVC4::kind::UNDEFINED_KIND;
        	                  if (args.size() >= 2)
        	                  {
        	                    if (kind == CVC4::kind::INTS_DIVISION)
        	                    {
        	                      // Builtin operators that are not tokenized, are left associative,
        	                      // but not internally variadic must set this.
        	                      lassocKind = kind;
        	                    }
        	                    else
        	                    {
        	                      // may be partially applied function, in this case we use HO_APPLY
        	                      Type argt = args[0].getType();
        	                      if (argt.isFunction())
        	                      {
        	                        unsigned arity = static_cast<FunctionType>(argt).getArity();
        	                        if (args.size() - 1 < arity)
        	                        {
        	                          Debug("parser") << "Partial application of " << args[0];
        	                          Debug("parser") << " : #argTypes = " << arity;
        	                          Debug("parser") << ", #args = " << args.size() - 1 << std::endl;
        	                          // must curry the partial application
        	                          lassocKind = CVC4::kind::HO_APPLY;
        	                        }
        	                      }
        	                    }
        	                  }
        	                  if (lassocKind != CVC4::kind::UNDEFINED_KIND)
        	                  {
        	                    expr = EXPR_MANAGER->mkLeftAssociative(lassocKind, args);
        	                  }
        	                  else
        	                  {
        	                    if (isBuiltinOperator)
        	                    {
        	                      PARSER_STATE->checkOperator(kind, args.size());
        	                    }
        	                    expr = MK_EXPR(kind, args);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1926:5: LPAREN_TOK ( indexedFunctionName[op, kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK CONST_TOK sortSymbol[type, CHECK_DECLARED] RPAREN_TOK term[f, f2] RPAREN_TOK )
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3923);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1927:5: ( indexedFunctionName[op, kind] termList[args,expr] RPAREN_TOK | LPAREN_TOK AS_TOK CONST_TOK sortSymbol[type, CHECK_DECLARED] RPAREN_TOK term[f, f2] RPAREN_TOK )
        	        {
        	            int alt51=2;
        	            switch ( LA(1) )
        	            {
        	            case LPAREN_TOK:
        	            	{
        	            		switch ( LA(2) )
        	            		{
        	            		case INDEX_TOK:
        	            			{
        	            				alt51=1;
        	            			}
        	            		    break;
        	            		case AS_TOK:
        	            			{
        	            				alt51=2;
        	            			}
        	            		    break;

        	            		default:
        	            		    CONSTRUCTEX();
        	            		    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	            		    EXCEPTION->message      = (void *)"";
        	            		    EXCEPTION->decisionNum  = 51;
        	            		    EXCEPTION->state        = 1;


        	            		    goto ruletermNonVariableEx;

        	            		}

        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 51;
        	                EXCEPTION->state        = 0;


        	                goto ruletermNonVariableEx;

        	            }

        	            switch (alt51)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1928:7: indexedFunctionName[op, kind] termList[args,expr] RPAREN_TOK
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_indexedFunctionName_in_termNonVariable3939);
        	        	        indexedFunctionName(ctx, op, kind);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_termList_in_termNonVariable3942);
        	        	        termList(ctx, args, expr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3945);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        {
        	        	             
        	        	                    if(kind==CVC4::kind::APPLY_SELECTOR) {
        	        	                      //tuple selector case
        	        	                      Integer x = op.getConst<CVC4::Rational>().getNumerator();
        	        	                      if (!x.fitsUnsignedInt()) {
        	        	                        PARSER_STATE->parseError("index of tupSel is larger than size of unsigned int");
        	        	                      }
        	        	                      unsigned int n = x.toUnsignedInt();
        	        	                      if (args.size()>1) {
        	        	                        PARSER_STATE->parseError("tupSel applied to more than one tuple argument");
        	        	                      }
        	        	                      Type t = args[0].getType();
        	        	                      if (!t.isTuple()) {
        	        	                        PARSER_STATE->parseError("tupSel applied to non-tuple");
        	        	                      }
        	        	                      size_t length = ((DatatypeType)t).getTupleLength();
        	        	                      if (n >= length) {
        	        	                        std::stringstream ss;
        	        	                        ss << "tuple is of length " << length << "; cannot access index " << n;
        	        	                        PARSER_STATE->parseError(ss.str());
        	        	                      }
        	        	                      const Datatype & dt = ((DatatypeType)t).getDatatype();
        	        	                      op = dt[0][n].getSelector();
        	        	                    }
        	        	                    if (kind!=kind::NULL_EXPR) {
        	        	                      expr = MK_EXPR( kind, op, args );
        	        	                    } else {
        	        	                      expr = MK_EXPR(op, args);
        	        	                    }
        	        	                    PARSER_STATE->checkOperator(expr.getKind(), args.size());
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1960:7: LPAREN_TOK AS_TOK CONST_TOK sortSymbol[type, CHECK_DECLARED] RPAREN_TOK term[f, f2] RPAREN_TOK
        	        	    {
        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable3963);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(AS_TOK, &FOLLOW_AS_TOK_in_termNonVariable3965);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(CONST_TOK, &FOLLOW_CONST_TOK_in_termNonVariable3967);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_termNonVariable3969);
        	        	        sortSymbol(ctx, type, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3978);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable3980);
        	        	        term(ctx, f, f2);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable3983);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        {

        	        	                    if(!type.isArray()) {
        	        	                      std::stringstream ss;
        	        	                      ss << "expected array constant term, but cast is not of array type"
        	        	                         << std::endl
        	        	                         << "cast type: " << type;
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                    if(!f.isConst()) {
        	        	                      std::stringstream ss;
        	        	                      ss << "expected constant term inside array constant, but found "
        	        	                         << "nonconstant term:" << std::endl
        	        	                         << "the term: " << f;
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                    if(!ArrayType(type).getConstituentType().isComparableTo(f.getType())) {
        	        	                      std::stringstream ss;
        	        	                      ss << "type mismatch inside array constant term:" << std::endl
        	        	                         << "array type:          " << type << std::endl
        	        	                         << "expected const type: " << ArrayType(type).getConstituentType()
        	        	                         << std::endl
        	        	                         << "computed const type: " << f.getType();
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                    expr = MK_CONST( ::CVC4::ArrayStoreAll(type, f) );
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1990:5: LPAREN_TOK ( LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+ | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+ ) RPAREN_TOK term[expr, f2] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4009);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1990:16: ( LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+ | SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+ )
        	        {
        	            int alt54=2;
        	            switch ( LA(1) )
        	            {
        	            case LET_TOK:
        	            	{
        	            		alt54=1;
        	            	}
        	                break;
        	            case SYGUS_LET_TOK:
        	            	{
        	            		alt54=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 54;
        	                EXCEPTION->state        = 0;


        	                goto ruletermNonVariableEx;

        	            }

        	            switch (alt54)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1991:7: LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+
        	        	    {
        	        	         MATCHT(LET_TOK, &FOLLOW_LET_TOK_in_termNonVariable4020);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4022);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->pushScope(true); 
        	        	        }


        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1993:7: ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK )+
        	        	        {
        	        	            int cnt52=0;

        	        	            for (;;)
        	        	            {
        	        	                int alt52=2;
        	        	        	switch ( LA(1) )
        	        	        	{
        	        	        	case LPAREN_TOK:
        	        	        		{
        	        	        			alt52=1;
        	        	        		}
        	        	        	    break;

        	        	        	}

        	        	        	switch (alt52)
        	        	        	{
        	        	        	    case 1:
        	        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:1993:9: LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] term[expr, f2] RPAREN_TOK
        	        	        	        {
        	        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4040);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_symbol_in_termNonVariable4042);
        	        	        	            symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4053);
        	        	        	            term(ctx, expr, f2);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4064);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            {
        	        	        	                 if(names.count(name) == 1) {
        	        	        	                            std::stringstream ss;
        	        	        	                            ss << "warning: symbol `" << name << "' bound multiple times by let;"
        	        	        	                               << " the last binding will be used, shadowing earlier ones";
        	        	        	                            PARSER_STATE->warning(ss.str());
        	        	        	                          } else {
        	        	        	                            names.insert(name);
        	        	        	                          }
        	        	        	                          binders.push_back(std::make_pair(name, expr)); 
        	        	        	            }


        	        	        	        }
        	        	        	        break;

        	        	        	    default:

        	        	        		if ( cnt52 >= 1 )
        	        	        		{
        	        	        		    goto loop52;
        	        	        		}
        	        	        		/* mismatchedSetEx()
        	        	        		 */
        	        	        		CONSTRUCTEX();
        	        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        	        		goto ruletermNonVariableEx;
        	        	        	}
        	        	        	cnt52++;
        	        	            }
        	        	            loop52: ;	/* Jump to here if this rule does not match */
        	        	        }

        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2007:7: SYGUS_LET_TOK LPAREN_TOK ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+
        	        	    {
        	        	         MATCHT(SYGUS_LET_TOK, &FOLLOW_SYGUS_LET_TOK_in_termNonVariable4105);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4107);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermNonVariableEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->pushScope(true); 
        	        	        }


        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2009:7: ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK )+
        	        	        {
        	        	            int cnt53=0;

        	        	            for (;;)
        	        	            {
        	        	                int alt53=2;
        	        	        	switch ( LA(1) )
        	        	        	{
        	        	        	case LPAREN_TOK:
        	        	        		{
        	        	        			alt53=1;
        	        	        		}
        	        	        	    break;

        	        	        	}

        	        	        	switch (alt53)
        	        	        	{
        	        	        	    case 1:
        	        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2009:9: LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[type,CHECK_DECLARED] term[expr, f2] RPAREN_TOK
        	        	        	        {
        	        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4125);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_symbol_in_termNonVariable4127);
        	        	        	            symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_sortSymbol_in_termNonVariable4138);
        	        	        	            sortSymbol(ctx, type, CHECK_DECLARED);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4149);
        	        	        	            term(ctx, expr, f2);

        	        	        	            FOLLOWPOP();
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4160);
        	        	        	            if  (HASEXCEPTION())
        	        	        	            {
        	        	        	                goto ruletermNonVariableEx;
        	        	        	            }


        	        	        	            {
        	        	        	                 if(names.count(name) == 1) {
        	        	        	                            std::stringstream ss;
        	        	        	                            ss << "warning: symbol `" << name << "' bound multiple times by let;"
        	        	        	                               << " the last binding will be used, shadowing earlier ones";
        	        	        	                            PARSER_STATE->warning(ss.str());
        	        	        	                          } else {
        	        	        	                            names.insert(name);
        	        	        	                          }
        	        	        	                          binders.push_back(std::make_pair(name, expr)); 
        	        	        	            }


        	        	        	        }
        	        	        	        break;

        	        	        	    default:

        	        	        		if ( cnt53 >= 1 )
        	        	        		{
        	        	        		    goto loop53;
        	        	        		}
        	        	        		/* mismatchedSetEx()
        	        	        		 */
        	        	        		CONSTRUCTEX();
        	        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        	        		goto ruletermNonVariableEx;
        	        	        	}
        	        	        	cnt53++;
        	        	            }
        	        	            loop53: ;	/* Jump to here if this rule does not match */
        	        	        }

        	        	    }
        	        	    break;

        	            }
        	        }

        	        {
        	             // now implement these bindings
        	                  for(std::vector< std::pair<std::string, Expr> >::iterator
        	                        i = binders.begin(); i != binders.end(); ++i) {
        	                    PARSER_STATE->defineVar((*i).first, (*i).second);
        	                  }
        	                
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4205);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable4211);
        	        term(ctx, expr, f2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4218);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {
        	             PARSER_STATE->popScope(); 
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2035:5: LPAREN_TOK MATCH_TOK term[expr, f2] LPAREN_TOK ( LPAREN_TOK INDEX_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK LPAREN_TOK term[f, f2] ( symbol[name,CHECK_NONE,SYM_VARIABLE] )* RPAREN_TOK term[f3, f2] RPAREN_TOK | LPAREN_TOK symbol[name,CHECK_DECLARED,SYM_VARIABLE] term[f3, f2] RPAREN_TOK )+ RPAREN_TOK RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4236);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(MATCH_TOK, &FOLLOW_MATCH_TOK_in_termNonVariable4238);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable4240);
        	        term(ctx, expr, f2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  if( !expr.getType().isDatatype() ){
        	                    PARSER_STATE->parseError("Cannot match on non-datatype term.");
        	                  }
        	                
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4249);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2041:5: ( LPAREN_TOK INDEX_TOK term[f, f2] RPAREN_TOK | LPAREN_TOK LPAREN_TOK term[f, f2] ( symbol[name,CHECK_NONE,SYM_VARIABLE] )* RPAREN_TOK term[f3, f2] RPAREN_TOK | LPAREN_TOK symbol[name,CHECK_DECLARED,SYM_VARIABLE] term[f3, f2] RPAREN_TOK )+
        	        {
        	            int cnt56=0;

        	            for (;;)
        	            {
        	                int alt56=4;
        	        	switch ( LA(1) )
        	        	{
        	        	case LPAREN_TOK:
        	        		{
        	        			switch ( LA(2) )
        	        			{
        	        			case INDEX_TOK:
        	        				{
        	        					alt56=1;
        	        				}
        	        			    break;
        	        			case LPAREN_TOK:
        	        				{
        	        					alt56=2;
        	        				}
        	        			    break;
        	        			case CHECK_SYNTH_TOK:
        	        			case CONSTRAINT_TOK:
        	        			case DECLARE_PRIMED_VAR_TOK:
        	        			case DECLARE_VAR_TOK:
        	        			case INV_CONSTRAINT_TOK:
        	        			case QUOTED_SYMBOL:
        	        			case SET_OPTIONS_TOK:
        	        			case SIMPLE_SYMBOL:
        	        			case SYNTH_FUN_TOK:
        	        			case SYNTH_INV_TOK:
        	        			case UNTERMINATED_QUOTED_SYMBOL:
        	        			case 160:
        	        				{
        	        					alt56=3;
        	        				}
        	        			    break;

        	        			}

        	        		}
        	        	    break;

        	        	}

        	        	switch (alt56)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2043:8: LPAREN_TOK INDEX_TOK term[f, f2] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4273);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	             MATCHT(INDEX_TOK, &FOLLOW_INDEX_TOK_in_termNonVariable4275);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4277);
        	        	            term(ctx, f, f2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {
        	        	                 
        	        	                          if( match_vindex==-1 ){
        	        	                            match_vindex = (int)patexprs.size(); 
        	        	                          }
        	        	                          patexprs.push_back( f ); 
        	        	                          patconds.push_back(MK_CONST(bool(true)));
        	        	                        
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4290);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	        }
        	        	        break;
        	        	    case 2:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2051:9: LPAREN_TOK LPAREN_TOK term[f, f2] ( symbol[name,CHECK_NONE,SYM_VARIABLE] )* RPAREN_TOK term[f3, f2] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4300);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4302);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4304);
        	        	            term(ctx, f, f2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {
        	        	                 
        	        	                           args.clear(); 
        	        	                           PARSER_STATE->pushScope(true); 
        	        	                           //f should be a constructor
        	        	                           type = f.getType();
        	        	                           Debug("parser-dt") << "Pattern head : " << f << " " << f.getType() << std::endl;
        	        	                           if( !type.isConstructor() ){
        	        	                             PARSER_STATE->parseError("Pattern must be application of a constructor or a variable.");
        	        	                           }
        	        	                           if( Datatype::datatypeOf(f).isParametric() ){
        	        	                             type = Datatype::datatypeOf(f)[Datatype::indexOf(f)].getSpecializedConstructorType(expr.getType());
        	        	                           }
        	        	                           match_ptypes = ((ConstructorType)type).getArgTypes();
        	        	                         
        	        	            }



        	        	            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2066:10: ( symbol[name,CHECK_NONE,SYM_VARIABLE] )*

        	        	            for (;;)
        	        	            {
        	        	                int alt55=2;
        	        	                switch ( LA(1) )
        	        	                {
        	        	                case CHECK_SYNTH_TOK:
        	        	                case CONSTRAINT_TOK:
        	        	                case DECLARE_PRIMED_VAR_TOK:
        	        	                case DECLARE_VAR_TOK:
        	        	                case INV_CONSTRAINT_TOK:
        	        	                case QUOTED_SYMBOL:
        	        	                case SET_OPTIONS_TOK:
        	        	                case SIMPLE_SYMBOL:
        	        	                case SYNTH_FUN_TOK:
        	        	                case SYNTH_INV_TOK:
        	        	                case UNTERMINATED_QUOTED_SYMBOL:
        	        	                case 160:
        	        	                	{
        	        	                		alt55=1;
        	        	                	}
        	        	                    break;

        	        	                }

        	        	                switch (alt55)
        	        	                {
        	        	            	case 1:
        	        	            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2066:12: symbol[name,CHECK_NONE,SYM_VARIABLE]
        	        	            	    {
        	        	            	        FOLLOWPUSH(FOLLOW_symbol_in_termNonVariable4330);
        	        	            	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

        	        	            	        FOLLOWPOP();
        	        	            	        if  (HASEXCEPTION())
        	        	            	        {
        	        	            	            goto ruletermNonVariableEx;
        	        	            	        }


        	        	            	        {

        	        	            	                         if( args.size()>=match_ptypes.size() ){
        	        	            	                           PARSER_STATE->parseError("Too many arguments for pattern.");
        	        	            	                         }
        	        	            	                         //make of proper type
        	        	            	                         Expr arg = PARSER_STATE->mkBoundVar(name, match_ptypes[args.size()]);
        	        	            	                         args.push_back( arg );
        	        	            	                       
        	        	            	        }


        	        	            	    }
        	        	            	    break;

        	        	            	default:
        	        	            	    goto loop55;	/* break out of the loop */
        	        	            	    break;
        	        	                }
        	        	            }
        	        	            loop55: ; /* Jump out to here if this rule does not match */


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4356);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4367);
        	        	            term(ctx, f3, f2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {
        	        	                 
        	        	                           const DatatypeConstructor& dtc = Datatype::datatypeOf(f)[Datatype::indexOf(f)];
        	        	                           if( args.size()!=dtc.getNumArgs() ){
        	        	                             PARSER_STATE->parseError("Bad number of arguments for application of constructor in pattern.");
        	        	                           }
        	        	                           //FIXME: make MATCH a kind and make this a rewrite
        	        	                           // build a lambda
        	        	                           std::vector<Expr> largs;
        	        	                           largs.push_back( MK_EXPR( CVC4::kind::BOUND_VAR_LIST, args ) );
        	        	                           largs.push_back( f3 );
        	        	                           std::vector< Expr > aargs;
        	        	                           aargs.push_back( MK_EXPR( CVC4::kind::LAMBDA, largs ) );
        	        	                           for( unsigned i=0; i<dtc.getNumArgs(); i++ ){
        	        	                             //can apply total version since we will be guarded by ITE condition
        	        	                             // however, we need to apply partial version since we don't have the internal selector available
        	        	                             aargs.push_back( MK_EXPR( CVC4::kind::APPLY_SELECTOR, dtc[i].getSelector(), expr ) );
        	        	                           }
        	        	                           patexprs.push_back( MK_EXPR( CVC4::kind::APPLY, aargs ) );
        	        	                           patconds.push_back( MK_EXPR( CVC4::kind::APPLY_TESTER, dtc.getTester(), expr ) );
        	        	                         
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4381);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {
        	        	                 PARSER_STATE->popScope(); 
        	        	            }


        	        	        }
        	        	        break;
        	        	    case 3:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2098:10: LPAREN_TOK symbol[name,CHECK_DECLARED,SYM_VARIABLE] term[f3, f2] RPAREN_TOK
        	        	        {
        	        	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4404);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_symbol_in_termNonVariable4406);
        	        	            symbol(ctx, name, CHECK_DECLARED, SYM_VARIABLE);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {

        	        	                           f = PARSER_STATE->getVariable(name);
        	        	                           type = f.getType();
        	        	                           if( !type.isConstructor() || !((ConstructorType)type).getArgTypes().empty() ){
        	        	                             PARSER_STATE->parseError("Must apply constructors of arity greater than 0 to arguments in pattern.");
        	        	                           }
        	        	                         
        	        	            }


        	        	            FOLLOWPUSH(FOLLOW_term_in_termNonVariable4420);
        	        	            term(ctx, f3, f2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {

        	        	                           const DatatypeConstructor& dtc = Datatype::datatypeOf(f)[Datatype::indexOf(f)];
        	        	                           patexprs.push_back( f3 );
        	        	                           patconds.push_back( MK_EXPR( CVC4::kind::APPLY_TESTER, dtc.getTester(), expr ) );
        	        	                         
        	        	            }


        	        	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4434);
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt56 >= 1 )
        	        		{
        	        		    goto loop56;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruletermNonVariableEx;
        	        	}
        	        	cnt56++;
        	            }
        	            loop56: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4447);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4449);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {
        	             
        	                  if( match_vindex==-1 ){
        	                    const Datatype& dt = ((DatatypeType)expr.getType()).getDatatype();
        	                    std::map< unsigned, bool > processed;
        	                    unsigned count = 0;
        	                    //ensure that all datatype constructors are matched (to ensure exhaustiveness)
        	                    for( unsigned i=0; i<patconds.size(); i++ ){
        	                      unsigned curr_index = Datatype::indexOf(patconds[i].getOperator());
        	                      if( curr_index<0 && curr_index>=dt.getNumConstructors() ){
        	                        PARSER_STATE->parseError("Pattern is not legal for the head of a match.");
        	                      }
        	                      if( processed.find( curr_index )==processed.end() ){
        	                        processed[curr_index] = true;
        	                        count++;
        	                      }
        	                    }
        	                    if( count!=dt.getNumConstructors() ){
        	                      PARSER_STATE->parseError("Patterns are not exhaustive in a match construct.");
        	                    }
        	                  }
        	                  //now, make the ITE
        	                  int end_index = match_vindex==-1 ? patexprs.size()-1 : match_vindex;
        	                  bool first_time = true;
        	                  for( int index = end_index; index>=0; index-- ){
        	                    if( first_time ){
        	                      expr = patexprs[index];
        	                      first_time = false;
        	                    }else{
        	                      expr = MK_EXPR( CVC4::kind::ITE, patconds[index], patexprs[index], expr );
        	                    }
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2146:5: LPAREN_TOK ATTRIBUTE_TOK term[expr, f2] ( attribute[expr, attexpr, attr] )+ RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4465);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(ATTRIBUTE_TOK, &FOLLOW_ATTRIBUTE_TOK_in_termNonVariable4467);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable4469);
        	        term(ctx, expr, f2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2147:5: ( attribute[expr, attexpr, attr] )+
        	        {
        	            int cnt57=0;

        	            for (;;)
        	            {
        	                int alt57=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case ATTRIBUTE_INST_LEVEL:
        	        	case ATTRIBUTE_NAMED_TOK:
        	        	case ATTRIBUTE_NO_PATTERN_TOK:
        	        	case ATTRIBUTE_PATTERN_TOK:
        	        	case ATTRIBUTE_RR_PRIORITY:
        	        	case KEYWORD:
        	        		{
        	        			alt57=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt57)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2147:7: attribute[expr, attexpr, attr]
        	        	        {
        	        	            FOLLOWPUSH(FOLLOW_attribute_in_termNonVariable4478);
        	        	            attribute(ctx, expr, attexpr, attr);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruletermNonVariableEx;
        	        	            }


        	        	            {
        	        	                 if( ! attexpr.isNull()) {
        	        	                          patexprs.push_back( attexpr );
        	        	                        }
        	        	                      
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt57 >= 1 )
        	        		{
        	        		    goto loop57;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruletermNonVariableEx;
        	        	}
        	        	cnt57++;
        	            }
        	            loop57: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4496);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  if(attr == ":rewrite-rule") {
        	                    Expr guard;
        	                    Expr body;
        	                    if(expr[1].getKind() == kind::IMPLIES ||
        	                       expr[1].getKind() == kind::EQUAL) {
        	                      guard = expr[0];
        	                      body = expr[1];
        	                    } else {
        	                      guard = MK_CONST(bool(true));
        	                      body = expr;
        	                    }
        	                    expr2 = guard;
        	                    args.push_back(body[0]);
        	                    args.push_back(body[1]);
        	                    if(!f2.isNull()) {
        	                      args.push_back(f2);
        	                    }

        	                    if( body.getKind()==kind::IMPLIES ){  
        	                      kind = kind::RR_DEDUCTION;
        	                    }else if( body.getKind()==kind::EQUAL ){
        	                      kind = body[0].getType().isBoolean() ? kind::RR_REDUCTION : kind::RR_REWRITE;
        	                    }else{
        	                      PARSER_STATE->parseError("Error parsing rewrite rule.");
        	                    }
        	                    expr = MK_EXPR( kind, args );
        	                  } else if(! patexprs.empty()) {
        	                    if( !f2.isNull() && f2.getKind()==kind::INST_PATTERN_LIST ){
        	                      for( size_t i=0; i<f2.getNumChildren(); i++ ){
        	                        if( f2[i].getKind()==kind::INST_PATTERN ){
        	                          patexprs.push_back( f2[i] );
        	                        }else{
        	                          std::stringstream ss;
        	                          ss << "warning: rewrite rules do not support " << f2[i]
        	                             << " within instantiation pattern list";
        	                          PARSER_STATE->warning(ss.str());
        	                        }
        	                      }
        	                    }
        	                    expr2 = MK_EXPR(kind::INST_PATTERN_LIST, patexprs);
        	                  } else {
        	                    expr2 = f2;
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 9:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2199:5: LPAREN_TOK HO_LAMBDA_TOK LPAREN_TOK sortedVarList[sortedVarNames] RPAREN_TOK term[f, f2] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4514);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(HO_LAMBDA_TOK, &FOLLOW_HO_LAMBDA_TOK_in_termNonVariable4516);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4522);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortedVarList_in_termNonVariable4524);
        	        sortedVarList(ctx, sortedVarNames);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4527);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  PARSER_STATE->pushScope(true);
        	                  for(const std::pair<std::string, CVC4::Type>& svn : sortedVarNames){
        	                    args.push_back(PARSER_STATE->mkBoundVar(svn.first, svn.second));
        	                  }
        	                  Expr bvl = MK_EXPR(kind::BOUND_VAR_LIST, args);
        	                  args.clear();
        	                  args.push_back(bvl);
        	                
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_termNonVariable4539);
        	        term(ctx, f, f2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4542);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                  args.push_back( f );
        	                  PARSER_STATE->popScope();
        	                  expr = MK_EXPR( CVC4::kind::LAMBDA, args );
        	                
        	        }


        	    }
        	    break;
        	case 10:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2217:5: LPAREN_TOK TUPLE_CONST_TOK termList[args,expr] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termNonVariable4555);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(TUPLE_CONST_TOK, &FOLLOW_TUPLE_CONST_TOK_in_termNonVariable4557);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_termList_in_termNonVariable4559);
        	        termList(ctx, args, expr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termNonVariable4562);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {

        	                std::vector<api::Sort> sorts;
        	                std::vector<api::Term> terms;
        	                for (const Expr& arg : args)
        	                {
        	                  sorts.emplace_back(arg.getType());
        	                  terms.emplace_back(arg);
        	                }
        	                expr = SOLVER->mkTuple(sorts, terms).getExpr();
        	              
        	        }


        	    }
        	    break;
        	case 11:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2229:5: termAtomic[atomTerm]
        	    {
        	        FOLLOWPUSH(FOLLOW_termAtomic_in_termNonVariable4578);
        	        termAtomic(ctx, atomTerm);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermNonVariableEx;
        	        }


        	        {
        	             expr = atomTerm.getExpr(); 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruletermNonVariableEx; /* Prevent compiler warnings */
    ruletermNonVariableEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end termNonVariable */

/**
 * $ANTLR start termAtomic
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2237:1: termAtomic[CVC4::api::Term& atomTerm] : ( INTEGER_LITERAL | DECIMAL_LITERAL | REAL_PI_TOK | LPAREN_TOK INDEX_TOK (bvLit= SIMPLE_SYMBOL size= INTEGER_LITERAL | FP_PINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NAN_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_PZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | EMP_TOK sortSymbol[type,CHECK_DECLARED] sortSymbol[type2,CHECK_DECLARED] ) RPAREN_TOK | HEX_LITERAL | BINARY_LITERAL | FP_RNE_TOK | FP_RNA_TOK | FP_RTP_TOK | FP_RTN_TOK | FP_RTZ_TOK | FP_RNE_FULL_TOK | FP_RNA_FULL_TOK | FP_RTP_FULL_TOK | FP_RTN_FULL_TOK | FP_RTZ_FULL_TOK | str[s,false] | RENOSTR_TOK | REALLCHAR_TOK | EMPTYSET_TOK | UNIVSET_TOK | NILREF_TOK | TUPLE_CONST_TOK );
 */
static void
termAtomic(pSmt2Parser ctx, CVC4::api::Term& atomTerm)
{
    pANTLR3_COMMON_TOKEN    bvLit;
    pANTLR3_COMMON_TOKEN    size;
    pANTLR3_COMMON_TOKEN    eb;
    pANTLR3_COMMON_TOKEN    sb;
    pANTLR3_COMMON_TOKEN    INTEGER_LITERAL11;
    pANTLR3_COMMON_TOKEN    DECIMAL_LITERAL12;
    pANTLR3_COMMON_TOKEN    HEX_LITERAL13;
    pANTLR3_COMMON_TOKEN    BINARY_LITERAL14;

    /* Initialize rule variables
     */


      Type type;
      Type type2;
      std::string s;

    bvLit       = NULL;
    size       = NULL;
    eb       = NULL;
    sb       = NULL;
    INTEGER_LITERAL11       = NULL;
    DECIMAL_LITERAL12       = NULL;
    HEX_LITERAL13       = NULL;
    BINARY_LITERAL14       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2244:3: ( INTEGER_LITERAL | DECIMAL_LITERAL | REAL_PI_TOK | LPAREN_TOK INDEX_TOK (bvLit= SIMPLE_SYMBOL size= INTEGER_LITERAL | FP_PINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NAN_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_PZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | EMP_TOK sortSymbol[type,CHECK_DECLARED] sortSymbol[type2,CHECK_DECLARED] ) RPAREN_TOK | HEX_LITERAL | BINARY_LITERAL | FP_RNE_TOK | FP_RNA_TOK | FP_RTP_TOK | FP_RTN_TOK | FP_RTZ_TOK | FP_RNE_FULL_TOK | FP_RNA_FULL_TOK | FP_RTP_FULL_TOK | FP_RTN_FULL_TOK | FP_RTZ_FULL_TOK | str[s,false] | RENOSTR_TOK | REALLCHAR_TOK | EMPTYSET_TOK | UNIVSET_TOK | NILREF_TOK | TUPLE_CONST_TOK )

            ANTLR3_UINT32 alt60;

            alt60=23;

            switch ( LA(1) )
            {
            case INTEGER_LITERAL:
            	{
            		alt60=1;
            	}
                break;
            case DECIMAL_LITERAL:
            	{
            		alt60=2;
            	}
                break;
            case REAL_PI_TOK:
            	{
            		alt60=3;
            	}
                break;
            case LPAREN_TOK:
            	{
            		alt60=4;
            	}
                break;
            case HEX_LITERAL:
            	{
            		alt60=5;
            	}
                break;
            case BINARY_LITERAL:
            	{
            		alt60=6;
            	}
                break;
            case FP_RNE_TOK:
            	{
            		alt60=7;
            	}
                break;
            case FP_RNA_TOK:
            	{
            		alt60=8;
            	}
                break;
            case FP_RTP_TOK:
            	{
            		alt60=9;
            	}
                break;
            case FP_RTN_TOK:
            	{
            		alt60=10;
            	}
                break;
            case FP_RTZ_TOK:
            	{
            		alt60=11;
            	}
                break;
            case FP_RNE_FULL_TOK:
            	{
            		alt60=12;
            	}
                break;
            case FP_RNA_FULL_TOK:
            	{
            		alt60=13;
            	}
                break;
            case FP_RTP_FULL_TOK:
            	{
            		alt60=14;
            	}
                break;
            case FP_RTN_FULL_TOK:
            	{
            		alt60=15;
            	}
                break;
            case FP_RTZ_FULL_TOK:
            	{
            		alt60=16;
            	}
                break;
            case STRING_LITERAL:
            	{
            		alt60=17;
            	}
                break;
            case RENOSTR_TOK:
            	{
            		alt60=18;
            	}
                break;
            case REALLCHAR_TOK:
            	{
            		alt60=19;
            	}
                break;
            case EMPTYSET_TOK:
            	{
            		alt60=20;
            	}
                break;
            case UNIVSET_TOK:
            	{
            		alt60=21;
            	}
                break;
            case NILREF_TOK:
            	{
            		alt60=22;
            	}
                break;
            case TUPLE_CONST_TOK:
            	{
            		alt60=23;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 60;
                EXCEPTION->state        = 0;


                goto ruletermAtomicEx;

            }

            switch (alt60)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2244:5: INTEGER_LITERAL
        	    {
        	        INTEGER_LITERAL11 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4609);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  std::string intStr = AntlrInput::tokenText(INTEGER_LITERAL11);
        	                  atomTerm = SOLVER->mkReal(intStr);
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2249:5: DECIMAL_LITERAL
        	    {
        	        DECIMAL_LITERAL12 = (pANTLR3_COMMON_TOKEN) MATCHT(DECIMAL_LITERAL, &FOLLOW_DECIMAL_LITERAL_in_termAtomic4621);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  std::string realStr = AntlrInput::tokenText(DECIMAL_LITERAL12);
        	                  atomTerm = SOLVER->ensureTermSort(SOLVER->mkReal(realStr),
        	                                                    SOLVER->getRealSort());
        	                
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2257:5: REAL_PI_TOK
        	    {
        	         MATCHT(REAL_PI_TOK, &FOLLOW_REAL_PI_TOK_in_termAtomic4637);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkPi(); 
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2261:5: LPAREN_TOK INDEX_TOK (bvLit= SIMPLE_SYMBOL size= INTEGER_LITERAL | FP_PINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NAN_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_PZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | EMP_TOK sortSymbol[type,CHECK_DECLARED] sortSymbol[type2,CHECK_DECLARED] ) RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_termAtomic4652);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	         MATCHT(INDEX_TOK, &FOLLOW_INDEX_TOK_in_termAtomic4654);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2262:5: (bvLit= SIMPLE_SYMBOL size= INTEGER_LITERAL | FP_PINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NAN_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_PZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_NZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | EMP_TOK sortSymbol[type,CHECK_DECLARED] sortSymbol[type2,CHECK_DECLARED] )
        	        {
        	            int alt59=7;
        	            switch ( LA(1) )
        	            {
        	            case SIMPLE_SYMBOL:
        	            	{
        	            		alt59=1;
        	            	}
        	                break;
        	            case FP_PINF_TOK:
        	            	{
        	            		alt59=2;
        	            	}
        	                break;
        	            case FP_NINF_TOK:
        	            	{
        	            		alt59=3;
        	            	}
        	                break;
        	            case FP_NAN_TOK:
        	            	{
        	            		alt59=4;
        	            	}
        	                break;
        	            case FP_PZERO_TOK:
        	            	{
        	            		alt59=5;
        	            	}
        	                break;
        	            case FP_NZERO_TOK:
        	            	{
        	            		alt59=6;
        	            	}
        	                break;
        	            case EMP_TOK:
        	            	{
        	            		alt59=7;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 59;
        	                EXCEPTION->state        = 0;


        	                goto ruletermAtomicEx;

        	            }

        	            switch (alt59)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2262:7: bvLit= SIMPLE_SYMBOL size= INTEGER_LITERAL
        	        	    {
        	        	        bvLit = (pANTLR3_COMMON_TOKEN) MATCHT(SIMPLE_SYMBOL, &FOLLOW_SIMPLE_SYMBOL_in_termAtomic4665);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        size = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4669);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    if(AntlrInput::tokenText(bvLit).find("bv") == 0)
        	        	                    {
        	        	                      std::string bvStr = AntlrInput::tokenTextSubstr(bvLit, 2);
        	        	                      uint32_t bvSize = AntlrInput::tokenToUnsigned(size);
        	        	                      atomTerm = SOLVER->mkBitVector(bvSize, bvStr, 10);
        	        	                    }
        	        	                    else
        	        	                    {
        	        	                       PARSER_STATE->parseError("Unexpected symbol `" +
        	        	                                                AntlrInput::tokenText(bvLit) + "'");
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2278:7: FP_PINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
        	        	    {
        	        	         MATCHT(FP_PINF_TOK, &FOLLOW_FP_PINF_TOK_in_termAtomic4692);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4696);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4700);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    atomTerm = SOLVER->mkPosInf(AntlrInput::tokenToUnsigned(eb),
        	        	                                            AntlrInput::tokenToUnsigned(sb));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 3:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2283:7: FP_NINF_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
        	        	    {
        	        	         MATCHT(FP_NINF_TOK, &FOLLOW_FP_NINF_TOK_in_termAtomic4716);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4720);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4724);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    atomTerm = SOLVER->mkNegInf(AntlrInput::tokenToUnsigned(eb),
        	        	                                            AntlrInput::tokenToUnsigned(sb));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 4:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2288:7: FP_NAN_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
        	        	    {
        	        	         MATCHT(FP_NAN_TOK, &FOLLOW_FP_NAN_TOK_in_termAtomic4740);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4744);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4748);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    atomTerm = SOLVER->mkNaN(AntlrInput::tokenToUnsigned(eb),
        	        	                                         AntlrInput::tokenToUnsigned(sb));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 5:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2293:7: FP_PZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
        	        	    {
        	        	         MATCHT(FP_PZERO_TOK, &FOLLOW_FP_PZERO_TOK_in_termAtomic4764);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4768);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4772);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    atomTerm = SOLVER->mkPosZero(AntlrInput::tokenToUnsigned(eb),
        	        	                                             AntlrInput::tokenToUnsigned(sb));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 6:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2298:7: FP_NZERO_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
        	        	    {
        	        	         MATCHT(FP_NZERO_TOK, &FOLLOW_FP_NZERO_TOK_in_termAtomic4788);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4792);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_termAtomic4796);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    atomTerm = SOLVER->mkNegZero(AntlrInput::tokenToUnsigned(eb),
        	        	                                             AntlrInput::tokenToUnsigned(sb));
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 7:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2305:7: EMP_TOK sortSymbol[type,CHECK_DECLARED] sortSymbol[type2,CHECK_DECLARED]
        	        	    {
        	        	         MATCHT(EMP_TOK, &FOLLOW_EMP_TOK_in_termAtomic4818);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_termAtomic4826);
        	        	        sortSymbol(ctx, type, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        FOLLOWPUSH(FOLLOW_sortSymbol_in_termAtomic4835);
        	        	        sortSymbol(ctx, type2, CHECK_DECLARED);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruletermAtomicEx;
        	        	        }


        	        	        {

        	        	                    api::Term v1 = SOLVER->mkVar(api::Sort(type), "_emp1");
        	        	                    api::Term v2 = SOLVER->mkVar(api::Sort(type2), "_emp2");
        	        	                    atomTerm = SOLVER->mkTerm(api::SEP_EMP, v1, v2);
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_termAtomic4862);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2319:5: HEX_LITERAL
        	    {
        	        HEX_LITERAL13 = (pANTLR3_COMMON_TOKEN) MATCHT(HEX_LITERAL, &FOLLOW_HEX_LITERAL_in_termAtomic4872);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                assert(AntlrInput::tokenText(HEX_LITERAL13).find("#x") == 0);
        	                std::string hexStr = AntlrInput::tokenTextSubstr(HEX_LITERAL13, 2);
        	                atomTerm = SOLVER->mkBitVector(hexStr, 16);
        	                
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2325:5: BINARY_LITERAL
        	    {
        	        BINARY_LITERAL14 = (pANTLR3_COMMON_TOKEN) MATCHT(BINARY_LITERAL, &FOLLOW_BINARY_LITERAL_in_termAtomic4882);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  assert(AntlrInput::tokenText(BINARY_LITERAL14).find("#b") == 0);
        	                  std::string binStr = AntlrInput::tokenTextSubstr(BINARY_LITERAL14, 2);
        	                  atomTerm = SOLVER->mkBitVector(binStr, 2);
        	                
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2333:5: FP_RNE_TOK
        	    {
        	         MATCHT(FP_RNE_TOK, &FOLLOW_FP_RNE_TOK_in_termAtomic4898);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_NEAREST_TIES_TO_EVEN); 
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2334:5: FP_RNA_TOK
        	    {
        	         MATCHT(FP_RNA_TOK, &FOLLOW_FP_RNA_TOK_in_termAtomic4911);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_NEAREST_TIES_TO_AWAY); 
        	        }


        	    }
        	    break;
        	case 9:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2335:5: FP_RTP_TOK
        	    {
        	         MATCHT(FP_RTP_TOK, &FOLLOW_FP_RTP_TOK_in_termAtomic4924);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_POSITIVE); 
        	        }


        	    }
        	    break;
        	case 10:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2336:5: FP_RTN_TOK
        	    {
        	         MATCHT(FP_RTN_TOK, &FOLLOW_FP_RTN_TOK_in_termAtomic4937);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_NEGATIVE); 
        	        }


        	    }
        	    break;
        	case 11:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2337:5: FP_RTZ_TOK
        	    {
        	         MATCHT(FP_RTZ_TOK, &FOLLOW_FP_RTZ_TOK_in_termAtomic4950);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_ZERO); 
        	        }


        	    }
        	    break;
        	case 12:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2338:5: FP_RNE_FULL_TOK
        	    {
        	         MATCHT(FP_RNE_FULL_TOK, &FOLLOW_FP_RNE_FULL_TOK_in_termAtomic4963);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_NEAREST_TIES_TO_EVEN); 
        	        }


        	    }
        	    break;
        	case 13:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2339:5: FP_RNA_FULL_TOK
        	    {
        	         MATCHT(FP_RNA_FULL_TOK, &FOLLOW_FP_RNA_FULL_TOK_in_termAtomic4971);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_NEAREST_TIES_TO_AWAY); 
        	        }


        	    }
        	    break;
        	case 14:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2340:5: FP_RTP_FULL_TOK
        	    {
        	         MATCHT(FP_RTP_FULL_TOK, &FOLLOW_FP_RTP_FULL_TOK_in_termAtomic4979);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_POSITIVE); 
        	        }


        	    }
        	    break;
        	case 15:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2341:5: FP_RTN_FULL_TOK
        	    {
        	         MATCHT(FP_RTN_FULL_TOK, &FOLLOW_FP_RTN_FULL_TOK_in_termAtomic4987);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_NEGATIVE); 
        	        }


        	    }
        	    break;
        	case 16:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2342:5: FP_RTZ_FULL_TOK
        	    {
        	         MATCHT(FP_RTZ_FULL_TOK, &FOLLOW_FP_RTZ_FULL_TOK_in_termAtomic4995);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRoundingMode(api::ROUND_TOWARD_ZERO); 
        	        }


        	    }
        	    break;
        	case 17:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2345:5: str[s,false]
        	    {
        	        FOLLOWPUSH(FOLLOW_str_in_termAtomic5007);
        	        str(ctx, s, false);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkString(s, true); 
        	        }


        	    }
        	    break;
        	case 18:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2348:5: RENOSTR_TOK
        	    {
        	         MATCHT(RENOSTR_TOK, &FOLLOW_RENOSTR_TOK_in_termAtomic5020);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRegexpEmpty(); 
        	        }


        	    }
        	    break;
        	case 19:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2349:5: REALLCHAR_TOK
        	    {
        	         MATCHT(REALLCHAR_TOK, &FOLLOW_REALLCHAR_TOK_in_termAtomic5028);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkRegexpSigma(); 
        	        }


        	    }
        	    break;
        	case 20:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2352:5: EMPTYSET_TOK
        	    {
        	         MATCHT(EMPTYSET_TOK, &FOLLOW_EMPTYSET_TOK_in_termAtomic5040);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {
        	             atomTerm = SOLVER->mkEmptySet(SOLVER->getNullSort()); 
        	        }


        	    }
        	    break;
        	case 21:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2353:5: UNIVSET_TOK
        	    {
        	         MATCHT(UNIVSET_TOK, &FOLLOW_UNIVSET_TOK_in_termAtomic5048);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  // the Boolean sort is a placeholder here since we don't have type info
        	                  // without type annotation
        	                  atomTerm = SOLVER->mkUniverseSet(SOLVER->getBooleanSort());
        	                
        	        }


        	    }
        	    break;
        	case 22:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2361:5: NILREF_TOK
        	    {
        	         MATCHT(NILREF_TOK, &FOLLOW_NILREF_TOK_in_termAtomic5064);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  // the Boolean sort is a placeholder here since we don't have type info
        	                  // without type annotation
        	                  atomTerm = SOLVER->mkSepNil(SOLVER->getBooleanSort());
        	                
        	        }


        	    }
        	    break;
        	case 23:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2371:5: TUPLE_CONST_TOK
        	    {
        	         MATCHT(TUPLE_CONST_TOK, &FOLLOW_TUPLE_CONST_TOK_in_termAtomic5088);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruletermAtomicEx;
        	        }


        	        {

        	                  atomTerm = SOLVER->mkTuple(std::vector<api::Sort>(),
        	                                             std::vector<api::Term>());
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruletermAtomicEx; /* Prevent compiler warnings */
    ruletermAtomicEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end termAtomic */

/**
 * $ANTLR start attribute
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2381:1: attribute[CVC4::Expr& expr, CVC4::Expr& retExpr, std::string& attr] : ( KEYWORD ( simpleSymbolicExprNoKeyword[sexpr] )? | ATTRIBUTE_PATTERN_TOK LPAREN_TOK ( term[patexpr, e2] )+ RPAREN_TOK | ATTRIBUTE_NO_PATTERN_TOK term[patexpr, e2] |tok= ( ATTRIBUTE_INST_LEVEL | ATTRIBUTE_RR_PRIORITY ) INTEGER_LITERAL | ATTRIBUTE_NAMED_TOK symbolicExpr[sexpr] );
 */
static void
attribute(pSmt2Parser ctx, CVC4::Expr& expr, CVC4::Expr& retExpr, std::string& attr)
{
    pANTLR3_COMMON_TOKEN    tok;
    pANTLR3_COMMON_TOKEN    KEYWORD15;
    pANTLR3_COMMON_TOKEN    INTEGER_LITERAL16;

    /* Initialize rule variables
     */


      SExpr sexpr;
      Expr patexpr;
      std::vector<Expr> patexprs;
      Expr e2;
      bool hasValue = false;

    tok       = NULL;
    KEYWORD15       = NULL;
    INTEGER_LITERAL16       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2389:3: ( KEYWORD ( simpleSymbolicExprNoKeyword[sexpr] )? | ATTRIBUTE_PATTERN_TOK LPAREN_TOK ( term[patexpr, e2] )+ RPAREN_TOK | ATTRIBUTE_NO_PATTERN_TOK term[patexpr, e2] |tok= ( ATTRIBUTE_INST_LEVEL | ATTRIBUTE_RR_PRIORITY ) INTEGER_LITERAL | ATTRIBUTE_NAMED_TOK symbolicExpr[sexpr] )

            ANTLR3_UINT32 alt63;

            alt63=5;

            switch ( LA(1) )
            {
            case KEYWORD:
            	{
            		alt63=1;
            	}
                break;
            case ATTRIBUTE_PATTERN_TOK:
            	{
            		alt63=2;
            	}
                break;
            case ATTRIBUTE_NO_PATTERN_TOK:
            	{
            		alt63=3;
            	}
                break;
            case ATTRIBUTE_INST_LEVEL:
            case ATTRIBUTE_RR_PRIORITY:
            	{
            		alt63=4;
            	}
                break;
            case ATTRIBUTE_NAMED_TOK:
            	{
            		alt63=5;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 63;
                EXCEPTION->state        = 0;


                goto ruleattributeEx;

            }

            switch (alt63)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2389:5: KEYWORD ( simpleSymbolicExprNoKeyword[sexpr] )?
        	    {
        	        KEYWORD15 = (pANTLR3_COMMON_TOKEN) MATCHT(KEYWORD, &FOLLOW_KEYWORD_in_attribute5117);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2389:13: ( simpleSymbolicExprNoKeyword[sexpr] )?
        	        {
        	            int alt61=2;
        	            switch ( LA(1) )
        	            {
        	                case AND_TOK:
        	                case ASSERT_TOK:
        	                case BINARY_LITERAL:
        	                case BV2NAT_TOK:
        	                case CHECK_SAT_ASSUMING_TOK:
        	                case CHECK_SAT_TOK:
        	                case CHECK_SYNTH_TOK:
        	                case CONSTRAINT_TOK:
        	                case DECIMAL_LITERAL:
        	                case DECLARE_DATATYPES_TOK:
        	                case DECLARE_FUN_TOK:
        	                case DECLARE_PRIMED_VAR_TOK:
        	                case DECLARE_SORT_TOK:
        	                case DECLARE_VAR_TOK:
        	                case DEFINE_FUNS_REC_TOK:
        	                case DEFINE_FUN_REC_TOK:
        	                case DEFINE_FUN_TOK:
        	                case DEFINE_SORT_TOK:
        	                case DISTINCT_TOK:
        	                case DIV_TOK:
        	                case DTSIZE_TOK:
        	                case ECHO_TOK:
        	                case EQUAL_TOK:
        	                case EXIT_TOK:
        	                case FMFCARDVAL_TOK:
        	                case FMFCARD_TOK:
        	                case GET_ASSERTIONS_TOK:
        	                case GET_ASSIGNMENT_TOK:
        	                case GET_INFO_TOK:
        	                case GET_MODEL_TOK:
        	                case GET_OPTION_TOK:
        	                case GET_PROOF_TOK:
        	                case GET_UNSAT_ASSUMPTIONS_TOK:
        	                case GET_UNSAT_CORE_TOK:
        	                case GET_VALUE_TOK:
        	                case GREATER_THAN_EQUAL_TOK:
        	                case GREATER_THAN_TOK:
        	                case HEX_LITERAL:
        	                case IMPLIES_TOK:
        	                case INST_CLOSURE_TOK:
        	                case INTEGER_LITERAL:
        	                case INV_CONSTRAINT_TOK:
        	                case ITE_TOK:
        	                case LESS_THAN_EQUAL_TOK:
        	                case LESS_THAN_TOK:
        	                case MINUS_TOK:
        	                case NOT_TOK:
        	                case OR_TOK:
        	                case PLUS_TOK:
        	                case POP_TOK:
        	                case PROPAGATION_RULE_TOK:
        	                case PUSH_TOK:
        	                case QUOTED_SYMBOL:
        	                case REDUCTION_RULE_TOK:
        	                case RESET_ASSERTIONS_TOK:
        	                case RESET_TOK:
        	                case REWRITE_RULE_TOK:
        	                case SET_INFO_TOK:
        	                case SET_LOGIC_TOK:
        	                case SET_OPTIONS_TOK:
        	                case SET_OPTION_TOK:
        	                case SIMPLE_SYMBOL:
        	                case SIMPLIFY_TOK:
        	                case STAR_TOK:
        	                case STRING_LITERAL:
        	                case SYNTH_FUN_TOK:
        	                case SYNTH_INV_TOK:
        	                case UNTERMINATED_QUOTED_SYMBOL:
        	                case XOR_TOK:
        	                case 160:
        	                	{
        	                		alt61=1;
        	                	}
        	                    break;
        	            }

        	            switch (alt61)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2389:15: simpleSymbolicExprNoKeyword[sexpr]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_simpleSymbolicExprNoKeyword_in_attribute5121);
        	        	        simpleSymbolicExprNoKeyword(ctx, sexpr);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto ruleattributeEx;
        	        	        }


        	        	        {
        	        	             hasValue = true; 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {

        	                attr = AntlrInput::tokenText(KEYWORD15);
        	                // EXPR_MANAGER->setNamedAttribute( expr, attr );
        	                if(attr == ":rewrite-rule") {
        	                  if(hasValue) {
        	                    std::stringstream ss;
        	                    ss << "warning: Attribute " << attr
        	                       << " does not take a value (ignoring)";
        	                    PARSER_STATE->warning(ss.str());
        	                  }
        	                  // do nothing
        	                }
        	                else if (attr==":axiom" || attr==":conjecture" || attr==":fun-def")
        	                {
        	                  if(hasValue) {
        	                    std::stringstream ss;
        	                    ss << "warning: Attribute " << attr
        	                       << " does not take a value (ignoring)";
        	                    PARSER_STATE->warning(ss.str());
        	                  }
        	                  Expr avar;
        	                  bool success = true;
        	                  std::string attr_name = attr;
        	                  attr_name.erase( attr_name.begin() );
        	                  if( attr==":fun-def" ){
        	                    if( expr.getKind()!=kind::EQUAL || expr[0].getKind()!=kind::APPLY_UF ){
        	                      success = false;
        	                    }else{
        	                      FunctionType t = (FunctionType)expr[0].getOperator().getType();
        	                      for( unsigned i=0; i<expr[0].getNumChildren(); i++ ){
        	                        if( expr[0][i].getKind() != kind::BOUND_VARIABLE ||
        	                            expr[0][i].getType() != t.getArgTypes()[i] ){
        	                          success = false;
        	                          break;
        	                        }else{
        	                          for( unsigned j=0; j<i; j++ ){
        	                            if( expr[0][j]==expr[0][i] ){
        	                              success = false;
        	                              break;
        	                            }
        	                          }
        	                        }
        	                      }
        	                    }
        	                    if( !success ){
        	                      std::stringstream ss;
        	                      ss << "warning: Function definition should be an equality whose LHS "
        	                         << "is an uninterpreted function applied to unique variables.";
        	                      PARSER_STATE->warning(ss.str());
        	                    }else{
        	                      avar = expr[0];
        	                    }
        	                  }else{
        	                    Type t = EXPR_MANAGER->booleanType();
        	                    avar = PARSER_STATE->mkVar(attr_name, t);
        	                  }
        	                  if( success ){
        	                    //Will set the attribute on auxiliary var (preserves attribute on
        	                    //formula through rewriting).
        	                    retExpr = MK_EXPR(kind::INST_ATTRIBUTE, avar);
        	                    Command* c = new SetUserAttributeCommand( attr_name, avar );
        	                    c->setMuted(true);
        	                    PARSER_STATE->preemptCommand(c);
        	                  }
        	                } else {
        	                  PARSER_STATE->attributeNotSupported(attr);
        	                }
        	              
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2458:5: ATTRIBUTE_PATTERN_TOK LPAREN_TOK ( term[patexpr, e2] )+ RPAREN_TOK
        	    {
        	         MATCHT(ATTRIBUTE_PATTERN_TOK, &FOLLOW_ATTRIBUTE_PATTERN_TOK_in_attribute5137);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_attribute5139);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2459:5: ( term[patexpr, e2] )+
        	        {
        	            int cnt62=0;

        	            for (;;)
        	            {
        	                int alt62=2;
        	        	switch ( LA(1) )
        	        	{
        	        	case BINARY_LITERAL:
        	        	case CHECK_SYNTH_TOK:
        	        	case CONSTRAINT_TOK:
        	        	case DECIMAL_LITERAL:
        	        	case DECLARE_PRIMED_VAR_TOK:
        	        	case DECLARE_VAR_TOK:
        	        	case EMPTYSET_TOK:
        	        	case FP_RNA_FULL_TOK:
        	        	case FP_RNA_TOK:
        	        	case FP_RNE_FULL_TOK:
        	        	case FP_RNE_TOK:
        	        	case FP_RTN_FULL_TOK:
        	        	case FP_RTN_TOK:
        	        	case FP_RTP_FULL_TOK:
        	        	case FP_RTP_TOK:
        	        	case FP_RTZ_FULL_TOK:
        	        	case FP_RTZ_TOK:
        	        	case HEX_LITERAL:
        	        	case INTEGER_LITERAL:
        	        	case INV_CONSTRAINT_TOK:
        	        	case LPAREN_TOK:
        	        	case NILREF_TOK:
        	        	case QUOTED_SYMBOL:
        	        	case REALLCHAR_TOK:
        	        	case REAL_PI_TOK:
        	        	case RENOSTR_TOK:
        	        	case SET_OPTIONS_TOK:
        	        	case SIMPLE_SYMBOL:
        	        	case STRING_LITERAL:
        	        	case SYNTH_FUN_TOK:
        	        	case SYNTH_INV_TOK:
        	        	case TUPLE_CONST_TOK:
        	        	case UNIVSET_TOK:
        	        	case UNTERMINATED_QUOTED_SYMBOL:
        	        	case 160:
        	        		{
        	        			alt62=1;
        	        		}
        	        	    break;

        	        	}

        	        	switch (alt62)
        	        	{
        	        	    case 1:
        	        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2459:7: term[patexpr, e2]
        	        	        {
        	        	            FOLLOWPUSH(FOLLOW_term_in_attribute5147);
        	        	            term(ctx, patexpr, e2);

        	        	            FOLLOWPOP();
        	        	            if  (HASEXCEPTION())
        	        	            {
        	        	                goto ruleattributeEx;
        	        	            }


        	        	            {
        	        	                 patexprs.push_back( patexpr ); 
        	        	            }


        	        	        }
        	        	        break;

        	        	    default:

        	        		if ( cnt62 >= 1 )
        	        		{
        	        		    goto loop62;
        	        		}
        	        		/* mismatchedSetEx()
        	        		 */
        	        		CONSTRUCTEX();
        	        		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
        	        		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


        	        		goto ruleattributeEx;
        	        	}
        	        	cnt62++;
        	            }
        	            loop62: ;	/* Jump to here if this rule does not match */
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_attribute5165);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        {

        	                  attr = std::string(":pattern");
        	                  retExpr = MK_EXPR(kind::INST_PATTERN, patexprs);
        	                
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2466:5: ATTRIBUTE_NO_PATTERN_TOK term[patexpr, e2]
        	    {
        	         MATCHT(ATTRIBUTE_NO_PATTERN_TOK, &FOLLOW_ATTRIBUTE_NO_PATTERN_TOK_in_attribute5177);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_term_in_attribute5179);
        	        term(ctx, patexpr, e2);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        {

        	                  attr = std::string(":no-pattern");
        	                  retExpr = MK_EXPR(kind::INST_NO_PATTERN, patexpr);
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2471:5: tok= ( ATTRIBUTE_INST_LEVEL | ATTRIBUTE_RR_PRIORITY ) INTEGER_LITERAL
        	    {
        	        tok=(pANTLR3_COMMON_TOKEN)LT(1);

        	        if ( LA(1) == ATTRIBUTE_INST_LEVEL || LA(1) == ATTRIBUTE_RR_PRIORITY )
        	        {
        	            CONSUME();
        	            PERRORRECOVERY=ANTLR3_FALSE;
        	        }
        	        else
        	        {
        	            CONSTRUCTEX();
        	            EXCEPTION->type         = ANTLR3_MISMATCHED_SET_EXCEPTION;
        	            EXCEPTION->name         = (void *)ANTLR3_MISMATCHED_SET_NAME;
        	            EXCEPTION->expectingSet = NULL;

        	            goto ruleattributeEx;
        	        }


        	        INTEGER_LITERAL16 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_attribute5204);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        {

        	                  Expr n = MK_CONST( AntlrInput::tokenToInteger(INTEGER_LITERAL16) );
        	                  std::vector<Expr> values;
        	                  values.push_back( n );
        	                  std::string attr_name(AntlrInput::tokenText(tok));
        	                  attr_name.erase( attr_name.begin() );
        	                  Type t = EXPR_MANAGER->booleanType();
        	                  Expr avar = PARSER_STATE->mkVar(attr_name, t);
        	                  retExpr = MK_EXPR(kind::INST_ATTRIBUTE, avar);
        	                  Command* c = new SetUserAttributeCommand( attr_name, avar, values );
        	                  c->setMuted(true);
        	                  PARSER_STATE->preemptCommand(c);
        	                
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2485:5: ATTRIBUTE_NAMED_TOK symbolicExpr[sexpr]
        	    {
        	         MATCHT(ATTRIBUTE_NAMED_TOK, &FOLLOW_ATTRIBUTE_NAMED_TOK_in_attribute5216);
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_symbolicExpr_in_attribute5218);
        	        symbolicExpr(ctx, sexpr);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto ruleattributeEx;
        	        }


        	        {

        	                  attr = std::string(":named");
        	                  if(!sexpr.isKeyword()) {
        	                    PARSER_STATE->parseError("improperly formed :named annotation");
        	                  }
        	                  std::string name = sexpr.getValue();
        	                  PARSER_STATE->checkUserSymbol(name);
        	                  // ensure expr is a closed subterm
        	                  std::set<Expr> freeVars;
        	                  if(!isClosed(expr, freeVars)) {
        	                    assert(!freeVars.empty());
        	                    std::stringstream ss;
        	                    ss << ":named annotations can only name terms that are closed; this "
        	                       << "one contains free variables:";
        	                    for(std::set<Expr>::const_iterator i = freeVars.begin();
        	                        i != freeVars.end(); ++i) {
        	                      ss << " " << *i;
        	                    }
        	                    PARSER_STATE->parseError(ss.str());
        	                  }
        	                  // check that sexpr is a fresh function symbol, and reserve it
        	                  PARSER_STATE->reserveSymbolAtAssertionLevel(name);
        	                  // define it
        	                  Expr func = PARSER_STATE->mkFunction(name, expr.getType());
        	                  // remember the last term to have been given a :named attribute
        	                  PARSER_STATE->setLastNamedTerm(expr, name);
        	                  // bind name to expr with define-fun
        	                  Command* c =
        	                    new DefineNamedFunctionCommand(name, func, std::vector<Expr>(), expr);
        	                  c->setMuted(true);
        	                  PARSER_STATE->preemptCommand(c);
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto ruleattributeEx; /* Prevent compiler warnings */
    ruleattributeEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end attribute */

/**
 * $ANTLR start indexedFunctionName
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2523:1: indexedFunctionName[CVC4::Expr& op, CVC4::Kind& kind] : LPAREN_TOK INDEX_TOK ( 'extract' n1= INTEGER_LITERAL n2= INTEGER_LITERAL | 'repeat' n= INTEGER_LITERAL | 'zero_extend' n= INTEGER_LITERAL | 'sign_extend' n= INTEGER_LITERAL | 'rotate_left' n= INTEGER_LITERAL | 'rotate_right' n= INTEGER_LITERAL | DIVISIBLE_TOK n= INTEGER_LITERAL | INT2BV_TOK n= INTEGER_LITERAL | FP_TO_FP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPBV_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPFP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPR_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPS_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPU_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_UBV_TOK m= INTEGER_LITERAL | FP_TO_SBV_TOK m= INTEGER_LITERAL | TESTER_TOK term[expr, expr2] | TUPLE_SEL_TOK m= INTEGER_LITERAL | badIndexedFunctionName ) RPAREN_TOK ;
 */
static void
indexedFunctionName(pSmt2Parser ctx, CVC4::Expr& op, CVC4::Kind& kind)
{
    pANTLR3_COMMON_TOKEN    n1;
    pANTLR3_COMMON_TOKEN    n2;
    pANTLR3_COMMON_TOKEN    n;
    pANTLR3_COMMON_TOKEN    eb;
    pANTLR3_COMMON_TOKEN    sb;
    pANTLR3_COMMON_TOKEN    m;

    /* Initialize rule variables
     */


      Expr expr;
      Expr expr2;

    n1       = NULL;
    n2       = NULL;
    n       = NULL;
    eb       = NULL;
    sb       = NULL;
    m       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2528:3: ( LPAREN_TOK INDEX_TOK ( 'extract' n1= INTEGER_LITERAL n2= INTEGER_LITERAL | 'repeat' n= INTEGER_LITERAL | 'zero_extend' n= INTEGER_LITERAL | 'sign_extend' n= INTEGER_LITERAL | 'rotate_left' n= INTEGER_LITERAL | 'rotate_right' n= INTEGER_LITERAL | DIVISIBLE_TOK n= INTEGER_LITERAL | INT2BV_TOK n= INTEGER_LITERAL | FP_TO_FP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPBV_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPFP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPR_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPS_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPU_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_UBV_TOK m= INTEGER_LITERAL | FP_TO_SBV_TOK m= INTEGER_LITERAL | TESTER_TOK term[expr, expr2] | TUPLE_SEL_TOK m= INTEGER_LITERAL | badIndexedFunctionName ) RPAREN_TOK )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2528:5: LPAREN_TOK INDEX_TOK ( 'extract' n1= INTEGER_LITERAL n2= INTEGER_LITERAL | 'repeat' n= INTEGER_LITERAL | 'zero_extend' n= INTEGER_LITERAL | 'sign_extend' n= INTEGER_LITERAL | 'rotate_left' n= INTEGER_LITERAL | 'rotate_right' n= INTEGER_LITERAL | DIVISIBLE_TOK n= INTEGER_LITERAL | INT2BV_TOK n= INTEGER_LITERAL | FP_TO_FP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPBV_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPFP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPR_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPS_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPU_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_UBV_TOK m= INTEGER_LITERAL | FP_TO_SBV_TOK m= INTEGER_LITERAL | TESTER_TOK term[expr, expr2] | TUPLE_SEL_TOK m= INTEGER_LITERAL | badIndexedFunctionName ) RPAREN_TOK
        {
             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_indexedFunctionName5246);
            if  (HASEXCEPTION())
            {
                goto ruleindexedFunctionNameEx;
            }


             MATCHT(INDEX_TOK, &FOLLOW_INDEX_TOK_in_indexedFunctionName5248);
            if  (HASEXCEPTION())
            {
                goto ruleindexedFunctionNameEx;
            }



            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2529:5: ( 'extract' n1= INTEGER_LITERAL n2= INTEGER_LITERAL | 'repeat' n= INTEGER_LITERAL | 'zero_extend' n= INTEGER_LITERAL | 'sign_extend' n= INTEGER_LITERAL | 'rotate_left' n= INTEGER_LITERAL | 'rotate_right' n= INTEGER_LITERAL | DIVISIBLE_TOK n= INTEGER_LITERAL | INT2BV_TOK n= INTEGER_LITERAL | FP_TO_FP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPBV_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPFP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPR_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPS_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_FPU_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL | FP_TO_UBV_TOK m= INTEGER_LITERAL | FP_TO_SBV_TOK m= INTEGER_LITERAL | TESTER_TOK term[expr, expr2] | TUPLE_SEL_TOK m= INTEGER_LITERAL | badIndexedFunctionName )
            {
                int alt64=19;
                switch ( LA(1) )
                {
                case 159:
                	{
                		alt64=1;
                	}
                    break;
                case 160:
                	{
                		alt64=2;
                	}
                    break;
                case 164:
                	{
                		alt64=3;
                	}
                    break;
                case 163:
                	{
                		alt64=4;
                	}
                    break;
                case 161:
                	{
                		alt64=5;
                	}
                    break;
                case 162:
                	{
                		alt64=6;
                	}
                    break;
                case DIVISIBLE_TOK:
                	{
                		alt64=7;
                	}
                    break;
                case INT2BV_TOK:
                	{
                		alt64=8;
                	}
                    break;
                case FP_TO_FP_TOK:
                	{
                		alt64=9;
                	}
                    break;
                case FP_TO_FPBV_TOK:
                	{
                		alt64=10;
                	}
                    break;
                case FP_TO_FPFP_TOK:
                	{
                		alt64=11;
                	}
                    break;
                case FP_TO_FPR_TOK:
                	{
                		alt64=12;
                	}
                    break;
                case FP_TO_FPS_TOK:
                	{
                		alt64=13;
                	}
                    break;
                case FP_TO_FPU_TOK:
                	{
                		alt64=14;
                	}
                    break;
                case FP_TO_UBV_TOK:
                	{
                		alt64=15;
                	}
                    break;
                case FP_TO_SBV_TOK:
                	{
                		alt64=16;
                	}
                    break;
                case TESTER_TOK:
                	{
                		alt64=17;
                	}
                    break;
                case TUPLE_SEL_TOK:
                	{
                		alt64=18;
                	}
                    break;
                case QUOTED_SYMBOL:
                case SIMPLE_SYMBOL:
                case UNTERMINATED_QUOTED_SYMBOL:
                	{
                		alt64=19;
                	}
                    break;

                default:
                    CONSTRUCTEX();
                    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                    EXCEPTION->message      = (void *)"";
                    EXCEPTION->decisionNum  = 64;
                    EXCEPTION->state        = 0;


                    goto ruleindexedFunctionNameEx;

                }

                switch (alt64)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2529:7: 'extract' n1= INTEGER_LITERAL n2= INTEGER_LITERAL
            	    {
            	         MATCHT(159, &FOLLOW_159_in_indexedFunctionName5256);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n1 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5260);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n2 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5264);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorExtract(AntlrInput::tokenToUnsigned(n1),
            	                                                   AntlrInput::tokenToUnsigned(n2))); 
            	        }


            	    }
            	    break;
            	case 2:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2532:7: 'repeat' n= INTEGER_LITERAL
            	    {
            	         MATCHT(160, &FOLLOW_160_in_indexedFunctionName5280);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5284);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorRepeat(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 3:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2534:7: 'zero_extend' n= INTEGER_LITERAL
            	    {
            	         MATCHT(164, &FOLLOW_164_in_indexedFunctionName5300);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5304);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorZeroExtend(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 4:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2536:7: 'sign_extend' n= INTEGER_LITERAL
            	    {
            	         MATCHT(163, &FOLLOW_163_in_indexedFunctionName5320);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5324);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorSignExtend(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 5:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2538:7: 'rotate_left' n= INTEGER_LITERAL
            	    {
            	         MATCHT(161, &FOLLOW_161_in_indexedFunctionName5340);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5344);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorRotateLeft(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 6:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2540:7: 'rotate_right' n= INTEGER_LITERAL
            	    {
            	         MATCHT(162, &FOLLOW_162_in_indexedFunctionName5360);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5364);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(BitVectorRotateRight(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 7:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2542:7: DIVISIBLE_TOK n= INTEGER_LITERAL
            	    {
            	         MATCHT(DIVISIBLE_TOK, &FOLLOW_DIVISIBLE_TOK_in_indexedFunctionName5380);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5384);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(Divisible(AntlrInput::tokenToUnsigned(n))); 
            	        }


            	    }
            	    break;
            	case 8:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2544:7: INT2BV_TOK n= INTEGER_LITERAL
            	    {
            	         MATCHT(INT2BV_TOK, &FOLLOW_INT2BV_TOK_in_indexedFunctionName5400);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        n = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5404);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(IntToBitVector(AntlrInput::tokenToUnsigned(n)));
            	                    if(PARSER_STATE->strictModeEnabled()) {
            	                      PARSER_STATE->parseError(
            	                          "bv2nat and int2bv are not part of SMT-LIB, and aren't available "
            	                          "in SMT-LIB strict compliance mode");
            	                    } 
            	        }


            	    }
            	    break;
            	case 9:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2551:7: FP_TO_FP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FP_TOK, &FOLLOW_FP_TO_FP_TOK_in_indexedFunctionName5420);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5424);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5428);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPGeneric(
            	                            AntlrInput::tokenToUnsigned(eb),
            	                            AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 10:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2556:7: FP_TO_FPBV_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FPBV_TOK, &FOLLOW_FP_TO_FPBV_TOK_in_indexedFunctionName5444);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5448);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5452);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPIEEEBitVector(
            	                            AntlrInput::tokenToUnsigned(eb),
            	                            AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 11:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2561:7: FP_TO_FPFP_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FPFP_TOK, &FOLLOW_FP_TO_FPFP_TOK_in_indexedFunctionName5468);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5472);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5476);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPFloatingPoint(
            	                            AntlrInput::tokenToUnsigned(eb),
            	                            AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 12:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2566:7: FP_TO_FPR_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FPR_TOK, &FOLLOW_FP_TO_FPR_TOK_in_indexedFunctionName5492);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5496);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5500);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPReal(AntlrInput::tokenToUnsigned(eb),
            	                                                        AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 13:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2570:7: FP_TO_FPS_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FPS_TOK, &FOLLOW_FP_TO_FPS_TOK_in_indexedFunctionName5516);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5520);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5524);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPSignedBitVector(
            	                            AntlrInput::tokenToUnsigned(eb),
            	                            AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 14:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2575:7: FP_TO_FPU_TOK eb= INTEGER_LITERAL sb= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_FPU_TOK, &FOLLOW_FP_TO_FPU_TOK_in_indexedFunctionName5540);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        eb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5544);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        sb = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5548);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToFPUnsignedBitVector(
            	                            AntlrInput::tokenToUnsigned(eb),
            	                            AntlrInput::tokenToUnsigned(sb)));
            	                  
            	        }


            	    }
            	    break;
            	case 15:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2580:7: FP_TO_UBV_TOK m= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_UBV_TOK, &FOLLOW_FP_TO_UBV_TOK_in_indexedFunctionName5564);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        m = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5568);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToUBV(AntlrInput::tokenToUnsigned(m))); 
            	        }


            	    }
            	    break;
            	case 16:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2582:7: FP_TO_SBV_TOK m= INTEGER_LITERAL
            	    {
            	         MATCHT(FP_TO_SBV_TOK, &FOLLOW_FP_TO_SBV_TOK_in_indexedFunctionName5584);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        m = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5588);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             op = MK_CONST(FloatingPointToSBV(AntlrInput::tokenToUnsigned(m))); 
            	        }


            	    }
            	    break;
            	case 17:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2584:7: TESTER_TOK term[expr, expr2]
            	    {
            	         MATCHT(TESTER_TOK, &FOLLOW_TESTER_TOK_in_indexedFunctionName5604);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        FOLLOWPUSH(FOLLOW_term_in_indexedFunctionName5606);
            	        term(ctx, expr, expr2);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {
            	             
            	                    if( expr.getKind()==kind::APPLY_CONSTRUCTOR && expr.getNumChildren()==0 ){
            	                      //for nullary constructors, must get the operator
            	                      expr = expr.getOperator();
            	                    }
            	                    if( !expr.getType().isConstructor() ){
            	                      PARSER_STATE->parseError("Bad syntax for test (_ is X), X must be a constructor.");
            	                    }
            	                    op = Datatype::datatypeOf(expr)[Datatype::indexOf(expr)].getTester();
            	                    kind = CVC4::kind::APPLY_TESTER;
            	                  
            	        }


            	    }
            	    break;
            	case 18:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2595:7: TUPLE_SEL_TOK m= INTEGER_LITERAL
            	    {
            	         MATCHT(TUPLE_SEL_TOK, &FOLLOW_TUPLE_SEL_TOK_in_indexedFunctionName5617);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        m = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_indexedFunctionName5621);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	        {

            	                    kind = CVC4::kind::APPLY_SELECTOR;
            	                    //put m in op so that the caller (termNonVariable) can deal with this case
            	                    op = MK_CONST(Rational(AntlrInput::tokenToUnsigned(m)));
            	                  
            	        }


            	    }
            	    break;
            	case 19:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2600:7: badIndexedFunctionName
            	    {
            	        FOLLOWPUSH(FOLLOW_badIndexedFunctionName_in_indexedFunctionName5632);
            	        badIndexedFunctionName(ctx);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleindexedFunctionNameEx;
            	        }


            	    }
            	    break;

                }
            }

             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_indexedFunctionName5644);
            if  (HASEXCEPTION())
            {
                goto ruleindexedFunctionNameEx;
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruleindexedFunctionNameEx; /* Prevent compiler warnings */
    ruleindexedFunctionNameEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end indexedFunctionName */

/**
 * $ANTLR start badIndexedFunctionName
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2609:1: badIndexedFunctionName : id= ( SIMPLE_SYMBOL | QUOTED_SYMBOL | UNTERMINATED_QUOTED_SYMBOL ) ;
 */
static void
badIndexedFunctionName(pSmt2Parser ctx)
{

      std::string name;

    pANTLR3_COMMON_TOKEN    id;

    /* Initialize rule variables
     */

    id       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2613:3: (id= ( SIMPLE_SYMBOL | QUOTED_SYMBOL | UNTERMINATED_QUOTED_SYMBOL ) )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2613:5: id= ( SIMPLE_SYMBOL | QUOTED_SYMBOL | UNTERMINATED_QUOTED_SYMBOL )
        {
            id=(pANTLR3_COMMON_TOKEN)LT(1);

            if ( LA(1) == QUOTED_SYMBOL || LA(1) == SIMPLE_SYMBOL || LA(1) == UNTERMINATED_QUOTED_SYMBOL )
            {
                CONSUME();
                PERRORRECOVERY=ANTLR3_FALSE;
            }
            else
            {
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_MISMATCHED_SET_EXCEPTION;
                EXCEPTION->name         = (void *)ANTLR3_MISMATCHED_SET_NAME;
                EXCEPTION->expectingSet = NULL;

                goto rulebadIndexedFunctionNameEx;
            }


            {
                 PARSER_STATE->parseError(std::string("Unknown indexed function `") +
                          AntlrInput::tokenText(id) + "'");
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulebadIndexedFunctionNameEx; /* Prevent compiler warnings */
    rulebadIndexedFunctionNameEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end badIndexedFunctionName */

/**
 * $ANTLR start termList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2627:1: termList[std::vector<CVC4::Expr>& formulas, CVC4::Expr& expr] : ( term[expr, expr2] )+ ;
 */
static void
termList(pSmt2Parser ctx, std::vector<CVC4::Expr>& formulas, CVC4::Expr& expr)
{

      Expr expr2;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2631:3: ( ( term[expr, expr2] )+ )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2631:5: ( term[expr, expr2] )+
        {
            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2631:5: ( term[expr, expr2] )+
            {
                int cnt65=0;

                for (;;)
                {
                    int alt65=2;
            	switch ( LA(1) )
            	{
            	case BINARY_LITERAL:
            	case CHECK_SYNTH_TOK:
            	case CONSTRAINT_TOK:
            	case DECIMAL_LITERAL:
            	case DECLARE_PRIMED_VAR_TOK:
            	case DECLARE_VAR_TOK:
            	case EMPTYSET_TOK:
            	case FP_RNA_FULL_TOK:
            	case FP_RNA_TOK:
            	case FP_RNE_FULL_TOK:
            	case FP_RNE_TOK:
            	case FP_RTN_FULL_TOK:
            	case FP_RTN_TOK:
            	case FP_RTP_FULL_TOK:
            	case FP_RTP_TOK:
            	case FP_RTZ_FULL_TOK:
            	case FP_RTZ_TOK:
            	case HEX_LITERAL:
            	case INTEGER_LITERAL:
            	case INV_CONSTRAINT_TOK:
            	case LPAREN_TOK:
            	case NILREF_TOK:
            	case QUOTED_SYMBOL:
            	case REALLCHAR_TOK:
            	case REAL_PI_TOK:
            	case RENOSTR_TOK:
            	case SET_OPTIONS_TOK:
            	case SIMPLE_SYMBOL:
            	case STRING_LITERAL:
            	case SYNTH_FUN_TOK:
            	case SYNTH_INV_TOK:
            	case TUPLE_CONST_TOK:
            	case UNIVSET_TOK:
            	case UNTERMINATED_QUOTED_SYMBOL:
            	case 160:
            		{
            			alt65=1;
            		}
            	    break;

            	}

            	switch (alt65)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2631:7: term[expr, expr2]
            	        {
            	            FOLLOWPUSH(FOLLOW_term_in_termList5707);
            	            term(ctx, expr, expr2);

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruletermListEx;
            	            }


            	            {
            	                 formulas.push_back(expr); 
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt65 >= 1 )
            		{
            		    goto loop65;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto ruletermListEx;
            	}
            	cnt65++;
                }
                loop65: ;	/* Jump to here if this rule does not match */
            }

        }

    }


    // This is where rules clean up and exit
    //
    goto ruletermListEx; /* Prevent compiler warnings */
    ruletermListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end termList */

/**
 * $ANTLR start str
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2637:1: str[std::string& s, bool fsmtlib] : STRING_LITERAL ;
 */
static void
str(pSmt2Parser ctx, std::string& s, bool fsmtlib)
{
    pANTLR3_COMMON_TOKEN    STRING_LITERAL17;

    /* Initialize rule variables
     */

    STRING_LITERAL17       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2638:3: ( STRING_LITERAL )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2638:5: STRING_LITERAL
        {
            STRING_LITERAL17 = (pANTLR3_COMMON_TOKEN) MATCHT(STRING_LITERAL, &FOLLOW_STRING_LITERAL_in_str5729);
            if  (HASEXCEPTION())
            {
                goto rulestrEx;
            }


            {

                      s = AntlrInput::tokenText(STRING_LITERAL17);
                      /* strip off the quotes */
                      s = s.substr(1, s.size() - 2);
                      for (size_t i = 0; i < s.size(); i++)
                      {
                        if ((unsigned)s[i] > 127 && !isprint(s[i]))
                        {
                          PARSER_STATE->parseError(
                              "Extended/unprintable characters are not "
                              "part of SMT-LIB, and they must be encoded "
                              "as escape sequences");
                        }
                      }
                      if (fsmtlib || PARSER_STATE->escapeDupDblQuote())
                      {
                        char* p_orig = strdup(s.c_str());
                        char *p = p_orig, *q = p_orig;
                        while (*q != '\0')
                        {
                          if (PARSER_STATE->escapeDupDblQuote() && *q == '"')
                          {
                            // Handle SMT-LIB >=2.5 standard escape '""'.
                            ++q;
                            assert(*q == '"');
                          }
                          else if (!PARSER_STATE->escapeDupDblQuote() && *q == '\\')
                          {
                            ++q;
                            // Handle SMT-LIB 2.0 standard escapes '\\' and '\"'.
                            if (*q != '\\' && *q != '"')
                            {
                              assert(*q != '\0');
                              *p++ = '\\';
                            }
                          }
                          *p++ = *q++;
                        }
                        *p = '\0';
                        s = p_orig;
                        free(p_orig);
                      }
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulestrEx; /* Prevent compiler warnings */
    rulestrEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end str */

/**
 * $ANTLR start builtinOp
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2687:1: builtinOp[CVC4::Kind& kind] : ( NOT_TOK | IMPLIES_TOK | AND_TOK | OR_TOK | XOR_TOK | EQUAL_TOK | DISTINCT_TOK | ITE_TOK | GREATER_THAN_TOK | GREATER_THAN_EQUAL_TOK | LESS_THAN_EQUAL_TOK | LESS_THAN_TOK | PLUS_TOK | MINUS_TOK | STAR_TOK | DIV_TOK | BV2NAT_TOK | DTSIZE_TOK | FMFCARD_TOK | FMFCARDVAL_TOK | INST_CLOSURE_TOK );
 */
static void
builtinOp(pSmt2Parser ctx, CVC4::Kind& kind)
{
    /* Initialize rule variables
     */


      Debug("parser") << "builtin: " << AntlrInput::tokenText(LT(1)) << std::endl;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2691:3: ( NOT_TOK | IMPLIES_TOK | AND_TOK | OR_TOK | XOR_TOK | EQUAL_TOK | DISTINCT_TOK | ITE_TOK | GREATER_THAN_TOK | GREATER_THAN_EQUAL_TOK | LESS_THAN_EQUAL_TOK | LESS_THAN_TOK | PLUS_TOK | MINUS_TOK | STAR_TOK | DIV_TOK | BV2NAT_TOK | DTSIZE_TOK | FMFCARD_TOK | FMFCARDVAL_TOK | INST_CLOSURE_TOK )

            ANTLR3_UINT32 alt66;

            alt66=21;

            switch ( LA(1) )
            {
            case NOT_TOK:
            	{
            		alt66=1;
            	}
                break;
            case IMPLIES_TOK:
            	{
            		alt66=2;
            	}
                break;
            case AND_TOK:
            	{
            		alt66=3;
            	}
                break;
            case OR_TOK:
            	{
            		alt66=4;
            	}
                break;
            case XOR_TOK:
            	{
            		alt66=5;
            	}
                break;
            case EQUAL_TOK:
            	{
            		alt66=6;
            	}
                break;
            case DISTINCT_TOK:
            	{
            		alt66=7;
            	}
                break;
            case ITE_TOK:
            	{
            		alt66=8;
            	}
                break;
            case GREATER_THAN_TOK:
            	{
            		alt66=9;
            	}
                break;
            case GREATER_THAN_EQUAL_TOK:
            	{
            		alt66=10;
            	}
                break;
            case LESS_THAN_EQUAL_TOK:
            	{
            		alt66=11;
            	}
                break;
            case LESS_THAN_TOK:
            	{
            		alt66=12;
            	}
                break;
            case PLUS_TOK:
            	{
            		alt66=13;
            	}
                break;
            case MINUS_TOK:
            	{
            		alt66=14;
            	}
                break;
            case STAR_TOK:
            	{
            		alt66=15;
            	}
                break;
            case DIV_TOK:
            	{
            		alt66=16;
            	}
                break;
            case BV2NAT_TOK:
            	{
            		alt66=17;
            	}
                break;
            case DTSIZE_TOK:
            	{
            		alt66=18;
            	}
                break;
            case FMFCARD_TOK:
            	{
            		alt66=19;
            	}
                break;
            case FMFCARDVAL_TOK:
            	{
            		alt66=20;
            	}
                break;
            case INST_CLOSURE_TOK:
            	{
            		alt66=21;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 66;
                EXCEPTION->state        = 0;


                goto rulebuiltinOpEx;

            }

            switch (alt66)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2691:5: NOT_TOK
        	    {
        	         MATCHT(NOT_TOK, &FOLLOW_NOT_TOK_in_builtinOp5756);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::NOT;     
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2692:5: IMPLIES_TOK
        	    {
        	         MATCHT(IMPLIES_TOK, &FOLLOW_IMPLIES_TOK_in_builtinOp5769);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::IMPLIES; 
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2693:5: AND_TOK
        	    {
        	         MATCHT(AND_TOK, &FOLLOW_AND_TOK_in_builtinOp5778);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::AND;     
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2694:5: OR_TOK
        	    {
        	         MATCHT(OR_TOK, &FOLLOW_OR_TOK_in_builtinOp5791);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::OR;      
        	        }


        	    }
        	    break;
        	case 5:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2695:5: XOR_TOK
        	    {
        	         MATCHT(XOR_TOK, &FOLLOW_XOR_TOK_in_builtinOp5805);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::XOR;     
        	        }


        	    }
        	    break;
        	case 6:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2696:5: EQUAL_TOK
        	    {
        	         MATCHT(EQUAL_TOK, &FOLLOW_EQUAL_TOK_in_builtinOp5818);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::EQUAL;   
        	        }


        	    }
        	    break;
        	case 7:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2697:5: DISTINCT_TOK
        	    {
        	         MATCHT(DISTINCT_TOK, &FOLLOW_DISTINCT_TOK_in_builtinOp5829);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::DISTINCT; 
        	        }


        	    }
        	    break;
        	case 8:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2698:5: ITE_TOK
        	    {
        	         MATCHT(ITE_TOK, &FOLLOW_ITE_TOK_in_builtinOp5837);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::ITE; 
        	        }


        	    }
        	    break;
        	case 9:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2699:5: GREATER_THAN_TOK
        	    {
        	         MATCHT(GREATER_THAN_TOK, &FOLLOW_GREATER_THAN_TOK_in_builtinOp5850);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::GT; 
        	        }


        	    }
        	    break;
        	case 10:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2701:5: GREATER_THAN_EQUAL_TOK
        	    {
        	         MATCHT(GREATER_THAN_EQUAL_TOK, &FOLLOW_GREATER_THAN_EQUAL_TOK_in_builtinOp5875);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::GEQ; 
        	        }


        	    }
        	    break;
        	case 11:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2703:5: LESS_THAN_EQUAL_TOK
        	    {
        	         MATCHT(LESS_THAN_EQUAL_TOK, &FOLLOW_LESS_THAN_EQUAL_TOK_in_builtinOp5900);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::LEQ; 
        	        }


        	    }
        	    break;
        	case 12:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2705:5: LESS_THAN_TOK
        	    {
        	         MATCHT(LESS_THAN_TOK, &FOLLOW_LESS_THAN_TOK_in_builtinOp5925);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::LT; 
        	        }


        	    }
        	    break;
        	case 13:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2707:5: PLUS_TOK
        	    {
        	         MATCHT(PLUS_TOK, &FOLLOW_PLUS_TOK_in_builtinOp5950);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::PLUS; 
        	        }


        	    }
        	    break;
        	case 14:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2708:5: MINUS_TOK
        	    {
        	         MATCHT(MINUS_TOK, &FOLLOW_MINUS_TOK_in_builtinOp5962);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::MINUS; 
        	        }


        	    }
        	    break;
        	case 15:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2709:5: STAR_TOK
        	    {
        	         MATCHT(STAR_TOK, &FOLLOW_STAR_TOK_in_builtinOp5973);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::MULT; 
        	        }


        	    }
        	    break;
        	case 16:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2710:5: DIV_TOK
        	    {
        	         MATCHT(DIV_TOK, &FOLLOW_DIV_TOK_in_builtinOp5985);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::DIVISION; 
        	        }


        	    }
        	    break;
        	case 17:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2712:5: BV2NAT_TOK
        	    {
        	         MATCHT(BV2NAT_TOK, &FOLLOW_BV2NAT_TOK_in_builtinOp5999);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::BITVECTOR_TO_NAT;
        	                  if(PARSER_STATE->strictModeEnabled()) {
        	                    PARSER_STATE->parseError("bv2nat and int2bv are not part of SMT-LIB, "
        	                                             "and aren't available in SMT-LIB strict "
        	                                             "compliance mode");
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 18:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2721:5: DTSIZE_TOK
        	    {
        	         MATCHT(DTSIZE_TOK, &FOLLOW_DTSIZE_TOK_in_builtinOp6012);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::DT_SIZE; 
        	        }


        	    }
        	    break;
        	case 19:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2722:5: FMFCARD_TOK
        	    {
        	         MATCHT(FMFCARD_TOK, &FOLLOW_FMFCARD_TOK_in_builtinOp6026);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::CARDINALITY_CONSTRAINT; 
        	        }


        	    }
        	    break;
        	case 20:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2723:5: FMFCARDVAL_TOK
        	    {
        	         MATCHT(FMFCARDVAL_TOK, &FOLLOW_FMFCARDVAL_TOK_in_builtinOp6039);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::CARDINALITY_VALUE; 
        	        }


        	    }
        	    break;
        	case 21:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2724:5: INST_CLOSURE_TOK
        	    {
        	         MATCHT(INST_CLOSURE_TOK, &FOLLOW_INST_CLOSURE_TOK_in_builtinOp6049);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulebuiltinOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::INST_CLOSURE; 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulebuiltinOpEx; /* Prevent compiler warnings */
    rulebuiltinOpEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end builtinOp */

/**
 * $ANTLR start quantOp
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2734:1: quantOp[CVC4::Kind& kind] : ( EXISTS_TOK | FORALL_TOK );
 */
static void
quantOp(pSmt2Parser ctx, CVC4::Kind& kind)
{
    /* Initialize rule variables
     */


      Debug("parser") << "quant: " << AntlrInput::tokenText(LT(1)) << std::endl;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2738:3: ( EXISTS_TOK | FORALL_TOK )

            ANTLR3_UINT32 alt67;

            alt67=2;

            switch ( LA(1) )
            {
            case EXISTS_TOK:
            	{
            		alt67=1;
            	}
                break;
            case FORALL_TOK:
            	{
            		alt67=2;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 67;
                EXCEPTION->state        = 0;


                goto rulequantOpEx;

            }

            switch (alt67)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2738:5: EXISTS_TOK
        	    {
        	         MATCHT(EXISTS_TOK, &FOLLOW_EXISTS_TOK_in_quantOp6091);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulequantOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::EXISTS; 
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2739:5: FORALL_TOK
        	    {
        	         MATCHT(FORALL_TOK, &FOLLOW_FORALL_TOK_in_quantOp6102);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulequantOpEx;
        	        }


        	        {
        	             kind= CVC4::kind::FORALL; 
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulequantOpEx; /* Prevent compiler warnings */
    rulequantOpEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end quantOp */

/**
 * $ANTLR start functionName
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2746:1: functionName[std::string& name, CVC4::parser::DeclarationCheck check] : symbol[name,check,SYM_VARIABLE] ;
 */
static void
functionName(pSmt2Parser ctx, std::string& name, CVC4::parser::DeclarationCheck check)
{
    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2747:3: ( symbol[name,check,SYM_VARIABLE] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2747:5: symbol[name,check,SYM_VARIABLE]
        {
            FOLLOWPUSH(FOLLOW_symbol_in_functionName6123);
            symbol(ctx, name, check, SYM_VARIABLE);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulefunctionNameEx;
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulefunctionNameEx; /* Prevent compiler warnings */
    rulefunctionNameEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end functionName */

/**
 * $ANTLR start sortList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2754:1: sortList[std::vector<CVC4::Type>& sorts] : ( sortSymbol[t,CHECK_DECLARED] )* ;
 */
static void
sortList(pSmt2Parser ctx, std::vector<CVC4::Type>& sorts)
{

      Type t;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2758:3: ( ( sortSymbol[t,CHECK_DECLARED] )* )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2758:5: ( sortSymbol[t,CHECK_DECLARED] )*
        {

            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2758:5: ( sortSymbol[t,CHECK_DECLARED] )*

            for (;;)
            {
                int alt68=2;
                switch ( LA(1) )
                {
                case CHECK_SYNTH_TOK:
                case CONSTRAINT_TOK:
                case DECLARE_PRIMED_VAR_TOK:
                case DECLARE_VAR_TOK:
                case INV_CONSTRAINT_TOK:
                case LPAREN_TOK:
                case QUOTED_SYMBOL:
                case SET_OPTIONS_TOK:
                case SIMPLE_SYMBOL:
                case SYNTH_FUN_TOK:
                case SYNTH_INV_TOK:
                case UNTERMINATED_QUOTED_SYMBOL:
                case 160:
                	{
                		alt68=1;
                	}
                    break;

                }

                switch (alt68)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2758:7: sortSymbol[t,CHECK_DECLARED]
            	    {
            	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sortList6147);
            	        sortSymbol(ctx, t, CHECK_DECLARED);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesortListEx;
            	        }


            	        {
            	             sorts.push_back(t); 
            	        }


            	    }
            	    break;

            	default:
            	    goto loop68;	/* break out of the loop */
            	    break;
                }
            }
            loop68: ; /* Jump out to here if this rule does not match */


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesortListEx; /* Prevent compiler warnings */
    rulesortListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sortList */

/**
 * $ANTLR start nonemptySortList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2761:1: nonemptySortList[std::vector<CVC4::Type>& sorts] : ( sortSymbol[t,CHECK_DECLARED] )+ ;
 */
static void
nonemptySortList(pSmt2Parser ctx, std::vector<CVC4::Type>& sorts)
{

      Type t;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2765:3: ( ( sortSymbol[t,CHECK_DECLARED] )+ )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2765:5: ( sortSymbol[t,CHECK_DECLARED] )+
        {
            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2765:5: ( sortSymbol[t,CHECK_DECLARED] )+
            {
                int cnt69=0;

                for (;;)
                {
                    int alt69=2;
            	switch ( LA(1) )
            	{
            	case CHECK_SYNTH_TOK:
            	case CONSTRAINT_TOK:
            	case DECLARE_PRIMED_VAR_TOK:
            	case DECLARE_VAR_TOK:
            	case INV_CONSTRAINT_TOK:
            	case LPAREN_TOK:
            	case QUOTED_SYMBOL:
            	case SET_OPTIONS_TOK:
            	case SIMPLE_SYMBOL:
            	case SYNTH_FUN_TOK:
            	case SYNTH_INV_TOK:
            	case UNTERMINATED_QUOTED_SYMBOL:
            	case 160:
            		{
            			alt69=1;
            		}
            	    break;

            	}

            	switch (alt69)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2765:7: sortSymbol[t,CHECK_DECLARED]
            	        {
            	            FOLLOWPUSH(FOLLOW_sortSymbol_in_nonemptySortList6174);
            	            sortSymbol(ctx, t, CHECK_DECLARED);

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulenonemptySortListEx;
            	            }


            	            {
            	                 sorts.push_back(t); 
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt69 >= 1 )
            		{
            		    goto loop69;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto rulenonemptySortListEx;
            	}
            	cnt69++;
                }
                loop69: ;	/* Jump to here if this rule does not match */
            }

        }

    }


    // This is where rules clean up and exit
    //
    goto rulenonemptySortListEx; /* Prevent compiler warnings */
    rulenonemptySortListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end nonemptySortList */

/**
 * $ANTLR start sortedVarList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2772:1: sortedVarList[std::vector<std::pair<std::string, CVC4::Type> >& sortedVars] : ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )* ;
 */
static void
sortedVarList(pSmt2Parser ctx, std::vector<std::pair<std::string, CVC4::Type> >& sortedVars)
{

      std::string name;
      Type t;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2777:3: ( ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )* )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2777:5: ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )*
        {

            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2777:5: ( LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] RPAREN_TOK )*

            for (;;)
            {
                int alt70=2;
                switch ( LA(1) )
                {
                case LPAREN_TOK:
                	{
                		alt70=1;
                	}
                    break;

                }

                switch (alt70)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2777:7: LPAREN_TOK symbol[name,CHECK_NONE,SYM_VARIABLE] sortSymbol[t,CHECK_DECLARED] RPAREN_TOK
            	    {
            	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sortedVarList6203);
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesortedVarListEx;
            	        }


            	        FOLLOWPUSH(FOLLOW_symbol_in_sortedVarList6205);
            	        symbol(ctx, name, CHECK_NONE, SYM_VARIABLE);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesortedVarListEx;
            	        }


            	        FOLLOWPUSH(FOLLOW_sortSymbol_in_sortedVarList6214);
            	        sortSymbol(ctx, t, CHECK_DECLARED);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesortedVarListEx;
            	        }


            	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sortedVarList6217);
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesortedVarListEx;
            	        }


            	        {
            	             sortedVars.push_back(make_pair(name, t)); 
            	        }


            	    }
            	    break;

            	default:
            	    goto loop70;	/* break out of the loop */
            	    break;
                }
            }
            loop70: ; /* Jump out to here if this rule does not match */


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesortedVarListEx; /* Prevent compiler warnings */
    rulesortedVarListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sortedVarList */

/**
 * $ANTLR start sortName
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2787:1: sortName[std::string& name, CVC4::parser::DeclarationCheck check] : symbol[name,check,SYM_SORT] ;
 */
static void
sortName(pSmt2Parser ctx, std::string& name, CVC4::parser::DeclarationCheck check)
{
    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2788:3: ( symbol[name,check,SYM_SORT] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2788:5: symbol[name,check,SYM_SORT]
        {
            FOLLOWPUSH(FOLLOW_symbol_in_sortName6248);
            symbol(ctx, name, check, SYM_SORT);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto rulesortNameEx;
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesortNameEx; /* Prevent compiler warnings */
    rulesortNameEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sortName */

/**
 * $ANTLR start sortSymbol
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2791:1: sortSymbol[CVC4::Type& t, CVC4::parser::DeclarationCheck check] : ( sortName[name,CHECK_NONE] | LPAREN_TOK ( INDEX_TOK |) symbol[name,CHECK_NONE,SYM_SORT] ( nonemptyNumeralList[numerals] | sortList[args] ) RPAREN_TOK | LPAREN_TOK HO_ARROW_TOK sortList[args] RPAREN_TOK );
 */
static void
sortSymbol(pSmt2Parser ctx, CVC4::Type& t, CVC4::parser::DeclarationCheck check)
{

      std::string name;
      std::vector<CVC4::Type> args;
      std::vector<uint64_t> numerals;
      bool indexed = false;

    /* Initialize rule variables
     */

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2798:3: ( sortName[name,CHECK_NONE] | LPAREN_TOK ( INDEX_TOK |) symbol[name,CHECK_NONE,SYM_SORT] ( nonemptyNumeralList[numerals] | sortList[args] ) RPAREN_TOK | LPAREN_TOK HO_ARROW_TOK sortList[args] RPAREN_TOK )

            ANTLR3_UINT32 alt73;

            alt73=3;

            switch ( LA(1) )
            {
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case INV_CONSTRAINT_TOK:
            case QUOTED_SYMBOL:
            case SET_OPTIONS_TOK:
            case SIMPLE_SYMBOL:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case UNTERMINATED_QUOTED_SYMBOL:
            case 160:
            	{
            		alt73=1;
            	}
                break;
            case LPAREN_TOK:
            	{
            		switch ( LA(2) )
            		{
            		case HO_ARROW_TOK:
            			{
            				alt73=3;
            			}
            		    break;
            		case CHECK_SYNTH_TOK:
            		case CONSTRAINT_TOK:
            		case DECLARE_PRIMED_VAR_TOK:
            		case DECLARE_VAR_TOK:
            		case INDEX_TOK:
            		case INV_CONSTRAINT_TOK:
            		case QUOTED_SYMBOL:
            		case SET_OPTIONS_TOK:
            		case SIMPLE_SYMBOL:
            		case SYNTH_FUN_TOK:
            		case SYNTH_INV_TOK:
            		case UNTERMINATED_QUOTED_SYMBOL:
            		case 160:
            			{
            				alt73=2;
            			}
            		    break;

            		default:
            		    CONSTRUCTEX();
            		    EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
            		    EXCEPTION->message      = (void *)"";
            		    EXCEPTION->decisionNum  = 73;
            		    EXCEPTION->state        = 13;


            		    goto rulesortSymbolEx;

            		}

            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 73;
                EXCEPTION->state        = 0;


                goto rulesortSymbolEx;

            }

            switch (alt73)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2798:5: sortName[name,CHECK_NONE]
        	    {
        	        FOLLOWPUSH(FOLLOW_sortName_in_sortSymbol6268);
        	        sortName(ctx, name, CHECK_NONE);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	        {

        	                  if(check == CHECK_DECLARED || PARSER_STATE->isDeclared(name, SYM_SORT)) {
        	                    t = PARSER_STATE->getSort(name);
        	                  } else {
        	                    t = PARSER_STATE->mkUnresolvedType(name);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2806:5: LPAREN_TOK ( INDEX_TOK |) symbol[name,CHECK_NONE,SYM_SORT] ( nonemptyNumeralList[numerals] | sortList[args] ) RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sortSymbol6281);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2806:16: ( INDEX_TOK |)
        	        {
        	            int alt71=2;
        	            switch ( LA(1) )
        	            {
        	            case INDEX_TOK:
        	            	{
        	            		alt71=1;
        	            	}
        	                break;
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case INV_CONSTRAINT_TOK:
        	            case QUOTED_SYMBOL:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt71=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 71;
        	                EXCEPTION->state        = 0;


        	                goto rulesortSymbolEx;

        	            }

        	            switch (alt71)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2806:17: INDEX_TOK
        	        	    {
        	        	         MATCHT(INDEX_TOK, &FOLLOW_INDEX_TOK_in_sortSymbol6284);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesortSymbolEx;
        	        	        }


        	        	        {
        	        	            indexed = true;
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2806:47: 
        	        	    {
        	        	        {
        	        	            indexed = false;
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        FOLLOWPUSH(FOLLOW_symbol_in_sortSymbol6297);
        	        symbol(ctx, name, CHECK_NONE, SYM_SORT);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2808:5: ( nonemptyNumeralList[numerals] | sortList[args] )
        	        {
        	            int alt72=2;
        	            switch ( LA(1) )
        	            {
        	            case INTEGER_LITERAL:
        	            	{
        	            		alt72=1;
        	            	}
        	                break;
        	            case CHECK_SYNTH_TOK:
        	            case CONSTRAINT_TOK:
        	            case DECLARE_PRIMED_VAR_TOK:
        	            case DECLARE_VAR_TOK:
        	            case INV_CONSTRAINT_TOK:
        	            case LPAREN_TOK:
        	            case QUOTED_SYMBOL:
        	            case RPAREN_TOK:
        	            case SET_OPTIONS_TOK:
        	            case SIMPLE_SYMBOL:
        	            case SYNTH_FUN_TOK:
        	            case SYNTH_INV_TOK:
        	            case UNTERMINATED_QUOTED_SYMBOL:
        	            case 160:
        	            	{
        	            		alt72=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 72;
        	                EXCEPTION->state        = 0;


        	                goto rulesortSymbolEx;

        	            }

        	            switch (alt72)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2808:7: nonemptyNumeralList[numerals]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_nonemptyNumeralList_in_sortSymbol6306);
        	        	        nonemptyNumeralList(ctx, numerals);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesortSymbolEx;
        	        	        }


        	        	        {
        	        	             // allow sygus inputs to elide the `_'
        	        	                    if( !indexed && !PARSER_STATE->sygus() ) {
        	        	                      std::stringstream ss;
        	        	                      ss << "SMT-LIB requires use of an indexed sort here, e.g. (_ " << name
        	        	                         << " ...)";
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                    if( name == "BitVec" ) {
        	        	                      if( numerals.size() != 1 ) {
        	        	                        PARSER_STATE->parseError("Illegal bitvector type.");
        	        	                      }
        	        	                      if(numerals.front() == 0) {
        	        	                        PARSER_STATE->parseError("Illegal bitvector size: 0");
        	        	                      }
        	        	                      t = EXPR_MANAGER->mkBitVectorType(numerals.front());
        	        	                    } else if ( name == "FloatingPoint" ) {
        	        	                      if( numerals.size() != 2 ) {
        	        	                        PARSER_STATE->parseError("Illegal floating-point type.");
        	        	                      }
        	        	                      if(!validExponentSize(numerals[0])) {
        	        	                        PARSER_STATE->parseError("Illegal floating-point exponent size");
        	        	                      }
        	        	                      if(!validSignificandSize(numerals[1])) {
        	        	                        PARSER_STATE->parseError("Illegal floating-point significand size");
        	        	                      }
        	        	                      t = EXPR_MANAGER->mkFloatingPointType(numerals[0],numerals[1]);
        	        	                    } else {
        	        	                      std::stringstream ss;
        	        	                      ss << "unknown indexed sort symbol `" << name << "'";
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2841:7: sortList[args]
        	        	    {
        	        	        FOLLOWPUSH(FOLLOW_sortList_in_sortSymbol6323);
        	        	        sortList(ctx, args);

        	        	        FOLLOWPOP();
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesortSymbolEx;
        	        	        }


        	        	        {
        	        	             if( indexed ) {
        	        	                      std::stringstream ss;
        	        	                      ss << "Unexpected use of indexing operator `_' before `" << name
        	        	                         << "', try leaving it out";
        	        	                      PARSER_STATE->parseError(ss.str());
        	        	                    }
        	        	                    if(args.empty()) {
        	        	                      PARSER_STATE->parseError("Extra parentheses around sort name not "
        	        	                                               "permitted in SMT-LIB");
        	        	                    } else if(name == "Array" &&
        	        	                       PARSER_STATE->isTheoryEnabled(Smt2::THEORY_ARRAYS) ) {
        	        	                      if(args.size() != 2) {
        	        	                        PARSER_STATE->parseError("Illegal array type.");
        	        	                      }
        	        	                      t = EXPR_MANAGER->mkArrayType( args[0], args[1] );
        	        	                    } else if(name == "Set" &&
        	        	                              PARSER_STATE->isTheoryEnabled(Smt2::THEORY_SETS) ) {
        	        	                      if(args.size() != 1) {
        	        	                        PARSER_STATE->parseError("Illegal set type.");
        	        	                      }
        	        	                      t = EXPR_MANAGER->mkSetType( args[0] );
        	        	                    } else if(name == "Tuple") {
        	        	                      t = EXPR_MANAGER->mkTupleType(args); 
        	        	                    } else if(check == CHECK_DECLARED ||
        	        	                              PARSER_STATE->isDeclared(name, SYM_SORT)) {
        	        	                      t = PARSER_STATE->getSort(name, args);
        	        	                    } else {
        	        	                      // make unresolved type
        	        	                      if(args.empty()) {
        	        	                        t = PARSER_STATE->mkUnresolvedType(name);
        	        	                        Debug("parser-param") << "param: make unres type " << name
        	        	                                              << std::endl;
        	        	                      } else {
        	        	                        t = PARSER_STATE->mkUnresolvedTypeConstructor(name,args);
        	        	                        t = SortConstructorType(t).instantiate( args );
        	        	                        Debug("parser-param")
        	        	                            << "param: make unres param type " << name << " " << args.size()
        	        	                            << " " << PARSER_STATE->getArity( name ) << std::endl;
        	        	                      }
        	        	                    }
        	        	                  
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sortSymbol6340);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2884:5: LPAREN_TOK HO_ARROW_TOK sortList[args] RPAREN_TOK
        	    {
        	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_sortSymbol6346);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	         MATCHT(HO_ARROW_TOK, &FOLLOW_HO_ARROW_TOK_in_sortSymbol6348);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	        FOLLOWPUSH(FOLLOW_sortList_in_sortSymbol6350);
        	        sortList(ctx, args);

        	        FOLLOWPOP();
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_sortSymbol6353);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesortSymbolEx;
        	        }


        	        {

        	                  if(args.size()<2) {
        	                    PARSER_STATE->parseError("Arrow types must have at least 2 arguments");
        	                  }
        	                  //flatten the type
        	                  Type rangeType = args.back();
        	                  args.pop_back();
        	                  t = PARSER_STATE->mkFlatFunctionType( args, rangeType );
        	                
        	        }


        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesortSymbolEx; /* Prevent compiler warnings */
    rulesortSymbolEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end sortSymbol */

/**
 * $ANTLR start symbolList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2900:1: symbolList[std::vector<std::string>& names,\n CVC4::parser::DeclarationCheck check,\n CVC4::parser::SymbolType type] : ( symbol[id,check,type] )* ;
 */
static void
symbolList(pSmt2Parser ctx, std::vector<std::string>& names, CVC4::parser::DeclarationCheck check, CVC4::parser::SymbolType type)
{

      std::string id;

    /* Initialize rule variables
     */

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2906:3: ( ( symbol[id,check,type] )* )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2906:5: ( symbol[id,check,type] )*
        {

            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2906:5: ( symbol[id,check,type] )*

            for (;;)
            {
                int alt74=2;
                switch ( LA(1) )
                {
                case CHECK_SYNTH_TOK:
                case CONSTRAINT_TOK:
                case DECLARE_PRIMED_VAR_TOK:
                case DECLARE_VAR_TOK:
                case INV_CONSTRAINT_TOK:
                case QUOTED_SYMBOL:
                case SET_OPTIONS_TOK:
                case SIMPLE_SYMBOL:
                case SYNTH_FUN_TOK:
                case SYNTH_INV_TOK:
                case UNTERMINATED_QUOTED_SYMBOL:
                case 160:
                	{
                		alt74=1;
                	}
                    break;

                }

                switch (alt74)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2906:7: symbol[id,check,type]
            	    {
            	        FOLLOWPUSH(FOLLOW_symbol_in_symbolList6382);
            	        symbol(ctx, id, check, type);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto rulesymbolListEx;
            	        }


            	        {
            	             names.push_back(id); 
            	        }


            	    }
            	    break;

            	default:
            	    goto loop74;	/* break out of the loop */
            	    break;
                }
            }
            loop74: ; /* Jump out to here if this rule does not match */


        }

    }


    // This is where rules clean up and exit
    //
    goto rulesymbolListEx; /* Prevent compiler warnings */
    rulesymbolListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end symbolList */

/**
 * $ANTLR start symbol
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2915:1: symbol[std::string& id,\n CVC4::parser::DeclarationCheck check,\n CVC4::parser::SymbolType type] : ( SIMPLE_SYMBOL | ( 'repeat' | SET_OPTIONS_TOK | DECLARE_VAR_TOK | DECLARE_PRIMED_VAR_TOK | SYNTH_FUN_TOK | SYNTH_INV_TOK | CONSTRAINT_TOK | INV_CONSTRAINT_TOK | CHECK_SYNTH_TOK ) | QUOTED_SYMBOL | UNTERMINATED_QUOTED_SYMBOL ( EOF | '\\\\' ) );
 */
static void
symbol(pSmt2Parser ctx, std::string& id, CVC4::parser::DeclarationCheck check, CVC4::parser::SymbolType type)
{
    pANTLR3_COMMON_TOKEN    SIMPLE_SYMBOL18;
    pANTLR3_COMMON_TOKEN    QUOTED_SYMBOL19;

    /* Initialize rule variables
     */

    SIMPLE_SYMBOL18       = NULL;
    QUOTED_SYMBOL19       = NULL;

    {
        {
            //  /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2918:3: ( SIMPLE_SYMBOL | ( 'repeat' | SET_OPTIONS_TOK | DECLARE_VAR_TOK | DECLARE_PRIMED_VAR_TOK | SYNTH_FUN_TOK | SYNTH_INV_TOK | CONSTRAINT_TOK | INV_CONSTRAINT_TOK | CHECK_SYNTH_TOK ) | QUOTED_SYMBOL | UNTERMINATED_QUOTED_SYMBOL ( EOF | '\\\\' ) )

            ANTLR3_UINT32 alt77;

            alt77=4;

            switch ( LA(1) )
            {
            case SIMPLE_SYMBOL:
            	{
            		alt77=1;
            	}
                break;
            case CHECK_SYNTH_TOK:
            case CONSTRAINT_TOK:
            case DECLARE_PRIMED_VAR_TOK:
            case DECLARE_VAR_TOK:
            case INV_CONSTRAINT_TOK:
            case SET_OPTIONS_TOK:
            case SYNTH_FUN_TOK:
            case SYNTH_INV_TOK:
            case 160:
            	{
            		alt77=2;
            	}
                break;
            case QUOTED_SYMBOL:
            	{
            		alt77=3;
            	}
                break;
            case UNTERMINATED_QUOTED_SYMBOL:
            	{
            		alt77=4;
            	}
                break;

            default:
                CONSTRUCTEX();
                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
                EXCEPTION->message      = (void *)"";
                EXCEPTION->decisionNum  = 77;
                EXCEPTION->state        = 0;


                goto rulesymbolEx;

            }

            switch (alt77)
            {
        	case 1:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2918:5: SIMPLE_SYMBOL
        	    {
        	        SIMPLE_SYMBOL18 = (pANTLR3_COMMON_TOKEN) MATCHT(SIMPLE_SYMBOL, &FOLLOW_SIMPLE_SYMBOL_in_symbol6404);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolEx;
        	        }


        	        {
        	             id = AntlrInput::tokenText(SIMPLE_SYMBOL18);
        	                  if(!PARSER_STATE->isAbstractValue(id)) {
        	                    // if an abstract value, SmtEngine handles declaration
        	                    PARSER_STATE->checkDeclaration(id, check, type);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 2:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2925:5: ( 'repeat' | SET_OPTIONS_TOK | DECLARE_VAR_TOK | DECLARE_PRIMED_VAR_TOK | SYNTH_FUN_TOK | SYNTH_INV_TOK | CONSTRAINT_TOK | INV_CONSTRAINT_TOK | CHECK_SYNTH_TOK )
        	    {

        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2925:5: ( 'repeat' | SET_OPTIONS_TOK | DECLARE_VAR_TOK | DECLARE_PRIMED_VAR_TOK | SYNTH_FUN_TOK | SYNTH_INV_TOK | CONSTRAINT_TOK | INV_CONSTRAINT_TOK | CHECK_SYNTH_TOK )
        	        {
        	            int alt75=9;
        	            switch ( LA(1) )
        	            {
        	            case 160:
        	            	{
        	            		alt75=1;
        	            	}
        	                break;
        	            case SET_OPTIONS_TOK:
        	            	{
        	            		alt75=2;
        	            	}
        	                break;
        	            case DECLARE_VAR_TOK:
        	            	{
        	            		alt75=3;
        	            	}
        	                break;
        	            case DECLARE_PRIMED_VAR_TOK:
        	            	{
        	            		alt75=4;
        	            	}
        	                break;
        	            case SYNTH_FUN_TOK:
        	            	{
        	            		alt75=5;
        	            	}
        	                break;
        	            case SYNTH_INV_TOK:
        	            	{
        	            		alt75=6;
        	            	}
        	                break;
        	            case CONSTRAINT_TOK:
        	            	{
        	            		alt75=7;
        	            	}
        	                break;
        	            case INV_CONSTRAINT_TOK:
        	            	{
        	            		alt75=8;
        	            	}
        	                break;
        	            case CHECK_SYNTH_TOK:
        	            	{
        	            		alt75=9;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 75;
        	                EXCEPTION->state        = 0;


        	                goto rulesymbolEx;

        	            }

        	            switch (alt75)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2925:7: 'repeat'
        	        	    {
        	        	         MATCHT(160, &FOLLOW_160_in_symbol6418);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "repeat"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2928:7: SET_OPTIONS_TOK
        	        	    {
        	        	         MATCHT(SET_OPTIONS_TOK, &FOLLOW_SET_OPTIONS_TOK_in_symbol6434);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "set-options"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 3:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2929:7: DECLARE_VAR_TOK
        	        	    {
        	        	         MATCHT(DECLARE_VAR_TOK, &FOLLOW_DECLARE_VAR_TOK_in_symbol6444);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "declare-var"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 4:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2930:7: DECLARE_PRIMED_VAR_TOK
        	        	    {
        	        	         MATCHT(DECLARE_PRIMED_VAR_TOK, &FOLLOW_DECLARE_PRIMED_VAR_TOK_in_symbol6454);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "declare-primed-var"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 5:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2931:7: SYNTH_FUN_TOK
        	        	    {
        	        	         MATCHT(SYNTH_FUN_TOK, &FOLLOW_SYNTH_FUN_TOK_in_symbol6464);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "synth-fun"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 6:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2932:7: SYNTH_INV_TOK
        	        	    {
        	        	         MATCHT(SYNTH_INV_TOK, &FOLLOW_SYNTH_INV_TOK_in_symbol6474);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "synth-inv"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 7:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2933:7: CONSTRAINT_TOK
        	        	    {
        	        	         MATCHT(CONSTRAINT_TOK, &FOLLOW_CONSTRAINT_TOK_in_symbol6484);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "constraint"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 8:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2934:7: INV_CONSTRAINT_TOK
        	        	    {
        	        	         MATCHT(INV_CONSTRAINT_TOK, &FOLLOW_INV_CONSTRAINT_TOK_in_symbol6494);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "inv-constraint"; 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 9:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2935:7: CHECK_SYNTH_TOK
        	        	    {
        	        	         MATCHT(CHECK_SYNTH_TOK, &FOLLOW_CHECK_SYNTH_TOK_in_symbol6504);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             id = "check-synth"; 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	        {
        	             PARSER_STATE->checkDeclaration(id, check, type); 
        	        }


        	    }
        	    break;
        	case 3:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2938:5: QUOTED_SYMBOL
        	    {
        	        QUOTED_SYMBOL19 = (pANTLR3_COMMON_TOKEN) MATCHT(QUOTED_SYMBOL, &FOLLOW_QUOTED_SYMBOL_in_symbol6524);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolEx;
        	        }


        	        {
        	             id = AntlrInput::tokenText(QUOTED_SYMBOL19);
        	                  /* strip off the quotes */
        	                  id = id.substr(1, id.size() - 2);
        	                  if(!PARSER_STATE->isAbstractValue(id)) {
        	                    // if an abstract value, SmtEngine handles declaration
        	                    PARSER_STATE->checkDeclaration(id, check, type);
        	                  }
        	                
        	        }


        	    }
        	    break;
        	case 4:
        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2947:5: UNTERMINATED_QUOTED_SYMBOL ( EOF | '\\\\' )
        	    {
        	         MATCHT(UNTERMINATED_QUOTED_SYMBOL, &FOLLOW_UNTERMINATED_QUOTED_SYMBOL_in_symbol6536);
        	        if  (HASEXCEPTION())
        	        {
        	            goto rulesymbolEx;
        	        }



        	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2948:5: ( EOF | '\\\\' )
        	        {
        	            int alt76=2;
        	            switch ( LA(1) )
        	            {
        	            case EOF:
        	            	{
        	            		alt76=1;
        	            	}
        	                break;
        	            case 158:
        	            	{
        	            		alt76=2;
        	            	}
        	                break;

        	            default:
        	                CONSTRUCTEX();
        	                EXCEPTION->type         = ANTLR3_NO_VIABLE_ALT_EXCEPTION;
        	                EXCEPTION->message      = (void *)"";
        	                EXCEPTION->decisionNum  = 76;
        	                EXCEPTION->state        = 0;


        	                goto rulesymbolEx;

        	            }

        	            switch (alt76)
        	            {
        	        	case 1:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2948:7: EOF
        	        	    {
        	        	         MATCHT(EOF, &FOLLOW_EOF_in_symbol6544);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->unexpectedEOF("unterminated |quoted| symbol"); 
        	        	        }


        	        	    }
        	        	    break;
        	        	case 2:
        	        	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2950:7: '\\\\'
        	        	    {
        	        	         MATCHT(158, &FOLLOW_158_in_symbol6560);
        	        	        if  (HASEXCEPTION())
        	        	        {
        	        	            goto rulesymbolEx;
        	        	        }


        	        	        {
        	        	             PARSER_STATE->unexpectedEOF("backslash not permitted in |quoted| "
        	        	                                                "symbol"); 
        	        	        }


        	        	    }
        	        	    break;

        	            }
        	        }

        	    }
        	    break;

            }
        }
    }


    // This is where rules clean up and exit
    //
    goto rulesymbolEx; /* Prevent compiler warnings */
    rulesymbolEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end symbol */

/**
 * $ANTLR start nonemptyNumeralList
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2960:1: nonemptyNumeralList[std::vector<uint64_t>& numerals] : ( INTEGER_LITERAL )+ ;
 */
static void
nonemptyNumeralList(pSmt2Parser ctx, std::vector<uint64_t>& numerals)
{
    pANTLR3_COMMON_TOKEN    INTEGER_LITERAL20;

    /* Initialize rule variables
     */

    INTEGER_LITERAL20       = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2961:3: ( ( INTEGER_LITERAL )+ )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2961:5: ( INTEGER_LITERAL )+
        {
            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2961:5: ( INTEGER_LITERAL )+
            {
                int cnt78=0;

                for (;;)
                {
                    int alt78=2;
            	switch ( LA(1) )
            	{
            	case INTEGER_LITERAL:
            		{
            			alt78=1;
            		}
            	    break;

            	}

            	switch (alt78)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2961:7: INTEGER_LITERAL
            	        {
            	            INTEGER_LITERAL20 = (pANTLR3_COMMON_TOKEN) MATCHT(INTEGER_LITERAL, &FOLLOW_INTEGER_LITERAL_in_nonemptyNumeralList6592);
            	            if  (HASEXCEPTION())
            	            {
            	                goto rulenonemptyNumeralListEx;
            	            }


            	            {
            	                 numerals.push_back(AntlrInput::tokenToUnsigned(INTEGER_LITERAL20)); 
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt78 >= 1 )
            		{
            		    goto loop78;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto rulenonemptyNumeralListEx;
            	}
            	cnt78++;
                }
                loop78: ;	/* Jump to here if this rule does not match */
            }

        }

    }


    // This is where rules clean up and exit
    //
    goto rulenonemptyNumeralListEx; /* Prevent compiler warnings */
    rulenonemptyNumeralListEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end nonemptyNumeralList */

/**
 * $ANTLR start datatypeDef
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2969:1: datatypeDef[bool isCo, std::vector<CVC4::Datatype>& datatypes,\n std::vector< CVC4::Type >& params] : symbol[id,CHECK_NONE,SYM_SORT] ( LPAREN_TOK constructorDef[datatypes.back()] RPAREN_TOK )+ ;
 */
static void
datatypeDef(pSmt2Parser ctx, bool isCo, std::vector<CVC4::Datatype>& datatypes, std::vector< CVC4::Type >& params)
{
    /* Initialize rule variables
     */


      std::string id;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2978:3: ( symbol[id,CHECK_NONE,SYM_SORT] ( LPAREN_TOK constructorDef[datatypes.back()] RPAREN_TOK )+ )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2978:5: symbol[id,CHECK_NONE,SYM_SORT] ( LPAREN_TOK constructorDef[datatypes.back()] RPAREN_TOK )+
        {
            FOLLOWPUSH(FOLLOW_symbol_in_datatypeDef6634);
            symbol(ctx, id, CHECK_NONE, SYM_SORT);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruledatatypeDefEx;
            }


            {
                 PARSER_STATE->pushScope(true); 
            }


            {
                 datatypes.push_back(Datatype(id,params,isCo));
                      if(!PARSER_STATE->isUnresolvedType(id)) {
                        // if not unresolved, must be undeclared
                        PARSER_STATE->checkDeclaration(id, CHECK_UNDECLARED, SYM_SORT);
                      }
                    
            }


            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2994:5: ( LPAREN_TOK constructorDef[datatypes.back()] RPAREN_TOK )+
            {
                int cnt79=0;

                for (;;)
                {
                    int alt79=2;
            	switch ( LA(1) )
            	{
            	case LPAREN_TOK:
            		{
            			alt79=1;
            		}
            	    break;

            	}

            	switch (alt79)
            	{
            	    case 1:
            	        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:2994:7: LPAREN_TOK constructorDef[datatypes.back()] RPAREN_TOK
            	        {
            	             MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_datatypeDef6657);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypeDefEx;
            	            }


            	            FOLLOWPUSH(FOLLOW_constructorDef_in_datatypeDef6659);
            	            constructorDef(ctx, datatypes.back());

            	            FOLLOWPOP();
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypeDefEx;
            	            }


            	             MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_datatypeDef6662);
            	            if  (HASEXCEPTION())
            	            {
            	                goto ruledatatypeDefEx;
            	            }


            	        }
            	        break;

            	    default:

            		if ( cnt79 >= 1 )
            		{
            		    goto loop79;
            		}
            		/* mismatchedSetEx()
            		 */
            		CONSTRUCTEX();
            		EXCEPTION->type = ANTLR3_EARLY_EXIT_EXCEPTION;
            		EXCEPTION->name = (void *)ANTLR3_EARLY_EXIT_NAME;


            		goto ruledatatypeDefEx;
            	}
            	cnt79++;
                }
                loop79: ;	/* Jump to here if this rule does not match */
            }

            {
                 PARSER_STATE->popScope(); 
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruledatatypeDefEx; /* Prevent compiler warnings */
    ruledatatypeDefEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end datatypeDef */

/**
 * $ANTLR start constructorDef
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3001:1: constructorDef[CVC4::Datatype& type] : symbol[id,CHECK_NONE,SYM_VARIABLE] ( LPAREN_TOK selector[*ctor] RPAREN_TOK )* ;
 */
static void
constructorDef(pSmt2Parser ctx, CVC4::Datatype& type)
{
    /* Initialize rule variables
     */


      std::string id;
      CVC4::DatatypeConstructor* ctor = NULL;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3006:3: ( symbol[id,CHECK_NONE,SYM_VARIABLE] ( LPAREN_TOK selector[*ctor] RPAREN_TOK )* )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3006:5: symbol[id,CHECK_NONE,SYM_VARIABLE] ( LPAREN_TOK selector[*ctor] RPAREN_TOK )*
        {
            FOLLOWPUSH(FOLLOW_symbol_in_constructorDef6692);
            symbol(ctx, id, CHECK_NONE, SYM_VARIABLE);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruleconstructorDefEx;
            }


            {
                 // make the tester
                      std::string testerId("is-");
                      testerId.append(id);
                      ctor = new CVC4::DatatypeConstructor(id, testerId);
                    
            }



            // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3012:5: ( LPAREN_TOK selector[*ctor] RPAREN_TOK )*

            for (;;)
            {
                int alt80=2;
                switch ( LA(1) )
                {
                case LPAREN_TOK:
                	{
                		alt80=1;
                	}
                    break;

                }

                switch (alt80)
                {
            	case 1:
            	    // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3012:7: LPAREN_TOK selector[*ctor] RPAREN_TOK
            	    {
            	         MATCHT(LPAREN_TOK, &FOLLOW_LPAREN_TOK_in_constructorDef6707);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleconstructorDefEx;
            	        }


            	        FOLLOWPUSH(FOLLOW_selector_in_constructorDef6709);
            	        selector(ctx, *ctor);

            	        FOLLOWPOP();
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleconstructorDefEx;
            	        }


            	         MATCHT(RPAREN_TOK, &FOLLOW_RPAREN_TOK_in_constructorDef6712);
            	        if  (HASEXCEPTION())
            	        {
            	            goto ruleconstructorDefEx;
            	        }


            	    }
            	    break;

            	default:
            	    goto loop80;	/* break out of the loop */
            	    break;
                }
            }
            loop80: ; /* Jump out to here if this rule does not match */


            {
                 // make the constructor
                      type.addConstructor(*ctor);
                      Debug("parser-idt") << "constructor: " << id.c_str() << std::endl;
                      delete ctor;
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruleconstructorDefEx; /* Prevent compiler warnings */
    ruleconstructorDefEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end constructorDef */

/**
 * $ANTLR start selector
 * /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3020:1: selector[CVC4::DatatypeConstructor& ctor] : symbol[id,CHECK_NONE,SYM_SORT] sortSymbol[t,CHECK_NONE] ;
 */
static void
selector(pSmt2Parser ctx, CVC4::DatatypeConstructor& ctor)
{
    /* Initialize rule variables
     */


      std::string id;
      Type t, t2;

    {
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3025:3: ( symbol[id,CHECK_NONE,SYM_SORT] sortSymbol[t,CHECK_NONE] )
        // /builddir/build/BUILD/CVC4-1.7/src/parser/smt2/Smt2.g:3025:5: symbol[id,CHECK_NONE,SYM_SORT] sortSymbol[t,CHECK_NONE]
        {
            FOLLOWPUSH(FOLLOW_symbol_in_selector6740);
            symbol(ctx, id, CHECK_NONE, SYM_SORT);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruleselectorEx;
            }


            FOLLOWPUSH(FOLLOW_sortSymbol_in_selector6743);
            sortSymbol(ctx, t, CHECK_NONE);

            FOLLOWPOP();
            if  (HASEXCEPTION())
            {
                goto ruleselectorEx;
            }


            {
                 ctor.addArg(id, t);
                      Debug("parser-idt") << "selector: " << id.c_str()
                                          << " of type " << t << std::endl;
                    
            }


        }

    }


    // This is where rules clean up and exit
    //
    goto ruleselectorEx; /* Prevent compiler warnings */
    ruleselectorEx: ;

            if (HASEXCEPTION())
            {
                PREPORTERROR();
                PRECOVER();
            }
    return ;
}
/* $ANTLR end selector */
/* End of parsing rules
 * ==============================================
 */

/* ==============================================
 * Syntactic predicates
 */
/* End of syntactic predicates
 * ==============================================
 */






/* End of code
 * =============================================================================
 */
